!     LAST CHANGE: MFG 1/29/2008 2:48:10 PM

    MODULE NRTYPE
	INTEGER, PARAMETER :: I4B = SELECTED_INT_KIND(9)
	INTEGER, PARAMETER :: I2B = SELECTED_INT_KIND(4)
	INTEGER, PARAMETER :: I1B = SELECTED_INT_KIND(2)
	INTEGER, PARAMETER :: SP = KIND(1.0D0)
	INTEGER, PARAMETER :: DP = KIND(1.0D0)
	INTEGER, PARAMETER :: SPC = KIND((1.0,1.0))
	INTEGER, PARAMETER :: DPC = KIND((1.0D0,1.0D0))
	INTEGER, PARAMETER :: LGT = KIND(.TRUE.)
	REAL(SP), PARAMETER :: PI=3.141592653589793238462643383279502884197_SP
	REAL(SP), PARAMETER :: PIO2=1.57079632679489661923132169163975144209858_SP
	REAL(SP), PARAMETER :: TWOPI=6.283185307179586476925286766559005768394_SP
	REAL(SP), PARAMETER :: SQRT2=1.41421356237309504880168872420969807856967_SP
	REAL(SP), PARAMETER :: EULER=0.5772156649015328606065120900824024310422_SP
	REAL(DP), PARAMETER :: PI_D=3.141592653589793238462643383279502884197_DP
	REAL(DP), PARAMETER :: PIO2_D=1.57079632679489661923132169163975144209858_DP
	REAL(DP), PARAMETER :: TWOPI_D=6.283185307179586476925286766559005768394_DP
	TYPE SPRS2_SP
		INTEGER(I4B) :: N,LEN
		REAL(SP), DIMENSION(:), POINTER :: VAL
		INTEGER(I4B), DIMENSION(:), POINTER :: IROW
		INTEGER(I4B), DIMENSION(:), POINTER :: JCOL
	END TYPE SPRS2_SP
	TYPE SPRS2_DP
		INTEGER(I4B) :: N,LEN
		REAL(DP), DIMENSION(:), POINTER :: VAL
		INTEGER(I4B), DIMENSION(:), POINTER :: IROW
		INTEGER(I4B), DIMENSION(:), POINTER :: JCOL
	END TYPE SPRS2_DP
END MODULE NRTYPE


!==================================================================
!==================================================================
!==================================================================
!==================================================================
!==================================================================
!==================================================================
!===================================================================================================

MODULE MYPARAMSHAB
USE NRTYPE
IMPLICIT NONE
SAVE

 REAL(DP), PARAMETER:: ONE= 1.0D00
 REAL(DP), PARAMETER:: EPSC=0.001_DP
 REAL(DP):: KMIN, KMAX
 REAL(DP), PARAMETER:: CMIN= EPSC
 REAL(DP), PARAMETER:: STMINS=0.0_DP          
                                     
 REAL(DP), PARAMETER:: BMINNRATIO=6.0_DP , BMINSRATIO=6.0_DP
 REAL(DP), PARAMETER:: RAT_BMINFEAS = 0.9_SP, FDRATIO=0.15_DP
 REAL(DP):: FD, WMINN, WMINS, BMINS, BMINN




 INTEGER, PARAMETER:: WNUM=20              !NUMBER OF POINTS FOR INDIVIDUAL WEALTH GRID
 INTEGER, PARAMETER:: KNUM=5                 !  "         "     "   AGGREGATE CAPITAL
 INTEGER, PARAMETER:: ZNUM=15               !   "        "          TFP SHOCKS
 INTEGER, PARAMETER:: GNUM=12               ! NUMBER OF POINTS IN "B" DIRECTION
 INTEGER :: ITERMAIN, SETINVEST

 REAL(DP), PARAMETER:: INERROR= -1.0E20
 REAL(SP), PARAMETER:: POWER = 2.9_SP        ! DETERMINES THE SPACING OF POINTS IN WEALTH  DIRECTION
 REAL(DP), PARAMETER:: WEIGHTB = 0.493_DP
 REAL(DP), PARAMETER:: TOL_DISCRRAL= 1.0E-5_DP, TOL_SBOND=1.0E-2_DP , TOL_SSTOCK=1.0E-2_DP
 REAL(DP), PARAMETER:: TOL_BISECT=1.0E-10_DP, TOL_EXCESSD = 1.0E-7_DP
 REAL(DP), PARAMETER:: TOL_PBOND=1.0E-6_DP, TOL_CAPITAL = 1.0E-5, TOL_GAMM =1.0E-5

!MODEL PARAMS =====================================================================

REAL(SP), PARAMETER:: STDZ = 0.011_SP           !STD OF TFP SHOCK INNOVATIONS
REAL(SP), PARAMETER:: MYBETA =0.9966_SP      !SUBJECTIVE DISCOUNT FACTOR
REAL(SP), PARAMETER:: MYDELTA =0.0067_SP                 !DEPRECIATION RATE
REAL(SP) :: ROS, RON, ROJ                ! ELASTICITY OF SUBS PARAMETER= (1-RO)^(-1)
REAL(SP) :: THETAS, THETAN, THETAJ
REAL(SP), PARAMETER:: LAMDA=0.2_SP              !FRACTION OF POPULATION WHO ARE STOCKHOLDERS
REAL(SP), PARAMETER:: ALFA= 0.30_SP                  !CAPITAL SHARE OF OUTPUT
REAL(SP):: WMAXN, WMAXS
REAL(SP), PARAMETER:: KSI = 0.4_SP               ! ELASTICITY OF ADJUSTMENT COSTS..
REAL(DP) :: MEANR, BMINRA, WMINRA, WMAXRA, MEANLABSUP


 ! LAW OF MOTION FOR WEALTH... ONLY FOR INITIALIZATION 
 REAL, DIMENSION (ZNUM) :: W1
 REAL, DIMENSION (ZNUM) :: W2
 REAL, DIMENSION (ZNUM) :: W3

 INTEGER :: COUNTHMAX, ITERVAL_GLOBS, ITERVAL_GLOBN
 REAL(DP), DIMENSION (WNUM)  :: WEALTHN, WEALTHS, WEALTHRA        !GRIDS FOR INDIVIDUAL WEALTH
 REAL(DP), DIMENSION (GNUM) :: GAMMA                 ! GRID IN "B" DIRECTION 
 REAL(DP), DIMENSION (KNUM) :: CAPITAL                          !GRID FOR AGGREGATE CAPITAL
 REAL(DP), DIMENSION (ZNUM):: ZGRID                                 !GRID FOR AGGREGATE SHOCK
 REAL(DP):: INCWEALTHS, INCWEALTHN, INCCAPITAL, INCGAMMA,STMIN
 REAL(DP):: GMIN, GMAX, MEANZ

! MATRICES THAT HOLD AGGREGATE FUNCTIONS.. THOSE ENDING WITH "0" ARE INITIAL VALUES
 REAL(DP), DIMENSION (KNUM,ZNUM) :: WAGE
 REAL(DP), DIMENSION (KNUM,GNUM,ZNUM) :: PBOND, PSTOCK, DIVD, INVEST, CAPITAL_SPREAD
 REAL(DP), DIMENSION (KNUM,GNUM,ZNUM) :: CAPITAL_NEXT
 REAL(DP), DIMENSION (KNUM,GNUM,ZNUM) :: GAM_NEXT,GAM_NEXT0, CAPITAL_NEXT0
 REAL(DP), DIMENSION (KNUM,GNUM,ZNUM,ZNUM) :: INTEREST_NEXT0
 REAL(DP), DIMENSION(KNUM,ZNUM,ZNUM)::  WAGE_NEXT
 REAL(DP), DIMENSION (KNUM,GNUM,ZNUM,ZNUM) :: PSTOCK_NEXT, DIVD_NEXT, INVEST_NEXT
 REAL(DP), DIMENSION (KNUM, ZNUM) :: WAGE0, INTEREST0
 REAL(DP), DIMENSION (KNUM,ZNUM) :: CAPITAL_NEXTRAL
 REAL, DIMENSION (ZNUM,ZNUM) :: PROBZ



END MODULE
!===========================================================================================
!===========================================================================================
!===========================================================================================
!===========================================================================================
!===========================================================================================
!===========================================================================================
!===========================================================================================


MODULE MY_PROCSHAB


USE MYPARAMSHAB
IMPLICIT NONE

CONTAINS

!----------------------------------------------------------

SUBROUTINE MYECHO_2(MYFILE2, FILENAME2)
IMPLICIT NONE

!DUMMY ARGUMENTS
REAL(DP), DIMENSION(:,:), INTENT(IN):: MYFILE2
CHARACTER(LEN =*), INTENT(IN) :: FILENAME2

!LOCAL
INTEGER, DIMENSION(2) :: FILEDIM
INTEGER:: I,J

OPEN( UNIT=11, FILE=FILENAME2, STATUS='REPLACE', ACTION = 'WRITE')

FILEDIM= SHAPE(MYFILE2)
IF (FILEDIM(2)>100) THEN
  WRITE (*,*) "ERROR THE SECOND DIMENSION OF FILE >100, FORMAT STATEMENT CURRENTLY USES CANNOT HANDLE THIS SIZE"
END IF

DO I=1,FILEDIM(1)
        WRITE(11,100) (MYFILE2(I,J), J=1,FILEDIM(2))
END DO

CLOSE(UNIT=11)

100 FORMAT(1X,100(3X,F20.10))

END SUBROUTINE  MYECHO_2

!-----------------------------------------------------------------
SUBROUTINE MYECHO_3(MYFILE3, FILENAME3)
IMPLICIT NONE
!!!!!!  NOTE: THIS CODE HAS A DIFFERENT CONVENTION THAN THE 4 DIMENSIONAL CODE  BELOW...
!!!!!!  THE CODE BELOW OUTPUTS THE SECOND DIMENSION OF THE ORIGINAL MATRIX TO THE SECOND DIMENSION
!!!!!!  (THAT IS THE X-AXIS) OF THE OUTPUT 2 DIMENSIONAL MATRIX.. HOWEVER, THE CURRENT CODE
!!!!!!  OUTPUTS THE FIRST DIMENSION OF THE ORIGINAL MATRIX TO THE X-AXIS OF THE OUTPUT MARIX
!!!!!!  THIS IS DONES FOR BACKWARD COMPATIBILITY WITH OLD CODE... SO THAT 'CAPITAL' ALWSAYS APPEARS
!!!!!!  AS THE SECOND DIMENSION WHEN USED IN MATLAB

!DUMMY ARGUMENTS
REAL(DP), DIMENSION(:,:,:), INTENT(IN):: MYFILE3
CHARACTER(LEN =*), INTENT(IN) :: FILENAME3

!LOCAL
INTEGER, DIMENSION(3) :: FILEDIM
INTEGER:: I,J,K

OPEN( UNIT=11, FILE=FILENAME3, STATUS='REPLACE', ACTION = 'WRITE')

FILEDIM= SHAPE(MYFILE3)
IF (FILEDIM(2)>100) THEN
  WRITE (*,*) "ERROR THE SECOND DIMENSION OF FILE >100, FORMAT STATEMENT CURRENTLY USES CANNOT HANDLE THIS SIZE"
END IF

WRITE (*,*) "FILEDIME IS", FILEDIM

DO K=1,FILEDIM(3)
   DO J=1,FILEDIM(2)

        WRITE(11,100) (MYFILE3(I,J,K), I=1,FILEDIM(1))

   END DO
END DO

CLOSE(UNIT=11)

100 FORMAT(1X,100(3X,F20.10))



END SUBROUTINE  MYECHO_3

!-------------------------------------------------------

SUBROUTINE MYECHO_4(MYFILE4, FILENAME4)
IMPLICIT NONE

!DUMMY ARGUMENTS
REAL(DP), DIMENSION(:,:,:,:), INTENT(IN):: MYFILE4
CHARACTER(LEN =*), INTENT(IN) :: FILENAME4

!LOCAL
INTEGER, DIMENSION(4) :: FILEDIM
INTEGER:: I,J,K,M

OPEN( UNIT=11, FILE=FILENAME4, STATUS='REPLACE', ACTION = 'WRITE')

FILEDIM= SHAPE(MYFILE4)
IF (FILEDIM(2)>200) THEN
  WRITE (*,*) "ERROR THE SECOND DIMENSION OF FILE >200, FORMAT STATEMENT CURRENTLY USES CANNOT HANDLE THIS SIZE"
END IF

WRITE (*,*) "FILEDIME IS", FILEDIM

DO K=1,FILEDIM(4)
  DO M=1,FILEDIM(3)
   DO I=1,FILEDIM(1)

        WRITE(11,100) (MYFILE4(I,J,M,K), J=1,FILEDIM(2))

    END DO
   END DO
END DO

CLOSE(UNIT=11)

100 FORMAT(1X,100(3X,F20.10))



END SUBROUTINE  MYECHO_4
!-----------------------------------------------------------


SUBROUTINE INITIALIZER()
IMPLICIT NONE

!LOCAL VARIABLES...
REAL(DP), DIMENSION (WNUM) :: SQRT_WEALTHS, SQRT_WEALTHN
REAL(DP) ::  SQRT_WMINS, SQRT_WMINN, SQRT_WMAXN, SQRT_WMAXS, KDIFF
REAL(DP), DIMENSION (GNUM) :: CHEBG
REAL(DP), DIMENSION (ZNUM) :: KSTAR, A1, B1
INTEGER(I4B):: I,L,LL,J,GAMMANOW,ZNOW

OPEN( UNIT=27, FILE='PROBZ.DAT', STATUS='OLD', ACTION = 'READ')
READ (27,*) ((PROBZ(I,J), J=1,ZNUM), I=1,ZNUM)
CLOSE(UNIT=27);

WRITE (*,*) 'MY BETA IS =',MYBETA
WRITE (*,*) 'HERE IS KSI=', KSI


WRITE (*,*) '----------------------------------------------------------------------------'
WRITE (*,*) 'LAMDA IS = ', LAMDA, ',     ALFA IS =  ', ALFA
WRITE (*,*) 'EIS_S AND EIS_N ARE', (ONE-ROS)**(-1),  (ONE-RON)**(-1)
WRITE (*,*) 'RISK AVERSION PARAMETERS, THETAS AND THETA_N ARE', (ONE-THETAS), (ONE-THETAN)
WRITE (*,*) '----------------------------------------------------------------------------'
WRITE (*,*) 'HERE IS Z: '
WRITE(*,120) ZGRID
WRITE (*,*) '----------------------------------------------------------------------------'
WRITE (*,*) 'THE PROBABILITY TRANSITION MATRIX IS:'
WRITE (*,120)  PROBZ
WRITE (*,*) '----------------------------------------------------------------------------'


!---- CAPITAL
DO I=1,ZNUM
       KSTAR(I) = (((ONE/MYBETA)-ONE+MYDELTA)/(ALFA*ZGRID(I)))**(ONE/(ALFA-ONE))
END DO

KDIFF=KSTAR(ZNUM)-KSTAR(1)
KMIN=KSTAR(1)-(KDIFF/2.0)
KMAX=KSTAR(ZNUM)+(KDIFF/2.0)
INCCAPITAL = (KMAX -KMIN)/(KNUM -ONE)
CAPITAL= (/ (KMIN + (I-1)* INCCAPITAL, I=1,KNUM) /)

IF (KSTAR(ZNUM)>MAXVAL(CAPITAL)) THEN
    WRITE (*,*) 'CAUTION: CURRENTLY CAPITAL GRID DOES NOT CONTAIN MAXIMUM STEADY STATE CAPITAL LEVEL'
    WRITE (*,*) KSTAR
    PAUSE
ELSEIF (KSTAR(1)< -MAXVAL(-CAPITAL)) THEN
    WRITE (*,*) 'ERROR CURRENTLY CAPITAL GRID DOES NOT CONTAIN MINIMUM STEADY STATE CAPITAL LEVEL'
    WRITE (*,*) KSTAR

    PAUSE
END IF

!GD=GDRATIO*(SUM(ZGRID)/SIZE(ZGRID))*((SUM(CAPITAL)/SIZE(CAPITAL))**ALFA)

FD=FDRATIO*SUM(KSTAR)/SIZE(KSTAR)

WRITE (*,*) 'FIRM LEVERAGE IS ', FD, 'AND MINIMUM DEBT OBLIGATION IS', FD*(MYBETA-ONE)
WRITE (*,*) 'MINIMUM OUTPUT NET OF WAGES IS', (ALFA)*ZGRID(1)*(CAPITAL(1)**ALFA)

PAUSE

BMINS=-BMINSRATIO*(ONE-ALFA)*(SUM(ZGRID)/SIZE(ZGRID))*((SUM(CAPITAL)/SIZE(CAPITAL))**ALFA)
BMINN=-BMINNRATIO*(ONE-ALFA)*(SUM(ZGRID)/SIZE(ZGRID))*((SUM(CAPITAL)/SIZE(CAPITAL))**ALFA)

WMINN=BMINN
WMINS=BMINS
WMAXN= 3.0_SP*(FD-LAMDA*BMINS)/(ONE-LAMDA)
WMAXS= 1.2_SP*(KMAX + FD - (ONE- LAMDA)*BMINN)/LAMDA


 !INITIALIZING THE WEALTH, CAPITAL AND GAMMA GRIDS... FIXED THROUGHOUT THE PROBLEM
 !----- INITIALZING WEALTHS
 SQRT_WMAXS= ((WMAXS-WMINS)**(ONE/POWER))
 SQRT_WMINS = 0.0_DP
 INCWEALTHS=(SQRT_WMAXS - SQRT_WMINS  )/((WNUM)-ONE)
 SQRT_WEALTHS =(/ (SQRT_WMINS  + (L-1)*INCWEALTHS, L=1,WNUM) /)
 WEALTHS= (SQRT_WEALTHS ** POWER)+ WMINS
 !----- INITIALIZING WEALTHN
 SQRT_WMAXN= ((WMAXN-WMINN) ** (ONE/POWER))
 SQRT_WMINN = 0.0_DP
 INCWEALTHN=(SQRT_WMAXN - SQRT_WMINN  )/((WNUM)-ONE)
 SQRT_WEALTHN =(/ (SQRT_WMINN  + (LL-1)*INCWEALTHN, LL=1,WNUM) /)
 WEALTHN= (SQRT_WEALTHN **POWER)+ WMINN

 WRITE (*,*) '-----------HERE IS WEALTHNS----------'
 !---- GAMMA

 !INITIALIZING GLOBAL VARIABLES GMIN AND GMAX:
 GMIN = BMINN * (ONE-LAMDA)
 GMAX = -BMINS * LAMDA +FD
 GAMMA =(/ (GMIN  + (LL-1)*((GMAX-GMIN)/(GNUM-ONE)), LL=1,GNUM) /)
 
 !DO I = 0, GNUM - 1
 !   CHEBG(I+1)=-COS(((REAL(I))/(REAL(GNUM-1)))*PI)
 !END DO
 !GAMMA= (CHEBG + 1)*((GMAX-GMIN)/2.0) + GMIN


 WRITE (*,*) '-------------------------HERE IS WEALTHS----------------------------'
 WRITE (*,120)  WEALTHS
 WRITE (*,*) '-------------------------HERE IS WEALTHN-----------------------------'
 WRITE (*,120)  WEALTHN
 WRITE (*,*) '--------------------------- CAPITAL IS--------------------------------'
 WRITE (*,120)  CAPITAL

 WRITE(*,*) '-------------------------------GAMMA IS --------------------------------'
 WRITE (*,120)  GAMMA
 112 FORMAT(1X, 4F15.8)
 120 FORMAT(1X, 10F15.8)


! INITIALIZING CAP_NEXT0 SUCH THAT THE STEADY STATE CAPITAL IS THE MIDDLE OF K GRID ====
B1 =(/ (MYBETA- 0.001*((ZNUM-1.0_SP)/2.0_SP)+ 0.001*(I-1), I=1,ZNUM) /)
A1= (ONE-B1)*LOG(KSTAR)
W1= 0.01_SP
W2= 0.0_SP
W3= 0.99_SP


CALL WAGE_SUB(CAPITAL, WAGE)
CALL INTEREST_SUB(CAPITAL, INTEREST0)
CALL CAP_NEXT0 (CAPITAL, A1, B1, CAPITAL_NEXT0)
CALL INTERESTNEXT_SUB(CAPITAL_NEXT0, INTEREST_NEXT0)
CALL GAMMA_NEXTV(CAPITAL,GAMMA,W1,W2,W3, GAM_NEXT0)
!GAM_NEXT0=GAM_NEXTTEMP(1,:,:)

OPEN( UNIT=12, FILE='WEALTHS.DAT', STATUS='REPLACE', ACTION = 'WRITE')
OPEN( UNIT=13, FILE='WEALTHN.DAT', STATUS='REPLACE', ACTION = 'WRITE')
OPEN( UNIT=14, FILE='CAPITAL.DAT', STATUS='REPLACE', ACTION = 'WRITE')
OPEN( UNIT=15, FILE='GAMMA.DAT', STATUS='REPLACE', ACTION = 'WRITE')
OPEN( UNIT=16, FILE='LAMDA.DAT', STATUS='REPLACE', ACTION = 'WRITE')

WRITE (12,114) WEALTHS
WRITE (13,114) WEALTHN
WRITE (14,114) CAPITAL
WRITE (15,114) GAMMA
WRITE (16,*) LAMDA

114 FORMAT( 1X, 200(3X,F20.10))


FORALL(GAMMANOW=1:GNUM,ZNOW=1:ZNUM)
    INVEST(:,GAMMANOW,ZNOW)=MYDELTA*CAPITAL
END FORALL

CLOSE (UNIT=12);  CLOSE (UNIT=13);  CLOSE (UNIT=14);  CLOSE (UNIT=15);  CLOSE (UNIT=16)


END SUBROUTINE INITIALIZER

!--------------------------------------

FUNCTION OUTERPROD(A,B)
REAL(DP), DIMENSION(:), INTENT(IN) :: A,B
REAL(DP), DIMENSION(SIZE(A),SIZE(B)) :: OUTERPROD
OUTERPROD = SPREAD(A,DIM=2,NCOPIES=SIZE(B)) * &
	SPREAD(B,DIM=1,NCOPIES=SIZE(A))
END FUNCTION OUTERPROD


!----------------------------------------------------------

 SUBROUTINE WAGE_SUB0(K, COMP_WAGE)

 IMPLICIT NONE

 REAL(DP), DIMENSION (KNUM), INTENT (IN) :: K                 ! CAPITAL VALUES (POSSIBLY AN ARRAY) TO CALCULATE THE FACTOR PRICES
 REAL(DP), DIMENSION (KNUM, ZNUM), INTENT (OUT) :: COMP_WAGE

 COMP_WAGE=(ONE -ALFA)* OUTERPROD((K **(ALFA)), ZGRID)

 END SUBROUTINE  WAGE_SUB0

!--------------------------------------------

 SUBROUTINE INTEREST_SUB0(K,INT_RATE)
 IMPLICIT NONE

 REAL(DP), DIMENSION (KNUM), INTENT (IN) :: K                 ! CAPITAL VALUES (POSSIBLY AN ARRAY) TO CALCULATE THE FACTOR PRICES
 REAL(DP), DIMENSION (KNUM,ZNUM), INTENT (OUT) :: INT_RATE

 INT_RATE=(ALFA)* OUTERPROD((K **(ALFA-ONE)), ZGRID) -MYDELTA

 END SUBROUTINE INTEREST_SUB0

!-----------------------------------------------


 SUBROUTINE CAP_NEXT0(K,  A,B, CAP_NEXT)
 !PURPOSE: RETURNS A [ZNUM X ZNUM X SIZE(K)] ARRAY WHICH GIVES NEXT PERIOD
 ! WEALTH LEVELS FOR ALL POSSIBLE WEALTH LEVELS TODAY AND SHOCK COMBINATIONS (ZNOW, ZNEXT)
 IMPLICIT NONE

 REAL(DP), DIMENSION (KNUM), INTENT(IN) :: K

 !WEALTH EVLOUTION PARAMS
 REAL(DP), DIMENSION (ZNUM), INTENT (IN) :: A
 REAL(DP), DIMENSION (ZNUM), INTENT(IN) :: B
 REAL(DP) , DIMENSION (KNUM,GNUM, ZNUM), INTENT(OUT) :: CAP_NEXT
 INTEGER :: I,SIZEZ,J

 SIZEZ=SIZE(ZGRID)

 DO J=1,GNUM
  DO I=1, SIZEZ
        CAP_NEXT(:,J,I) = A(I) + B(I) *LOG(K)
  END DO
  END DO

 CAP_NEXT= EXP(CAP_NEXT)

 END SUBROUTINE CAP_NEXT0


!=================================================================


 SUBROUTINE WAGE_SUB(K, COMP_WAGE)

! USE NRUTIL
 IMPLICIT NONE

 REAL(DP), DIMENSION (KNUM), INTENT (IN) :: K                 ! CAPITAL VALUES (POSSIBLY AN ARRAY) TO CALCULATE THE FACTOR PRICES
 REAL(DP), DIMENSION (KNUM,ZNUM), INTENT (OUT) :: COMP_WAGE

 COMP_WAGE=(ONE -ALFA)* OUTERPROD((K **(ALFA)), ZGRID)

 END SUBROUTINE  WAGE_SUB


!-----------------------------------------------------------


 SUBROUTINE WAGENEXT_SUB(CAPITAL_NEXT, COMP_WAGENEXT)

 IMPLICIT NONE

 REAL(DP), DIMENSION(KNUM,GNUM,ZNUM), INTENT (IN) :: CAPITAL_NEXT
 ! CAPITAL VALUES (POSSIBLY AN ARRAY) TO CALCULATE THE FACTOR PRICES
 REAL(DP), DIMENSION(KNUM,GNUM,ZNUM,ZNUM), INTENT (OUT) :: COMP_WAGENEXT
 INTEGER:: J


    DO J=1,ZNUM
        COMP_WAGENEXT(:,:,:,J) =(ONE -ALFA)* (ZGRID(J) * CAPITAL_NEXT **(ALFA))
    END DO



END SUBROUTINE  WAGENEXT_SUB

!----------------------------------------------------------------


 SUBROUTINE INTEREST_SUB(K,INT_RATE)
! USE NRUTIL
 IMPLICIT NONE

 REAL(DP), DIMENSION (KNUM), INTENT (IN) :: K                 ! CAPITAL VALUES (POSSIBLY AN ARRAY) TO CALCULATE THE FACTOR PRICES
 REAL(DP), DIMENSION (KNUM,ZNUM), INTENT (OUT) :: INT_RATE

 INT_RATE=(ALFA)* OUTERPROD((K **(ALFA-ONE)), ZGRID) -MYDELTA

 END SUBROUTINE INTEREST_SUB

!-----------------------------------------------


 SUBROUTINE INTERESTNEXT_SUB(CAPITAL_NEXT, INT_RATENEXT)
 IMPLICIT NONE

 REAL(DP), DIMENSION (KNUM,GNUM,ZNUM), INTENT (IN) :: CAPITAL_NEXT
 REAL(DP), DIMENSION (KNUM,GNUM,ZNUM,ZNUM), INTENT (OUT) :: INT_RATENEXT
 INTEGER:: I

 DO I=1,ZNUM
          INT_RATENEXT(:,:,:,I) =(ALFA)* (ZGRID(I) * CAPITAL_NEXT **(ALFA- ONE)) - MYDELTA
 END DO

END SUBROUTINE  INTERESTNEXT_SUB

!--------------------------------------------------


 SUBROUTINE GAMMA_NEXTV(K,GAM,A,B,C, GAMMA_NEXT)
 IMPLICIT NONE

 REAL(DP), DIMENSION (KNUM), INTENT(IN) :: K
 REAL(DP), DIMENSION (GNUM), INTENT(IN) :: GAM


 !WEALTH EVLOUTION PARAMS
 REAL, DIMENSION (ZNUM), INTENT (IN) :: A,B,C
 REAL(DP), DIMENSION (KNUM,GNUM,ZNUM), INTENT(OUT) :: GAMMA_NEXT

 !LOCAL
 REAL(DP), DIMENSION(KNUM, GNUM) :: KVEC, GAMVEC
 INTEGER :: I

 KVEC=SPREAD(K,2,GNUM)
 GAMVEC=SPREAD(GAM,1,KNUM)


 OUTER: DO I=1, ZNUM
          GAMMA_NEXT(:,:,I) = A(I) + B(I) *LOG(KVEC) + C(I)* (GAMVEC)
       END DO  OUTER


 END SUBROUTINE GAMMA_NEXTV


!------------------------------------------------------

 SUBROUTINE MYSPLINT3HAB(XA,YA,Y2A,X, XGUESS, Y, YP, YDP)
 USE NRTYPE
 IMPLICIT NONE
 REAL(DP), DIMENSION(:), INTENT(IN) :: XA,YA,Y2A
 REAL(DP), INTENT(IN) :: X
 INTEGER(I4B), INTENT(IN) :: XGUESS  !INITIAL GUESS FOR "MYHUNT"
 REAL(DP), INTENT(OUT), OPTIONAL:: Y
 REAL(DP), INTENT(OUT), OPTIONAL:: YP
 REAL(DP), INTENT(OUT), OPTIONAL:: YDP
 INTEGER(I4B) :: KHI,KLO, INDX
 REAL(DP) :: A,B,H
 INDX=XGUESS
 CALL MYHUNT(XA,X,INDX)
 IF (INDX>=SIZE(XA)) THEN
     INDX=SIZE(XA)-1
    ! WRITE(*,*) 'CAUTION, EXTRAPOLATING BEYOND HIGHEST GRID POINT!'
   !  WRITE(*,*) 'DISTANCE FROM FINAL GRID POINT IS',(X-XA(SIZE(XA)))/(XA(SIZE(XA))-XA(SIZE(XA)-1))
 ELSEIF	(INDX==0) THEN
     INDX=1
    ! WRITE(*,*) 'CAUTION, EXTRAPOLATING BEYOND LOWEST GRID POINT!'
    ! WRITE(*,*) 'DISTANCE FROM FIRST GRID POINT IS', (X-XA(1))/(XA(2)-XA(1))
 END IF
 KLO=INDX
 KHI=KLO+1
 H=XA(KHI)-XA(KLO)


 IF (H == 0.0) THEN
    WRITE(*,*) 'BAD XA INPUT IN SPLINT'
    PAUSE
 END IF

 A=(XA(KHI)-X)/H
 B=(X-XA(KLO))/H
 IF (PRESENT(Y)) THEN
 Y=A*YA(KLO)+B*YA(KHI)+((A**3-A)*Y2A(KLO)+(B**3-B)*Y2A(KHI))*(H**2)/6.0_SP
 END IF
 IF (PRESENT(YP)) THEN
 YP=(YA(KHI)-YA(KLO))/H -((3.0D+00*(A**2)-ONE)/6.0_SP)*H*Y2A(KLO) + ((3.0D+00*(B**2)-ONE)/6.0_SP)*H*Y2A(KHI)
 END IF
 IF (PRESENT(YDP)) THEN
 YDP=A*Y2A(KLO) + B*Y2A(KHI)
 END IF

 END SUBROUTINE MYSPLINT3HAB

 !-----------------------------------------------------

 SUBROUTINE MYSPLINT3HABV(XA,YA,Y2A,X, XGUESS, Y, YP, YDP)
 USE NRTYPE
 IMPLICIT NONE

 REAL(DP), DIMENSION(:), INTENT(IN) :: XA
 REAL(DP), DIMENSION(:,:), INTENT(IN) :: YA, Y2A
 REAL(DP), INTENT(IN) :: X
 INTEGER(I4B), INTENT(IN) :: XGUESS  !INITIAL GUESS FOR "MYHUNT"
 REAL(DP), DIMENSION(WNUM), INTENT(OUT), OPTIONAL:: Y
 REAL(DP), DIMENSION(WNUM), INTENT(OUT), OPTIONAL:: YP
 REAL(DP), DIMENSION(WNUM), INTENT(OUT), OPTIONAL:: YDP
 INTEGER(I4B) :: KHI,KLO, INDX
 REAL(DP) :: A,B,H
 INDX=XGUESS
 CALL MYHUNT(XA,X,INDX)
 IF (INDX>=SIZE(XA)) THEN
    INDX=SIZE(XA)-1
  !  WRITE(*,*) 'CAUTION, EXTRAPOLATING BEYOND HIGHEST GRID POINT!'
  !  WRITE(*,*) 'DISTANCE FROM FINAL GRID POPINT IS', (X-XA(SIZE(XA)))/(XA(SIZE(XA))-XA(SIZE(XA)-1))
  !  PAUSE
 ELSEIF	(INDX<1) THEN
    INDX=1
 END IF

 KLO=INDX
 KHI=KLO+1
 H=XA(KHI)-XA(KLO)

 IF (H == 0.0) THEN
    WRITE(*,*) 'BAD XA INPUT IN SPLINT'
    PAUSE
 END IF

 A=(XA(KHI)-X)/H
 B=(X-XA(KLO))/H
 IF (PRESENT(Y)) THEN
 Y=A*YA(:,KLO)+B*YA(:,KHI)+((A**3-A)*Y2A(:,KLO)+(B**3-B)*Y2A(:,KHI))*(H**2)/6.0_SP
 END IF
 IF (PRESENT(YP)) THEN
 YP=(YA(:,KHI)-YA(:,KLO))/H -((3.0D+00*(A**2)-ONE)/6.0_SP)*H*Y2A(:,KLO) + ((3.0D+00*(B**2)-ONE)/6.0_SP)*H*Y2A(:,KHI)
 END IF
 IF (PRESENT(YDP)) THEN
 YDP=A*Y2A(:,KLO) + B*Y2A(:,KHI)
 END IF

 END SUBROUTINE MYSPLINT3HABV



!----------------------------------------------------------

SUBROUTINE MYHUNT(XX,X,JLO)
USE NRTYPE
IMPLICIT NONE
INTEGER(I4B), INTENT(INOUT) :: JLO
REAL(DP), INTENT(IN) :: X
REAL(DP), DIMENSION(:), INTENT(IN) :: XX
INTEGER(I4B) :: N,INC,JHI,JM
LOGICAL :: ASCND
N=SIZE(XX)
ASCND = (XX(N) >= XX(1))
IF (JLO <= 0 .OR. JLO > N) THEN
JLO=0
JHI=N+1
ELSE
INC=1
IF (X >= XX(JLO) .EQV. ASCND) THEN
	DO
		JHI=JLO+INC
		IF (JHI > N) THEN
			JHI=N+1
			EXIT
		ELSE
			IF (X < XX(JHI) .EQV. ASCND) EXIT
			JLO=JHI
			INC=INC+INC
		END IF
	END DO
ELSE
	JHI=JLO
	DO
		JLO=JHI-INC
		IF (JLO < 1) THEN
			JLO=0
			EXIT
		ELSE
			IF (X >= XX(JLO) .EQV. ASCND) EXIT
			JHI=JLO
			INC=INC+INC
		END IF
	END DO
END IF
END IF
DO
IF (JHI-JLO <= 1) THEN
	IF (X == XX(N)) JLO=N-1
	IF (X == XX(1)) JLO=1
	EXIT
ELSE
	JM=(JHI+JLO)/2
	IF (X >= XX(JM) .EQV. ASCND) THEN
		JLO=JM
	ELSE
		JHI=JM
	END IF
END IF
END DO
END SUBROUTINE MYHUNT

!----------------------------------------------------------
 SUBROUTINE INTERP2D(VALUEFUN, VALU )
 IMPLICIT NONE

REAL(DP), DIMENSION(WNUM, KNUM, GNUM, ZNUM), INTENT(IN) :: VALUEFUN
REAL(DP), DIMENSION(WNUM, KNUM, GNUM, ZNUM,ZNUM), INTENT(OUT) :: VALU


!LOCAL
INTEGER :: ZNEXT, GAMMANEXT, J, ZNOW, GAMMANOW, KNOW
REAL(DP), DIMENSION(WNUM, KNUM, GNUM, ZNUM,ZNUM) :: VALU_IN
REAL(DP), DIMENSION(WNUM, KNUM,GNUM, ZNUM, GNUM, ZNUM):: VALUINT
REAL(DP), DIMENSION(WNUM, KNUM) :: COEFF2A
REAL(DP), DIMENSION(WNUM, GNUM):: COEFF2AG
REAL(DP), DIMENSION(WNUM):: DUMMYARRW


DUMMYARRW=1

 !NOW INTERPOLATING VALUE AT NEXT PERIOD'S K AND GAMMA
   LOOP1: DO ZNEXT=1,ZNUM
      LOOP2: DO GAMMANEXT=1,GNUM

              CALL MYSPLIE2(DUMMYARRW, CAPITAL, VALUEFUN (:,:, GAMMANEXT, ZNEXT), COEFF2A)
              LOOP3: DO J=1,KNUM
                    LOOP4: DO ZNOW=1,ZNUM
                       LOOP5: DO GAMMANOW=1, GNUM


                       CALL  MYSPLINT3HABV(CAPITAL, VALUEFUN (:,:, GAMMANEXT, ZNEXT), COEFF2A,&
                                      CAPITAL_NEXT(J, GAMMANOW,ZNOW), J , &
                                      Y= VALUINT(:,J,GAMMANOW, ZNOW, GAMMANEXT, ZNEXT))

             !THIS STEP COMPUTES THE SPLINE INTERPOLATION IN THE CAPITAL DIRECTION
			 !FOR NEXT PERIOD'S CAPITAL VALUES, BUT FOR ALL IND.WEALTH LEVELS AT ONCE
			 ! **** VALUINT_H IS THE VALUE FUNCTION INTERPOLATED AT NEXT PERIOD'S CAPITAL
			 ! FOR GRID POINTS OF GAMMA.. SO GAMMA DIRECTION NOT INTERPOLATED YET

                             END DO LOOP5
                          END DO LOOP4
                     END DO LOOP3
           END DO LOOP2

	   !-------------------------INTERPOLATING IN THE GAMMA DIRECTION------------

           LOOP8: DO KNOW=1,KNUM
              LOOP9: DO ZNOW=1,ZNUM
                 LOOP10: DO GAMMANOW=1,GNUM

		        !WRITE(*,*) KNOW, GAMMANOW, ZNOW, ZNEXT
		        CALL MYSPLIE2(DUMMYARRW, GAMMA, VALUINT(:,KNOW,GAMMANOW, ZNOW, :, ZNEXT), COEFF2AG)

			CALL MYSPLINT3HABV(GAMMA, VALUINT(:,KNOW, GAMMANOW, ZNOW,:, ZNEXT), COEFF2AG, &
			                 GAM_NEXT(KNOW,GAMMANOW, ZNOW), GAMMANOW,&
					 Y=VALU_IN(:,KNOW,GAMMANOW,ZNOW,ZNEXT))

                          END DO LOOP10
                   END DO LOOP9
              END DO LOOP8

END DO LOOP1

VALU=VALU_IN
END SUBROUTINE INTERP2D


!=======================================================================

SUBROUTINE INTERPGEN2D( X_INPUT, X_INTERPOL )
 IMPLICIT NONE

REAL(DP), DIMENSION(KNUM, GNUM, ZNUM), INTENT(IN) :: X_INPUT
REAL(DP), DIMENSION(KNUM, GNUM, ZNUM,ZNUM), INTENT(OUT) :: X_INTERPOL


!LOCAL
INTEGER :: ZNEXT, GAMMANEXT, J, ZNOW, GAMMANOW, KNOW
REAL(DP), DIMENSION(KNUM, GNUM, ZNUM,ZNUM) :: X_INTERPOL_LOCAL
REAL(DP), DIMENSION(KNUM,GNUM, ZNUM, GNUM, ZNUM):: X_INTERMEDIATE
REAL(DP), DIMENSION(KNUM) :: COEFFA
REAL(DP), DIMENSION(GNUM):: COEFFAG
REAL(DP), DIMENSION(WNUM):: DUMMYARRW


DUMMYARRW=1

 !NOW INTERPOLATING VALUE AT NEXT PERIOD'S K AND GAMMA
   LOOP1: DO ZNEXT=1,ZNUM
      LOOP2: DO GAMMANEXT=1,GNUM

              CALL MYSPLINE(CAPITAL, X_INPUT (:, GAMMANEXT, ZNEXT),1.0E30_SP,1.0E30_SP, COEFFA)
              LOOP3: DO J=1,KNUM
                    LOOP4: DO ZNOW=1,ZNUM
                       LOOP5: DO GAMMANOW=1, GNUM

                       CALL  MYSPLINT3HAB(CAPITAL, X_INPUT (:, GAMMANEXT, ZNEXT), COEFFA,&
                                      CAPITAL_NEXT(J, GAMMANOW,ZNOW), J , &
                                      Y= X_INTERMEDIATE(J,GAMMANOW, ZNOW, GAMMANEXT, ZNEXT))

             !THIS STEP COMPUTES THE SPLINE INTERPOLATION IN THE CAPITAL DIRECTION
			 !FOR NEXT PERIOD'S CAPITAL VALUES, BUT FOR ALL IND.WEALTH LEVELS AT ONCE
			 ! **** VALUINT_H IS THE VALUE FUNCTION INTERPOLATED AT NEXT PERIOD'S CAPITAL
			 ! FOR GRID POINTS OF GAMMA.. SO GAMMA DIRECTION NOT INTERPOLATED YET

                             END DO LOOP5
                          END DO LOOP4
                     END DO LOOP3
           END DO LOOP2

	   !-------------------------INTERPOLATING IN THE GAMMA DIRECTION------------

           LOOP8: DO KNOW=1,KNUM
              LOOP9: DO ZNOW=1,ZNUM
                 LOOP10: DO GAMMANOW=1,GNUM

		        !WRITE(*,*) KNOW, GAMMANOW, ZNOW, ZNEXT
		        CALL MYSPLINE(GAMMA, X_INTERMEDIATE(KNOW,GAMMANOW, ZNOW, :, ZNEXT), 1.0E30_SP,1.0E30_SP,COEFFAG)

			CALL MYSPLINT3HAB(GAMMA, X_INTERMEDIATE(KNOW, GAMMANOW, ZNOW,:, ZNEXT), COEFFAG, &
			                 GAM_NEXT(KNOW,GAMMANOW, ZNOW), GAMMANOW,&
					 Y=X_INTERPOL_LOCAL(KNOW,GAMMANOW,ZNOW,ZNEXT))

                          END DO LOOP10
                   END DO LOOP9
              END DO LOOP8

END DO LOOP1

X_INTERPOL = X_INTERPOL_LOCAL
END SUBROUTINE INTERPGEN2D

!===============================================================================================
FUNCTION HOWARD(BOND_H, STOCK_H, VALUE_H, CHOICE_H, TYPE_H)
IMPLICIT NONE

REAL(DP), DIMENSION(WNUM, KNUM, GNUM, ZNUM), INTENT(IN) :: BOND_H, STOCK_H
REAL(DP), DIMENSION(WNUM, KNUM, GNUM, ZNUM, ZNUM), INTENT(IN) :: VALUE_H
INTEGER, INTENT(IN) :: CHOICE_H
CHARACTER, INTENT(IN) :: TYPE_H
REAL(DP), DIMENSION(WNUM,KNUM,GNUM,ZNUM) :: HOWARD


!LOCAL
INTEGER :: COUNTER, ZNOW,KNOW,GAMMANOW,WNOW
REAL(DP), DIMENSION(WNUM, KNUM, GNUM, ZNUM,ZNUM) :: VALU_H
REAL(DP), DIMENSION(WNUM, KNUM, GNUM, ZNUM) :: VALUEFUN_H
REAL(DP), DIMENSION(ZNUM):: DUMMYARRZ
REAL(DP), DIMENSION(WNUM,ZNUM):: COEFFV_F
REAL(DP), DIMENSION(ZNUM,WNUM):: COEFFT


DUMMYARRZ=ONE

! WRITE(*,*) 'HELLOO, WE ARE IN HOWARD NOW '
 !PAUSE
IF (CHOICE_H ==0) THEN
    VALU_H=1
ELSE
    VALU_H=VALUE_H
!    WRITE (*,*)' .. IN THE ELSEIF PART'
END IF

ITER_H: DO COUNTER=1, COUNTHMAX

      IF (TYPE_H == 'N') THEN
           A: DO KNOW=1,KNUM
             B: DO ZNOW=1,ZNUM
              C:  DO GAMMANOW=1,GNUM
               D:   DO WNOW=1,WNUM
                    CALL MYSPLIE2(DUMMYARRZ, WEALTHN, TRANSPOSE(VALU_H(:,KNOW,GAMMANOW,ZNOW,:)), COEFFT)
                    COEFFV_F=TRANSPOSE(COEFFT)
                     VALUEFUN_H(WNOW,KNOW,GAMMANOW,ZNOW)=VALUEFUNCN(BOND_H(WNOW,KNOW,GAMMANOW,ZNOW),&
                      & VALU_H(:,KNOW,GAMMANOW,ZNOW,:),COEFFV_F,WNOW, KNOW, GAMMANOW, ZNOW)
                  END DO D
                END DO	C
              END DO   B

             END DO  A

       ELSEIF (TYPE_H == 'S') THEN
!       WRITE (*,*)' ..IN THE "S" PART'

             AA: DO KNOW=1,KNUM
                BB: DO ZNOW=1,ZNUM
                  CC:  DO GAMMANOW=1,GNUM
                    DD:   DO WNOW=1,WNUM
                          CALL MYSPLIE2(DUMMYARRZ, WEALTHS, TRANSPOSE(VALU_H(:,KNOW,GAMMANOW,ZNOW,:)), COEFFT)
                          COEFFV_F=TRANSPOSE(COEFFT)
                          VALUEFUN_H(WNOW,KNOW,GAMMANOW,ZNOW)=VALUEFUNCS(BOND_H(WNOW,KNOW,GAMMANOW,ZNOW), &
                          &STOCK_H(WNOW,KNOW,GAMMANOW,ZNOW),VALU_H(:,KNOW,GAMMANOW,ZNOW,:), COEFFV_F,WNOW, KNOW, GAMMANOW, ZNOW)
                      END DO DD
                    END DO CC
                  END DO BB
             END DO AA
      ELSEIF (TYPE_H == 'R') THEN
           DO KNOW=1,KNUM
              DO ZNOW=1,ZNUM
               DO GAMMANOW=1,GNUM
                  DO WNOW=1,WNUM
                    CALL MYSPLIE2(DUMMYARRZ, WEALTHRA, TRANSPOSE(VALU_H(:,KNOW,GAMMANOW,ZNOW,:)), COEFFT)
                    COEFFV_F=TRANSPOSE(COEFFT)
                     VALUEFUN_H(WNOW,KNOW,GAMMANOW,ZNOW)=VALUEFUNCRA(BOND_H(WNOW,KNOW,GAMMANOW,ZNOW),&
                      & VALU_H(:,KNOW,GAMMANOW,ZNOW,:),COEFFV_F,WNOW, KNOW, GAMMANOW, ZNOW)
                  END DO
                END DO
              END DO

             END DO


       ELSE
       WRITE (*,*) ' ERROR: THE TYPE OF VALUE FNCTION ITERATION MUST BE N OR S'
       END IF

     !INTERPOLATING AT NEXT PERIOD'S CAPITAL AND GAMMA, OUTPUT VALU_H IS THE INTERPOLATED MATRIX
       IF (COUNTER < COUNTHMAX) THEN
            CALL INTERP2D(VALUEFUN_H, VALU_H )
       END IF


END DO	ITER_H

HOWARD =VALUEFUN_H

END FUNCTION HOWARD


!=======================================================


 REAL(DP) FUNCTION VALUEFUNCRA(X, VALU_F ,COEFFV_RA, WNOW_F, KNOW_F, GAMMANOW_F, ZNOW_F)
 IMPLICIT NONE


! DUMMY ARGUMENTS
REAL(DP), DIMENSION(WNUM ,ZNUM), INTENT(IN) :: VALU_F, COEFFV_RA
INTEGER, INTENT(IN):: WNOW_F, KNOW_F, GAMMANOW_F, ZNOW_F
REAL(DP), INTENT(IN) :: X

!LOCAL
REAL(DP), DIMENSION(ZNUM) :: VF

INTEGER :: I, XGUESS
REAL(DP) :: EXP_VNEXTF, A,B, H, UTILF, SLOPE, WEIGHT1, CASH_F


CASH_F= WEALTHRA(WNOW_F) + WAGE(KNOW_F, ZNOW_F)

UTILF= ((CASH_F - PBOND(KNOW_F,GAMMANOW_F,ZNOW_F)*X)** ROJ)
XGUESS=WNOW_F
CALL MYHUNT(WEALTHRA, X, XGUESS)
IF (XGUESS>=WNUM)    XGUESS=WNUM-1
IF (XGUESS==0)      XGUESS=1

DO I=1,ZNUM
     H=WEALTHRA(XGUESS+1)-WEALTHRA(XGUESS)
     A=(WEALTHRA(XGUESS+1)-X)/H
     B=(X-WEALTHRA(XGUESS))/H
     VF(I)=A*VALU_F(XGUESS,I)+B*VALU_F(XGUESS+1,I)+((A**3-A)*COEFFV_RA(XGUESS,I)+(B**3-B)*COEFFV_RA(XGUESS+1,I))*(H**2)/6.0_SP

END DO

EXP_VNEXTF=SUM(PROBZ(ZNOW_F,:)*(VF(:)**THETAJ))
VALUEFUNCRA= (((ONE-MYBETA) * UTILF) + (MYBETA * (EXP_VNEXTF**(ROJ/THETAJ))))**(ONE/ROJ)

!!!!!! DO NOT CHANGE PREVIOUS LINE!
!!!!   I REMOVED THE (MINUS) IN FRONT OF THE EXPRESSION ON THE ABOVE LINE.. THIS IS CONSISTENT WITH
!!!!!  REST OF CODE...

 END FUNCTION  VALUEFUNCRA



!-----------------------------------------------


 REAL(DP) FUNCTION VALUEFUNCN(X, VALU_F ,COEFFV_N,WNOW_F, KNOW_F, GAMMANOW_F, ZNOW_F)
 IMPLICIT NONE


! DUMMY ARGUMENTS
REAL(DP), DIMENSION(WNUM ,ZNUM), INTENT(IN) :: VALU_F, COEFFV_N
INTEGER, INTENT(IN):: WNOW_F, KNOW_F, GAMMANOW_F, ZNOW_F
REAL(DP), INTENT(IN) :: X

!LOCAL
REAL(DP), DIMENSION(ZNUM) :: VF

INTEGER :: I, XGUESS
REAL(DP) :: EXP_VNEXTF, A,B, H, UTILF, SLOPE, WEIGHT1, CASH_F


CASH_F= WEALTHN(WNOW_F) + WAGE(KNOW_F, ZNOW_F)

UTILF= ((CASH_F - PBOND(KNOW_F,GAMMANOW_F,ZNOW_F)*X)** RON)
XGUESS=WNOW_F
CALL MYHUNT(WEALTHN, X, XGUESS)
IF (XGUESS>=WNUM)    XGUESS=WNUM-1
IF (XGUESS==0)      XGUESS=1

DO I=1,ZNUM
     H=WEALTHN(XGUESS+1)-WEALTHN(XGUESS)
     A=(WEALTHN(XGUESS+1)-X)/H
     B=(X-WEALTHN(XGUESS))/H
     VF(I)=A*VALU_F(XGUESS,I)+B*VALU_F(XGUESS+1,I)+((A**3-A)*COEFFV_N(XGUESS,I)+(B**3-B)*COEFFV_N(XGUESS+1,I))*(H**2)/6.0_SP

END DO

EXP_VNEXTF=SUM(PROBZ(ZNOW_F,:)*(VF(:)**THETAN))
VALUEFUNCN= (((ONE-MYBETA) * UTILF) + (MYBETA * (EXP_VNEXTF**(RON/THETAN))))**(ONE/RON)

!!!!!! DO NOT CHANGE PREVIOUS LINE!
!!!!   I REMOVED THE (MINUS) IN FRONT OF THE EXPRESSION ON THE ABOVE LINE.. THIS IS CONSISTENT WITH
!!!!!  REST OF CODE...

 END FUNCTION  VALUEFUNCN

 !------------------------------------------------

REAL(DP) FUNCTION VALUEFUNCS(B,S, VALU_F ,COEFFV_F, WNOW_F, KNOW_F, GAMMANOW_F, ZNOW_F)
IMPLICIT NONE

! DUMMY ARGUMENTS
REAL(DP), DIMENSION(WNUM ,ZNUM), INTENT(IN) :: VALU_F, COEFFV_F
INTEGER, INTENT(IN):: WNOW_F, KNOW_F, GAMMANOW_F, ZNOW_F
REAL(DP), INTENT(IN) :: S,B

!LOCAL
REAL(DP), DIMENSION(ZNUM) :: VF, WEALTHNEXT_F, PSTOCK_NEXT_F, DIVD_NEXT_F
REAL(DP) :: EXP_VNEXTF,H,A1,A2
REAL(DP) :: UTILF, SLOPE, WEIGHT1
REAL(DP) :: CASH_F
INTEGER, DIMENSION(ZNUM):: INDXX
INTEGER :: I, XGUESS

 PSTOCK_NEXT_F=PSTOCK_NEXT(KNOW_F,GAMMANOW_F,ZNOW_F,:)
 DIVD_NEXT_F=DIVD_NEXT(KNOW_F,GAMMANOW_F,ZNOW_F,:)


 EXP_VNEXTF=0.0_DP
 CASH_F= WEALTHS(WNOW_F) + WAGE(KNOW_F, ZNOW_F)
 UTILF=  ((CASH_F -PSTOCK(KNOW_F,GAMMANOW_F,ZNOW_F)*S -PBOND(KNOW_F, GAMMANOW_F, ZNOW_F)* B) **ROS)
 WEALTHNEXT_F = (PSTOCK_NEXT_F + DIVD_NEXT_F) * S + B

 XGUESS=WNOW_F

DO I=1,ZNUM
    CALL MYHUNT(WEALTHS, WEALTHNEXT_F(I), XGUESS)
    INDXX(I)=XGUESS
END DO
WHERE (INDXX>=WNUM)    INDXX=WNUM-1
WHERE (INDXX==0)        INDXX=1

DO I=1,ZNUM
 H=WEALTHS(INDXX(I)+1)-WEALTHS(INDXX(I))
 A1=(WEALTHS(INDXX(I)+1)-WEALTHNEXT_F(I))/H
 A2=(WEALTHNEXT_F(I)-WEALTHS(INDXX(I)))/H
VF(I)=A1*VALU_F(INDXX(I),I)+A2*VALU_F(INDXX(I)+1,I)+((A1**3-A1)*COEFFV_F(INDXX(I),I)+(A2**3-A2)*&
& COEFFV_F(INDXX(I)+1,I))*(H**2)/6.0_SP
END DO

EXP_VNEXTF=SUM(PROBZ(ZNOW_F,:)*(VF(:)**THETAS))
VALUEFUNCS= (((ONE-MYBETA) * UTILF) + (MYBETA * (EXP_VNEXTF**(ROS/THETAS))))**(ONE/ROS)
!!!!!! DO NOT CHANGE PREVIOUS LINE!
!!!!   I REMOVED THE (MINUS) IN FRONT OF THE EXPRESSION ON THE ABOVE LINE.. THIS IS CONSISTENT WITH
!!!!!  REST OF CODE...


 END FUNCTION  VALUEFUNCS


 !--------------------------------------------


 	SUBROUTINE MYSPLINE(X,Y,YP1,YPN,Y2)
	USE NRTYPE
      	IMPLICIT NONE
	REAL(DP), DIMENSION(:), INTENT(IN) :: X,Y
	REAL(SP), INTENT(IN) :: YP1,YPN
	REAL(DP), DIMENSION(:), INTENT(OUT) :: Y2
	INTEGER(I4B) :: N
	REAL(DP), DIMENSION(SIZE(X)) :: A,B,C,R

        IF (SIZE(X) == SIZE(Y) .AND. SIZE(Y) == SIZE(Y2)) THEN
		N= SIZE(X)
	ELSE
		WRITE (*,*) 'NRERROR: AN ASSERT_EQ FAILED WITH THIS TAG: MYSPLINE'
                WRITE (*,*)   SIZE(X)
                WRITE (*,*)   SIZE(Y)
                WRITE (*,*)   SIZE(Y2)
                PAUSE


	END IF
     	C(1:N-1)=X(2:N)-X(1:N-1)
	R(1:N-1)=6.0_SP*((Y(2:N)-Y(1:N-1))/C(1:N-1))
	R(2:N-1)=R(2:N-1)-R(1:N-2)
	A(2:N-1)=C(1:N-2)
	B(2:N-1)=2.0_SP*(C(2:N-1)+A(2:N-1))
	B(1)=1.0
	B(N)=1.0
	IF (YP1 > 0.99E30_SP) THEN
		R(1)=0.0
		C(1)=0.0
	ELSE
		R(1)=(3.0_SP/(X(2)-X(1)))*((Y(2)-Y(1))/(X(2)-X(1))-YP1)
		C(1)=0.5
	END IF
	IF (YPN > 0.99E30_SP) THEN
		R(N)=0.0
		A(N)=0.0
	ELSE
		R(N)=(-3.0_SP/(X(N)-X(N-1)))*((Y(N)-Y(N-1))/(X(N)-X(N-1))-YPN)
		A(N)=0.5
	END IF
	IF (N<4) THEN
           CALL MYTRIDAG_SER(A(2:N),B(1:N),C(1:N-1),R(1:N),Y2(1:N))
	ELSE
           CALL MYTRIDAG_PAR(A(2:N),B(1:N),C(1:N-1),R(1:N),Y2(1:N))
	END IF

	END SUBROUTINE MYSPLINE


!-----------------------------------------------------

	SUBROUTINE MYSPLIE2(X1A,X2A,YA,Y2A)
	USE NRTYPE
	IMPLICIT NONE
	REAL(DP), DIMENSION(:), INTENT(IN) :: X1A,X2A
	REAL(DP), DIMENSION(:,:), INTENT(IN) :: YA
	REAL(DP), DIMENSION(:,:), INTENT(OUT) :: Y2A
	INTEGER(I4B) :: J,M, NDUM

        IF (SIZE(X1A) == SIZE(YA,1) .AND. SIZE(YA,1) == SIZE(Y2A,1)) THEN
		M= SIZE(X1A)
	ELSE
		WRITE (*,*) 'NRERROR: AN ASSERT_EQ FAILED WITH THIS TAG: MYSPLIE2:1'
	END IF
        IF (SIZE(X2A) == SIZE(YA,2) .AND. SIZE(YA,2) == SIZE(Y2A,2)) THEN
		NDUM= SIZE(X2A)
	ELSE
		WRITE (*,*) 'NRERROR: AN ASSERT_EQ FAILED WITH THIS TAG: MYSPLIE2:2'
	END IF

	DO J=1,M
		CALL MYSPLINE(X2A,YA(J,:),1.0E30_SP,1.0E30_SP,Y2A(J,:))
	END DO
	END SUBROUTINE MYSPLIE2


!----------------------------------------------------




 	SUBROUTINE MYTRIDAG_SER(A,B,C,R,U)
	USE NRTYPE
	IMPLICIT NONE
	REAL(DP), DIMENSION(:), INTENT(IN) :: A,B,C,R
	REAL(DP), DIMENSION(:), INTENT(OUT) :: U
	REAL(DP), DIMENSION(SIZE(B)) :: GAM
	INTEGER(I4B) :: N,J
        INTEGER(I4B), DIMENSION(5) :: VECTRIDAG
	REAL(DP) :: BET
	VECTRIDAG= (/SIZE(A)+1,SIZE(B),SIZE(C)+1,SIZE(R),SIZE(U)/)

        IF (ALL(VECTRIDAG(2:) == VECTRIDAG(1))) THEN
		N= VECTRIDAG(1)
	ELSE
		WRITE (*,*) 'NRERROR: AN ASSERT_EQ FAILED WITH THIS TAG: MYTRIDAG_SER'
	END IF
	BET=B(1)
	IF (BET == 0.0) THEN
        WRITE(*,*) 'MYTRIDAG_SER: ERROR AT CODE STAGE 1'
        END IF

	U(1)=R(1)/BET
	DO J=2,N
		GAM(J)=C(J-1)/BET
		BET=B(J)-A(J-1)*GAM(J)
		IF (BET == 0.0) THEN
		   WRITE(*,*) 'MYTRIDAG_SER: ERROR AT CODE STAGE 2'
                END IF
		U(J)=(R(J)-A(J-1)*U(J-1))/BET
	END DO
	DO J=N-1,1,-1
		U(J)=U(J)-GAM(J+1)*U(J+1)
	END DO
	END SUBROUTINE MYTRIDAG_SER

	RECURSIVE SUBROUTINE MYTRIDAG_PAR(A,B,C,R,U)
	USE NRTYPE
	!USE NR, ONLY : MYTRIDAG_SER
	IMPLICIT NONE
	REAL(DP), DIMENSION(:), INTENT(IN) :: A,B,C,R
	REAL(DP), DIMENSION(:), INTENT(OUT) :: U
	INTEGER(I4B), PARAMETER :: NPAR_TRIDAG=4
	INTEGER(I4B) :: N,N2,NM,NX
        INTEGER(I4B), DIMENSION(5) :: VECTRIDAG
	REAL(DP), DIMENSION(SIZE(B)/2) :: Y,Q,PIVA
	REAL(DP), DIMENSION(SIZE(B)/2-1) :: X,Z
	REAL(DP), DIMENSION(SIZE(A)/2) :: PIVC

	VECTRIDAG= (/SIZE(A)+1,SIZE(B),SIZE(C)+1,SIZE(R),SIZE(U)/)
        IF (ALL(VECTRIDAG(2:) == VECTRIDAG(1))) THEN
		N= VECTRIDAG(1)
	ELSE
		WRITE (*,*) 'NRERROR: AN ASSERT_EQ FAILED WITH THIS TAG: MYTRIDAG_SER'
	END IF
       	IF (N < NPAR_TRIDAG) THEN
		CALL MYTRIDAG_SER(A,B,C,R,U)
	ELSE
		IF (MAXVAL(ABS(B(1:N))) == 0.0) THEN
                WRITE (*,*) 'MYTRIDAG_PAR: POSSIBLE SINGULAR MATRIX'
                PAUSE
                END IF

		N2=SIZE(Y)
		NM=SIZE(PIVC)
		NX=SIZE(X)
		PIVA = A(1:N-1:2)/B(1:N-1:2)
		PIVC = C(2:N-1:2)/B(3:N:2)
		Y(1:NM) = B(2:N-1:2)-PIVA(1:NM)*C(1:N-2:2)-PIVC*A(2:N-1:2)
		Q(1:NM) = R(2:N-1:2)-PIVA(1:NM)*R(1:N-2:2)-PIVC*R(3:N:2)
		IF (NM < N2) THEN
			Y(N2) = B(N)-PIVA(N2)*C(N-1)
			Q(N2) = R(N)-PIVA(N2)*R(N-1)
		END IF
		X = -PIVA(2:N2)*A(2:N-2:2)
		Z = -PIVC(1:NX)*C(3:N-1:2)
		CALL MYTRIDAG_PAR(X,Y,Z,Q,U(2:N:2))
		U(1) = (R(1)-C(1)*U(2))/B(1)
		U(3:N-1:2) = (R(3:N-1:2)-A(2:N-2:2)*U(2:N-2:2) &
			-C(3:N-1:2)*U(4:N:2))/B(3:N-1:2)
		IF (NM == N2) U(N)=(R(N)-A(N-1)*U(N-1))/B(N)
	END IF
	END SUBROUTINE MYTRIDAG_PAR

 !------------------------------------------------

END MODULE




!===================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================


MODULE MY_FIRMHAB


USE MYPARAMSHAB
USE MY_PROCSHAB, ONLY : INTERPGEN2D
IMPLICIT NONE

CONTAINS

!-------------------------------------------------------
SUBROUTINE INVESTMENT_SUB(CONSS, VALUES_IN, INVEST_IN,WHTRINIT)
IMPLICIT NONE

REAL(DP), DIMENSION (:,:,:,:), INTENT(IN) :: CONSS, VALUES_IN
REAL(DP), DIMENSION(:,:,:), INTENT(OUT) ::INVEST_IN
INTEGER, INTENT(IN) :: WHTRINIT

REAL(DP), DIMENSION(KNUM, GNUM, ZNUM,ZNUM) :: MUC
REAL(DP), DIMENSION(KNUM,GNUM,ZNUM) :: OPT_INV, INVEST_LAG
REAL(DP) ::  XX, DX, Q_MIN, Q_MAX, QLOW, QHIGH, QMID,EXCESS_A, EXCESS_B, EXCESS_C, INV_MIN, INV_MAX, KKNEXT
REAL(DP) , DIMENSION(ZNUM) :: INVNEXT_IN, MUC_IN, AUXIL
REAL(DP):: OBJ1, OBJ2, OBJ3, DISCRINV

INTEGER :: KNOW, GAMMANOW, ZNOW, MAXBIS, J, COUNTJ,I,K, ITERMAX, ITER
LOGICAL:: FLAG
INTEGER, PARAMETER:: INVTOLER=1.0E-4

MAXBIS=100
ITERMAX=100

Q_MIN= 0.002_SP
Q_MAX= MYDELTA + 0.10_SP

WRITE (*,*) 'HELLO WE ARE IN INVESTMENT SUB'

CALL MARGINALUC(CONSS, VALUES_IN, MUC,WHTRINIT)

IF (SETINVEST==1) THEN
    CALL INTERPGEN2D(INVEST, INVEST_NEXT)
ELSE
    DO I=1,ZNUM
      DO J=1,ZNUM
         DO K=1,GNUM
             INVEST_NEXT(:,K,J,I)=MYDELTA*CAPITAL
         END DO
      END DO
    END DO
END IF

INV: DO ITER=1,ITERMAX
! MAIN ITERATION LOOP STARTS

  LOOP11: DO KNOW=1,KNUM
    LOOP12: DO GAMMANOW=1,GNUM
      LOOP13: DO ZNOW=1,ZNUM

       !SOLVE FOR INVESTMENT AT THIS AGG. GRID POINT -------------
         INV_MIN=CAPITAL(KNOW)*Q_MIN
         INV_MAX=CAPITAL(KNOW)*Q_MAX
         DX=INV_MAX-INV_MIN
         QLOW=INV_MIN
         QHIGH=INV_MAX

MUC_IN=MUC(KNOW,GAMMANOW,ZNOW,:)
INVNEXT_IN= INVEST_NEXT(KNOW,GAMMANOW,ZNOW,:)


XX= 0.00_DP
DO I=1,ZNUM
   XX= XX+  PROBZ(ZNOW,I)*MUC(KNOW,GAMMANOW,ZNOW,I) * ZGRID(I)
END DO


KKNEXT= ((ONE-MYDELTA) +ADJINVEST(INV_MIN, CAPITAL(KNOW)))*CAPITAL(KNOW)

OBJ1 =(ALFA*(KKNEXT**(ALFA-ONE))*XX )
OBJ2=ONE/DIFF_ADJINVEST(INV_MIN, CAPITAL(KNOW))
DO I=1,ZNUM
    AUXIL(I)=DIFF_ADJINVEST(INVNEXT_IN(I), KKNEXT)
END DO

OBJ3=0.0_SP
DO I=1,ZNUM
    OBJ3 = OBJ3+ MUC_IN(I)*PROBZ(ZNOW,I)*((ONE-MYDELTA)/AUXIL(I) -INVNEXT_IN(I)/KKNEXT + ADJINVEST(INVNEXT_IN(I), KKNEXT)/AUXIL(I))
END DO

EXCESS_A=OBJ1-OBJ2+OBJ3



KKNEXT= ((ONE-MYDELTA) +ADJINVEST(INV_MAX, CAPITAL(KNOW)))*CAPITAL(KNOW)
OBJ1 =(ALFA*(KKNEXT**(ALFA-ONE))*XX )
OBJ2=ONE/DIFF_ADJINVEST(INV_MAX, CAPITAL(KNOW))
DO I=1,ZNUM
    AUXIL(I)=DIFF_ADJINVEST(INVNEXT_IN(I), KKNEXT)
END DO

OBJ3=0.0_SP
DO I=1,ZNUM
    OBJ3 = OBJ3+ MUC_IN(I)*PROBZ(ZNOW,I)*((ONE-MYDELTA)/AUXIL(I) -INVNEXT_IN(I)/KKNEXT + ADJINVEST(INVNEXT_IN(I), KKNEXT)/AUXIL(I))
END DO

EXCESS_B=OBJ1-OBJ2+OBJ3



         IF ((EXCESS_A >0) .AND. (EXCESS_B<0)) THEN                ! LOOKING FOR A ZERO BETWEEN QLOW AND QHIGH

             J=1; FLAG=.FALSE.;
             DO WHILE ((J < MAXBIS) .AND. (FLAG == .FALSE.))

                   DX=0.5_SP * DX
                   QMID= QLOW + DX

                    KKNEXT= ((ONE-MYDELTA) +ADJINVEST(QMID, CAPITAL(KNOW)))*CAPITAL(KNOW)

                    OBJ1 =(ALFA*(KKNEXT**(ALFA-ONE))*XX )
                    OBJ2=ONE/DIFF_ADJINVEST(QMID, CAPITAL(KNOW))
                    DO I=1,ZNUM
                        AUXIL(I)=DIFF_ADJINVEST(INVNEXT_IN(I), KKNEXT)
                    END DO

                    OBJ3=0.0_SP
    DO I=1,ZNUM
    OBJ3 = OBJ3+ MUC_IN(I)*PROBZ(ZNOW,I)*((ONE-MYDELTA)/AUXIL(I) -INVNEXT_IN(I)/KKNEXT + ADJINVEST(INVNEXT_IN(I), KKNEXT)/AUXIL(I))
    END DO

                    EXCESS_C=OBJ1-OBJ2+OBJ3

                   IF (EXCESS_C > 0) THEN
                       QLOW=QMID
                   END  IF
                   IF ((ABS(EXCESS_C) < TOL_EXCESSD )) THEN
                       OPT_INV(KNOW, GAMMANOW,ZNOW)=QMID
                  !     WRITE (*,*) 'OPT INVESMENT IS', QMID
                       FLAG= .TRUE.
                   END IF
                   J=J+1
                   COUNTJ=J
             END DO

             IF (COUNTJ >=MAXBIS) THEN
                 WRITE (*,*)' NO ROOT FOUND IN', MAXBIS, 'ITERATIONS EVEN THOUGH QLOW AND QHIGH SEEMS TO BRACKET A ZERO'
                 WRITE (*,*) 'EXCESS_C IS', EXCESS_C
             END IF


             IF ((COUNTJ>=MAXBIS) .AND.  ((ABS(EXCESS_C) < MIN(5.0E-2_DP, 5000.0_DP*TOL_EXCESSD)))) THEN
                   OPT_INV(KNOW,GAMMANOW,ZNOW)= QMID
                   WRITE (*,*) 'THE WEAKER BOUNDS ARE SATISFIED AND THIS INVESTMENT VALUE IS RECORDED'
                   WRITE (*,*) 'OPT INVESMENT IS', QMID
             END IF
         ELSE
             WRITE (*,*) 'ERROR IN INVESTMENT SUB'
             WRITE (*,*)  'EXCESS A AND B ARE', EXCESS_A, EXCESS_B
             WRITE (*,*) 'ADJ AT INVMIN AND INVMAX ARE',  ADJINVEST(INV_MIN, CAPITAL(KNOW)),ADJINVEST(INV_MAX, CAPITAL(KNOW))
             WRITE (*,*)  'DERIVATIVES ARE', DIFF_ADJINVEST(INV_MIN,CAPITAL(KNOW)),DIFF_ADJINVEST(INV_MAX,CAPITAL(KNOW))
             PAUSE
         END IF

      END  DO  LOOP13
    END  DO  LOOP12
 END  DO  LOOP11

 CALL INTERPGEN2D(OPT_INV, INVEST_NEXT)
 DISCRINV=MAXVAL(ABS(OPT_INV-INVEST_LAG))
 IF (DISCRINV <INVTOLER) EXIT INV
 INVEST_LAG=OPT_INV


 END DO INV

IF (ITER>=ITERMAX) THEN
WRITE (*,*) 'NO OPTIMUM FOUND IN ',ITERMAX,'ITERATIONS.. PAUSING'
WRITE (*,*) 'HERE IS THE DISCREPANCY'
WRITE (*,*) (DISCRINV)

END IF

WRITE (*,*) 'HERE IS INVESTMENT SOLUTION:'
WRITE (*,*) OPT_INV

INVEST_IN=OPT_INV





END SUBROUTINE INVESTMENT_SUB

!---------------------------------------------------------------------


SUBROUTINE UPDATE_PSTOCK(CONSS, VALUES_IN, PSTOCKNEW, DISCR,WHTRINIT)

REAL(DP), DIMENSION(:,:,:,:), INTENT(IN):: CONSS, VALUES_IN
REAL(DP), DIMENSION(:,:,:), INTENT(OUT):: PSTOCKNEW, DISCR
INTEGER, INTENT(IN) :: WHTRINIT


!LOCAL
REAL(DP), DIMENSION(KNUM, GNUM,ZNUM,ZNUM) :: MUC, PSTOCK_NEXT_UPD, TEMP_VEC
REAL(DP), DIMENSION(KNUM, GNUM,ZNUM) :: PSTOCK_UPD
INTEGER:: T, TMAX, ZNOW, ZNEXT

CALL MARGINALUC(CONSS, VALUES_IN, MUC,WHTRINIT)


!UPDATE ON THE PRESENT VALUE EQUATION T TIMES

IF (WHTRINIT /=0) THEN
    PSTOCK_UPD =PSTOCK
    CALL INTERPGEN2D(PSTOCK_UPD, PSTOCK_NEXT_UPD)
    TMAX=25
ELSE
    PSTOCK_NEXT_UPD=0.0_DP
    PSTOCK_UPD=0.0_DP
    TMAX=50
END IF


DO T=1, TMAX

    TEMP_VEC= MUC*(DIVD_NEXT + PSTOCK_NEXT_UPD)
    PSTOCK_UPD=0.0_DP

    DO ZNOW=1,ZNUM
     DO ZNEXT=1,ZNUM
        PSTOCK_UPD(:,:,ZNOW)= PSTOCK_UPD(:,:,ZNOW) + PROBZ(ZNOW,ZNEXT)*TEMP_VEC(:,:,ZNOW,ZNEXT)
        END DO
    END DO

    WRITE (*,*) ' HERE IS PSTOCK AT', T,'ITERATION'
   ! WRITE (*,*) PSTOCK_UPD

    CALL INTERPGEN2D(PSTOCK_UPD, PSTOCK_NEXT_UPD)
END DO


IF (WHTRINIT==0) THEN
    PSTOCK_UPD=(ONE/(ONE-(MYBETA**TMAX)))*PSTOCK_UPD
END IF

WRITE (*,*) PSTOCK_UPD

DISCR = (ABS(PSTOCK-PSTOCK_UPD))

PSTOCKNEW=PSTOCK_UPD
END SUBROUTINE UPDATE_PSTOCK

!-------------------------------------------------------------

SUBROUTINE MARGINALUC(CONSS, VALUES_IN, MUC, WHTRIN)
USE MY_PROCSHAB, ONLY : MYSPLINE, MYSPLINT3HAB, INTERP2D

REAL(DP), DIMENSION(:,:,:,:), INTENT(IN):: CONSS, VALUES_IN
REAL(DP), DIMENSION(:,:,:,:), INTENT(OUT):: MUC
INTEGER, INTENT(IN) :: WHTRIN

!LOCALS
REAL(DP), DIMENSION(WNUM,KNUM,GNUM,ZNUM,ZNUM) :: CONSS_NEXT, VALUES_NEXT
REAL(DP), DIMENSION(KNUM,GNUM,ZNUM) :: CONSS_INTERPOL, AGWS, VALUES_INTERPOL,TERM1,TERM2,TERM3
REAL(DP), DIMENSION(KNUM,GNUM,ZNUM,ZNUM) :: CONSS_NEXT_INTERPOL, AGW_NEXT_S, VALUES_NEXT_INTERPOL
REAL(DP), DIMENSION(ZNUM) :: PSTOCK_NEXT_S, DIVD_NEXT_S, GAM_NEXT_S
REAL(DP), DIMENSION(WNUM):: COEFFA, COEFFB
REAL(DP) :: PSTOCK_S, DIVD_S

INTEGER :: KNOW, GAMMANOW, ZNOW,I,LL


CALL INTERP2D(CONSS, CONSS_NEXT)
CALL INTERP2D(VALUES_IN, VALUES_NEXT)



 LOOP11: DO KNOW=1,KNUM
    LOOP12: DO GAMMANOW=1,GNUM
      LOOP13: DO ZNOW=1,ZNUM

          !FIND AGGREGATE STOCKHOLDER CONSUMPTION TODAY
          IF (WHTRIN /= 0) THEN
              PSTOCK_S = PSTOCK(KNOW, GAMMANOW, ZNOW)
              DIVD_S = DIVD(KNOW, GAMMANOW, ZNOW)
              AGWS(KNOW,GAMMANOW,ZNOW)= ((PSTOCK_S + DIVD_S)* ONE  + (FD- GAMMA(GAMMANOW)))/(LAMDA)
          ELSE
              PSTOCK_S =0.0_SP
              DIVD_S = 0.0_SP
              AGWS(KNOW,GAMMANOW,ZNOW)= ((CAPITAL(KNOW)) *(ONE+INTEREST0(KNOW, ZNOW)) + (FD-GAMMA(GAMMANOW)))/(LAMDA)
          END IF


          CALL  MYSPLINE(WEALTHS, CONSS(:, KNOW, GAMMANOW, ZNOW),1.0E30_SP,1.0E30_SP, COEFFA)
          CALL  MYSPLINT3HAB(WEALTHS, CONSS (:, KNOW,GAMMANOW, ZNOW), COEFFA,&
                                      AGWS(KNOW,GAMMANOW,ZNOW), WNUM/2 , &
                                      Y= CONSS_INTERPOL(KNOW, GAMMANOW, ZNOW))

          CALL  MYSPLINE(WEALTHS, VALUES_IN(:, KNOW, GAMMANOW, ZNOW),1.0E30_SP,1.0E30_SP, COEFFB)
          CALL  MYSPLINT3HAB(WEALTHS, VALUES_IN (:, KNOW,GAMMANOW, ZNOW), COEFFB,&
                                      AGWS(KNOW,GAMMANOW,ZNOW), WNUM/2 , &
                                      Y= VALUES_INTERPOL(KNOW, GAMMANOW, ZNOW))
                                      

          !FIND AGGREGATE STOCKHOLDER CONSUMPTION TOMORROW
          IF (WHTRIN /=0) THEN
              PSTOCK_NEXT_S = PSTOCK_NEXT(KNOW, GAMMANOW, ZNOW,:)
              DIVD_NEXT_S = DIVD_NEXT(KNOW, GAMMANOW, ZNOW,:)
              GAM_NEXT_S = GAM_NEXT(KNOW,GAMMANOW, ZNOW)
              AGW_NEXT_S(KNOW,GAMMANOW,ZNOW,:)= ((PSTOCK_NEXT_S + DIVD_NEXT_S)* ONE  + (FD-GAM_NEXT_S))/(LAMDA)
          ELSE         ! IF THIS IS THE INITIALIZATION THEN USE A GUESS FUNCTION FOR NEXT PERIOD'S WEALTH
              PSTOCK_NEXT_S=0.0_SP
              DIVD_NEXT_S =0.0_SP
              GAM_NEXT_S =0.0_SP
       AGW_NEXT_S(KNOW,GAMMANOW,ZNOW,:)= ((CAPITAL_NEXT0(KNOW,GAMMANOW,ZNOW)) *(1.0_SP+ INTEREST_NEXT0(KNOW, GAMMANOW,ZNOW,:)) &
                           & +FD-GAM_NEXT0(KNOW,GAMMANOW,ZNOW))/(LAMDA)
          END IF

          DO I=1,ZNUM
              CALL  MYSPLINE(WEALTHS, CONSS_NEXT(:, KNOW, GAMMANOW, ZNOW,I),1.0E30_SP,1.0E30_SP, COEFFA)
              CALL  MYSPLINT3HAB(WEALTHS, CONSS_NEXT (:, KNOW,GAMMANOW, ZNOW,I), COEFFA,&
                                          AGW_NEXT_S(KNOW,GAMMANOW,ZNOW,I), WNUM/2 , &
                                          Y= CONSS_NEXT_INTERPOL(KNOW, GAMMANOW, ZNOW,I))

              CALL  MYSPLINE(WEALTHS, VALUES_NEXT(:, KNOW, GAMMANOW, ZNOW,I),1.0E30_SP,1.0E30_SP, COEFFB)
              CALL  MYSPLINT3HAB(WEALTHS, VALUES_NEXT (:, KNOW,GAMMANOW, ZNOW,I), COEFFB,&
                                          AGW_NEXT_S(KNOW,GAMMANOW,ZNOW,I), WNUM/2 , &
                                          Y= VALUES_NEXT_INTERPOL(KNOW, GAMMANOW, ZNOW,I))

          END DO



      END  DO  LOOP13
    END  DO  LOOP12
 END  DO  LOOP11


          WRITE (*,*) 'THE MINIMUM VALUE OF CONS IS'
          WRITE (*,120) CONSS_INTERPOL
          WRITE (*,*) 'THE MINIMUM VALUE OF CONS_NEXT IS'
          WRITE (*,120) CONSS_NEXT_INTERPOL
          !PAUSE
            WRITE (*,*) 'THE MINIMUM VALUE OF CONS IS'
          WRITE (*,120) VALUES_INTERPOL
          WRITE (*,*) 'THE MINIMUM VALUE OF CONS_NEXT IS'
          WRITE (*,120) VALUES_NEXT_INTERPOL
        !  PAUSE
          WRITE (*,*) 'HERE IS AGWS'
          WRITE (*,120) AGWS
          WRITE (*,*) 'HERE IS AGWSNEXT'
          WRITE (*,120) AGW_NEXT_S(:,:,:,1)
          WRITE (*,*) '========================================================================='

          WRITE (*,*) 'HERE IS CAPITAL_NEXT0'
          WRITE (*,120) CAPITAL_NEXT0
          WRITE (*,*) 'HERE IS GAM_NEXT0'
          WRITE (*,120) GAM_NEXT0
          WRITE (*,*) 'INTEREST_NEXT0'
          WRITE (*,120) INTEREST_NEXT0
       !  PAUSE


          IF (ANY(CONSS_INTERPOL <=0)) THEN
          WRITE (*,*) "NEGATIVE VALUE FOR CONSUMPTION IN MARGINAL_UC"
          !PAUSE

          END IF
          IF (ANY(CONSS_NEXT_INTERPOL <=0)) THEN
          WRITE (*,*) "NEGATIVE VALUE FOR NEXT PERIODS CONSUMPTION IN MARGINAL_UC"
          !PAUSE

          END IF


          IF (ANY(VALUES_INTERPOL <=0)) THEN
          WRITE (*,*) "NEGATIVE VALUE FOR VALUE IN MARGINAL_UC"
          !PAUSE

          END IF
          IF (ANY(VALUES_NEXT_INTERPOL <=0)) THEN
          WRITE (*,*) "NEGATIVE VALUE FOR NEXT PERIODS VALUE IN MARGINAL_UC"
          !PAUSE

          END IF

           120 FORMAT(1X, 5F15.8)

 DO LL=1,ZNUM
       TERM1=(MYBETA**(THETAS/ROS))*(((CONSS_NEXT_INTERPOL(:,:,:,LL)/CONSS_INTERPOL)) ** (ROS-ONE))
       TERM2= (VALUES_NEXT_INTERPOL(:,:,:,LL)/CONSS_INTERPOL)
       TERM3= (((VALUES_INTERPOL/CONSS_INTERPOL)**ROS)-(ONE-MYBETA))**(ONE/ROS)

    MUC(:,:,:,LL) =TERM1*((TERM2/TERM3)**(THETAS-ROS))

 END DO

END  SUBROUTINE MARGINALUC


!--------------------------------------

!--------------------------------------

FUNCTION ADJINVEST(INVEST_IN, KAPITAL)
IMPLICIT NONE

REAL(DP), INTENT(IN):: INVEST_IN
REAL(DP), INTENT(IN):: KAPITAL
REAL(DP) :: ADJINVEST
REAL(DP):: ADJA, ADJB, ADJC


ADJA=((MYDELTA**(ONE/KSI))/(ONE-(ONE/KSI)))
ADJB= (ONE/(ONE-KSI))*MYDELTA
ADJC= (ONE-(ONE/KSI))

ADJINVEST = ADJB + ADJA*((INVEST_IN/KAPITAL) ** ADJC)


END FUNCTION  ADJINVEST
!-----------------------------------------

FUNCTION ADJINVESTV(INVESTV_IN)
IMPLICIT NONE

REAL(DP), DIMENSION (:,:,:),INTENT(IN):: INVESTV_IN
REAL(DP), DIMENSION(KNUM,GNUM,ZNUM) :: ADJINVESTV
REAL(DP) :: ADJA, ADJB, ADJC


ADJA=((MYDELTA**(ONE/KSI))/(ONE-(ONE/KSI)))
ADJB= (ONE/(ONE-KSI))*MYDELTA
ADJC= (ONE-(ONE/KSI))

ADJINVESTV = ADJB + ADJA*((INVESTV_IN/CAPITAL_SPREAD) ** ADJC)

END FUNCTION  ADJINVESTV

!------------------------------------------------
FUNCTION DIFF_ADJINVEST(INVEST_IN, KAPITAL)
IMPLICIT NONE

REAL(DP), INTENT(IN):: INVEST_IN,KAPITAL
REAL(DP) :: DIFF_ADJINVEST
REAL(DP):: ADJA, ADJB

ADJA=(MYDELTA**(ONE/KSI))
ADJB= -(ONE/KSI)

DIFF_ADJINVEST = ADJA*((INVEST_IN/KAPITAL) ** ADJB)

END FUNCTION  DIFF_ADJINVEST


END MODULE


!===================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================


!     LAST CHANGE:  UR   20 MAY 2003   11:44 AM
MODULE MMAXIMHAB


 USE MYPARAMSHAB
 USE MY_PROCSHAB, ONLY : MYHUNT
IMPLICIT NONE

CONTAINS

!======================================================


SUBROUTINE MAXIMEZS (VALU_S, WNOW_S, KNOW_S, GAMMANOW_S, ZNOW_S, STOCK_S, BOND_S, VALUEMAX_S, WHOCALL, QD, AGWS)

USE MY_PROCSHAB, ONLY: MYSPLIE2
USE MYPARAMSHAB
IMPLICIT NONE

!DUMMY ARGUMENTS
REAL(DP), DIMENSION(WNUM, ZNUM), INTENT(IN) :: VALU_S
INTEGER, INTENT(IN) :: WNOW_S, KNOW_S, GAMMANOW_S, ZNOW_S
REAL(DP), INTENT(INOUT) :: BOND_S, STOCK_S         ! INITIAL GUESS UPON ENTRY.. AND..OPTIMAL SOLUTION UPON EXIT
REAL(DP), INTENT(OUT) :: VALUEMAX_S
CHARACTER, INTENT(IN):: WHOCALL
REAL(DP), INTENT(IN) :: QD , AGWS

!LOCAL
REAL(DP) ::CASH_S, PBOND_S, BMAXS, STMAXS
REAL(DP), DIMENSION(2) :: XMIN_BRENT2B, XMIN_BRENT2S, FMIN_BRENT2S, FMIN_BRENT2B
REAL(DP), DIMENSION(ZNUM):: DUMMYARRZ
REAL(DP), DIMENSION(ZNUM) :: PSTOCK_NEXT_S, DIVD_NEXT_S
REAL(DP):: AX, BX, CX, F1, F2,F3, FBMAX, FSTMAX, STOCK_IN, BOND_IN, VALUEMAX_IN, FA,FB,FC, PSTOCK_S
INTEGER :: I, SUCCESS, MYCHOICE, BOUNDARY_IN
REAL(DP), DIMENSION(WNUM,ZNUM):: COEFFV_S
REAL(DP), DIMENSION(ZNUM,WNUM):: COEFFT


!LOCAL PARAMETER
REAL(DP):: EPS1, EPS2
REAL(DP):: TOL_DBRENT

!TOL_DBRENT= MAX(1.0E-10_DP,1.0E-9/(SQRT(REAL(ITERVAL_GLOBS))*(ITERMAIN)))

TOL_DBRENT= 1.0E-10_DP
DUMMYARRZ=ONE

!VARIABLES CONSTRUCTED IN HERE FOR FURTHER CALCULATIONS...
EPS1= MIN((WEALTHS(2)-WEALTHS(1))/10, 0.0001_DP)
EPS2= MIN((WEALTHS(2)-WEALTHS(1))/10, 0.0001_DP)
PSTOCK_NEXT_S= PSTOCK_NEXT(KNOW_S, GAMMANOW_S, ZNOW_S,:)
DIVD_NEXT_S = DIVD_NEXT(KNOW_S, GAMMANOW_S,ZNOW_S,:)
PSTOCK_S = PSTOCK(KNOW_S, GAMMANOW_S, ZNOW_S)

CALL MYSPLIE2(DUMMYARRZ, WEALTHS, TRANSPOSE(VALU_S), COEFFT)
COEFFV_S=TRANSPOSE(COEFFT)


IF (WHOCALL == 'B') THEN
    CASH_S= WEALTHS(WNOW_S) + WAGE(KNOW_S, ZNOW_S)
    PBOND_S = PBOND(KNOW_S, GAMMANOW_S, ZNOW_S)
!    TOL_DBRENT= MAX(1.0E-9_DP,1.0E-7/(1+SQRT(REAL(ITERVAL_GLOBS))*(ITERMAIN)))

ELSEIF (WHOCALL == 'D') THEN
    !WRITE (*,*) 'IN MAXIMEZS'
    CASH_S= AGWS + WAGE(KNOW_S, ZNOW_S)
    PBOND_S = QD
 !   TOL_DBRENT= 1.0E-9_DP

ELSE
    WRITE (*,*)' ERROR IN MAXIMHABS: VARIABLE "WHOCALL" MAY EITHER BE DEMAND OR BELLMAN'
    PAUSE
END IF

!----------------------------------------------------------
!CHEK OF THERE IS A FEASIBLE POINT..

STMAXS= UPBOUND( CASH_S, PSTOCK_S, PBOND_S, BMINS)
BMAXS= UPBOUND( CASH_S, PBOND_S, PSTOCK_S, STMINS)

IF ((BMAXS-BMINS < 0.000001) .OR. (STMAXS-STMINS <0.000001)) THEN
    WRITE(*,*)  WNOW_S, KNOW_S, GAMMANOW_S, ZNOW_S
    WRITE (*,*)' NO FEASIBLE POINT, INTERVAL TOO SMALL..'
    WRITE (*,*)' BMAXS - BMINS =', BMAXS-BMINS
    WRITE (*,*)'STMAXS - STMINS=', STMAXS-STMINS
  !  PAUSE
END IF

!-----------------------------------------------

!CHECK IF AGENT IS AT A CORNER WITH RESPECT TO BOTH ASSETS
BOND_IN= BMINS
STOCK_IN=STMINS
F1= FUNCS(STMINS, BMINS, 0)
F2= FUNCS(STMINS + EPS2, BMINS, 0)
F3= FUNCS(STMINS, BMINS + EPS1, 0)


IF ((F1 < F2) .AND. (F1 < F3)) THEN
    FBMAX= FUNCS(STMINS, BMAXS,0)
    FSTMAX=FUNCS(STMAXS, BMINS,0)
    IF ((F2<FSTMAX) .AND. (F3<FBMAX)) THEN
        STOCK_S= STMINS
        BOND_S= BMINS
        VALUEMAX_S = -F1
        !WRITE(*,*) ' WNOW_S, KNOW_S, GAMMANOW_S, ZNOW_S', WNOW_S, KNOW_S, GAMMANOW_S, ZNOW_S
	!WRITE (*,*) ' BOUNDARY SOLUTION OBTAINED IN 1, STOCK, BOND ARE=', STOCK_S, BOND_S
        RETURN
    END IF
END IF
!-------------------------------------
AX= STMINS;  BX=0.0; MYCHOICE=0

DO I=1,2
    BOND_IN = BMINS + EPS2*(I-1)
    STMAXS= UPBOUND( CASH_S, PSTOCK_S , PBOND_S, BOND_IN)
    CX= STMAXS

    CALL MYBRAK(AX, BX, CX, FA, FB, FC, MYCHOICE, BOND_IN, BOUNDARY_IN)
    FMIN_BRENT2B(I)= BRENT1(AX,BX,CX,TOL_DBRENT, XMIN_BRENT2B(I), MYCHOICE, BOND_IN)
END DO


!----------------------------

!CHECK IF BOUNDARY SOLUTION
!CASE 2: SET STOCK HOLDINGS TO STMIN, AND CHECK IF OPTIMAL

AX= BMINS; BX=0.0 ; MYCHOICE=1

DO I=1,2
    STOCK_IN = STMINS + EPS2*(I-1)
    BMAXS= UPBOUND( CASH_S, PBOND_S, PSTOCK_S, STOCK_IN)
    CX= BMAXS

    CALL MYBRAK(AX,BX,CX, FA,FB,FC, MYCHOICE, STOCK_IN, BOUNDARY_IN)
    FMIN_BRENT2S(I)= BRENT1(AX,BX,CX,TOL_DBRENT, XMIN_BRENT2S(I), MYCHOICE, STOCK_IN)
END DO

!-----------------------------

IF ((FMIN_BRENT2B(1) < FMIN_BRENT2B(2)) .AND. (FMIN_BRENT2S(1) >= FMIN_BRENT2S(2)))THEN
    BOND_S= BMINS
    STOCK_S= XMIN_BRENT2B(1)
    VALUEMAX_S = -FMIN_BRENT2B(1)
   ! WRITE (*,*) ' CORNER SOLUTION FOR BOND OBTAINED'
RETURN
ELSEIF ((FMIN_BRENT2S(1) < FMIN_BRENT2S(2)) .AND. (FMIN_BRENT2B(1) >= FMIN_BRENT2B(2))) THEN
    STOCK_S= STMINS
    BOND_S= XMIN_BRENT2S(1)
    VALUEMAX_S = -FMIN_BRENT2S(1)
 !   WRITE (*,*) ' CORNER SOLUTION FOR STOCK OBTAINED'
RETURN
ELSEIF ((FMIN_BRENT2B(1) < FMIN_BRENT2B(2)) .AND. (FMIN_BRENT2S(1) < FMIN_BRENT2S(2))) THEN

WRITE (*,*)'BOUNDARY CHECK GIVES INCONSISTENT SOLUTION, PROCCEDING WITH 2D MAXIMIZATION.....'
WRITE (*,*)' STATE IS=', WNOW_S, KNOW_S, GAMMANOW_S, ZNOW_S

END IF
!----------------------------------------------

! IF WE ARE HERE THIS MEANS THERE IS NO CORNER SOLUTION SO TRY INTERIOR SOLUTION

CALL MIN2D(STOCK_IN, BOND_IN, VALUEMAX_IN, SUCCESS)
IF (SUCCESS == 1) THEN
    BOND_S= BOND_IN
    STOCK_S=STOCK_IN
    VALUEMAX_S =VALUEMAX_IN
   ! WRITE (*,*)' WEALTH LEVEL IS=', WEALTHS(WNOW_S)
   ! WRITE (*,*)'STATE IS WNOW, KNOW, GAMMANOW, ZNOW=', WNOW_S, KNOW_S, GAMMANOW_S, ZNOW_S
  !  WRITE (*,*)' VALUE OF BOND AND STOCK FROM 2D MAXIMIZATION IS', BOND_S, STOCK_S
 !  PAUSE
ELSE
    BOND_S= BOND_IN
    STOCK_S=STOCK_IN
    VALUEMAX_S= INERROR
    WRITE(*,*) 'ERROR IN MAXIMHABS: SUCCESS IS EQUAL TO', SUCCESS
    WRITE(*,*) ' STATE IS WNOW, KNOW, GAMMANOW, ZNOW=', WNOW_S, KNOW_S, GAMMANOW_S, ZNOW_S
 PAUSE
END IF

!-----------------------------------------------------------------

CONTAINS

 REAL(DP) FUNCTION FUNCS(X,W, CHOICE)
 IMPLICIT NONE

 REAL(DP), INTENT(IN) :: X,W
 INTEGER, INTENT(IN):: CHOICE


 REAL(DP), DIMENSION (ZNUM) :: WEALTHNEXT_S, V
 INTEGER :: I, XGUESS
 REAL(DP) :: EXP_VNEXT, H, A, B, UTIL, SLOPE, WEIGHT1
 INTEGER, DIMENSION(ZNUM):: INDXX

IF (CHOICE==0) THEN

    UTIL= ((CASH_S - W * PBOND_S - X*PSTOCK_S)** ROS)
    WEALTHNEXT_S = ((PSTOCK_NEXT_S + DIVD_NEXT_S) * X + W)
    XGUESS=WNOW_S

    DO I=1,ZNUM
        CALL MYHUNT(WEALTHS, WEALTHNEXT_S(I), XGUESS)
        INDXX(I)=XGUESS
    END DO
    WHERE (INDXX>=WNUM)    INDXX=WNUM-1
    WHERE (INDXX==0)        INDXX=1

    DO I=1,ZNUM
     H=WEALTHS(INDXX(I)+1)-WEALTHS(INDXX(I))
     A=(WEALTHS(INDXX(I)+1)-WEALTHNEXT_S(I))/H
     B=(WEALTHNEXT_S(I)-WEALTHS(INDXX(I)))/H
     V(I)=A*VALU_S(INDXX(I),I)+B*VALU_S(INDXX(I)+1,I)+((A**3-A)*COEFFV_S(INDXX(I),I)+(B**3-B)*COEFFV_S(INDXX(I)+1,I))*(H**2)/6.0_SP
    END DO

    EXP_VNEXT=SUM(PROBZ(ZNOW_S,:)*(V(:)**THETAS))
    FUNCS= -(((ONE-MYBETA) * UTIL) + (MYBETA * (EXP_VNEXT**(ROS/THETAS))))**(ONE/ROS)


ELSEIF (CHOICE==1) THEN
    UTIL= ((CASH_S - X * PBOND_S- W*PSTOCK_S) ** ROS)
    WEALTHNEXT_S = ((PSTOCK_NEXT_S + DIVD_NEXT_S ) * W + X)
    XGUESS=WNOW_S

    DO I=1,ZNUM
        CALL MYHUNT(WEALTHS, WEALTHNEXT_S(I), XGUESS)
        INDXX(I)=XGUESS
    END DO
    WHERE (INDXX>=WNUM)    INDXX=WNUM-1
    WHERE (INDXX==0)        INDXX=1

    DO I=1,ZNUM
     H=WEALTHS(INDXX(I)+1)-WEALTHS(INDXX(I))
     A=(WEALTHS(INDXX(I)+1)-WEALTHNEXT_S(I))/H
     B=(WEALTHNEXT_S(I)-WEALTHS(INDXX(I)))/H
     V(I)=A*VALU_S(INDXX(I),I)+B*VALU_S(INDXX(I)+1,I)+((A**3-A)*COEFFV_S(INDXX(I),I)+(B**3-B)*COEFFV_S(INDXX(I)+1,I))*(H**2)/6.0_SP
    END DO
    EXP_VNEXT=SUM(PROBZ(ZNOW_S,:)*(V(:)**THETAS))
    FUNCS= -(((ONE-MYBETA) * UTIL) + (MYBETA * (EXP_VNEXT**(ROS/THETAS))))**(ONE/ROS)

END IF

 END FUNCTION  FUNCS


!-----------------------------
SUBROUTINE MYBRAK(AX, BX, CX, FA,FB,FC, CHOICE, FIXPARAM, BOUNDARY)

REAL(DP), INTENT(INOUT ) :: AX, BX, CX
REAL(DP), INTENT(OUT):: FA,FB,FC
INTEGER, INTENT(IN):: CHOICE
REAL(DP), INTENT(IN) ::FIXPARAM
INTEGER, INTENT(OUT) :: BOUNDARY
!LOCAL
REAL(DP), PARAMETER::  STEP =0.618
INTEGER, PARAMETER:: ITERMAX=40
REAL(DP) :: FA_INIT, FC_INIT
INTEGER :: I

BOUNDARY=0

FA_INIT= FUNCS(AX, FIXPARAM, CHOICE)
FC_INIT= FUNCS(CX, FIXPARAM, CHOICE)

FA=FA_INIT
FC=FC_INIT

    DO I=1,ITERMAX
            BX= AX + STEP* ( CX-AX)
            FB= FUNCS(BX, FIXPARAM, CHOICE)
            IF (FA<= FC) THEN
                IF (FB <= FA )  THEN
                    !WRITE(*,*) 'BRACKETTING OBTAINED IN', I, 'ITERATIONS'
                    RETURN
                END IF
                IF ((FB > FA ) .AND. (FB <=FC)) THEN
                    CX=BX
                    FC=FB
                ELSEIF ((FB* (ONE + TOL_DBRENT) >FA) .AND. (FB* (ONE + TOL_DBRENT) > FC)) THEN
                    WRITE (*,*) 'WE ARE IN MAXIMHABS, PART MYBRAK AND WE HAVE A PROBLEM:'
                    WRITE (*,*) 'SOMETHING WRONG WITH BRACKETTING, FA, FB, FC ARE:', FA,FB, FC
                    CX=BX
                    FC=FB
                 !   PAUSE
                END IF

             ELSEIF (FC< FA) THEN
                IF (FB <= FC )  THEN
                    !WRITE(*,*) 'BRACKETTING OBTAINED IN', I,'ITERATIONS'
                    RETURN
                END IF
                IF ((FB > FC ) .AND. (FB < FA)) THEN
                    AX=BX
                    FA=FB
                ELSEIF ((FB* (ONE + TOL_DBRENT) >  FC ) .AND. (FB* (ONE + TOL_DBRENT) > FA)) THEN
                    WRITE (*,*) 'WE ARE IN MAXIMHABS, PART MYBRAK AND WE HAVE A PROBLEM:'
                    WRITE (*,*) 'SOMETHING WRONG WITH BRACKETTING, FA, FB, FC ARE:', FA,FB, FC
                    AX=BX
                    FA=FB
!                    PAUSE
                END IF
             END IF
    END DO


IF (FA==FA_INIT) THEN
     BX =0.5*(AX +CX)
     !WRITE (*,*) ' BOUNDARY SOLUTION OBRAINED AT LOWER BOUND IN MYBRAK'
     BOUNDARY=1
ELSEIF (FC==FC_INIT) THEN
     BX=0.5*(AX + CX)
     !WRITE(*,*) ' BOUNDARY SOLUTION OBTAINED AT UPPER BOUND IN MYBRAK'
     BOUNDARY=2
END IF
END SUBROUTINE MYBRAK

!---------------------------------------------------------

SUBROUTINE MYBRAK2(AX,BX,CX, FA,FB,FC, CHOICE, BOUNDARY)

REAL(DP), INTENT(INOUT ) :: AX,CX
REAL(DP), INTENT(INOUT) :: BX
REAL(DP), INTENT(OUT):: FA,FB,FC
INTEGER, INTENT(IN):: CHOICE
INTEGER, INTENT(OUT) :: BOUNDARY
!LOCAL
REAL(DP), PARAMETER::  STEP =0.618
INTEGER, PARAMETER:: ITERMAX=40
REAL(DP) :: FA_INIT, FC_INIT, SA, SB, SC
INTEGER :: I

!WRITE (*,*) ' IN MYBRAK2'

BOUNDARY=0
!WRITE (*,*)' TWO CONSECUTIVE CALLS TO MIN1D'
CALL MIN1D(AX,CHOICE, FA_INIT, SA)
CALL MIN1D(CX,CHOICE, FC_INIT, SC)
FA=FA_INIT
FC=FC_INIT

    DO I=1,ITERMAX
            BX= AX + STEP* (CX-AX)
            !WRITE (*,*)' REPEATED CALLS IN THE LOOP FOR BRACKETTING IN BOND DIRECTION'
            CALL MIN1D(BX,CHOICE, FB, SB)
            IF (FA<= FC) THEN
                IF (FB <= FA )  THEN
                    !WRITE(*,*) 'BRACKETTING OBTAINED IN', I, 'ITERATIONS'
                    RETURN
                END IF
                IF ((FB > FA ) .AND. (FB <=FC)) THEN
                    CX=BX
                    FC=FB
                    SC=SB
                ELSEIF ((FB > (ONE + TOL_DBRENT)*FA) .AND. (FB > (ONE + TOL_DBRENT)* FC)) THEN
                    WRITE (*,*) 'WE ARE IN MAXIMHABS, PART MYBRAK2 AND WE HAVE A PROBLEM:'
                    WRITE (*,*) 'SOMETHING WRONG WITH BRACKETTING,AX,BX,CX, FA, FB, FC ARE:',AX, BX,CX, FA,FB, FC
                    WRITE(*,*) ' SA,SB,SC ARE=', SA, SB, SC
                    CX=BX
                    FC=FB
                    SC=SB
                  !  PAUSE
                END IF
             ELSEIF (FC< FA) THEN
                IF (FB <= FC )  THEN
                    !WRITE(*,*) 'BRACKETTING OBTAINED IN', I,'ITERATIONS'
                    RETURN
                END IF
                IF ((FB > FC ) .AND. (FB < FA)) THEN
                    AX=BX
                    FA=FB
                    SA=SB
                ELSEIF ((FB > (ONE + TOL_DBRENT) * FC ) .AND. (FB > (ONE+ TOL_DBRENT)* FA)) THEN
                    WRITE (*,*) 'WE ARE IN MAXIMHABS, PART MYBRAK2 AND WE HAVE A PROBLEM:'
                    WRITE (*,*) 'SOMETHING WRONG WITH BRACKETTING, AX,BX,CX, FA, FB, FC ARE:', AX,BX,CX, FA,FB, FC
                    WRITE(*,*) ' SA,SB,SC ARE=', SA, SB, SC
                    AX=BX
                    FA=FB
                    SA=SB
                  ! PAUSE
                END IF
             END IF
             !WRITE (*,*) ' AX, BX, CX ARE= ',  AX, BX, CX
    END DO

IF (FA==FA_INIT) THEN
     BX =0.5*(AX +CX)
     !WRITE (*,*) ' BOUNDARY SOLUTION OBRAINED AT LOWER BOUND IN MYBRAK'
     BOUNDARY=1
ELSEIF (FC==FC_INIT) THEN
     BX=0.5*(AX + CX)
     !WRITE(*,*) ' BOUNDARY SOLUTION OBTAINED AT UPPER BOUND IN MYBRAK'
     BOUNDARY=2
END IF

END SUBROUTINE MYBRAK2

!------------------------------------------------------------


 REAL(DP) FUNCTION UPBOUND(CASH_F, PRICE_F, PRICEASSET_F, ASSET_F)
 IMPLICIT NONE

 REAL(DP) , INTENT(IN) :: CASH_F, PRICEASSET_F, ASSET_F ,PRICE_F

 IF (ABS (PRICE_F) < TINY(CASH_F)  ) THEN
     WRITE (*,*) ' ASSETS OWN PRICE IS DANGEROUSLY CLOSE TO ZERO...'
     WRITE (*,*) ' POSSIBILITY OF DIVISION BY ZERO, SO QUITTING..'
     RETURN
 ELSE
     UPBOUND = (ONE/ PRICE_F) * (CASH_F - PRICEASSET_F * ASSET_F - EPSC)
 END IF

 END FUNCTION UPBOUND

!------------------------------------------

!IN THE CURRENT VERSION WE ALWAYS BISECT OVER BOND HOLDINGS AND FIND THE MAXIMUM OVER  STOCK HOLDINGS
!FOR THOSE FIXED BOND VALUES. SO THIS FUNCTION WILL ALWAYS BE CALLED WITH *** CHOICE = 0 ***

 SUBROUTINE MIN2D( MAXSTOCK, MAXBOND, VALUEMAX, OPT_STATUS)
 IMPLICIT NONE

 REAL(DP), INTENT(OUT) :: MAXSTOCK, MAXBOND, VALUEMAX
 INTEGER, INTENT(OUT) ::  OPT_STATUS

 !LOCAL
 REAL(DP) :: AX, BX, CX1, CX2
 REAL(DP) :: FA,SA,FC1,SC1, FC2, SC2
 REAL(DP):: XMIN_STOCK, FMIN_STOCK
 REAL(DP):: FMIN2D, XMIN2D, BMAX2D, FIXPARAM
 LOGICAL :: FLAG
 REAL(DP), PARAMETER :: STEP1 = 0.618                
 INTEGER, PARAMETER:: ITERMAX =100
 INTEGER ::  ITER
 INTEGER:: CHOICE, BOUNDARY

 !WRITE (*,*) ' IN MIN2D'

 OPT_STATUS=1
 !SET CHOICE =0 SO THAT WE BISECT OVER BOND AND SEARCH OVER STOCKS
 CHOICE=0
 FIXPARAM= STMINS

 AX= BMINS              !INITIALIZE AX TO BMINS UPON ENTRANCE
 BX=0.0
 FLAG=.FALSE.          !INITIALIZE BRACKETTING CONTROL VARIABLE FLAG
 BMAX2D= UPBOUND( CASH_S, PBOND_S, PSTOCK_S, STMINS)
 !WRITE (*,*) 'BMAX2D IS', BMAX2D
 !WRITE (*,*)' TWO CALLS TO MIN1D IN MIN2D'
 CALL MIN1D(AX, CHOICE, FA, SA )
 CX1= AX + STEP1 * ( BMAX2D - AX)
 CALL MIN1D(CX1, CHOICE, FC1, SC1 )

 !WRITE (*,*) ' AX, CX1, FA, FC1 =', AX, CX1, FA, FC1
 !PAUSE
!---------------------------------------------------
  !WE ARE TRYING TO BRACKET THE MINIMUM IN THE BOND DIRECTION, THAT IS:
 !WE ARE TRYING TO FIND BONDA, BONDB SUCH THAT THERE EXIST A BONDC BETWEEN THESE TOW POINTS
 !THE MAXIMIZED VALUE OVER STOCKS AT BONDC IS SMALLER THAN BOTH ENDPOINTS
 !FIXING BOND AT AX1 AND CX1 IN TURN, MAXIMIZE OVER STOCK


 ITER=1
 DO WHILE ((.NOT. FLAG) .AND. (ITER <=ITERMAX))
     !EPS2= (BMAXS - CX) * ( PBOND / PSTOCK)
 OUTER: IF (FC1 < FA) THEN                !WE COULD NOT FIND AX AND BX YET
            CX2= CX1 + STEP1 * ( BMAX2D-CX1)
            !WRITE (*,*) ' CX2 IS=', CX2
            CALL MIN1D(CX2, CHOICE, FC2, SC2 )
            !WRITE (*,*)' IN THE LOOP, ITERATION=', ITER
            !WRITE (*,*) 'CX2, FC2=', CX2, FC2
            !PAUSE
            INNER:  IF (FC1 > FC2) THEN
                           AX=CX1
                           FA= FC1
                           CX1=CX2
                           FC1=FC2
                    ELSEIF (FC1 <FC2) THEN
                           BX=CX1
                           FB=FC1
                           CX1=CX2
                           FC1=FC2
                           FLAG=.TRUE.
                    END IF INNER
        ELSEIF (FC1 >=FA) THEN
            CALL MYBRAK2(AX,BX,CX1,FA,FB,FC1, CHOICE, BOUNDARY)
            !WRITE (*,*)' BRACKETTING IN MIN2D OBTAINED IN' , ITER, 'ITERATIONS'
            FLAG=.TRUE.
        END IF OUTER
     ITER = ITER +1
 END DO

IF (ITER > ITERMAX ) THEN
 WRITE (*,*) 'COULD NOT BRACKET A MINIMUM IN ITERMAX ITERATIONS'
 WRITE(*,*) ' CURRENT VALUE OF VARIABLES, FA,FB,FC1 FC2' , FA, FB, FC1,FC2
 WRITE (*,*)' CURRENT VALUE OF ABCISSA', AX, BX, CX1,CX2
 OPT_STATUS = 0
END IF

   !WRITE (*,*)' DONE WITH BRACKETTING ---------------------------------------'
   !WRITE (*,*)' GOING INTO BRENT, AX, BX, CX1 AND VALUES=', AX, BX, CX1, FA, FB, FC1
   FMIN2D = BRENT(AX,BX,CX1,TOL_DBRENT,XMIN2D, CHOICE)

   VALUEMAX= -FMIN2D
   MAXBOND= XMIN2D
   !TO SET MAXSTOCK CALL MIN1D WITH OPTIMAL BOND HOLDINGS
   CALL MIN1D(MAXBOND, CHOICE, FMIN_STOCK, XMIN_STOCK)
   MAXSTOCK= XMIN_STOCK


 !UPDATE BRENT SO THAT IS ALSO GIVES THE MAXIMIZED VALUE OF STOCK (CALLED DUMMY IN BRENT) AS OUTPUT

 END SUBROUTINE

!---------------------------------------------

 SUBROUTINE MIN1D(ASSETFIX,CHOICE, FMIN_IN, XMIN_IN)
 USE MYPARAMSHAB
 IMPLICIT NONE

 REAL(DP), INTENT(IN) :: ASSETFIX
 INTEGER , INTENT(IN) :: CHOICE
 REAL(DP), INTENT(OUT) :: XMIN_IN
 REAL(DP), INTENT(OUT) :: FMIN_IN

 !LOCAL
 REAL(DP) :: AX,BX,CX,FA,FB,FC
 REAL(DP) :: STMAX1D, BMAX1D

 !LOCAL
 INTEGER:: BOUNDARY
! WRITE (*,*) ' IN MIN1D'
 IF (CHOICE ==0) THEN
     STMAX1D= UPBOUND( CASH_S, PSTOCK_S , PBOND_S, ASSETFIX)
     AX=STMINS
     BX=0.0
     CX=STMAX1D
     IF ((CX-AX) < ( EPSC/1000)) THEN
     WRITE (*,*)' CAUTION THE INTERVAL FOR STOCK MAXIMIZATION IS DANGEROUSLY NARROW', WNOW_S, KNOW_S, GAMMANOW_S, ZNOW_S
     PAUSE

     END IF
 ELSEIF (CHOICE==1) THEN
     BMAX1D= UPBOUND(CASH_S, PBOND_S, PSTOCK_S , ASSETFIX)
     AX=BMINS
     BX=0.0
     CX=BMAX1D
     IF ((CX-AX) < (EPSC/1000)) THEN
     WRITE (*,*)' CAUTION THE INTERVAL FOR STOCK MAXIMIZATION IS DANGEROUSLY NARROW', WNOW_S, KNOW_S, GAMMANOW_S, ZNOW_S
     PAUSE
     END IF
 END IF

    CALL MYBRAK(AX, BX, CX, FA, FB, FC, CHOICE, ASSETFIX, BOUNDARY)
    !WRITE(*,*) 'IN MIN1D, HERE IS THE BRACKETTING TRIPLET OF STOCK VALUES: AX, BX, CX=', AX,BX, CX
    IF (BOUNDARY==1) THEN
        XMIN_IN=AX
        FMIN_IN=FA
    ELSEIF (BOUNDARY == 2) THEN
        XMIN_IN = CX
        FMIN_IN = FC
    ELSEIF (BOUNDARY == 0) THEN
        FMIN_IN= BRENT1(AX,BX,CX,TOL_DBRENT, XMIN_IN, CHOICE, ASSETFIX)
    END IF
    !WRITE(*,*) ' OPTIMAL POINT IS, OBJ=', FMIN_IN,'STOCK',XMIN_IN

 END SUBROUTINE MIN1D

!-----------------------------------------------------------



 	FUNCTION BRENT(AX,BX,CX,TOL,XMIN, CHOICE) !LAST ARGUMENT 'CHOICE' ADDED TO BRENT
	USE NRTYPE
	IMPLICIT NONE
	REAL(DP), INTENT(IN) :: AX,BX,CX,TOL
	REAL(DP), INTENT(OUT) :: XMIN
	REAL(DP) :: BRENT
        INTEGER(I4B) :: CHOICE

	INTEGER(I4B), PARAMETER :: ITMAX=100
	REAL(DP), PARAMETER :: CGOLD=0.3819660_SP,ZEPS=1.0E-3_SP*EPSILON(AX)
	INTEGER(I4B) :: ITER
	REAL(DP) :: A,B,D,E,ETEMP,FU,FV,FW,FX,P,Q,R,TOL1,TOL2,U,V,W,X,XM
        REAL(DP):: ARGX, ARGU   !THIS DEFINITION ADDED TO BRENT
	A=MIN(AX,CX)
	B=MAX(AX,CX)
        !WRITE (*,*) ' IN BRENT'
	V=BX
	W=V
	X=V
	E=0.0
        !WRITE (*,*) ' EVALUATING AT X, CALLING MIN1D'
        CALL MIN1D(X, CHOICE, FX, ARGX)    !THESE TWO LINES CHANGED FROM THE ORIGINAL BRENT
        !PAUSE
       !FX=FUNCS(X)
	FV=FX
	FW=FX
	DO ITER=1,ITMAX
		XM=0.5_DP*(A+B)
		TOL1=TOL*ABS(X)+ZEPS
		TOL2=2.0_DP*TOL1
		IF (ABS(X-XM) <= (TOL2-0.5_DP*(B-A))) THEN
			XMIN=X
			BRENT=FX
			RETURN
		END IF
		IF (ABS(E) > TOL1) THEN
			R=(X-W)*(FX-FV)
			Q=(X-V)*(FX-FW)
			P=(X-V)*Q-(X-W)*R
			Q=2.0_DP*(Q-R)
			IF (Q > 0.0) P=-P
			Q=ABS(Q)
			ETEMP=E
			E=D
			IF (ABS(P) >= ABS(0.5_DP*Q*ETEMP) .OR. &
				P <= Q*(A-X) .OR. P >= Q*(B-X)) THEN
				E=MERGE(A-X,B-X, X >= XM )
				D=CGOLD*E
			ELSE
				D=P/Q
				U=X+D
				IF (U-A < TOL2 .OR. B-U < TOL2) D=SIGN(TOL1,XM-X)
			END IF
		ELSE
			E=MERGE(A-X,B-X, X >= XM )
			D=CGOLD*E
		END IF
		U=MERGE(X+D,X+SIGN(TOL1,D), ABS(D) >= TOL1 )

                !WRITE(*,*) ' EVALUATING AT U, CALLING MIN1D'
                CALL MIN1D(U, CHOICE, FU, ARGU)    !THESE TWO LINES CHANGED FROM THE ORIGINAL BRENT
                !PAUSE
	!	FU=FUNCS(U)


		IF (FU <= FX) THEN
			IF (U >= X) THEN
				A=X
			ELSE
				B=X
			END IF
			CALL SHFT(V,W,X,U)
			CALL SHFT(FV,FW,FX,FU)
		ELSE
			IF (U < X) THEN
				A=U
			ELSE
				B=U
			END IF
			IF (FU <= FW .OR. W == X) THEN
				V=W
				FV=FW
				W=U
				FW=FU
			ELSE IF (FU <= FV .OR. V == X .OR. V == W) THEN
				V=U
				FV=FU
			END IF
		END IF
	END DO
	WRITE(*,*) 'BRENT: EXCEED MAXIMUM ITERATIONS'
        PAUSE

	END FUNCTION BRENT

!--------------------------------------

	FUNCTION BRENT1(AX,BX,CX,TOL,XMIN, CHOICE, PARAM) !LAST ARGUMENT 'CHOICE' ADDED TO BRENT
	USE NRTYPE
	IMPLICIT NONE
	REAL(DP), INTENT(IN) :: AX,BX,CX,TOL, PARAM
	REAL(DP), INTENT(OUT) :: XMIN
	REAL(DP) :: BRENT1
        INTEGER(I4B) :: CHOICE

	INTEGER(I4B), PARAMETER :: ITMAX=100
	REAL(DP), PARAMETER :: CGOLD=0.3819660_DP,ZEPS=1.0E-3_DP*EPSILON(AX)
	INTEGER(I4B) :: ITER
	REAL(DP) :: A,B,D,E,ETEMP,FU,FV,FW,FX,P,Q,R,TOL1,TOL2,U,V,W,X,XM
	A=MIN(AX,CX)
	B=MAX(AX,CX)
        !WRITE (*,*) ' IN BRENT'
	V=BX
	W=V
	X=V
	E=0.0
        !WRITE (*,*) ' EVALUATING AT X, CALLING MIN1D'
        FX=FUNCS(X,PARAM,CHOICE)
        !PAUSE
       !FX=FUNCS(X)
	FV=FX
	FW=FX
	DO ITER=1,ITMAX
		XM=0.5_DP*(A+B)
		TOL1=TOL* ABS(X)+ZEPS
		TOL2=2.0_DP*TOL1
		IF (ABS(X-XM) <= (TOL2-0.5_DP*(B-A))) THEN
			XMIN=X
			BRENT1=FX
			RETURN
		END IF
		IF (ABS(E) > TOL1) THEN
			R=(X-W)*(FX-FV)
			Q=(X-V)*(FX-FW)
			P=(X-V)*Q-(X-W)*R
			Q=2.0_DP*(Q-R)
			IF (Q > 0.0) P=-P
			Q=ABS(Q)
			ETEMP=E
			E=D
			IF (ABS(P) >= ABS(0.5_DP*Q*ETEMP) .OR. &
				P <= Q*(A-X) .OR. P >= Q*(B-X)) THEN
				E=MERGE(A-X,B-X, X >= XM )
				D=CGOLD*E
			ELSE
				D=P/Q
				U=X+D
				IF (U-A < TOL2 .OR. B-U < TOL2) D=SIGN(TOL1,XM-X)
			END IF
		ELSE
			E=MERGE(A-X,B-X, X >= XM )
			D=CGOLD*E
		END IF
		U=MERGE(X+D,X+SIGN(TOL1,D), ABS(D) >= TOL1 )

                !WRITE(*,*) ' EVALUATING AT U, CALLING MIN1D'

                FU=FUNCS(U,PARAM,CHOICE)
                !PAUSE
	!	FU=FUNCS(U)


		IF (FU <= FX) THEN
			IF (U >= X) THEN
				A=X
			ELSE
				B=X
			END IF
			CALL SHFT(V,W,X,U)
			CALL SHFT(FV,FW,FX,FU)
		ELSE
			IF (U < X) THEN
				A=U
			ELSE
				B=U
			END IF
			IF (FU <= FW .OR. W == X) THEN
				V=W
				FV=FW
				W=U
				FW=FU
			ELSE IF (FU <= FV .OR. V == X .OR. V == W) THEN
				V=U
				FV=FU
			END IF
		END IF
	END DO
	WRITE(*,*) 'BRENT1: EXCEED MAXIMUM ITERATIONS'

	END FUNCTION BRENT1
!----------------------------------------------------------

      	SUBROUTINE MOV3(A,B,C,D,E,F)
        USE NRTYPE
	REAL(DP), INTENT(IN) :: D,E,F
	REAL(DP), INTENT(OUT) :: A,B,C
	A=D
	B=E
	C=F
	END SUBROUTINE MOV3



	SUBROUTINE SHFT(A,B,C,D)
        USE NRTYPE
	REAL(DP), INTENT(OUT) :: A
	REAL(DP), INTENT(INOUT) :: B,C
	REAL(DP), INTENT(IN) :: D
	A=B
	B=C
	C=D
	END SUBROUTINE SHFT



END SUBROUTINE MAXIMEZS

!==================================================================
!=====================================================================
!=================================================================


SUBROUTINE MAXIMEZN (VALU_N, WNOW_S, KNOW_S, GAMMANOW_S, ZNOW_S, BOND_S, VALUEMAX_S, WHOCALL, QD, AGWN)
USE MY_PROCSHAB, ONLY: MYSPLIE2
IMPLICIT NONE


!DUMMY ARGUMENTS
REAL(DP), DIMENSION(WNUM, ZNUM), INTENT(IN) :: VALU_N
INTEGER, INTENT(IN) :: WNOW_S, KNOW_S, GAMMANOW_S, ZNOW_S
REAL(DP), INTENT(INOUT) :: BOND_S         ! INITIAL GUESS UPON ENTRY.. AND..OPTIMAL SOLUTION UPON EXIT
REAL(DP), INTENT(OUT) :: VALUEMAX_S
CHARACTER, INTENT(IN) :: WHOCALL
REAL(DP), INTENT(IN):: QD, AGWN


!LOCAL
REAL(DP) ::CASH_S, PBOND_S
REAL(DP) :: XMIN_DBRENT1, FMIN_DBRENT1
REAL(DP):: FBPLUS, FBHIGH, FBLOW, FBMINUS, BHIGH
INTEGER ::  SUCCESS, DERIVATIVE
REAL(DP), DIMENSION(ZNUM):: DUMMYARRZ
REAL(DP), DIMENSION(WNUM,ZNUM):: COEFFV_N
REAL(DP), DIMENSION(ZNUM,WNUM):: COEFFT


!LOCAL PARAMETER
REAL(DP):: EPS1
REAL(DP):: TOL_DBRENT

DUMMYARRZ=ONE
CALL MYSPLIE2(DUMMYARRZ, WEALTHN, TRANSPOSE(VALU_N), COEFFT)
COEFFV_N=TRANSPOSE(COEFFT)


!VARIABLES CONSTRUCTED IN HERE FOR FURTHER CALCULATIONS...
EPS1= MIN((WEALTHN(2)-WEALTHN(1))/10.0, EPSC)
DERIVATIVE=1  !THIS MEANS FOR NOW, WE ARE USING THE DERIVATIVE INFORMATION TO CHECK BOUDARY SOLUTIONS

IF (WHOCALL == 'B') THEN
    PBOND_S = PBOND( KNOW_S, GAMMANOW_S, ZNOW_S)
    CASH_S= WEALTHN(WNOW_S) + WAGE(KNOW_S, ZNOW_S)
!    TOL_DBRENT= MAX(1.0E-9_DP,1.0E-6/(1+SQRT(REAL(ITERVAL_GLOBN))*(ITERMAIN)))
     TOL_DBRENT=1.0E-9
ELSEIF (WHOCALL == 'D') THEN
    !WRITE (*,*)'IN MAXIMEZN'
    PBOND_S = QD
    CASH_S= AGWN + WAGE(KNOW_S, ZNOW_S)
    TOL_DBRENT= 1.0E-9_DP


ELSE
    WRITE (*,*)' ERROR: VARIABLE "WHOCALL" MAY EITTHER BE DEMAND OR BELLMAN'
END IF



!----------------------------------------
!CHECK TO SEE IF THE INTERVAL IS LARGE ENOUGH FOR THE FOLLOWING MAXIMIZATION ARGUMENTS TO MAKE SENSE..
IF ((CASH_S- PBOND_S*BMINN)< (EPSC + EPS1)) THEN
    WRITE (*,*)' ERROR AT MAXIMEZN, CHECK PART1, CASH_S- BMINN IS', CASH_S -BMINN
    WRITE (*,*) ' THE INTERVAL FOR BOND CHOICE IS VERY SMALL.. NO FEASIBLE POINT FOUND FOR BOND CHOICE'
    PAUSE
END IF
!-------------------------------------------
!CHECKING FOR A BOUNDARY SOLUTION

DERIV: IF (DERIVATIVE == 1) THEN
            BHIGH= (CASH_S - EPSC)/(PBOND_S)
            IF (DFUNCN(BMINN)>0) THEN
               BOND_S =BMINN
               VALUEMAX_S = -FUNCN(BMINN)
            ELSEIF (DFUNCN(BHIGH) <0) THEN
               BOND_S  =BHIGH
               VALUEMAX_S = -FUNCN(BHIGH)
            END IF

    ELSEIF (DERIVATIVE ==0) THEN


       BHIGH= (CASH_S - EPSC)/(PBOND_S)
       FBLOW= FUNCN(BMINN)
       FBPLUS=FUNCN(BMINN + EPS1)
       FBHIGH=FUNCN(BHIGH)


       IF ((FBLOW < FBPLUS) .AND. ( FBPLUS < FBHIGH)) THEN
           BOND_S= BMINN                     !LOWER BOUNDARY IS THE MAXIMUM
           VALUEMAX_S =-FBLOW
           WRITE(*,*) ' BOUNDARY SOLUTION OBTAINED AT LOWER BOUND', WNOW_S, KNOW_S, GAMMANOW_S, ZNOW_S
           ! PAUSE
           RETURN
       ELSEIF ((FBLOW < FBPLUS) .AND. ((FBPLUS > FBHIGH)) .AND. ( BHIGH> BMINN+EPS1)) THEN
            WRITE (*,*) ' IN MAXIMEZN, BOUNDARY CHECK PART 1 GIVES INCONISTENT RESULTS...'
            WRITE (*,*) ' PROCEEDING TO CALL MIN1D, STATE =', WNOW_S, KNOW_S, GAMMANOW_S, ZNOW_S


                                                                   ! DIAGNOSTICS END
       ELSE
           FBMINUS = FUNCN(BHIGH-EPS1)
           INNER: IF ((FBHIGH < FBMINUS) .AND. (FBMINUS < FBLOW)) THEN
               BOND_S = BHIGH             !UPPER BOUNDARY IS THE MAXIUM
               VALUEMAX_S = -FBHIGH
               RETURN
           ELSEIF ((FBHIGH < FBMINUS) .AND. (FBMINUS > FBLOW)) THEN
                WRITE (*,*) ' IN MAXIMEZN, BOUNDARY CHECK PART 2 GIVES INCONISTENT RESULTS...'
                WRITE (*,*) ' PROCEEDING TO CALL MIN1D, STATE=', WNOW_S, KNOW_S, GAMMANOW_S, ZNOW_S
                                                                  ! DIAGNOSTICS END
           END IF INNER
       END IF
 END IF DERIV

!----------------------------------------

! IF WE ARE HERE THIS MEANS THERE IS NO CORNER SOLUTION SO TRY INTERIOR SOLUTION

CALL MIN1D(FMIN_DBRENT1, XMIN_DBRENT1, SUCCESS)

IF (SUCCESS == 1) THEN
    BOND_S= XMIN_DBRENT1
    VALUEMAX_S = FMIN_DBRENT1
   ! WRITE(*,*) 'BOND_S AT', WNOW_S, KNOW_S, GAMMANOW_S, ZNOW_S, ' IS ', BOND_S
ELSE
    BOND_S= INERROR
    VALUEMAX_S= INERROR
    WRITE(*,*) 'ERROR IN MAXIMEZN SUCCESS IS EQUAL TO', SUCCESS
    PAUSE
END IF


!-----------------------------------------------------------------

CONTAINS

 REAL(DP) FUNCTION FUNCN(X)
 IMPLICIT NONE

 REAL(DP), INTENT(IN) :: X
 !LOCAL
 REAL(DP), DIMENSION(ZNUM) :: V

 INTEGER(I4B) :: I
 REAL(DP) :: EXP_VNEXT, UTIL,SLOPE, WEIGHT1, A, B, H
 INTEGER(I4B):: XGUESS

 IF ((CASH_S - PBOND_S*X) <EPSC/2 ) THEN
  WRITE (*,*) 'CAUTION, CONSUMPTION IS ONLY...=', CASH_S - PBOND_S*X
  PAUSE
 END IF


UTIL= ((CASH_S - PBOND_S*X)** RON)
XGUESS=WNOW_S
CALL MYHUNT(WEALTHN, X, XGUESS)
IF (XGUESS>=WNUM)    XGUESS=WNUM-1
IF (XGUESS==0)      XGUESS=1

DO I=1,ZNUM
     H=WEALTHN(XGUESS+1)-WEALTHN(XGUESS)
     A=(WEALTHN(XGUESS+1)-X)/H
     B=(X-WEALTHN(XGUESS))/H
     V(I)=A*VALU_N(XGUESS,I)+B*VALU_N(XGUESS+1,I)+((A**3-A)*COEFFV_N(XGUESS,I)+(B**3-B)*COEFFV_N(XGUESS+1,I))*(H**2)/6.0_SP

END DO

EXP_VNEXT=SUM(PROBZ(ZNOW_S,:)*(V(:)**THETAN))
FUNCN= -(((ONE-MYBETA) * UTIL) + (MYBETA * (EXP_VNEXT**(RON/THETAN))))**(ONE/RON)


END FUNCTION  FUNCN

 !---------------------------------------------------------


 REAL(DP) FUNCTION DFUNCN(X)
 IMPLICIT NONE

 REAL(DP), INTENT(IN) :: X
 !LOCAL
 REAL(DP), DIMENSION(ZNUM) :: V, VD
 REAL(DP) :: EXP_VNEXT,EXP_VDNEXT, A,B,H
 REAL(DP)::UTIL, OBJ1,OBJ2,OBJ3
 REAL(DP):: SLOPE, WEIGHT1
 INTEGER(I4B):: XGUESS, I




UTIL= ((CASH_S - PBOND_S*X)** RON)
XGUESS=WNOW_S
CALL MYHUNT(WEALTHN, X, XGUESS)
IF (XGUESS>=WNUM)   XGUESS=WNUM-1
IF (XGUESS==0)     XGUESS=1

DO I=1,ZNUM
     H=WEALTHN(XGUESS+1)-WEALTHN(XGUESS)
     A=(WEALTHN(XGUESS+1)-X)/H
     B=(X-WEALTHN(XGUESS))/H
     V(I)=A*VALU_N(XGUESS,I)+B*VALU_N(XGUESS+1,I)+((A**3-A)*COEFFV_N(XGUESS,I)+(B**3-B)*COEFFV_N(XGUESS+1,I))*(H**2)/6.0_SP
     VD(I)=(VALU_N(XGUESS+1,I)-VALU_N(XGUESS,I))/H -((3.0_DP*(A**2)-ONE)/6.0_DP)*H*COEFFV_N(XGUESS,I) +&
                                                                        & ((3.0_DP*(B**2)-ONE)/6.0_DP)*H*COEFFV_N(XGUESS+1,I)

END DO

EXP_VNEXT=SUM(PROBZ(ZNOW_S,:)*(V(:)**THETAN))
EXP_VDNEXT=SUM(PROBZ(ZNOW_S,:)*(V(:)**(THETAN-ONE))*VD(:))

OBJ1= ((((ONE-MYBETA) * UTIL) + (MYBETA * (EXP_VNEXT **( RON/THETAN))))**((ONE/RON)-ONE))	       !(ONE/RO)
OBJ2=(-(ONE- MYBETA)*PBOND_S*((CASH_S -PBOND_S*X)**(RON - ONE)))
OBJ3= MYBETA*(EXP_VNEXT **((RON/THETAN)-ONE))*(EXP_VDNEXT)

DFUNCN= -(OBJ1 * (OBJ2 + OBJ3))

 END FUNCTION DFUNCN



!-----------------------------

SUBROUTINE MYBRAK(AX,BX,CX,FA,FB,FC, BOUNDARY)

REAL(DP), INTENT(INOUT ) :: AX,CX
REAL(DP), INTENT(INOUT) :: BX
REAL(DP), INTENT(OUT) :: FA,FB,FC
INTEGER, INTENT(OUT) :: BOUNDARY

!LOCAL
REAL, PARAMETER::  STEP =0.618
REAL(DP) :: FA_INIT, FC_INIT
INTEGER, PARAMETER:: ITERMAX=40
INTEGER :: I

BOUNDARY=0

FA_INIT= FUNCN(AX)
FC_INIT= FUNCN(CX)

FA=FA_INIT
FC=FC_INIT

  DO I=1,ITERMAX
            BX= AX + STEP* ( CX-AX)
            FB= FUNCN(BX)
            IF (FA<= FC) THEN
                IF (FB <= FA )  THEN
                    !WRITE(*,*) 'BRACKETTING OBTAINED IN', I, 'ITERATIONS'
                    RETURN
                END IF
                IF ((FB > FA ) .AND. (FB <=FC)) THEN
                    CX=BX
                    FC=FB
                ELSEIF ((FB > FA) .AND. (FB >  FC)) THEN
                    WRITE (*,*) 'WE ARE IN MAXIMEZN, PART MYBRAK1 AND WE HAVE A PROBLEM:'
                    WRITE (*,*) 'SOMETHING WRONG WITH BRACKETTING, FA, FB, FC ARE:', FA,FB, FC, AX, BX, CX
                    WRITE (*,*) ' BMAX IS', (CASH_S - EPSC)/PBOND_S
                    WRITE (*,*) 'STATE IS=' ,WNOW_S, KNOW_S, GAMMANOW_S, ZNOW_S

                    CX=BX
                    FC=FB
                   ! PAUSE
                END IF

             ELSEIF (FC< FA) THEN
                IF (FB <= FC )  THEN
                    !WRITE(*,*) 'BRACKETTING OBTAINED IN', I,'ITERATIONS'
                    RETURN
                END IF
                IF ((FB > FC ) .AND. (FB < FA)) THEN
                    AX=BX
                    FA=FB
                ELSEIF ((FB > FC ) .AND. (FB > FA)) THEN
                    WRITE (*,*) 'WE ARE IN MAXIMEZN, PART MYBRAK2 AND WE HAVE A PROBLEM:'
                    WRITE (*,*) 'SOMETHING WRONG WITH BRACKETTING, FA, FB, FC ARE:', FA,FB, FC, AX, BX, CX
                    WRITE (*,*) ' BMAX IS', (CASH_S - EPSC)/PBOND_S
                    WRITE (*,*) 'STATE IS=' ,WNOW_S, KNOW_S, GAMMANOW_S, ZNOW_S
                    AX=BX
                    FA=FB
                   ! PAUSE
                END IF
             END IF
    END DO

IF (FA==FA_INIT) THEN
     BX =0.5*(AX +CX)
     !WRITE (*,*) ' BOUNDARY SOLUTION OBRAINED AT LOWER BOUND IN MYBRAK'
     BOUNDARY=1
ELSEIF (FC==FC_INIT) THEN
     BX=0.5*(AX + CX)
     !WRITE(*,*) ' BOUNDARY SOLUTION OBTAINED AT UPPER BOUND IN MYBRAK'
     BOUNDARY=2
END IF
END SUBROUTINE MYBRAK


!------------------------------------------

 SUBROUTINE MIN1D( FMIN_IN, XMIN_IN,STATE_IN)
 USE MYPARAMSHAB
 IMPLICIT NONE

 REAL(DP), INTENT(INOUT) :: XMIN_IN
 REAL(DP), INTENT(OUT) :: FMIN_IN
 INTEGER(I4B),INTENT(OUT) :: STATE_IN
 !LOCAL
 REAL(DP) :: AX,BX,CX, FA, FB, FC
 INTEGER:: BOUNDARY_IN



 STATE_IN =0
 AX=BMINN
 BX=0.0           !0.0 IS AN ARBITRARY VALUE TO INITIALIZE BX. IT WILL BE SET IN "MYBRAK"
 CX= (CASH_S- EPSC)/PBOND_S


    CALL MYBRAK(AX, BX, CX, FA, FB,FC,  BOUNDARY_IN )

    IF (BOUNDARY_IN==1) THEN
        XMIN_IN=AX
        FMIN_IN=FA
        STATE_IN =1
    ELSEIF (BOUNDARY_IN == 2) THEN
        XMIN_IN = CX
        FMIN_IN = FC
        STATE_IN=1
    ELSEIF (BOUNDARY_IN == 0) THEN
        FMIN_IN= BRENT1(AX,BX, CX,TOL_DBRENT, XMIN_IN, STATE_IN)
    END IF

 END SUBROUTINE MIN1D

 !--------------------------------------------------------

 FUNCTION BRENT1(AX,BX,CX,TOL,XMIN, STATE)
	USE NRTYPE
	IMPLICIT NONE
	REAL(DP), INTENT(IN) :: AX,BX,CX,TOL
	REAL(DP), INTENT(OUT) :: XMIN
        INTEGER, INTENT(OUT) :: STATE
	REAL(DP) :: BRENT1

	INTEGER(I4B), PARAMETER :: ITMAX=100
	REAL(DP), PARAMETER :: CGOLD=0.3819660_DP,ZEPS=1.0E-3_DP*EPSILON(AX)
	INTEGER(I4B) :: ITER
	REAL(DP) :: A,B,D,E,ETEMP,FU,FV,FW,FX,P,Q,R,TOL1,TOL2,U,V,W,X,XM

        STATE=1
	A=MIN(AX,CX)
	B=MAX(AX,CX)
        !WRITE (*,*) ' IN BRENT'
	V=BX
	W=V
	X=V
	E=0.0
        FX=FUNCN(X)
	FV=FX
	FW=FX
	DO ITER=1,ITMAX
		XM=0.5_DP*(A+B)
		TOL1=TOL* ABS(X)+ZEPS
		TOL2=2.0_DP*TOL1
		IF (ABS(X-XM) <= (TOL2-0.5_DP*(B-A))) THEN
			XMIN=X
			BRENT1=FX
			RETURN
		END IF
		IF (ABS(E) > TOL1) THEN
			R=(X-W)*(FX-FV)
			Q=(X-V)*(FX-FW)
			P=(X-V)*Q-(X-W)*R
			Q=2.0_DP*(Q-R)
			IF (Q > 0.0) P=-P
			Q=ABS(Q)
			ETEMP=E
			E=D
			IF (ABS(P) >= ABS(0.5_DP*Q*ETEMP) .OR. &
				P <= Q*(A-X) .OR. P >= Q*(B-X)) THEN
				E=MERGE(A-X,B-X, X >= XM )
				D=CGOLD*E
			ELSE
				D=P/Q
				U=X+D
				IF (U-A < TOL2 .OR. B-U < TOL2) D=SIGN(TOL1,XM-X)
			END IF
		ELSE
			E=MERGE(A-X,B-X, X >= XM )
			D=CGOLD*E
		END IF
		U=MERGE(X+D,X+SIGN(TOL1,D), ABS(D) >= TOL1 )

                !WRITE(*,*) ' EVALUATING AT U, CALLING MIN1D'

                FU=FUNCN(U)


		IF (FU <= FX) THEN
			IF (U >= X) THEN
				A=X
			ELSE
				B=X
			END IF
			CALL SHFT(V,W,X,U)
			CALL SHFT(FV,FW,FX,FU)
		ELSE
			IF (U < X) THEN
				A=U
			ELSE
				B=U
			END IF
			IF (FU <= FW .OR. W == X) THEN
				V=W
				FV=FW
				W=U
				FW=FU
			ELSE IF (FU <= FV .OR. V == X .OR. V == W) THEN
				V=U
				FV=FU
			END IF
		END IF
	END DO
      	IF (ITER > ITMAX) THEN
           WRITE(*,*) 'BRENT1: EXCEEDED MAXIMUM ITERATIONS'
          STATE=0
          PAUSE
        END IF

	END FUNCTION BRENT1
!----------------------------------------------------------

      	SUBROUTINE MOV3(A,B,C,D,E,F)
        USE NRTYPE
	REAL(DP), INTENT(IN) :: D,E,F
	REAL(DP), INTENT(OUT) :: A,B,C
	A=D
	B=E
	C=F
	END SUBROUTINE MOV3



	SUBROUTINE SHFT(A,B,C,D)
        USE NRTYPE
	REAL(DP), INTENT(OUT) :: A
	REAL(DP), INTENT(INOUT) :: B,C
	REAL(DP), INTENT(IN) :: D
	A=B
	B=C
	C=D
	END SUBROUTINE SHFT

!-------


END SUBROUTINE MAXIMEZN

!------------------------------------------------------
!=======================================================


SUBROUTINE MAXIMRA (VALU_RA, WNOW_S, KNOW_S, GAMMANOW_S, ZNOW_S, BOND_S, VALUEMAX_S, WHOCALL, QD, AGWRA)
USE MY_PROCSHAB, ONLY: MYSPLIE2
IMPLICIT NONE


!DUMMY ARGUMENTS
REAL(DP), DIMENSION(WNUM, ZNUM), INTENT(IN) :: VALU_RA
INTEGER, INTENT(IN) :: WNOW_S, KNOW_S, GAMMANOW_S, ZNOW_S
REAL(DP), INTENT(INOUT) :: BOND_S         ! INITIAL GUESS UPON ENTRY.. AND..OPTIMAL SOLUTION UPON EXIT
REAL(DP), INTENT(OUT) :: VALUEMAX_S
CHARACTER, INTENT(IN) :: WHOCALL
REAL(DP), INTENT(IN):: QD, AGWRA


!LOCAL
REAL(DP) ::CASH_S, PBOND_S
REAL(DP) :: XMIN_DBRENT1, FMIN_DBRENT1, BHIGH
INTEGER ::  SUCCESS
REAL(DP), DIMENSION(ZNUM):: DUMMYARRZ
REAL(DP), DIMENSION(WNUM,ZNUM):: COEFFV_RA
REAL(DP), DIMENSION(ZNUM,WNUM):: COEFFT


!LOCAL PARAMETER
REAL(DP):: EPS1
REAL(DP):: TOL_DBRENT

TOL_DBRENT=1.0E-9

DUMMYARRZ=ONE
CALL MYSPLIE2(DUMMYARRZ, WEALTHRA, TRANSPOSE(VALU_RA), COEFFT)
COEFFV_RA=TRANSPOSE(COEFFT)

EPS1= MIN((WEALTHRA(2)-WEALTHRA(1))/10.0, 0.00001_SP)

IF (WHOCALL == 'B') THEN
    PBOND_S = PBOND( KNOW_S, GAMMANOW_S, ZNOW_S)
    CASH_S= WEALTHRA(WNOW_S) + WAGE(KNOW_S, ZNOW_S)
ELSEIF (WHOCALL == 'D') THEN
    !WRITE (*,*)'IN MAXIMLABRA'
    PBOND_S = QD
    CASH_S= AGWRA + WAGE(KNOW_S, ZNOW_S)

ELSE
    WRITE (*,*)' ERROR: VARIABLE "WHOCALL" MAY EITTHER BE DEMAND OR BELLMAN'
END IF

!----------------------------------------
!CHECK TO SEE IF THE INTERVAL IS LARGE ENOUGH FOR THE FOLLOWING MAXIMIZATION ARGUMENTS TO MAKE SENSE..
IF ((CASH_S- PBOND_S*BMINRA)< (EPSC + EPS1)) THEN
    WRITE (*,*)' ERROR AT MAXIMRA, CHECK PART1, CASH_S- BMINRA IS', CASH_S -PBOND_S*BMINRA, BMINRA, CASH_S, PBOND_S
    WRITE (*,*) ' THE INTERVAL FOR BOND CHOICE IS VERY SMALL.. NO FEASIBLE POINT FOUND FOR BOND CHOICE'
    PAUSE
END IF
!-------------------------------------------
!CHECKING FOR A BOUNDARY SOLUTION

BHIGH= (CASH_S - EPSC)/(PBOND_S)
IF (DFUNCRA(BMINRA)>0) THEN
   BOND_S =BMINRA
   VALUEMAX_S = -FUNCRA(BMINRA)
ELSEIF (DFUNCRA(BHIGH) <0) THEN
   BOND_S  =BHIGH
   VALUEMAX_S = -FUNCRA(BHIGH)
END IF

!----------------------------------------

! IF WE ARE HERE THIS MEANS THERE IS NO CORNER SOLUTION SO TRY INTERIOR SOLUTION

CALL MIN1D(FMIN_DBRENT1, XMIN_DBRENT1, SUCCESS)

IF (SUCCESS == 1) THEN
    BOND_S= XMIN_DBRENT1
    VALUEMAX_S = -FMIN_DBRENT1
   ! WRITE(*,*) 'BOND_S AT', WNOW_S, KNOW_S, GAMMANOW_S, ZNOW_S, ' IS ', BOND_S
ELSE
    BOND_S= INERROR
    VALUEMAX_S= INERROR
    WRITE(*,*) 'ERROR IN MAXIMLABRA SUCCESS IS EQUAL TO', SUCCESS
    PAUSE
END IF


!-----------------------------------------------------------------

CONTAINS

 REAL(DP) FUNCTION FUNCRA(X)
 IMPLICIT NONE

 REAL(DP), INTENT(IN) :: X
 !LOCAL
 REAL(DP), DIMENSION(ZNUM) :: V

 INTEGER(I4B) :: I
 REAL(DP) :: EXP_VNEXT, UTIL,SLOPE, WEIGHT1, A, B, H
 INTEGER(I4B):: XGUESS

 IF ((CASH_S - PBOND_S*X) <EPSC/2 ) THEN
  WRITE (*,*) 'CAUTION, CONSUMPTION IS ONLY...=', CASH_S - PBOND_S*X
  PAUSE
 END IF


UTIL= ((CASH_S - PBOND_S*X)** ROJ)
XGUESS=WNOW_S
CALL MYHUNT(WEALTHRA, X, XGUESS)
IF (XGUESS>=WNUM)    XGUESS=WNUM-1
IF (XGUESS==0)      XGUESS=1

DO I=1,ZNUM
     H=WEALTHRA(XGUESS+1)-WEALTHRA(XGUESS)
     A=(WEALTHRA(XGUESS+1)-X)/H
     B=(X-WEALTHRA(XGUESS))/H
     V(I)=A*VALU_RA(XGUESS,I)+B*VALU_RA(XGUESS+1,I)+((A**3-A)*COEFFV_RA(XGUESS,I)+(B**3-B)*COEFFV_RA(XGUESS+1,I))*(H**2)/6.0_SP

END DO

EXP_VNEXT=SUM(PROBZ(ZNOW_S,:)*(V(:)**THETAJ))
FUNCRA= -(((ONE-MYBETA) * UTIL) + (MYBETA * (EXP_VNEXT**(ROJ/THETAJ))))**(ONE/ROJ)


END FUNCTION  FUNCRA

 !---------------------------------------------------------



 REAL(DP) FUNCTION DFUNCRA(X)
 IMPLICIT NONE

 REAL(DP), INTENT(IN) :: X
 !LOCAL
 REAL(DP), DIMENSION(ZNUM) :: V, VD
 REAL(DP) :: EXP_VNEXT,EXP_VDNEXT, A,B,H
 REAL(DP)::UTIL, OBJ1,OBJ2,OBJ3
 REAL(DP):: SLOPE, WEIGHT1
 INTEGER(I4B):: XGUESS, I




UTIL= ((CASH_S - PBOND_S*X)** ROJ)
XGUESS=WNOW_S
CALL MYHUNT(WEALTHRA, X, XGUESS)
IF (XGUESS>=WNUM)   XGUESS=WNUM-1
IF (XGUESS==0)     XGUESS=1

DO I=1,ZNUM
     H=WEALTHRA(XGUESS+1)-WEALTHRA(XGUESS)
     A=(WEALTHRA(XGUESS+1)-X)/H
     B=(X-WEALTHRA(XGUESS))/H
     V(I)=A*VALU_RA(XGUESS,I)+B*VALU_RA(XGUESS+1,I)+((A**3-A)*COEFFV_RA(XGUESS,I)+(B**3-B)*COEFFV_RA(XGUESS+1,I))*(H**2)/6.0_SP
     VD(I)=(VALU_RA(XGUESS+1,I)-VALU_RA(XGUESS,I))/H -((3.0_DP*(A**2)-ONE)/6.0_DP)*H*COEFFV_RA(XGUESS,I) +&
                                                                        & ((3.0_DP*(B**2)-ONE)/6.0_DP)*H*COEFFV_RA(XGUESS+1,I)

END DO

EXP_VNEXT=SUM(PROBZ(ZNOW_S,:)*(V(:)**THETAJ))
EXP_VDNEXT=SUM(PROBZ(ZNOW_S,:)*(V(:)**(THETAJ-ONE))*VD(:))

OBJ1= ((((ONE-MYBETA) * UTIL) + (MYBETA * (EXP_VNEXT **( ROJ/THETAJ))))**((ONE/ROJ)-ONE))	       !(ONE/RO)
OBJ2=(-(ONE- MYBETA)*PBOND_S*((CASH_S -PBOND_S*X)**(ROJ - ONE)))
OBJ3= MYBETA*(EXP_VNEXT **((ROJ/THETAJ)-ONE))*(EXP_VDNEXT)

DFUNCRA= -(OBJ1 * (OBJ2 + OBJ3))

 END FUNCTION DFUNCRA


!-----------------------------

SUBROUTINE MYBRAK(AX,BX,CX,FA,FB,FC, BOUNDARY)

REAL(DP), INTENT(INOUT ) :: AX,CX
REAL(DP), INTENT(INOUT) :: BX
REAL(DP), INTENT(OUT) :: FA,FB,FC
INTEGER, INTENT(OUT) :: BOUNDARY

!LOCAL
REAL, PARAMETER::  STEP =0.618
REAL(DP) :: FA_INIT, FC_INIT
INTEGER, PARAMETER:: ITERMAX=40
INTEGER :: I

BOUNDARY=0

FA_INIT= FUNCRA(AX)
FC_INIT= FUNCRA(CX)

FA=FA_INIT
FC=FC_INIT


  DO I=1,ITERMAX
            BX= AX + STEP* ( CX-AX)
            FB= FUNCRA(BX)
            IF (FA<= FC) THEN
                IF (FB <= FA )  THEN
                    !WRITE(*,*) 'BRACKETTING OBTAINED IN', I, 'ITERATIONS'
                    RETURN
                END IF
                IF ((FB > FA ) .AND. (FB <=FC)) THEN
                    CX=BX
                    FC=FB
                ELSEIF ((FB > FA) .AND. (FB >  FC)) THEN
                    WRITE (*,*) 'WE ARE IN MAXIMLABRA, PART MYBRAK1 AND WE HAVE A PROBLEM:'
                    WRITE (*,*) 'SOMETHING WRONG WITH BRACKETTING, FA, FB, FC ARE:', FA,FB, FC, AX, BX, CX
                    WRITE (*,*) ' BMAX IS', (CASH_S - EPSC)/PBOND_S
                    WRITE (*,*) 'STATE IS=' ,WNOW_S, KNOW_S, GAMMANOW_S, ZNOW_S

                    CX=BX
                    FC=FB
                   ! PAUSE
                END IF

             ELSEIF (FC< FA) THEN
                IF (FB <= FC )  THEN
                    !WRITE(*,*) 'BRACKETTING OBTAINED IN', I,'ITERATIONS'
                    RETURN
                END IF
                IF ((FB > FC ) .AND. (FB < FA)) THEN
                    AX=BX
                    FA=FB
                ELSEIF ((FB > FC ) .AND. (FB > FA)) THEN
                    WRITE (*,*) 'WE ARE IN MAXIMLABRA, PART MYBRAK2 AND WE HAVE A PROBLEM:'
                    WRITE (*,*) 'SOMETHING WRONG WITH BRACKETTING, FA, FB, FC ARE:', FA,FB, FC, AX, BX, CX
                    WRITE (*,*) ' BMAX IS', (CASH_S - EPSC)/PBOND_S
                    WRITE (*,*) 'STATE IS=' ,WNOW_S, KNOW_S, GAMMANOW_S, ZNOW_S
                    AX=BX
                    FA=FB
                   ! PAUSE
                END IF
             END IF
    END DO

IF (FA==FA_INIT) THEN
     BX =0.5*(AX +CX)
     !WRITE (*,*) ' BOUNDARY SOLUTION OBRAINED AT LOWER BOUND IN MYBRAK'
     BOUNDARY=1
ELSEIF (FC==FC_INIT) THEN
     BX=0.5*(AX + CX)
     !WRITE(*,*) ' BOUNDARY SOLUTION OBTAINED AT UPPER BOUND IN MYBRAK'
     BOUNDARY=2
END IF
END SUBROUTINE MYBRAK


!------------------------------------------

 SUBROUTINE MIN1D( FMIN_IN, XMIN_IN,STATE_IN)
 USE MYPARAMSHAB
 IMPLICIT NONE

 REAL(DP), INTENT(INOUT) :: XMIN_IN
 REAL(DP), INTENT(OUT) :: FMIN_IN
 INTEGER(I4B),INTENT(OUT) :: STATE_IN
 !LOCAL
 REAL(DP) :: AX,BX,CX, FA, FB, FC
 INTEGER:: BOUNDARY_IN



 STATE_IN =0
 AX=BMINRA
 BX=0.0           !0.0 IS AN ARBITRARY VALUE TO INITIALIZE BX. IT WILL BE SET IN "MYBRAK"
 CX= (CASH_S- EPSC)/PBOND_S


 IF (AX>=CX) THEN
 WRITE (*,*) 'ERROR IN MIN1D IN MAXIMRA: CX > AX...:', CX, AX
 PAUSE

 END IF

    CALL MYBRAK(AX, BX, CX, FA, FB,FC,  BOUNDARY_IN )

    IF (BOUNDARY_IN==1) THEN
        XMIN_IN=AX
        FMIN_IN=FA
        STATE_IN =1
    ELSEIF (BOUNDARY_IN == 2) THEN
        XMIN_IN = CX
        FMIN_IN = FC
        STATE_IN=1
    ELSEIF (BOUNDARY_IN == 0) THEN
        FMIN_IN= BRENT1(AX,BX, CX,TOL_DBRENT, XMIN_IN, STATE_IN)
    END IF

 END SUBROUTINE MIN1D

 !--------------------------------------------------------

 FUNCTION BRENT1(AX,BX,CX,TOL,XMIN, STATE)
USE NRTYPE
IMPLICIT NONE
REAL(DP), INTENT(IN) :: AX,BX,CX,TOL
REAL(DP), INTENT(OUT) :: XMIN
INTEGER, INTENT(OUT) :: STATE
REAL(DP) :: BRENT1

INTEGER(I4B), PARAMETER :: ITMAX=100
REAL(DP), PARAMETER :: CGOLD=0.3819660_DP,ZEPS=1.0E-3_DP*EPSILON(AX)
INTEGER(I4B) :: ITER
REAL(DP) :: A,B,D,E,ETEMP,FU,FV,FW,FX,P,Q,R,TOL1,TOL2,U,V,W,X,XM

STATE=1
A=MIN(AX,CX)
B=MAX(AX,CX)
!WRITE (*,*) ' IN BRENT'
V=BX
W=V
X=V
E=0.0
FX=FUNCRA(X)
FV=FX
FW=FX
DO ITER=1,ITMAX
	XM=0.5_DP*(A+B)
	TOL1=TOL* ABS(X)+ZEPS
	TOL2=2.0_DP*TOL1
	IF (ABS(X-XM) <= (TOL2-0.5_DP*(B-A))) THEN
		XMIN=X
		BRENT1=FX
		RETURN
	END IF
	IF (ABS(E) > TOL1) THEN
		R=(X-W)*(FX-FV)
		Q=(X-V)*(FX-FW)
		P=(X-V)*Q-(X-W)*R
		Q=2.0_DP*(Q-R)
		IF (Q > 0.0) P=-P
		Q=ABS(Q)
		ETEMP=E
		E=D
		IF (ABS(P) >= ABS(0.5_DP*Q*ETEMP) .OR. &
			P <= Q*(A-X) .OR. P >= Q*(B-X)) THEN
			E=MERGE(A-X,B-X, X >= XM )
			D=CGOLD*E
		ELSE
			D=P/Q
			U=X+D
			IF (U-A < TOL2 .OR. B-U < TOL2) D=SIGN(TOL1,XM-X)
		END IF
	ELSE
		E=MERGE(A-X,B-X, X >= XM )
		D=CGOLD*E
	END IF
	U=MERGE(X+D,X+SIGN(TOL1,D), ABS(D) >= TOL1 )

        !WRITE(*,*) ' EVALUATING AT U, CALLING MIN1D'

        FU=FUNCRA(U)


	IF (FU <= FX) THEN
		IF (U >= X) THEN
			A=X
		ELSE
			B=X
		END IF
		CALL SHFT(V,W,X,U)
		CALL SHFT(FV,FW,FX,FU)
	ELSE
		IF (U < X) THEN
			A=U
		ELSE
			B=U
		END IF
		IF (FU <= FW .OR. W == X) THEN
			V=W
			FV=FW
			W=U
			FW=FU
		ELSE IF (FU <= FV .OR. V == X .OR. V == W) THEN
			V=U
			FV=FU
		END IF
	END IF
END DO
IF (ITER > ITMAX) THEN
   WRITE(*,*) 'BRENT1: EXCEEDED MAXIMUM ITERATIONS'
  STATE=0
  PAUSE
END IF

END FUNCTION BRENT1
!----------------------------------------------------------

SUBROUTINE MOV3(A,B,C,D,E,F)
USE NRTYPE
REAL(DP), INTENT(IN) :: D,E,F
REAL(DP), INTENT(OUT) :: A,B,C
A=D;B=E;C=F;
END SUBROUTINE MOV3



SUBROUTINE SHFT(A,B,C,D)
USE NRTYPE
REAL(DP), INTENT(OUT) :: A
REAL(DP), INTENT(INOUT) :: B,C
REAL(DP), INTENT(IN) :: D
A=B;B=C;C=D
END SUBROUTINE SHFT

!-------


END SUBROUTINE MAXIMRA


!==================================================
END MODULE  MMAXIMHAB

!===================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================


MODULE MBONDSOLVER

USE MYPARAMSHAB

IMPLICIT NONE



!--------------------------
CONTAINS

!-----------------------------------


SUBROUTINE DEMANDB(VALUEFUN_DN, VALUEFUN_DS, PBEQ, BONDN_EQ, STOCKS_EQ, EX_EQ, FAILCOUNT)

USE MY_PROCSHAB, ONLY: INTERP2D
IMPLICIT NONE


REAL(DP), DIMENSION(WNUM, KNUM, GNUM, ZNUM), INTENT(IN) :: VALUEFUN_DN, VALUEFUN_DS
REAL(DP), DIMENSION( KNUM, GNUM, ZNUM),INTENT(OUT) ::PBEQ
REAL(DP), DIMENSION(KNUM, GNUM, ZNUM) :: STOCKS_EQ, BONDN_EQ, EX_EQ
INTEGER, INTENT(OUT) :: FAILCOUNT


!LOCAL
REAL(DP), DIMENSION(WNUM, KNUM, GNUM, ZNUM,ZNUM) :: VALU_DN, VALU_DS
REAL(DP), DIMENSION(KNUM, GNUM, ZNUM) :: FAILVEC
REAL(DP), DIMENSION(WNUM, ZNUM):: VAL_DN, VAL_DS

REAL(DP) :: PRICEB, SS_EQ, BN_EQ, EXCESS_EQ
INTEGER :: ZNOW, GAMMANOW, KNOW
LOGICAL :: SUCCESS


!---------------------------
FAILCOUNT=0
FAILVEC=0

!NOW INTERPOLATING VALUE AT NEXT PERIOD'S K AND GAMMA
 CALL INTERP2D( VALUEFUN_DN, VALU_DN )

!NOW INTERPOLATING VALUE AT NEXT PERIOD'S K AND GAMMA
 CALL INTERP2D( VALUEFUN_DS, VALU_DS )
   

 LOOP11: DO KNOW=1,KNUM
    LOOP12: DO GAMMANOW=1,GNUM
      LOOP13: DO ZNOW=1,ZNUM

      VAL_DN= VALU_DN(1:WNUM, KNOW, GAMMANOW, ZNOW, 1:ZNUM)
      VAL_DS= VALU_DS(1:WNUM, KNOW, GAMMANOW, ZNOW, 1:ZNUM)
      CALL BOND_SOLVER(VAL_DN, VAL_DS, KNOW, GAMMANOW, ZNOW, PRICEB, BN_EQ, SS_EQ, EXCESS_EQ, SUCCESS)

      !WRITE (*,*) 'SOLUTION FOR THIS ROUND FROM BONDSOLVER=' , SS_EQ, BN_EQ, PRICEB
      PBEQ( KNOW, GAMMANOW, ZNOW) = PRICEB
      STOCKS_EQ( KNOW, GAMMANOW,ZNOW) = SS_EQ
      BONDN_EQ( KNOW, GAMMANOW , ZNOW) = BN_EQ
      EX_EQ( KNOW, GAMMANOW , ZNOW) = EXCESS_EQ


      IF (.NOT. SUCCESS ) THEN
         FAILVEC(KNOW, GAMMANOW, ZNOW)=1
         FAILCOUNT= FAILCOUNT+1
      END  IF


      END  DO  LOOP13
    END  DO  LOOP12
 END  DO  LOOP11


END  SUBROUTINE    DEMANDB

!--------------------------------------------------------------


SUBROUTINE BOND_SOLVER(VNEXTN, VNEXTS, KNOW_B, GAMMANOW_B, ZNOW_B, PBONDEQ, BONDN_OUT, STOCKS_OUT, EXCESS_OUT, SUCCESS)
USE MMAXIMHAB, ONLY: MAXIMEZN, MAXIMEZS
IMPLICIT NONE

REAL(DP), DIMENSION(WNUM, ZNUM), INTENT(IN) :: VNEXTN, VNEXTS
REAL(DP), INTENT(OUT) :: PBONDEQ
INTEGER, INTENT(IN) :: KNOW_B, GAMMANOW_B, ZNOW_B
LOGICAL, INTENT(OUT) :: SUCCESS
REAL(DP), INTENT(OUT) :: STOCKS_OUT, BONDN_OUT, EXCESS_OUT


!LOCAL
REAL(DP) :: EXCESSD1, EXCESSD2, EXCESSD, STOCKS, BONDS, BONDN, VALUEMAXS, VALUEMAXN
REAL(DP) ::  QLOW, QHIGH, QMIN, QMAX, QMID, DX, AGWN, AGWS
INTEGER :: J, WNOW_B         
INTEGER, PARAMETER :: MAXBIS = 40


!---------------
WNOW_B = WNUM/2       !THIS VALUE IS TO PASS TO MAXIMEZ, BUT SHOULD HAVE NO EFFECT IN PRINCIPLE
                            !OTHER THAN THAT IT IS THE INITIAL GUESS IN MYHUNT, IN MAXIMEZ
SUCCESS=.TRUE.
!--WEALTH OF EACH AGENT IN CURRENT AGGREGATE STATE----
AGWN= GAMMA(GAMMANOW_B)/(ONE-LAMDA)
AGWS=((PSTOCK(KNOW_B,GAMMANOW_B,ZNOW_B) + DIVD(KNOW_B,GAMMANOW_B,ZNOW_B))*ONE+ (FD - GAMMA(GAMMANOW_B)))/(LAMDA)


QMIN=MIN(MAX(0.92_DP, (AGWN + (WAGE(KNOW_B,ZNOW_B)) - EPSC*10.0_SP)/(BMINN)),MYBETA-0.01_DP)
QMAX=1.05_SP
QLOW=MAX(QMIN+10.0_DP*EPSC,MYBETA-0.04_DP)
QHIGH=0.3_SP*MYBETA+0.7_SP*QMAX

!QMIN=0.85
!QLOW=0.92
!QHIGH=1.1
!QMAX=1.15
IF (QMIN>MYBETA-0.005) THEN
WRITE (*,*) 'ERROR IN MBONDSOLVER.. QMIN GREATER THAN IT SHOULD BE...'
WRITE (*,*) QMIN, MYBETA
PAUSE

END IF
DX= QHIGH-QLOW


!-------------------------------------

!DEMAND AT QLOW
WRITE (*,*) 'PART 1'

!WRITE (*,*) WNOW_B, KNOW_B, GAMMANOW_B, ZNOW_B, STOCKS, BONDS, VALUEMAXS
WRITE (*,*) QLOW, AGWS, AGWN
CALL MAXIMEZS( VNEXTS, WNOW_B, KNOW_B, GAMMANOW_B, ZNOW_B, STOCKS, BONDS, VALUEMAXS, 'D', QLOW, AGWS)
CALL MAXIMEZN( VNEXTN, WNOW_B, KNOW_B, GAMMANOW_B, ZNOW_B, BONDN, VALUEMAXN, 'D', QLOW, AGWN)
EXCESSD1= LAMDA*BONDS + (ONE-LAMDA)* BONDN  - FD
WRITE (*,*) 'EXCESSD1 IS=' , EXCESSD1

!NOTE THAT IF EXCESSD >0 THEN WE HAVE TO INCREAS BOND PRICE, TO REDUCE THE RETURN AND REDUCE DEMAND FOR BOND
CALL MAXIMEZS( VNEXTS, WNOW_B, KNOW_B, GAMMANOW_B, ZNOW_B, STOCKS, BONDS, VALUEMAXS, 'D', QHIGH, AGWS)
CALL MAXIMEZN( VNEXTN, WNOW_B, KNOW_B, GAMMANOW_B, ZNOW_B, BONDN, VALUEMAXN, 'D', QHIGH, AGWN)
EXCESSD2= LAMDA*BONDS + (ONE-LAMDA)* BONDN  - FD
WRITE (*,*) 'EXCESSD2 IS=' , EXCESSD2
!WRITE (*,*) 'RSTOCK HIGH AND LOW ARE=    ', R_STOCK(2), R_STOCK(1)
WRITE (*,*) KNOW_B, GAMMANOW_B, ZNOW_B

!WRITE (*,*) 'DIVDNEXT IS', DIVD_NEXT(KNOW_B, GAMMANOW_B, ZNOW_B,:)
!WRITE (*,*) 'PSTOCKNEXT IS', PSTOCK_NEXT(KNOW_B, GAMMANOW_B, ZNOW_B,:)
!WRITE (*,*)  'CAPITAL_NEXT IS', CAPITAL_NEXT(KNOW_B, GAMMANOW_B, ZNOW_B)



!=====================================================
IF ((EXCESSD1 >0) .AND. (EXCESSD2<0)) THEN                ! LOOKING FOR A ZERO BETWEEN QLOW AND QHIGH
WRITE (*,*) 'PART 2'

      DO J=1, MAXBIS

           DX=0.5_DP * DX
           QMID= QLOW + DX

           CALL MAXIMEZS( VNEXTS, WNOW_B, KNOW_B, GAMMANOW_B, ZNOW_B, STOCKS, BONDS, VALUEMAXS, 'D', QMID, AGWS)
           CALL MAXIMEZN( VNEXTN, WNOW_B, KNOW_B, GAMMANOW_B, ZNOW_B, BONDN, VALUEMAXN, 'D', QMID, AGWN)
           EXCESSD= LAMDA*BONDS + (ONE-LAMDA)* BONDN  - FD

           IF (EXCESSD > 0) THEN
               QLOW=QMID
           END  IF
           IF ((ABS(EXCESSD) < TOL_EXCESSD )) THEN
               PBONDEQ= QMID
               STOCKS_OUT=STOCKS
               BONDN_OUT=BONDN
               EXCESS_OUT=EXCESSD
               WRITE (*,*) 'STOCKS=', STOCKS
               WRITE (*,*) 'BONDS=', BONDS
               WRITE (*,*) 'EXCESSD=', EXCESSD
               WRITE (*,*) 'DX=', DX

               RETURN
           END IF
      END DO
      WRITE (*,*)' NO ROOT FOUND IN', MAXBIS, 'ITERATIONS EVEN THOUGH QLOW AND QHIGH SEEMS TO BRACKET A ZERO'
      WRITE (*,*) 'EXCESSD IS', EXCESSD
      IF ((ABS(EXCESSD) < MIN(5.0E-2_DP, 5000.0_DP*TOL_EXCESSD) )) THEN
           PBONDEQ= QMID
           STOCKS_OUT=STOCKS
           BONDN_OUT=BONDN
           EXCESS_OUT=EXCESSD

           WRITE (*,*) 'THE WEAKER BOUNDS ARE SATISFIED AND THESE PRICES ARE RECORDED'
           RETURN
       END IF
       SUCCESS=.FALSE.
           PBONDEQ= QMID
           STOCKS_OUT=STOCKS
           BONDN_OUT=BONDN
           EXCESS_OUT=EXCESSD

  END  IF
  !-----------------
  IF (EXCESSD1 < 0) THEN           !LOOKING FOR A ZERO BETWEEN QMIN AND QLOW
        ! FIND EXCESS DEMAND AT QMIN
        WRITE (*,*) 'PART 3'

        CALL MAXIMEZS( VNEXTS, WNOW_B, KNOW_B, GAMMANOW_B, ZNOW_B, STOCKS, BONDS, VALUEMAXS, 'D', QMIN, AGWS)
        CALL MAXIMEZN( VNEXTN, WNOW_B, KNOW_B, GAMMANOW_B, ZNOW_B, BONDN, VALUEMAXN, 'D', QMIN, AGWN)
        EXCESSD= LAMDA*BONDS + (ONE-LAMDA)* BONDN - FD
        WRITE (*,*) 'EXCESSD IS=' , EXCESSD

        IF (EXCESSD <0 ) THEN
        WRITE (*,*)' EXCESS SUPPLY OF BONDS EVEN AT QMIN=', QMIN,' SO QUITTING'
        SUCCESS=.FALSE.
        PAUSE
        END  IF
         !IF EXCESSD AT QMIN IS >0 THEN SEARCH FOR A ZERO BETWEEN QMIN AND QLOW
         DX= QLOW-QMIN
         QHIGH=QLOW
         QLOW=QMIN
         DO J=1, MAXBIS

                   DX=0.5_DP * DX
                   QMID= QLOW + DX
                   WRITE (*,*) 'PART 4'

                   CALL MAXIMEZS( VNEXTS, WNOW_B, KNOW_B, GAMMANOW_B, ZNOW_B, STOCKS, BONDS, VALUEMAXS, 'D', QMID, AGWS)
                   CALL MAXIMEZN( VNEXTN, WNOW_B, KNOW_B, GAMMANOW_B, ZNOW_B, BONDN, VALUEMAXN, 'D', QMID, AGWN)
                   EXCESSD= LAMDA*BONDS + (ONE-LAMDA)* BONDN - FD
                   WRITE (*,*) 'EXCESSD IS=' , EXCESSD

                   IF (EXCESSD > 0) THEN
                       QLOW=QMID
                   END  IF

                   IF ((ABS(EXCESSD) < TOL_EXCESSD )) THEN
                       PBONDEQ= QMID
                       STOCKS_OUT=STOCKS
                       BONDN_OUT=BONDN
                       EXCESS_OUT=EXCESSD

                       WRITE (*,*) 'STOCKS=', STOCKS
                       WRITE (*,*) 'BONDS=', BONDS
                       WRITE (*,*) 'EXCESSD=', EXCESSD
                       WRITE (*,*) 'DX=', DX

                       RETURN
                   END IF
          END DO

          WRITE (*,*)' NO ROOT FOUND IN', MAXBIS, 'ITERATIONS BETWEEN QMIN AND QLOW'
          WRITE (*,*) 'EXCESSD IS', EXCESSD

          IF ((ABS(EXCESSD) < MIN(5.0E-2_DP, 5000.0_DP*TOL_EXCESSD) )) THEN
               PBONDEQ= QMID
               STOCKS_OUT=STOCKS
               BONDN_OUT=BONDN
               EXCESS_OUT=EXCESSD

               WRITE (*,*) 'THE WEAKER BOUNDS ARE SATISFIED AND THESE PRICES ARE RECORDED'
               RETURN
          END IF
           PBONDEQ= QMID
           STOCKS_OUT=STOCKS
           BONDN_OUT=BONDN
           EXCESS_OUT=EXCESSD

          SUCCESS=.FALSE.
   END  IF
   !---------------
    IF (EXCESSD2 > 0) THEN           !LOOKING FOR A ZERO BETWEEN QHIGH AND QMAX
         ! FIND EXCESS DEMAND AT QMIN
          WRITE (*,*) 'PART 5'

           CALL MAXIMEZS( VNEXTS, WNOW_B, KNOW_B, GAMMANOW_B, ZNOW_B, STOCKS, BONDS, VALUEMAXS, 'D', QMAX, AGWS)
           CALL MAXIMEZN( VNEXTN, WNOW_B, KNOW_B, GAMMANOW_B, ZNOW_B, BONDN, VALUEMAXN, 'D', QMAX, AGWN)
           EXCESSD= LAMDA*BONDS + (ONE-LAMDA)* BONDN - FD
           WRITE (*,*) 'EXCESSD IS=' , EXCESSD

           IF (EXCESSD >0 ) THEN
           WRITE (*,*)' EXCESS DEMAND FOR BONDS EVEN AT QMAX=', QMAX,' SO QUITTING '
           SUCCESS=.FALSE.
           PAUSE
           END  IF
       !--------------------------------------
       !IF EXCESSD AT QMAX IS < 0 THEN SEARCH FOR A ZERO BETWEEN QHIGH AND QMAX
         DX= QMAX-QHIGH
         QLOW=QHIGH
         QHIGH=QMAX
         DO J=1, MAXBIS
       !  WRITE (*,*) QMID

               DX=0.5_DP * DX
               QMID= QLOW + DX
               WRITE (*,*) 'PART 6'

               CALL MAXIMEZS( VNEXTS, WNOW_B, KNOW_B, GAMMANOW_B, ZNOW_B, STOCKS, BONDS, VALUEMAXS, 'D', QMID, AGWS)
               CALL MAXIMEZN( VNEXTN, WNOW_B, KNOW_B, GAMMANOW_B, ZNOW_B, BONDN, VALUEMAXN, 'D', QMID, AGWN)
               EXCESSD= LAMDA*BONDS + (ONE-LAMDA)* BONDN - FD
               !   WRITE (*,*) 'EXCESSD IS=' , EXCESSD

               IF (EXCESSD > 0) THEN
                       QLOW=QMID
               END  IF
               IF ((ABS(EXCESSD) < TOL_EXCESSD )) THEN
                   PBONDEQ= QMID
                   STOCKS_OUT=STOCKS
                   BONDN_OUT=BONDN
                   EXCESS_OUT=EXCESSD


                   WRITE (*,*) 'STOCKS=', STOCKS
                   WRITE (*,*) 'BONDS=', BONDS
                   WRITE (*,*) 'EXCESSD=', EXCESSD
                   WRITE (*,*) 'DX=', DX

                   RETURN
               END IF
         END DO

         WRITE (*,*)' NO ROOT FOUND IN', MAXBIS, 'ITERATIONS BETWEEN QHIGH AND QMAXW'
         WRITE (*,*) 'EXCESSD IS', EXCESSD

         IF ((ABS(EXCESSD) < MIN(5.0E-2_DP, 5000.0_DP*TOL_EXCESSD) )) THEN
               PBONDEQ= QMID
               STOCKS_OUT=STOCKS
               BONDN_OUT=BONDN
               EXCESS_OUT=EXCESSD

               WRITE (*,*) 'THE WEAKER BOUNDS ARE SATISFIED AND THESE PRICES ARE RECORDED'
               RETURN
         END IF
           PBONDEQ= QMID
           STOCKS_OUT=STOCKS
           BONDN_OUT=BONDN
           EXCESS_OUT=EXCESSD


         SUCCESS= .FALSE.
   END  IF

END  SUBROUTINE BOND_SOLVER

END  MODULE


!==================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================



MODULE BELLMANALL

USE NRTYPE
USE MYPARAMSHAB
USE MY_PROCSHAB, ONLY: MYSPLINE, MYSPLINT3HAB, HOWARD, INTERP2D, WAGE_SUB0, INTEREST_SUB0,  CAP_NEXT0
IMPLICIT NONE

CONTAINS

!=======================================================================

SUBROUTINE BELLMANRA (V_IN, WARMSTART, VALUERBELL, BONDRBELL, CONSRBELL, CHOICE)
 USE MMAXIMHAB, ONLY: MAXIMRA
 IMPLICIT NONE

 REAL(DP), DIMENSION(WNUM, KNUM, GNUM, ZNUM), INTENT(IN) :: V_IN
 LOGICAL , INTENT(IN) :: WARMSTART
 REAL(DP), DIMENSION (WNUM, KNUM, GNUM, ZNUM), INTENT(OUT) ::VALUERBELL, BONDRBELL, CONSRBELL
 INTEGER, INTENT(IN):: CHOICE

!LOCAL
 REAL(SP), PARAMETER:: LAMDA1=1.0_SP, LAMDA2=.6_SP,  LAMDA3=0.4_SP
 INTEGER, PARAMETER:: ITERMAX = 100, CHOICEH=1

 !LOCAL VARIABLE DEFINITION

 INTEGER:: KNOW,  WNOW, GAMMANOW, ZNOW, ITERVAL
 INTEGER, DIMENSION(4):: INDX

 !DEFINE PRICES
 REAL(DP):: BONDRA, VALUEMAXRA, DISCR_BONDRA, AV_DISC_BONDRA, LAMDA_UP
 REAL(DP):: TOL_DISCRRA_IN
 REAL(DP):: TIME0, TIME1, TIME2, TIME3
 REAL(DP), PARAMETER:: LAMDA_EMERG =0.15

 REAL(DP), DIMENSION (:,:) , ALLOCATABLE :: WEALTHSPREAD, WAGESPREAD
 REAL(DP), DIMENSION (:,:,:,:,:), ALLOCATABLE ::  VALUINT_RA
 REAL(DP), DIMENSION (:,:,:,:) , ALLOCATABLE :: VALUERA,  VAL_LAST
 REAL(DP), DIMENSION (:,:,:,:) , ALLOCATABLE :: BONDHOLDRA, BONDHOLDRA_LAST

 !----------------------------

 WRITE (*,*) 'IN BELLMAN RA ...........................'

 ALLOCATE(VALUERA(WNUM, KNUM, GNUM, ZNUM)); ALLOCATE ( VAL_LAST(WNUM, KNUM, GNUM, ZNUM))
 ALLOCATE(BONDHOLDRA(WNUM, KNUM, GNUM, ZNUM)); ALLOCATE ( BONDHOLDRA_LAST(WNUM, KNUM, GNUM, ZNUM))
 ALLOCATE(VALUINT_RA(WNUM, KNUM, GNUM, ZNUM, ZNUM))

 IF (CHOICE ==1) THEN
     BMINRA=BMINS
     ROJ=ROS
     THETAJ=THETAS
     WMINRA=WMINS
     WMAXRA=WMAXS
     WEALTHRA=WEALTHS
 ELSEIF (CHOICE==2) THEN
     BMINRA=BMINN
     ROJ=RON
     THETAJ=THETAN
     WMINRA=WMINN
     WMAXRA=WMAXN
     WEALTHRA=WEALTHN
 ELSE
     WRITE (*,*) ' ERROR IN BELLMAN RA.. CHOICE MUST BE 1 OR 2'
     PAUSE
 END IF


 IF (WARMSTART) THEN
     VALUERA= V_IN
     VAL_LAST =V_IN
 ELSE
     ALLOCATE (WEALTHSPREAD(WNUM ,KNUM)); ALLOCATE (WAGESPREAD(WNUM, KNUM));

     WEALTHSPREAD= SPREAD (WEALTHRA,2, KNUM)              !SPREAD WEALTH VECTOR INTO A MATRIX

     DO GAMMANOW=1, GNUM
        DO ZNOW=1,ZNUM
            WAGESPREAD=SPREAD (WAGE(:,ZNOW),1,WNUM)
            VALUERA (:,:, GAMMANOW, ZNOW)= ((ONE- MYBETA)**(ONE/ROJ))*(WEALTHSPREAD + WAGESPREAD- BMINRA)
        END DO
     END DO
     DEALLOCATE(WEALTHSPREAD, WAGESPREAD )
     VAL_LAST = INERROR
END IF

!------------------------

!SPACE FILLER SINCE "SPLIE2" REQUIRES A FIRST ENTRY
BONDHOLDRA_LAST=INERROR; COUNTHMAX=1
LAMDA_UP=1.0_SP; BONDHOLDRA = ONE

!=====================================================================================
!============================== MAIN  BODY  OF  THE  LOOP  ============================

LOOP1: DO ITERVAL=1, ITERMAX

        IF (ITERVAL>5) THEN
            COUNTHMAX= MIN(8, ITERVAL-5)
        END IF
        CALL CPU_TIME(TIME0)
        WRITE (*,*) '=================================================='
        WRITE (*,*) 'BEGINNING OF ITERATION', ITERVAL
        WRITE (*,*) 'COUNTHMAX', COUNTHMAX

        ! CALL 2 DIMENSIONAL SPLINE CONSTRUCTER
        CALL INTERP2D(VALUERA, VALUINT_RA)
        CALL CPU_TIME(TIME1)
        WRITE (*,*) 'ONE INTERPOLATION TAKES        ', TIME1-TIME0

         ! DONE: SPLINE CONSTRUCT
         !NOWAGENT'S MAXIMIZTAION PROBLEM
         !_________________________________________________________________________________

        OUTER: DO ZNOW=1,ZNUM
 !
          MIDO: DO KNOW=1,KNUM
 !
               MIDI: DO GAMMANOW=1,GNUM
 !
                   INNER: DO WNOW=1,WNUM

                          CALL MAXIMRA (VALUINT_RA(1:WNUM, KNOW, GAMMANOW, ZNOW, 1:ZNUM), &
                                             WNOW, KNOW, GAMMANOW, ZNOW, BONDRA, VALUEMAXRA, 'B', 0.0_DP,0.0_DP)

                          IF (BONDRA >INERROR) THEN
                              BONDRA=  LAMDA_UP*BONDRA + (ONE - LAMDA_UP)*BONDHOLDRA(WNOW,KNOW, GAMMANOW, ZNOW)
                              BONDHOLDRA(WNOW,KNOW,GAMMANOW,ZNOW)=BONDRA
		 	  END IF
                          END DO INNER
                !          PAUSE
                     END DO MIDI
            END DO MIDO
      END DO OUTER

      CALL CPU_TIME(TIME2)
      WRITE (*,*) 'MAXIMIZATION TAKES:    ', TIME2 - TIME1
  !    WRITE (*, 120) BONDHOLDRA
      VALUERA = HOWARD(BONDHOLDRA, BONDHOLDRA, VALUINT_RA, CHOICEH, 'R')
      CALL CPU_TIME(TIME3)
      WRITE (*,*) '=================================================================================='
    !  WRITE (*, 120) VALUERA

     ! WRITE (*,*) '=================================================================================='
      100 FORMAT(1X,200(3X,F20.10))
   !   PAUSE
 120 FORMAT(1X, 10F15.8)


      !------------------------

             ! DEFINE THE DISCREPANCY IN THE DECISION RULES, BETWEEN ITERATIONS
       DISCR_BONDRA= MAXVAL(ABS( BONDHOLDRA_LAST - BONDHOLDRA))
       AV_DISC_BONDRA= (SUM(ABS(BONDHOLDRA_LAST - BONDHOLDRA))/SIZE(BONDHOLDRA))
       INDX= MAXLOC(ABS(BONDHOLDRA_LAST  - BONDHOLDRA))

       WRITE(*,98) 'THE INDEX OF MAXIMUM DEVIATION FOR BOND IS', INDX
       WRITE(*,99) 'THE VALUE AT THAT POINT', BONDHOLDRA_LAST(INDX(1),INDX(2),INDX(3), INDX(4)),&
                                            & BONDHOLDRA(INDX(1),INDX(2),INDX(3),INDX(4))
       WRITE(*,98) 'THE INDEX OF MAXIMUM VALUE DEVIATION IS', MAXLOC( ABS(VAL_LAST -VALUERA))
       WRITE(*,99) 'DISCR_BONDRA IS', DISCR_BONDRA
       WRITE(*,99) ' AVERAGE DEVIATION IN BONDHOLDING', AV_DISC_BONDRA
       WRITE(*,99) 'ONE ITERATION TAKES:    ', TIME3-TIME0
       WRITE(*,99) '_________________________________________________'
       98 FORMAT(1X,A35, 3I8)
       99 FORMAT(1X,A35, 3F15.8)

       IF ((ABS(DISCR_BONDRA) < TOL_DISCRRA_IN)) EXIT LOOP1

       BONDHOLDRA_LAST = BONDHOLDRA
       VAL_LAST = VALUERA

     IF (DISCR_BONDRA >0.4) THEN
           LAMDA_UP=LAMDA1
     ELSE IF (DISCR_BONDRA<0.005) THEN
          LAMDA_UP=LAMDA3
     ELSE
          LAMDA_UP = LAMDA2
     END IF

    TOL_DISCRRA_IN=  1.0E-4


    IF (ITERVAL >= 80) THEN
       WRITE (*,*) ' ITERATION IN BELLMANHABN REACHED 80, DAMPENING THE ITERATION..'
        LAMDA_UP = LAMDA_EMERG
        TOL_DISCRRA_IN =2.0E-4
    END IF

END DO LOOP1

!------------------------------------------------------------
!  MAXIMIZATION LOOP ENDED AND COVERGENCE OBTAINED.. NOW HOUSEKEEPING....
!-------------------------------------------------------------

WRITE(*,*) 'FINAL VALUE OF DISCREPANCY IS:', DISCR_BONDRA
WRITE(*,*) 'AVERAGE DEVIATION IN BOND IS:', AV_DISC_BONDRA

IF (ITERVAL>ITERMAX) THEN
WRITE(*,*) ' PROGRAM COMPLETED, BUT NO CONVERGENCE IN SPECIFIED STEPS'
ELSE
WRITE (*,*) ' PROGRAM COMPLETED SUCCESSFULLY IN', ITERVAL, 'ITERATIONS'
END IF

DO WNOW =1,WNUM
     DO KNOW=1,KNUM
          DO GAMMANOW=1,GNUM
               DO ZNOW=1,ZNUM
                 CONSRBELL(WNOW,KNOW,GAMMANOW,ZNOW) = WEALTHRA(WNOW) + WAGE(KNOW, ZNOW) &
                                          & -PBOND(KNOW,GAMMANOW,ZNOW) * BONDHOLDRA(WNOW,KNOW,GAMMANOW,ZNOW)
               END DO
          END DO
     END DO
END DO

VALUERBELL= VALUERA
BONDRBELL= BONDHOLDRA
DEALLOCATE(VALUERA, BONDHOLDRA, BONDHOLDRA_LAST, VALUINT_RA, VAL_LAST)

END SUBROUTINE BELLMANRA


!=====================================================================================






!====================================================================================

SUBROUTINE BELLMANHABS(V_IN, WARMSTART, VALUESBELL, BONDSBELL, STOCKSBELL, CONSSBELL)

 USE MMAXIMHAB, ONLY: MAXIMEZS
 IMPLICIT NONE

! I/O
 REAL(DP), DIMENSION(WNUM, KNUM, GNUM, ZNUM), INTENT(IN) :: V_IN
 LOGICAL , INTENT(IN) :: WARMSTART
 REAL(DP), DIMENSION (WNUM, KNUM, GNUM, ZNUM), INTENT(OUT) ::VALUESBELL, BONDSBELL, STOCKSBELL, CONSSBELL

 !LOCAL
 REAL(SP), PARAMETER:: LAMDA1=1.0_SP, LAMDA2=0.5_SP,  LAMDA3=0.25_SP,LAMDA4=1.0_SP, LAMDA5=0.6_SP, LAMDA6=0.5_SP
 INTEGER, PARAMETER:: ITERMAX = 75

 INTEGER :: I, J, CHOICE
 INTEGER:: KNOW,  WNOW, GAMMANOW, ZNOW, ITERVAL, REPEATCOUNT, EMERGENCY, LAST_EMERG, COUNT1, COUNT2
 INTEGER, DIMENSION(4):: INDXB, INDXS

 !DEFINE PRICES

 REAL(DP), DIMENSION(ITERMAX) :: DEVS, DEVB
 REAL(DP), DIMENSION (5):: MONOTONB, MONOTONS
 REAL(DP) :: STOCKS, BONDS, VALUEMAXS , TOL_SBOND_IN, TOL_SSTOCK_IN,AV_PASTS, AV_PASTB, AV_S, AV_B
 REAL(DP) :: DISCR_BONDS, DISCR_STOCKS, AV_DISC_BONDS, AV_DISC_STOCKS, LAMDA_UP
 REAL(DP) :: TIME0, TIME1, TIME2,TIME3
 REAL(SP), PARAMETER:: LAMDA_EMERG= 0.2_SP
 LOGICAL:: MONOTON

!---------------

 REAL(DP), DIMENSION(WNUM, KNUM, GNUM, ZNUM) :: BONDSNEW, STOCKSNEW
 REAL(DP), DIMENSION (:,:), ALLOCATABLE :: WEALTHSPREAD, WAGESPREAD
 REAL(DP), DIMENSION (:,:,:,:,:), ALLOCATABLE  ::  VALUINT_S
 REAL(DP), DIMENSION (:,:,:,:), ALLOCATABLE :: VALUES, VAL_LAST        ! VALUE FUNCTION FOR ALL AGES
 REAL(DP), DIMENSION (:,:,:,:), ALLOCATABLE :: STOCKHOLDS, BONDHOLDS, STOCKHOLDS_LAST, BONDHOLDS_LAST

!----------------------

WRITE (*,*) 'IN BELLMANHABS !!!!!!'

CHOICE=1;COUNTHMAX=1;EMERGENCY=0;LAST_EMERG=0
 !----------------------------------


 !-----------------------------------------

 ALLOCATE(VALUES (WNUM, KNUM, GNUM, ZNUM)); ALLOCATE(VAL_LAST(WNUM, KNUM, GNUM, ZNUM))
 ALLOCATE(BONDHOLDS(WNUM, KNUM, GNUM, ZNUM)); ALLOCATE(BONDHOLDS_LAST(WNUM, KNUM, GNUM, ZNUM))
 ALLOCATE(STOCKHOLDS(WNUM, KNUM, GNUM, ZNUM)); ALLOCATE(STOCKHOLDS_LAST(WNUM, KNUM, GNUM, ZNUM))
 ALLOCATE(VALUINT_S(WNUM, KNUM, GNUM, ZNUM, ZNUM))

!---------
 IF (WARMSTART) THEN
     VALUES= V_IN
     VAL_LAST= V_IN
 ELSE
     ALLOCATE (WEALTHSPREAD(WNUM ,KNUM)); ALLOCATE (WAGESPREAD(WNUM, KNUM));

    WEALTHSPREAD= SPREAD (WEALTHS,2, KNUM)              !SPREAD WEALTH VECTOR INTO A MATRIX

    DO GAMMANOW=1, GNUM
       DO ZNOW=1,ZNUM
        WAGESPREAD=SPREAD (WAGE (:,ZNOW),1,WNUM)
        VALUES (:,:, GAMMANOW, ZNOW)=((ONE- MYBETA)**(ONE/ROS))*(WEALTHSPREAD + WAGESPREAD -STMINS -BMINS)
       END DO
    END DO
    DEALLOCATE(WEALTHSPREAD, WAGESPREAD)
    VAL_LAST= INERROR
END IF
!---------------------------------------------------------
!INITIALIZING A FEW VARIABLES..
BONDHOLDS_LAST=INERROR;STOCKHOLDS_LAST=INERROR
LAMDA_UP=1;TOL_SBOND_IN= TOL_SBOND;TOL_SSTOCK_IN =TOL_SSTOCK

!-------------------------------------------------
! ITERATION STARTS HERE.................
!--------------------------------------------------

COUNT1=FLOOR(30/REAL(ITERMAIN))
COUNT2=FLOOR(REAL(ITERMAIN/10)+1)
LOOP1: DO ITERVAL=1, ITERMAX


        IF (ITERVAL>COUNT1) THEN
            COUNTHMAX= MIN(MAX(10-COUNT2,2), ITERVAL-COUNT1)
            COUNTHMAX=MAX(1,COUNTHMAX-FLOOR(0.5*SQRT(REAL(ITERVAL-COUNT1))))
        END IF
        ITERVAL_GLOBS=ITERVAL
        CALL CPU_TIME(TIME0)
        WRITE (*,*) '=================================================='
        WRITE (*,*) 'BEGINNING OF ITERATION', ITERVAL
        WRITE (*,*) 'COUNTHMAX             ', COUNTHMAX

        ! CALL 2 DIMENSIONAL SPLINE CONSTRUCTER
        CALL INTERP2D(VALUES, VALUINT_S)
        CALL CPU_TIME(TIME1)
        WRITE (*,*) 'ONE INTERPOLATION TAKES        ', TIME1-TIME0

         !----------------------------------------  MAXIMIZATION   LOOP ----------------------
        OUTER: DO ZNOW=1,ZNUM
 !
            MIDO: DO KNOW=1,KNUM
 !
               MIDI: DO GAMMANOW=1,GNUM
 !
                   INNER: DO WNOW=1,WNUM

                        CALL MAXIMEZS(VALUINT_S(1:WNUM, KNOW, GAMMANOW,ZNOW, 1:ZNUM), &
                                     WNOW, KNOW, GAMMANOW, ZNOW, STOCKS, BONDS, VALUEMAXS, 'B', 0.0_DP,0.0_DP)

                          IF (( BONDS >INERROR) .AND. (STOCKS >INERROR)) THEN
                               BONDSNEW(WNOW,KNOW,GAMMANOW,ZNOW) = BONDS
                               STOCKSNEW(WNOW,KNOW,GAMMANOW,ZNOW)= STOCKS
                               BONDS= LAMDA_UP*BONDSNEW(WNOW,KNOW,GAMMANOW,ZNOW) &
                                        & +(ONE -LAMDA_UP)*BONDHOLDS(WNOW, KNOW, GAMMANOW, ZNOW)
			       STOCKS=LAMDA_UP*STOCKSNEW(WNOW, KNOW,GAMMANOW,ZNOW)&
                                      & + (ONE - LAMDA_UP)* STOCKHOLDS(WNOW, KNOW, GAMMANOW, ZNOW)
                               BONDHOLDS(WNOW, KNOW, GAMMANOW, ZNOW)= BONDS
			       STOCKHOLDS(WNOW, KNOW, GAMMANOW, ZNOW)= STOCKS
			  ELSE
                               BONDHOLDS(WNOW, KNOW, GAMMANOW, ZNOW)= INERROR
			       STOCKHOLDS(WNOW, KNOW, GAMMANOW, ZNOW)= INERROR
			  END IF
                          END DO INNER
                     END DO MIDI
               END DO MIDO
          END DO OUTER

         CALL CPU_TIME(TIME2)
         WRITE (*,*) 'MAXIMIZATION TAKES:    ', TIME2 - TIME1
         VALUES = HOWARD(BONDHOLDS, STOCKHOLDS, VALUINT_S, CHOICE, 'S')
         CALL CPU_TIME(TIME3)


 !-------------------------------------------------
 !-----------------------------------------

       ! DEFINE THE DISCREPANCY IN THE DECISION RULES, BETWEEN ITERATIONS
       DISCR_BONDS= MAXVAL(ABS( BONDHOLDS_LAST - BONDSNEW))
       DISCR_STOCKS=  MAXVAL(ABS( STOCKHOLDS_LAST - STOCKSNEW))
       AV_DISC_BONDS= (SUM(ABS(BONDHOLDS_LAST - BONDSNEW))/SIZE(BONDSNEW))
       AV_DISC_STOCKS= (SUM(ABS(STOCKHOLDS_LAST - STOCKSNEW))/SIZE(STOCKSNEW))
       INDXB= MAXLOC(ABS(BONDHOLDS_LAST  - BONDSNEW))
       INDXS= MAXLOC(ABS(STOCKHOLDS_LAST  - STOCKSNEW))


       WRITE(*,98) 'THE INDEX OF MAXIMUM DEVIATION FOR STOCK AND BOND  ARE', INDXS, '***', INDXB
       WRITE(*,99) 'THE VALUE AT THAT POINT FOR BOND IS', BONDHOLDS_LAST(INDXB(1),INDXB(2),INDXB(3), INDXB(4)),&
                                            & BONDSNEW(INDXB(1),INDXB(2),INDXB(3),INDXB(4))
       WRITE(*,99) 'THE VALUE AT THAT POINT FOR STOCK IS', STOCKHOLDS_LAST(INDXS(1),INDXS(2),INDXS(3), INDXS(4)),&
                                            & STOCKSNEW(INDXS(1),INDXS(2),INDXS(3),INDXS(4))
       WRITE(*,98) 'THE INDEX OF MAXIMUM VALUE DEVIATION IS', MAXLOC( ABS(VAL_LAST -VALUES))
       WRITE(*,99) 'DISCR_BONDS IS',  BONDSNEW(INDXB(1),INDXB(2),INDXB(3),INDXB(4))- &
                                     & BONDHOLDS_LAST(INDXB(1),INDXB(2),INDXB(3), INDXB(4))
       WRITE(*,99) 'DISCR_STOCKS IS',  STOCKSNEW(INDXS(1),INDXS(2),INDXS(3),INDXS(4))- &
                                       & STOCKHOLDS_LAST(INDXS(1),INDXS(2),INDXS(3), INDXS(4))

       WRITE(*,99) ' AVERAGE DEVIATION IN BONDHOLDING OF THE BONDHOLDERS', AV_DISC_BONDS
       WRITE(*,99) 'ONE ITERATION TAKES:    ', TIME3-TIME0
       98 FORMAT(1X,A35, 4I4, A5, 4I4)
       99 FORMAT(1X,A35, 3F15.8)
       WRITE (*,*) 'ITERMAIN, TOLERANCE IS', ITERMAIN, TOL_SBOND_IN

       ! UPDATING PREVIOUS PERIOD'S STOCK AND BOND HOLDING'S WITH THE NEW ONES
       BONDHOLDS_LAST = BONDHOLDS
       STOCKHOLDS_LAST= STOCKHOLDS
       VAL_LAST = VALUES

       IF ((AV_DISC_BONDS <3.0E-5) .AND. (AV_DISC_STOCKS < 3.0E-5)) EXIT LOOP1
       IF ((ABS(DISCR_BONDS) < TOL_SBOND_IN  ) .AND. (ABS(DISCR_STOCKS) < TOL_SSTOCK_IN)) EXIT LOOP1

!------------

       ! CHECKING IF THE ITERATION IS IN A LOOP
       DEVB (ITERVAL) =  BONDSNEW(INDXB(1),INDXB(2),INDXB(3),INDXB(4))- &
                                     & BONDHOLDS_LAST(INDXB(1),INDXB(2),INDXB(3), INDXB(4))
       DEVS (ITERVAL) =  STOCKSNEW(INDXS(1),INDXS(2),INDXS(3),INDXS(4))- &
                                       & STOCKHOLDS_LAST(INDXS(1),INDXS(2),INDXS(3), INDXS(4))


       IF ((ITERVAL > 15 ) .AND. (ITERVAL > LAST_EMERG +4)) THEN
           REPEATCOUNT=0
           DO I=1,5
               DO J=1,10
                   IF ((ABS( DEVS(ITERVAL-I+1) - DEVS (ITERVAL-4 -J)) < 1.0E-8) .OR. &
                       & (ABS( DEVB(ITERVAL-I+1) - DEVB (ITERVAL-4 -J)) < 1.0E-8))  THEN
                       REPEATCOUNT= REPEATCOUNT + 1
                   END IF
               END DO
           END DO
           IF (REPEATCOUNT >=3) THEN
           EMERGENCY= EMERGENCY +1
           LAST_EMERG= ITERVAL
           END IF

       END IF

       MONOTON=.FALSE.
       IF ((ITERVAL >20) .AND. (ITERVAL > LAST_EMERG +4)) THEN
          MONOTONS = DEVS(ITERVAL-4:ITERVAL)
          MONOTONB = DEVB(ITERVAL-4:ITERVAL)

          IF ((ALL(MONOTONB < 0) .OR. (ALL(MONOTONB >0))) .AND.  ((ALL(MONOTONS <0)) .OR. (ALL(MONOTONS >0)))) THEN
          MONOTON=.TRUE.
          END IF

          AV_PASTS=SUM(DEVS(ITERVAL-19:ITERVAL-10))/10.0
          AV_PASTB=SUM(DEVB(ITERVAL-19:ITERVAL-10))/10.0
          AV_S= SUM(DEVS(ITERVAL-9:ITERVAL))/10.0
          AV_B = SUM(DEVB(ITERVAL-9:ITERVAL))/10.0

          IF (((AV_PASTS < 1.2*AV_S) .OR. (AV_PASTB < 1.2*AV_B)) .AND. (.NOT. MONOTON))  THEN
              EMERGENCY = EMERGENCY+1
              LAST_EMERG=ITERVAL
          END IF


       END IF

    ! UPDATING LAMDA, THE DAMPENING RATIO.....
    IF ((EMERGENCY == 0) .OR. (ITERVAL > LAST_EMERG + 10) .OR. ( MONOTON)) THEN

        IF (ITERMAIN<15) THEN
        IF (MAX(DISCR_BONDS, DISCR_STOCKS) >0.4) THEN
            LAMDA_UP=LAMDA1
        ELSE IF (MAX(DISCR_BONDS, DISCR_STOCKS)<0.005) THEN
            LAMDA_UP=LAMDA3
        ELSE
            LAMDA_UP = LAMDA2
        END IF
        TOL_SBOND_IN= MAX( (TOL_SBOND/(REAL(ITERMAIN)**2)), 1.0E-4_DP)
        TOL_SSTOCK_IN= MAX( (TOL_SSTOCK/(REAL(ITERMAIN)**2)), 1.0E-4_DP)

        ELSE
        IF (MAX(DISCR_BONDS, DISCR_STOCKS) >0.4) THEN
           LAMDA_UP=LAMDA4
        ELSE IF (MAX(DISCR_BONDS, DISCR_STOCKS)<0.005) THEN
           LAMDA_UP=LAMDA5
        ELSE
           LAMDA_UP = LAMDA6
        END IF
        TOL_SBOND_IN= MAX( (TOL_SBOND/(REAL(ITERMAIN)**2)), 1.0E-4_DP)
        TOL_SSTOCK_IN= MAX( (TOL_SSTOCK/(REAL(ITERMAIN)**2)), 1.0E-4_DP)
        END IF
    ELSE
        WRITE (*,*) ' ITERATION IN BELLMANHABS GOT IN A LOOP OR NO IMPROVEMENT...'
        WRITE (*,*) 'DAMPENING THE ITERATION, EMERGENCY=', EMERGENCY
        LAMDA_UP = MAX(LAMDA_EMERG/ EMERGENCY, 0.05_DP)
        TOL_SBOND_IN= 5.0E-4
        TOL_SSTOCK_IN=5.0E-4

    END IF

    IF (ITERVAL > 70) THEN
      LAMDA_UP =LAMDA_EMERG/3
      TOL_SBOND_IN= 1.0E-3
      TOL_SSTOCK_IN=1.0E-3
    END IF
    IF ((ITERVAL >= 80) .AND. (ABS(DISCR_STOCKS) < 0.01) .AND. (ABS(DISCR_BONDS) < 0.01)) EXIT LOOP1
    WRITE (*,*) 'ITERATION NUMBER =', ITERVAL, ' COMPLETED.'

END DO LOOP1

!------------------------------------------------------------
!  MAXIMIZATION LOOP ENDED AND COVERGENCE OBTAINED.. NOW HOUSEKEEPING....
!-------------------------------------------------------------
100 FORMAT(1X,200(3X,F20.10))

WRITE(*,*) 'FINAL VALUE OF DISCREPANCY IS:', DISCR_BONDS
WRITE(*,*) 'AVERAGE DEVIATION IN STOCK IS:', AV_DISC_BONDS

IF (ITERVAL>ITERMAX) THEN
    WRITE(*,*) ' PROGRAM COMPLETED, BUT NO CONVERGENCE IN SPECIFIED STEPS'
ELSE
    WRITE (*,*) ' PROGRAM COMPLETED SUCCESSFULLY IN', ITERVAL, 'ITERATIONS'
END IF

DO WNOW =1,WNUM
     DO I=1,KNUM
          DO J=1,GNUM
               DO ZNOW=1,ZNUM
                 CONSSBELL(WNOW,I,J,ZNOW) = WEALTHS(WNOW) + WAGE(I,ZNOW) &
                                          & -PBOND(I,J,ZNOW) * BONDHOLDS(WNOW,I,J,ZNOW) - PSTOCK(I,J,ZNOW)*STOCKHOLDS(WNOW,I,J,ZNOW)
               END DO
          END DO
     END DO
END DO

VALUESBELL= VALUES
BONDSBELL= BONDHOLDS
STOCKSBELL= STOCKHOLDS

DEALLOCATE(VALUES, BONDHOLDS, STOCKHOLDS, STOCKHOLDS_LAST, BONDHOLDS_LAST, VALUINT_S, VAL_LAST)
END SUBROUTINE BELLMANHABS
!=======================================================================================




!=======================================================================

SUBROUTINE BELLMANHABN (V_IN, WARMSTART, VALUENBELL, BONDNBELL, CONSNBELL)
 USE MMAXIMHAB, ONLY: MAXIMEZN
 IMPLICIT NONE

 REAL(DP), DIMENSION(WNUM, KNUM, GNUM, ZNUM), INTENT(IN) :: V_IN
 LOGICAL , INTENT(IN) :: WARMSTART
 REAL(DP), DIMENSION (WNUM, KNUM, GNUM, ZNUM), INTENT(OUT) ::VALUENBELL, BONDNBELL, CONSNBELL

!LOCAL
 REAL(SP), PARAMETER:: LAMDA1=1.0_SP, LAMDA2=.6_SP,  LAMDA3=0.4_SP, TOL_DISCRN= 1.0E-3_SP
 INTEGER, PARAMETER:: ITERMAX = 100, CHOICEH=1

 !LOCAL VARIABLE DEFINITION
 INTEGER:: KNOW,  WNOW, GAMMANOW, ZNOW, ITERVAL, I, J, COUNT1, COUNT2
 INTEGER, DIMENSION(4):: INDX

 !DEFINE PRICES
 REAL(DP):: BONDN, VALUEMAXN, DISCR_BONDN, DISCR_VAL, AV_DISC_BONDN, LAMDA_UP, TOL_DISCRN_IN, TIME0, TIME1, TIME2, TIME_LAG, TIME3
 REAL(DP), PARAMETER:: LAMDA_EMERG =0.15

 REAL(DP), DIMENSION (:,:) , ALLOCATABLE :: WEALTHSPREAD, WAGESPREAD
 REAL(DP), DIMENSION (:,:,:,:,:), ALLOCATABLE ::  VALUINT_N
 REAL(DP), DIMENSION (:,:,:,:) , ALLOCATABLE :: VALUEN,  VAL_LAST
 REAL(DP), DIMENSION (:,:,:,:) , ALLOCATABLE :: BONDHOLDN, BONDHOLDN_LAST

 !----------------------------

 WRITE (*,*) 'IN BELLMANEZ N ...........................'

 ALLOCATE(VALUEN(WNUM, KNUM, GNUM, ZNUM)); ALLOCATE ( VAL_LAST(WNUM, KNUM, GNUM, ZNUM))
 ALLOCATE(BONDHOLDN(WNUM, KNUM, GNUM, ZNUM)); ALLOCATE ( BONDHOLDN_LAST(WNUM, KNUM, GNUM, ZNUM))
 ALLOCATE(VALUINT_N(WNUM, KNUM, GNUM, ZNUM, ZNUM))

 IF (WARMSTART) THEN
     VALUEN= V_IN
     VAL_LAST =V_IN
 ELSE
     ALLOCATE (WEALTHSPREAD(WNUM ,KNUM)); ALLOCATE (WAGESPREAD(WNUM, KNUM));

     WEALTHSPREAD= SPREAD (WEALTHN,2, KNUM)              !SPREAD WEALTH VECTOR INTO A MATRIX

     DO GAMMANOW=1, GNUM
        DO ZNOW=1,ZNUM
            WAGESPREAD=SPREAD (WAGE (:,ZNOW),1,WNUM)
            VALUEN (:,:, GAMMANOW, ZNOW)= ((ONE- MYBETA)**(ONE/RON))*(( WEALTHSPREAD + WAGESPREAD- BMINN ))
        END DO
     END DO
     DEALLOCATE(WEALTHSPREAD, WAGESPREAD )
     VAL_LAST = INERROR
END IF

!------------------------

!USELESS ARRAY, SPACE FILLER SINCE "SPLIE2" REQUIRES A FIRST ENTRY
BONDHOLDN_LAST=INERROR; COUNTHMAX=1
LAMDA_UP=1.0_SP; BONDHOLDN = ONE; TOL_DISCRN_IN = TOL_DISCRN

!=====================================================================================
!============================== MAIN  BODY  OF  THE  LOOP  ============================

COUNT1=FLOOR(30/REAL(ITERMAIN))
COUNT2=FLOOR(REAL(ITERMAIN/10)+1)
LOOP1: DO ITERVAL=1, ITERMAX


        IF (ITERVAL>COUNT1) THEN
            COUNTHMAX= MIN(MAX(10-COUNT2,2), ITERVAL-COUNT1)
            COUNTHMAX=MAX(1,COUNTHMAX-FLOOR(0.5_SP*SQRT(REAL(ITERVAL-COUNT1))))
        END IF
        ITERVAL_GLOBN=ITERVAL

CALL CPU_TIME(TIME0)

WRITE (*,*) '=================================================='
WRITE (*,*) 'BEGINNING OF ITERATION', ITERVAL
WRITE (*,*) 'COUNTHMAX', COUNTHMAX



! CALL 2 DIMENSIONAL SPLINE CONSTRUCTER
CALL INTERP2D(VALUEN, VALUINT_N)
CALL CPU_TIME(TIME1)
WRITE (*,*) 'ONE INTERPOLATION TAKES        ', TIME1-TIME0


 ! DONE: SPLINE CONSTRUCT
 !NOWAGENT'S MAXIMIZTAION PROBLEM
 !_________________________________________________________________________________

 OUTER: DO ZNOW=1,ZNUM
 !
      MIDO: DO KNOW=1,KNUM
 !
               MIDI: DO GAMMANOW=1,GNUM
 !
                   INNER: DO WNOW=1,WNUM

                          CALL MAXIMEZN (VALUINT_N(1:WNUM, KNOW, GAMMANOW, ZNOW, 1:ZNUM), &
                                             WNOW, KNOW, GAMMANOW, ZNOW, BONDN, VALUEMAXN, 'B', 0.0_DP,0.0_DP)

                          IF (BONDN >INERROR) THEN
                              BONDN=  LAMDA_UP*BONDN + (ONE - LAMDA_UP)*BONDHOLDN(WNOW,KNOW, GAMMANOW, ZNOW)
                              BONDHOLDN(WNOW,KNOW,GAMMANOW,ZNOW)=BONDN
			  END IF
                          END DO INNER
                     END DO MIDI
            END DO MIDO
      END DO OUTER

      CALL CPU_TIME(TIME2)
      WRITE (*,*) 'MAXIMIZATION TAKES:    ', TIME2 - TIME1
      VALUEN = HOWARD(BONDHOLDN, BONDHOLDN, VALUINT_N, CHOICEH, 'N')
      CALL CPU_TIME(TIME3)
      100 FORMAT(1X,200(3X,F20.10))

      !------------------------

       ! DEFINE THE DISCREPANCY IN THE DECISION RULES, BETWEEN ITERATIONS
       DISCR_BONDN= MAXVAL(ABS( BONDHOLDN_LAST - BONDHOLDN))

       AV_DISC_BONDN= (SUM(ABS(BONDHOLDN_LAST - BONDHOLDN))/SIZE(BONDHOLDN))
       INDX= MAXLOC(ABS(BONDHOLDN_LAST  - BONDHOLDN))

       WRITE(*,98) 'THE INDEX OF MAXIMUM DEVIATION IS', INDX
       WRITE(*,99) 'THE VALUE AT THAT POINT', BONDHOLDN_LAST(INDX(1),INDX(2),INDX(3), INDX(4)),&
                                            & BONDHOLDN(INDX(1),INDX(2),INDX(3),INDX(4))
       WRITE(*,98) 'THE INDEX OF MAXIMUM VALUE DEVIATION IS', MAXLOC( ABS(VAL_LAST -VALUEN))
       WRITE(*,99) 'DISCR_BONDN IS', DISCR_BONDN
       WRITE(*,99) ' AVERAGE DEVIATION IN BONDHOLDING OF THE BONDHOLDERS', AV_DISC_BONDN
       WRITE(*,99) 'ONE ITERATION TAKES:    ', TIME3-TIME0
       WRITE(*,99) '_________________________________________________'
       98 FORMAT(1X,A35, 3I8)
       99 FORMAT(1X,A35, 3F15.8)

       IF (ABS(DISCR_BONDN) < TOL_DISCRN_IN  ) EXIT LOOP1

       BONDHOLDN_LAST = BONDHOLDN
       VAL_LAST = VALUEN

     IF (DISCR_BONDN >0.4) THEN
           LAMDA_UP=LAMDA1
     ELSE IF (DISCR_BONDN<0.005) THEN
          LAMDA_UP=LAMDA3
     ELSE
          LAMDA_UP = LAMDA2
     END IF

    TOL_DISCRN_IN= MAX( (TOL_DISCRN/(REAL(ITERMAIN)**2)), 1.0E-4_DP)

    IF (ITERVAL >= 80) THEN
       WRITE (*,*) ' ITERATION IN BELLMANHABN REACHED 80, DAMPENING THE ITERATION..'
        LAMDA_UP = LAMDA_EMERG
        TOL_DISCRN_IN =1.0E-3
    END IF

END DO LOOP1

!------------------------------------------------------------
!  MAXIMIZATION LOOP ENDED AND COVERGENCE OBTAINED.. NOW HOUSEKEEPING....
!-------------------------------------------------------------

WRITE(*,*) 'FINAL VALUE OF DISCREPANCY IS:', DISCR_BONDN
WRITE(*,*) 'AVERAGE DEVIATION IN STOCK IS:', AV_DISC_BONDN

IF (ITERVAL>ITERMAX) THEN
WRITE(*,*) ' PROGRAM COMPLETED, BUT NO CONVERGENCE IN SPECIFIED STEPS'
ELSE
WRITE (*,*) ' PROGRAM COMPLETED SUCCESSFULLY IN', ITERVAL, 'ITERATIONS'
END IF

DO WNOW =1,WNUM
     DO I=1,KNUM
          DO J=1,GNUM
               DO ZNOW=1,ZNUM
                 CONSNBELL(WNOW,I,J,ZNOW) = WEALTHN(WNOW) + WAGE(I,ZNOW) &
                                          & -PBOND(I,J,ZNOW) * BONDHOLDN(WNOW,I,J,ZNOW)
               END DO
          END DO
     END DO
END DO

VALUENBELL= VALUEN
BONDNBELL= BONDHOLDN

DEALLOCATE(VALUEN, BONDHOLDN, BONDHOLDN_LAST, VALUINT_N, VAL_LAST)
END SUBROUTINE BELLMANHABN

END MODULE BELLMANALL


!===================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================
!===================================================================================================




PROGRAM MAINEQ

USE NRTYPE
USE MYPARAMSHAB
USE MY_FIRMHAB
USE MY_PROCSHAB, ONLY:WAGE_SUB, INTEREST_SUB, GAMMA_NEXTV, INTERESTNEXT_SUB, MYHUNT, INITIALIZER, OUTERPROD, &
                      & MYECHO_2, MYECHO_3, MYECHO_4
USE BELLMANALL, ONLY: BELLMANRA, BELLMANHABS, BELLMANHABN
USE MBONDSOLVER, ONLY:DEMANDB
IMPLICIT NONE

 !LOCAL
 REAL(DP), DIMENSION (WNUM, KNUM, GNUM, ZNUM) :: VALUES_M, VALUEN_M, VS_GUESS, VN_GUESS
 REAL(DP), DIMENSION(WNUM, KNUM, GNUM, ZNUM):: CONSS_M, CONSN_M, BONDS_M, BONDN_M, STOCKS_M
 REAL(DP), DIMENSION(KNUM,GNUM,ZNUM,ZNUM):: RSNEXT
 REAL(DP), DIMENSION(KNUM, GNUM, ZNUM) :: PBEQ, PB_LAG, GAMNEXT_LAG, CAPNEXT_LAG,RB, INVEST_M, CAPITAL_NEXT_TEMP, EXCESS_EQ
 REAL(DP), DIMENSION(KNUM, GNUM, ZNUM) :: STOCKS_EQ, BONDN_EQ, DISCRPS, PSTOCKNEW
 REAL(DP) :: DISCR_PBOND , DISCR_PSTOCK, DISCR_CAPITAL, DISCR_GAMM, AVG_PBOND, AVG_PSTOCK, AVG_CAPITAL, AVG_GAMM
 REAL(DP):: WEIGHTP, STDZ_SCALED, FDDUM, THETAS_0, ROS_0


 INTEGER, DIMENSION(3) :: INDXPBOND, INDXPSTOCK, INDX_CAP, INDX_GAMM
 INTEGER:: L, I, J,G, FAILCOUNT, GAMMANOW,ZNOW , ZNEXT, INITONE, INIT_ITERNUM
 INTEGER:: CONTAINED, TERMINATE, INDMAX, WHETHERCONS, NMAX,NMAXSMALL, INDMAXSMALL, INDMAXX
 LOGICAL:: WARMSTART

 !ALLOCATABLES
 REAL(DP), DIMENSION(:,:,:), ALLOCATABLE :: PSTOCK0, PBOND0, INVEST0,DISCR
 REAL(DP), DIMENSION(:,:), ALLOCATABLE :: CONSS_V, VALUES_V, VALUEN_V, CAPITAL_NEXT_V, GAM_NEXT_V, INVEST_V, CAPITAL_NEXTZZZ
 REAL(DP), DIMENSION(:,:), ALLOCATABLE:: STOCKS_V, BONDS_V, BONDN_V,  PBEQ_Z,  GAM_NEXTZ,PSTOCKZ,DIVDZ,INVESTZ,CONSN_V
 INTEGER, PARAMETER:: ITMAX_MAIN = 300


!===================================================================================================
!================================== M A I N      C O D E     B E G I N S    H E R E ===============
!===================================================================================================

!SET PREFERENCE PARAMETERS
ROS = -3.0_DP
RON = -9.0_DP
THETAS= -3.0_DP
THETAN= -9.0_DP

ROS_0=ROS
THETAS_0=THETAS

FDDUM=0.0_DP

SETINVEST=0
MEANZ=0.15_SP
STDZ_SCALED=STDZ*MEANZ
ZGRID= MEANZ+ (/ (-(ZNUM-1)*STDZ_SCALED/2 + (I-1)* STDZ_SCALED, I=1,ZNUM) /)  ;

TERMINATE=0;
PB_LAG = INERROR; CAPNEXT_LAG= INERROR; GAMNEXT_LAG = INERROR
WEIGHTP=0.25;
WRITE (*,*) '=========================================================================================='
WRITE (*,*) '====================  PROGRAM VERSION 10/01/04 ---- TIME =5:40PM   ========================'
WRITE (*,*) '=========================================================================================='

!CALL THE INITIALIZER CODE
CALL INITIALIZER()

CAPITAL_SPREAD= SPREAD(SPREAD (CAPITAL,2,GNUM),3,ZNUM)
INITONE=1;

!=======================================================================================================
!=======================================================================================================
 WRITE (*,*) 'ENTER THE INITIAL INTERATION NUMBER        >>'
 READ (*,*) INIT_ITERNUM
 !INIT_ITERNUM=0
 INITONE= INIT_ITERNUM

 IF (INIT_ITERNUM >1) THEN
 !START READING IN DATA FROM PREVIOUS ITERATIONS.....

        STDZ_SCALED=STDZ*MEANZ
        ZGRID= MEANZ+ (/ (-(ZNUM-1)*STDZ_SCALED/2 + (I-1)* STDZ_SCALED, I=1,ZNUM) /)  ;

        OPEN( UNIT=73, FILE='PBEQ_TMP.DAT', STATUS='OLD', ACTION = 'READ')
        OPEN( UNIT=76, FILE='CNEXT_TMP.DAT', STATUS='OLD', ACTION = 'READ')
        OPEN( UNIT=7, FILE='GNEXT_TMP.DAT', STATUS='OLD', ACTION = 'READ')
        OPEN( UNIT=17, FILE='PSTOCK_TMP.DAT', STATUS='OLD', ACTION = 'READ')
        OPEN( UNIT=18, FILE='DIVD_TMP.DAT', STATUS='OLD', ACTION = 'READ')
        OPEN( UNIT=19, FILE='INVEST_TMP.DAT', STATUS='OLD', ACTION = 'READ')

        OPEN( UNIT=10, FILE='STOCKS_TMP.DAT', STATUS='OLD', ACTION = 'READ')
        OPEN( UNIT=11, FILE='BONDS_TMP.DAT', STATUS='OLD', ACTION = 'READ')
        OPEN( UNIT=12, FILE='BONDN_TMP.DAT', STATUS='OLD', ACTION = 'READ')
        OPEN( UNIT=13, FILE='VALUES_TMP.DAT', STATUS='OLD', ACTION = 'READ')
        OPEN( UNIT=14, FILE='VALUEN_TMP.DAT', STATUS='OLD', ACTION = 'READ')
        OPEN( UNIT=15, FILE='CONSS_TMP.DAT', STATUS='OLD', ACTION = 'READ')
        OPEN( UNIT=16, FILE='CONSN_TMP.DAT', STATUS='OLD', ACTION = 'READ')

        NMAXSMALL= GNUM*ZNUM
        NMAX= WNUM*GNUM*ZNUM
        ALLOCATE(STOCKS_V(NMAX,KNUM));ALLOCATE( BONDS_V(NMAX,KNUM));ALLOCATE( BONDN_V(NMAX,KNUM));
        ALLOCATE(CONSS_V(NMAX,KNUM));ALLOCATE( CONSN_V(NMAX,KNUM));ALLOCATE( VALUES_V(NMAX,KNUM));
        ALLOCATE(VALUEN_V(NMAX,KNUM)); ALLOCATE(PBEQ_Z( NMAXSMALL,KNUM));
        ALLOCATE(CAPITAL_NEXTZZZ(NMAXSMALL,KNUM)); ALLOCATE(GAM_NEXTZ(NMAXSMALL,KNUM));
        ALLOCATE(PSTOCKZ(NMAXSMALL,KNUM)); ALLOCATE(DIVDZ(NMAXSMALL,KNUM)); ALLOCATE(INVESTZ(NMAXSMALL,KNUM))

        READ (10,*) ((STOCKS_V(I,J), J=1,KNUM), I=1,NMAX)
        READ (11,*) ((BONDS_V(I,J), J=1,KNUM), I=1,NMAX)
        READ (12,*) ((BONDN_V(I,J), J=1,KNUM), I=1,NMAX)
        READ (13,*) ((VALUES_V(I,J), J=1,KNUM), I=1,NMAX)
        READ (14,*) ((VALUEN_V(I,J), J=1,KNUM), I=1,NMAX)
        READ (15,*) ((CONSS_V(I,J), J=1,KNUM), I=1,NMAX)
        READ (16,*) ((CONSN_V(I,J), J=1,KNUM), I=1,NMAX)

        READ (73,*) ((PBEQ_Z(I,J),J=1,KNUM),I=1,NMAXSMALL)
        READ (76,*) ((CAPITAL_NEXTZZZ(I,J),J=1,KNUM),I=1,NMAXSMALL)
        READ (7,*) ((GAM_NEXTZ(I,J), J=1,KNUM),I=1,NMAXSMALL)
        READ (17,*) ((PSTOCKZ(I,J), J=1,KNUM),I=1,NMAXSMALL)
        READ (18,*) ((DIVDZ(I,J), J=1,KNUM),I=1,NMAXSMALL)
        READ (19,*) ((INVESTZ(I,J), J=1,KNUM),I=1,NMAXSMALL)

        CLOSE(UNIT=73);CLOSE(UNIT=76);CLOSE(UNIT=7); CLOSE(UNIT=10);CLOSE(UNIT=11)
        CLOSE(UNIT=12);CLOSE(UNIT=13);CLOSE(UNIT=14);CLOSE(UNIT=17);CLOSE(UNIT=18);CLOSE(UNIT=19)
        CLOSE(UNIT=15);CLOSE(UNIT=16);

        !!----------------------------------------------------------------

        DO L=1,ZNUM
                DO G=1, GNUM
                      INDMAXX=(G-1)*WNUM+(L-1)*WNUM*GNUM
                      STOCKS_M(:,:,G,L)= STOCKS_V(1+INDMAXX:INDMAXX+WNUM,:)
                      BONDS_M(:,:,G,L)=BONDS_V(1+INDMAXX:INDMAXX+WNUM,:)
                      BONDN_M(:,:,G,L)=BONDN_V(1+INDMAXX:INDMAXX+WNUM,:)
                      VALUES_M(:,:,G,L)=VALUES_V(1+INDMAXX:INDMAXX+WNUM,:)
                      VALUEN_M(:,:,G,L)=VALUEN_V(1+INDMAXX:INDMAXX+WNUM,:)
                      CONSS_M(:,:,G,L)=CONSS_V(1+INDMAXX:INDMAXX+WNUM,:)
                      CONSN_M(:,:,G,L)=CONSN_V(1+INDMAXX:INDMAXX+WNUM,:)
                END DO
        END DO
        WRITE (*,*) 'SHAPE OF NEW INCOMING FUNCTIONS IS', SHAPE(VALUES_M)


        DO ZNOW= 1, ZNUM
               INDMAXX=(ZNOW-1)*GNUM
               PBOND(:,:, ZNOW)= TRANSPOSE(PBEQ_Z(1+INDMAXX:INDMAXX+GNUM,: ))
               CAPITAL_NEXT(:,:,ZNOW)=TRANSPOSE(CAPITAL_NEXTZZZ(1+INDMAXX:INDMAXX+GNUM,:))
               GAM_NEXT(:,:, ZNOW)=TRANSPOSE(GAM_NEXTZ(1+INDMAXX:INDMAXX+GNUM,:))
               PSTOCK(:,:,ZNOW)=TRANSPOSE(PSTOCKZ(1+INDMAXX:INDMAXX+GNUM,:))
               DIVD(:,:,ZNOW)=TRANSPOSE(DIVDZ(1+INDMAXX:INDMAXX+GNUM,:))
               INVEST(:,:,ZNOW)=TRANSPOSE(INVESTZ(1+INDMAXX:INDMAXX+GNUM,:))
        END DO
        WRITE (*,*)'POINT 5'

        WRITE (*,*) 'HERE IS PBEQ'
        WRITE (*,121) PBOND
        WRITE (*,*) '----------------------------'
        WRITE (*,*) 'HERE IS CAPITAL_NEXT'
        WRITE (*,121) CAPITAL_NEXT
        WRITE (*,*)'-------------------------------'
        WRITE (*,*) 'HERE IS GAM_NEXT'
        WRITE (*,121) GAM_NEXT
        WRITE (*,*)'-------------------------------'
        WRITE (*,*) 'HERE IS PSTOCK'
        WRITE (*,121) PSTOCK
        WRITE (*,*) '----------------------------'
        WRITE (*,*) 'HERE IS DIVD'
        WRITE (*,121) DIVD
        WRITE (*,*)'-------------------------------'
        WRITE (*,*) 'HERE IS INVEST'
        WRITE (*,121) INVEST

        WRITE (*,*) 'MOST IMPORTANTLY, HERE IS THE SHAPE OF DATA...'
        WRITE (*,*) SHAPE (VALUES_M);  WRITE (*,*) SHAPE (VALUEN_M);  WRITE (*,*) SHAPE (PBOND)
        WRITE (*,*) SHAPE (CAPITAL_NEXT);  WRITE (*,*) SHAPE (GAM_NEXT); WRITE (*,*) SHAPE (PSTOCK)
        WRITE (*,*) SHAPE (DIVD); WRITE (*,*) SHAPE (INVEST)

        SETINVEST=1
        121 FORMAT(1X, 6F15.8)
    !    PAUSE

        CAPITAL_NEXT0=CAPITAL_NEXT

        CALL WAGE_SUB(CAPITAL, WAGE)
        CALL INTEREST_SUB(CAPITAL, INTEREST0)
        CALL INTERESTNEXT_SUB(CAPITAL_NEXT0, INTEREST_NEXT0)
        CAPITAL_NEXT0=CAPITAL_NEXT
        GAM_NEXT0=GAM_NEXT

        WRITE (*,*) ' CAPITALMIN , CAPITALMAX IS', MINVAL(CAPITAL), MAXVAL(CAPITAL)

        VN_GUESS = VALUEN_M
        VS_GUESS = VALUES_M
        WARMSTART = .TRUE.

        CALL INTERPGEN2D(PSTOCK, PSTOCK_NEXT)
        CALL INTERPGEN2D(DIVD, DIVD_NEXT)
        CALL INTERPGEN2D(INVEST, INVEST_NEXT)

        DEALLOCATE(STOCKS_V,BONDS_V, BONDN_V,VALUES_V, VALUEN_V, CONSS_V,CONSN_V)
        DEALLOCATE(PBEQ_Z,CAPITAL_NEXTZZZ, GAM_NEXTZ, PSTOCKZ,DIVDZ,INVESTZ)


END IF             ! THIS IS THE IF PART WHICH EXECUTES FOR INIT_ITER >0........



!!===================================================================================
!===================================================================================
!!===================================================================================

IF (INITONE==1) THEN
     WRITE (*,*) 'ENTER 1 IF YOU WANT TO INITIALIZE USING EISPAPER CONSUMPTION FUNCTION >>     '
     READ (*,*) WHETHERCONS

    ! THIS PART IMPORTS INITIALIZING DATA FROM EISPAPER VERSION IF EXECUTED
    IF (WHETHERCONS ==1) THEN

        OPEN( UNIT=10, FILE='CONSS_INIT.DAT', STATUS='OLD', ACTION = 'READ')
        OPEN( UNIT=11, FILE='VALUES_INIT.DAT', STATUS='OLD', ACTION = 'READ')
        OPEN( UNIT=12, FILE='VALUEN_INIT.DAT', STATUS='OLD', ACTION = 'READ')
        OPEN( UNIT=13, FILE='CNEXT_INIT.DAT', STATUS='OLD', ACTION = 'READ')
        OPEN( UNIT=14, FILE='GNEXT_INIT.DAT', STATUS='OLD', ACTION = 'READ')
        OPEN( UNIT=15, FILE='INVEST_INIT.DAT', STATUS='OLD', ACTION = 'READ')

        NMAX= WNUM*GNUM*ZNUM
        NMAXSMALL=GNUM*ZNUM

        ALLOCATE(CONSS_V(NMAX,KNUM));ALLOCATE(VALUES_V(NMAX,KNUM));ALLOCATE(VALUEN_V(NMAX,KNUM));
        ALLOCATE(CAPITAL_NEXT_V(NMAXSMALL,KNUM)); ALLOCATE(GAM_NEXT_V(NMAXSMALL,KNUM))
        ALLOCATE(INVEST_V(NMAXSMALL,KNUM))

        READ (10,*) ((CONSS_V(I,J), J=1,KNUM), I=1,NMAX)
        READ (11,*) ((VALUES_V(I,J), J=1,KNUM), I=1,NMAX)
        READ (12,*) ((VALUEN_V(I,J), J=1,KNUM), I=1,NMAX)
        READ (13,*) ((CAPITAL_NEXT_V(I,J), J=1,KNUM), I=1,NMAXSMALL)
        READ (14,*) ((GAM_NEXT_V(I,J), J=1,KNUM), I=1,NMAXSMALL)
        READ (15,*) ((INVEST_V(I,J), J=1,KNUM), I=1,NMAXSMALL)

        CLOSE(UNIT=10);CLOSE(UNIT=11);CLOSE(UNIT=12);

        DO L=1,ZNUM
                DO G=1, GNUM
                  INDMAX=(G-1)*WNUM+(L-1)*WNUM*GNUM
                  CONSS_M(:,:,G,L)= CONSS_V(1+INDMAX:INDMAX+WNUM,:)
                  VALUES_M(:,:,G,L)=VALUES_V(1+INDMAX:INDMAX+WNUM,:)
                  VALUEN_M(:,:,G,L)=VALUEN_V(1+INDMAX:INDMAX+WNUM,:)
              END DO
        END DO

        DO L=1,ZNUM
                  INDMAXSMALL=(L-1)*GNUM
                  CAPITAL_NEXT0(:,:,L)=TRANSPOSE(CAPITAL_NEXT_V(1+INDMAXSMALL:INDMAXSMALL+GNUM,:))
                  GAM_NEXT0(:,:,L)=TRANSPOSE(GAM_NEXT_V(1+INDMAXSMALL:INDMAXSMALL+GNUM,:))
                  INVEST(:,:,L)=TRANSPOSE(INVEST_V(1+INDMAXSMALL:INDMAXSMALL+GNUM,:))
           
        END DO

        SETINVEST=1

        WRITE (*,*) 'MOST IMPORTANTLY, HERE IS THE SHAPE OF DATA...'
        WRITE (*,*) SHAPE (CONSS_M)
        WRITE (*,*) SHAPE (VALUES_M)
        WRITE (*,*) SHAPE (VALUEN_M)
        WRITE (*,*) SHAPE (CAPITAL_NEXT0)
        WRITE (*,*) SHAPE (GAM_NEXT0)
        WRITE (*,*) 'HERE IS CAPITAL_NEXT0'
        WRITE (*,*) CAPITAL_NEXT0
        WRITE (*,*) 'HERE IS GAM_NEXT0'
        WRITE (*,*)  GAM_NEXT0

        DEALLOCATE(CONSS_V, VALUES_V, VALUEN_V,CAPITAL_NEXT_V,GAM_NEXT_V)

        VN_GUESS = VALUEN_M
        VS_GUESS = VALUES_M
        CLOSE(UNIT=10); CLOSE(UNIT=11); CLOSE(UNIT=12); CLOSE(UNIT=13); CLOSE(UNIT=14)

    ELSEIF (WHETHERCONS ==0) THEN
        CAPITAL_NEXT=CAPITAL_NEXT0
        GAM_NEXT=GAM_NEXT0
        PBOND=MYBETA
        WRITE (*,*) 'WAGE IS:  '
        WRITE(*,120) WAGE
        WRITE (*,*) 'CAPITAL_NEXT IS:  '
        WRITE(*,120) CAPITAL_NEXT
        WRITE (*,*) '=============== GAMMA_NEXTV IS ,===================='
        WRITE (*,120)  GAM_NEXT
        WRITE (*,*) '===============INTEREST0 IS: ======================'
        WRITE (*,120)  INTEREST0
        WRITE (*,*) '==========INTEREST_NEXT0 IS  ===================='
        WRITE (*,120) INTEREST_NEXT0
        WRITE (*,*) '======================================================'

       ! PAUSE
        WARMSTART=.FALSE.
        CALL BELLMANRA (VS_GUESS, WARMSTART, VALUES_M, BONDS_M, CONSS_M, 1)
        WARMSTART=.FALSE.

        CALL BELLMANRA (VN_GUESS, WARMSTART, VALUEN_M, BONDN_M, CONSN_M, 2)
    ELSE
        WRITE (*,*) ' ERROR: WHETHERCONS CAN ONLY BE 0 OR 1 '
        PAUSE
    END IF

   !!===============================================================================
   !=========================OBTAINING INITIAL GUESSES FOR AGGREGATE FUNCTIONS=================

    ALLOCATE (PSTOCK0(KNUM,GNUM,ZNUM)); ALLOCATE (PBOND0(KNUM, GNUM, ZNUM))
    ALLOCATE (INVEST0(KNUM, GNUM, ZNUM)); ALLOCATE (DISCR(KNUM, GNUM, ZNUM))

    !1) SOLVE FOR INVESTMENT USING THE EULER EQUATION
    CAPITAL_NEXT=CAPITAL_NEXT0
    GAM_NEXT=GAM_NEXT0
    CALL INVESTMENT_SUB(CONSS_M, VALUES_M, INVEST0,0)
    INVEST=INVEST0
    SETINVEST=1

    !2) OBTAIN NEW CAPITAL_NEXT USING THE INVESTMENT
    CAPITAL_SPREAD= SPREAD(SPREAD (CAPITAL,2,GNUM),3,ZNUM)
    CAPITAL_NEXT=(ONE-MYDELTA)*CAPITAL_SPREAD + ADJINVESTV(INVEST)*CAPITAL_SPREAD
    CAPITAL_NEXT= 0.8_SP*CAPITAL_NEXT + 0.2_SP*CAPITAL_NEXT0
    WRITE (*,*) 'CAPITAL_NEXT IS'
    WRITE (*,*) CAPITAL_NEXT

    !3) OBTAIN NEW VALUE FOR DIVIDEND FUNCTION
    DO GAMMANOW=1,GNUM
         DO ZNOW=1,ZNUM
              DIVD(:,GAMMANOW,ZNOW) = ALFA*ZGRID(ZNOW)*(CAPITAL**ALFA) -INVEST(:,GAMMANOW,ZNOW)-FDDUM*FD*(ONE-MYBETA)
         END DO
    END DO

    WRITE (*,*) 'POINT 5'

    CALL INTERPGEN2D(DIVD, DIVD_NEXT)
    WRITE (*,*) 'POINT 6'
    !4) 0BTAIN INITIAL STOCK PRICE USING PRESENT VALUE EQUATION
    CALL UPDATE_PSTOCK(CONSS_M, VALUES_M, PSTOCK0, DISCR,0)
    PSTOCK=PSTOCK0
    CALL INTERPGEN2D(PSTOCK, PSTOCK_NEXT)

    WRITE (*,120) DIVD
    WRITE (*,*) 'DIVIDEND IS ABOVE'
    WRITE (*,*) '============================================================================================'
    WRITE (*,120) PSTOCK
    WRITE (*,*) 'PSTOCK IS ABOVE'
    WRITE (*,*) '============================================================================================'
    WRITE (*,120) PSTOCK_NEXT
    WRITE (*,*) 'PSTOCK NEXT IS ABOVE'
    WRITE (*,*) '============================================================================================'
    WRITE (*,120) DIVD_NEXT
    WRITE (*,*) 'DIVIDEND NEXT IS ABOVE'
    WRITE (*,*) '============================================================================================'
    WRITE (*,120) INVEST
    WRITE (*,*) 'ABOVE IS INVESTMENT INITIAL SOLUTION==============================='

    WRITE (*,*) 'POINT 7'
  !  PAUSE
    !5) CLEAR MARKETS AND OBTAIN NEW BOND PRICING FUNCTION
    CALL DEMANDB(VALUEN_M, VALUES_M, PBOND0, BONDN_EQ, STOCKS_EQ, EXCESS_EQ,FAILCOUNT)
    GAM_NEXT = 0.5_SP*(ONE - LAMDA) * BONDN_EQ +0.5_SP*GAM_NEXT0
    PBOND=PBOND0
    DEALLOCATE(PSTOCK0,PBOND0, INVEST0, DISCR)
    !6) INTERPOLATE THESE FUNCTIONS EVERYTIME BEFORE BELLMAN'S ARE CALLED
    CALL INTERPGEN2D(PSTOCK, PSTOCK_NEXT)
    CALL INTERPGEN2D(DIVD, DIVD_NEXT)
    CALL INTERPGEN2D(INVEST, INVEST_NEXT)
    120 FORMAT(1X, 10F15.8)

END IF

!AT THIS POINT WE HAVE ALL THE INITIAL GUESSES FOR AGGREGATE FUNCTIONS=======================
!NOW WE ARE ITERATING ON THE BOND AND STOCK PRICES UNTIL CONVERGENCE=========================

!=================================================================================
!===================== M A I N    B O D Y   O F   T H E   C O D E ==================================
!=================================================================================

EQB: DO ITERMAIN=INITONE, ITMAX_MAIN

         IF ((ITERMAIN>=140)) THEN
!            ROS =MIN(ROS_0+0.20*(ITERMAIN-10.0_DP)/10.0_DP,-3.0_DP)
            THETAS =MAX(THETAS_0-0.4_DP*MAX(DBLE(REAL(FLOOR((ITERMAIN-130.0_DP)/10.0_DP))),0.0_DP),-5.0_DP)
  !          THETAN=THETAS
         END IF
         
         IF (ITERMAIN>=40) THEN
            FDDUM=MIN(0.20_DP*MAX((FLOOR(ITERMAIN/20.0_DP)-1.0_DP),0.0_DP),ONE)
         END IF
         WRITE (*,*)  'ITERMAIN, FDDUM AND FD ARE: ', ITERMAIN, FDDUM, FD


         WRITE (*,*)  'CURRENT VALUES OF RRA AND EIS ARE:', ONE-THETAS, ONE/(ONE-ROS)

         CALL BELLMANHABS (VS_GUESS, WARMSTART, VALUES_M, BONDS_M, STOCKS_M, CONSS_M)
         CALL BELLMANHABN (VN_GUESS, WARMSTART, VALUEN_M, BONDN_M, CONSN_M )
         WARMSTART= .TRUE.

         !1) SOLVE FOR INVESTMENT USING THE EULER EQUATION
         CALL INVESTMENT_SUB(CONSS_M,VALUES_M, INVEST_M,1)
         INVEST=INVEST_M
         !2) OBTAIN NEW CAPITAL_NEXT USING THE INVESTMENT
         CAPITAL_NEXT_TEMP=(ONE-MYDELTA)*CAPITAL_SPREAD + ADJINVESTV(INVEST)*CAPITAL_SPREAD
         CAPITAL_NEXT=WEIGHTP*CAPITAL_NEXT_TEMP +(ONE-WEIGHTP)*CAPITAL_NEXT
         !3) OBTAIN NEW VALUE FOR DIVIDEND FUNCTION
         DO I=1,ZNUM
              DIVD(:,:,I) = SPREAD(ZGRID(I)*ALFA*(CAPITAL **ALFA),2,GNUM) - INVEST(:,:,I)-FDDUM*FD*(ONE-PBOND(:,:,I))
         END DO
         CALL INTERPGEN2D(DIVD, DIVD_NEXT)

         !4) 0BTAIN NEW STOCK PRICE USING PRESENT VALUE EQUATION
         CALL  UPDATE_PSTOCK(CONSS_M, VALUES_M, PSTOCKNEW, DISCRPS,1)
         PSTOCK=WEIGHTP*PSTOCKNEW +(ONE-WEIGHTP) *PSTOCK

         !5) CLEAR MARKETS AND OBTAIN NEW BOND PRICING FUNCTION
         CALL DEMANDB(VALUEN_M, VALUES_M, PBEQ, BONDN_EQ, STOCKS_EQ, EXCESS_EQ, FAILCOUNT)
         GAM_NEXT = WEIGHTP* (ONE - LAMDA) * BONDN_EQ +(ONE-WEIGHTP) * GAM_NEXT
         PBOND = WEIGHTP * PBEQ + (ONE - WEIGHTP) * PBOND

         WRITE (*,*) 'HERE IS THE AMOUNT OF EXCESS DEMAND IN THE BOND MARKET:  '
         WRITE (*, 120) EXCESS_EQ
       !  PAUSE
         !UPDATING LAWS OF MOTION FOR CAPITAL AND GAMMA------------------------------------------

          IF ((MODULO(ITERMAIN, 3) ==0) .OR. ((ITERMAIN > 20) .AND. &
                & ((DISCR_CAPITAL < 1.0E-2) .AND. (DISCR_GAMM < 1.0E-2)))) THEN
          END IF

 !        AFTER UPDATING PSTOCK USING THE PRESENT VALUE EQUATION AND INVESTMENT FUNCTION BY SOLVING FIRM'S PROBLEM
 !        I SHOULD CREATE NEXT PERIOD'S INTERPOLATED VALUES FORM PSTOCK AND DIVIDEND.. THESE ARE USED IN AGENT'S PROBLEM AND MAYBE ELSEWHERE

          CALL INTERPGEN2D(PSTOCK, PSTOCK_NEXT)
          CALL INTERPGEN2D(DIVD, DIVD_NEXT)
          CALL INTERPGEN2D(INVEST, INVEST_NEXT)

         !CALCULATE ASSET PRICES....
          DO I=1,ZNUM
               RSNEXT(:,:,:,I) = (PSTOCK_NEXT(:,:,:,I) + DIVD_NEXT(:,:,:,I))/PSTOCK -ONE
          END DO
          RB = (ONE/ PBEQ) - ONE

          WRITE (*,*) "ITERATION NUMBER=  ", ITERMAIN, "COMPLETED"
          WRITE (*,*) 'INTERMEDIATE VALUES OF STOCK AND BOND RETURN ECHOED... NOW PAUSING'

          ! FIND DISCREPANCY BETWEEN ITERATIONS----------------------------------------------------
          DISCR_PBOND = MAXVAL(ABS((PBEQ - PB_LAG)))
          DISCR_PSTOCK= MAXVAL(DISCRPS)
          DISCR_CAPITAL = MAXVAL (ABS (CAPITAL_NEXT_TEMP - CAPNEXT_LAG))
          DISCR_GAMM = MAXVAL(ABS((ONE-LAMDA)*BONDN_EQ - GAMNEXT_LAG))

          INDXPBOND = MAXLOC (ABS(PBEQ-PB_LAG))
          INDXPSTOCK=MAXLOC (DISCRPS)
          INDX_CAP = MAXLOC(ABS(LAMDA*STOCKS_EQ- CAPNEXT_LAG))
          INDX_GAMM = MAXLOC (ABS((ONE-LAMDA)*BONDN_EQ - GAMNEXT_LAG))

          AVG_PBOND= SUM(ABS(PBEQ - PB_LAG)/(SIZE(PBEQ)))
          AVG_PSTOCK=SUM (DISCRPS)/SIZE(PSTOCK)
          AVG_CAPITAL= SUM(ABS(LAMDA*STOCKS_EQ - CAPNEXT_LAG)/(SIZE(CAPITAL_NEXT)))
          AVG_GAMM= SUM(ABS((ONE-LAMDA)*BONDN_EQ - GAMNEXT_LAG)/(SIZE(GAM_NEXT)))

          !--------------------------------------------------------------------------------------
          !ECHO INTERMEDAITE RESULTS...
          WRITE (*,*) ' PBOND NEW'
          WRITE(*,120) PBEQ
          WRITE (*,*) 'DIFFPBOND'
          WRITE(*,120) PBEQ - PB_LAG
          WRITE (*,*)'--------------------------'
          WRITE (*,*) ' CAPITAL_NEXT'
          WRITE(*,120) CAPITAL_NEXT
          WRITE (*,*) 'DIFFCAPITAL'
          WRITE(*,120) CAPITAL_NEXT - CAPNEXT_LAG
          WRITE (*,*)'------------------------'
          WRITE (*,*)'GAM_NEXT'
          WRITE(*,120)  GAM_NEXT
          WRITE (*,*)'DIFF-GAMMA'
          WRITE(*,120) GAM_NEXT- GAMNEXT_LAG
          WRITE (*,*)'----------------------------'
          WRITE (*,*) 'DISCR. IN BOND PRICE IS=', DISCR_PBOND, 'AT LOCATION=', PBEQ(INDXPBOND(1), &
                                                                        & INDXPBOND(2), INDXPBOND(3))
          WRITE (*,*) 'DISCR. IN STOCK PRICE IS=', DISCR_PSTOCK, 'AT LOCATION=', PSTOCK(INDXPSTOCK(1), &
                                                                        & INDXPSTOCK(2), INDXPSTOCK(3))
          WRITE (*,*) 'DISCR. IN CAPITAL LAW OF MOTION IS', DISCR_CAPITAL,'AT LOCATION',CAPITAL_NEXT(INDX_CAP(1), &
                                                                        & INDX_CAP(2), INDX_CAP(3))
          WRITE (*,*) 'DISCR. IN GAMMA LAW OF MOTION IS', DISCR_GAMM,'AT LOCATION',GAM_NEXT( INDX_GAMM(1), &
                                                                        & INDX_GAMM(2), INDX_GAMM(3))

          !----------------------------------------------------------------------------------------------
          !UPDATE
          VS_GUESS = VALUES_M
          VN_GUESS = VALUEN_M
          PB_LAG = PBEQ
          CAPNEXT_LAG = CAPITAL_NEXT
          GAMNEXT_LAG = GAM_NEXT


          IF (ITERMAIN>100) THEN
            WEIGHTP=0.25_SP
          ELSEIF (ITERMAIN>40) THEN
            WEIGHTP=0.25_SP
          ELSEIF (ITERMAIN>20) THEN
            WEIGHTP=0.25_SP
          ELSEIF (ITERMAIN>10) THEN
            WEIGHTP =0.25_SP
          END IF


          !------------------------------- ECHO RESULTS -----------------------------------------------------
          CALL MYECHO_3(PBEQ,'PBEQ_TMP.DAT'); CALL MYECHO_3(CAPITAL_NEXT,'CNEXT_TMP.DAT'); CALL MYECHO_3(GAM_NEXT,'GNEXT_TMP.DAT')
          CALL MYECHO_3(PSTOCK,'PSTOCK_TMP.DAT'); CALL MYECHO_3(DIVD,'DIVD_TMP.DAT'); CALL MYECHO_3(INVEST,'INVEST_TMP.DAT')
          CALL MYECHO_3(LAMDA*STOCKS_EQ,'STOCKS_EQ_TMP.DAT')

          CALL MYECHO_4(CONSS_M,'CONSS_TMP.DAT'); CALL MYECHO_4(CONSN_M,'CONSN_TMP.DAT'); CALL MYECHO_4(BONDS_M,'BONDS_TMP.DAT')
          CALL MYECHO_4(BONDN_M,'BONDN_TMP.DAT'); CALL MYECHO_4(VALUES_M,'VALUES_TMP.DAT'); CALL MYECHO_4(VALUEN_M,'VALUEN_TMP.DAT')
          CALL MYECHO_4(STOCKS_M,'STOCKS_TMP.DAT')

          OPEN( UNIT=38, FILE='RSTOCK_TMP.DAT', STATUS='REPLACE', ACTION = 'WRITE')
          OPEN( UNIT=42, FILE='ZSHOCK_TMP.DAT', STATUS='REPLACE', ACTION = 'WRITE')
          OPEN( UNIT=77, FILE='ITERATIONNUMB.DAT', STATUS='REPLACE', ACTION = 'WRITE')


          WRITE (77,*) ITERMAIN
          WRITE (42,100) ZGRID

          DO I=1,ZNUM
             RSNEXT(:,:,:,I) = ((PSTOCK_NEXT(:,:,:,I) + DIVD_NEXT(:,:,:,I))/PSTOCK) -ONE
          END DO

          DO ZNEXT=1,ZNUM
             DO ZNOW=1,ZNUM
                DO G=1,GNUM
                  WRITE (38,100) (RSNEXT(J,G,ZNOW,ZNEXT), J=1,KNUM)
                END DO
             END DO
          END DO

         CLOSE(UNIT=38);CLOSE(UNIT=42); CLOSE(UNIT=77)

         !------------------------------------ EXIT ??? --------------------------------------------------

          IF ((ITERMAIN > 10) .AND. (MODULO(ITERMAIN, 3) ==0)) THEN
              IF ((DISCR_PBOND < TOL_PBOND) .AND. (DISCR_CAPITAL < TOL_CAPITAL) .AND. (DISCR_GAMM < TOL_GAMM)) EXIT EQB
          END IF

          IF ((ITERMAIN >=250) .AND. (MODULO(ITERMAIN, 50) ==0)) THEN
              WRITE(*,*) 'HERE ARE THE DISCREPANCIES......'
              WRITE (*,*) 'DISCR. IN BOND PRICE IS=', DISCR_PBOND, 'AT LOCATION=', PBEQ(INDXPBOND(1), &
                                                                        & INDXPBOND(2), INDXPBOND(3))
              WRITE (*,*) 'DISCR. IN STOCK PRICE IS=', DISCR_PSTOCK, 'AT LOCATION=', PSTOCK(INDXPSTOCK(1), &
                                                                        & INDXPSTOCK(2), INDXPSTOCK(3))
              WRITE (*,*) 'DISCR IN CAPITAL LAW OF MOTION IS', DISCR_CAPITAL,'AT LOCATION',CAPITAL_NEXT( INDX_CAP(1), &
                                                                            & INDX_CAP(2), INDX_CAP(3))
              WRITE (*,*) 'DISCR IN GAMA LAW OF MOTION IS', DISCR_GAMM,'AT LOCATION',GAM_NEXT( INDX_GAMM(1), &
                                                                            & INDX_GAMM(2), INDX_GAMM(3))
              WRITE (*,*)'-------------------'
              WRITE (*,*) 'IF YOU WOULD LIKE TO TERMINATE THE PROGRAM ANYWAY, ENTER 1---------->>>>  '
              READ(*,*) TERMINATE
              IF (TERMINATE ==1) THEN
                  WRITE (*,*) 'YOU CHOSE TO TERMINATE THE PROGRAM SO SAVING RESULTS WITH THIS CONVERGENCE LEVEL'
                  EXIT EQB
              END IF

          END IF

         !-----------------------------------------------------------------------------------------------

END DO EQB

!====================================================================================
!========================== ITERATION ENDS HERE... NOW PREPARE DATA FOR OUTPUTTING=================
!====================================================================================
!====================================================================================

IF (ITERMAIN > ITMAX_MAIN) THEN
WRITE (*,*)' NO CONVERGENCE IN',ITMAX_MAIN,'NUMBER OF ITERATIONS'
ELSE
WRITE (*,*)'PROGRAM CONVERGED SUCCESSFULLY IN  ', ITERMAIN,'  ITERATIONS'
WRITE (*,*) PBEQ
END IF


DO I=1,ZNUM
    RSNEXT(:,:,:,I) = ((PSTOCK_NEXT(:,:,:,I) + DIVD_NEXT(:,:,:,I))/PSTOCK) -ONE
END DO


RB(:,:,:) = (ONE /PBEQ(:,:,:)) - ONE

IF ((ABS(MAXVAL(-CAPITAL_NEXT)) > CAPITAL(1)) .AND. (MAXVAL(CAPITAL_NEXT) < CAPITAL(KNUM))) THEN
CONTAINED= 1
END IF
WRITE (*,*) 'THE CONVERGED LAW OF MOTION IS CONTAINED? YES IF 1, NO IF 0', CONTAINED

CALL MYECHO_3(PBEQ,'PBEQ.DAT'); CALL MYECHO_3(CAPITAL_NEXT,'CNEXT.DAT'); CALL MYECHO_3(GAM_NEXT,'GNEXT.DAT')
CALL MYECHO_3(PSTOCK,'PSTOCK.DAT'); CALL MYECHO_3(DIVD,'DIVD.DAT'); CALL MYECHO_3(INVEST,'INVEST.DAT')
CALL MYECHO_3(LAMDA*STOCKS_EQ,'STOCKS_EQ.DAT')

CALL MYECHO_4(CONSS_M,'CONSS.DAT'); CALL MYECHO_4(CONSN_M,'CONSN.DAT'); CALL MYECHO_4(BONDS_M,'BONDS.DAT')
CALL MYECHO_4(BONDN_M,'BONDN.DAT'); CALL MYECHO_4(VALUES_M,'VALUES.DAT'); CALL MYECHO_4(VALUEN_M,'VALUEN.DAT')
CALL MYECHO_4(STOCKS_M,'STOCKS.DAT')


OPEN( UNIT=38, FILE='RSTOCK.DAT', STATUS='REPLACE', ACTION = 'WRITE')
OPEN( UNIT=39, FILE='RBOND.DAT', STATUS='REPLACE', ACTION = 'WRITE')
OPEN( UNIT=42, FILE='ZSHOCK.DAT', STATUS='REPLACE', ACTION = 'WRITE')
OPEN( UNIT=43, FILE='CONTAIN.DAT', STATUS='REPLACE', ACTION = 'WRITE')

WRITE (42,100) ZGRID
WRITE (43,1010) CONTAINED
1010 FORMAT (I5)

!!!!!!!!!!!!!!1! THE OUTPUT MATRIX IS (GNUM*ZNUM X KNUM) DIMENSIONAL !!!!!!!!!!!!!!!!!!!
DO ZNOW= 1, ZNUM
    DO G=1, GNUM
       WRITE (39,100) (RB(J,G,ZNOW), J=1,KNUM)
   END DO
END DO

!!!!!!!!!!!!!!1! THE OUTPUT MATRIX IS (GNUM*ZNUM*ZNUM X KNUM) DIMENSIONAL !!!!!!!!!!!!!!!!!!!

DO ZNEXT=1,ZNUM
 DO ZNOW= 1, ZNUM
    DO G=1, GNUM
       WRITE (38,100) (RSNEXT(J,G,ZNOW,ZNEXT), J=1,KNUM)
   END DO
 END DO
END DO


CLOSE( UNIT=38);CLOSE( UNIT=39);CLOSE(UNIT =42);CLOSE(UNIT=43);

100 FORMAT(1X,50(3X,F20.10))


END PROGRAM  MAINEQ





