!     Last change: MFG 12/19/2007 12:37:06 PM


!     Last change:  UR   14 Feb 2003    9:03 am
MODULE nrtype
	INTEGER, PARAMETER :: I4B = SELECTED_INT_KIND(9)
	INTEGER, PARAMETER :: I2B = SELECTED_INT_KIND(4)
	INTEGER, PARAMETER :: I1B = SELECTED_INT_KIND(2)
	INTEGER, PARAMETER :: SP = KIND(1.0)
	INTEGER, PARAMETER :: DP = KIND(1.0D0)
	INTEGER, PARAMETER :: SPC = KIND((1.0,1.0))
	INTEGER, PARAMETER :: DPC = KIND((1.0D0,1.0D0))
	INTEGER, PARAMETER :: LGT = KIND(.true.)
	REAL(SP), PARAMETER :: PI=3.141592653589793238462643383279502884197_sp
	REAL(SP), PARAMETER :: PIO2=1.57079632679489661923132169163975144209858_sp
	REAL(SP), PARAMETER :: TWOPI=6.283185307179586476925286766559005768394_sp
	REAL(SP), PARAMETER :: SQRT2=1.41421356237309504880168872420969807856967_sp
	REAL(SP), PARAMETER :: EULER=0.5772156649015328606065120900824024310422_sp
	REAL(DP), PARAMETER :: PI_D=3.141592653589793238462643383279502884197_dp
	REAL(DP), PARAMETER :: PIO2_D=1.57079632679489661923132169163975144209858_dp
	REAL(DP), PARAMETER :: TWOPI_D=6.283185307179586476925286766559005768394_dp
	TYPE sprs2_sp
		INTEGER(I4B) :: n,len
		REAL(SP), DIMENSION(:), POINTER :: val
		INTEGER(I4B), DIMENSION(:), POINTER :: irow
		INTEGER(I4B), DIMENSION(:), POINTER :: jcol
	END TYPE sprs2_sp
	TYPE sprs2_dp
		INTEGER(I4B) :: n,len
		REAL(DP), DIMENSION(:), POINTER :: val
		INTEGER(I4B), DIMENSION(:), POINTER :: irow
		INTEGER(I4B), DIMENSION(:), POINTER :: jcol
	END TYPE sprs2_dp
END MODULE nrtype

!===============================================================================================
!===============================================================================================
!===============================================================================================
!===============================================================================================
!===============================================================================================
!===============================================================================================
!===============================================================================================


!     Last change:  MFG  22 May 2004    6:13 pm

!mistake: ADJUST THEN PARAMS TO TAKE INTO ACCOUNT THAT ONE MODEL YEAR IS 3 ACTUAL YEARS
module myparamsHAB
USE nrtype
implicit none
save


 REAL(DP), PARAMETER:: one= 1.0D00
 REAL(DP), PARAMETER:: epsC=0.001_DP, myeps=0.001_DP
 REAL(DP):: kmin, kmax
 REAL(DP), PARAMETER:: cmin= epsC
 REAL(DP), PARAMETER:: stminS=0.0_DP          ! choose THIS NUMBER JUDICIOUSLY.. together with WMINS
 REAL(DP), PARAMETER:: bminNratio=2.0_DP , bminSratio=2.0_DP
 REAL(DP), PARAMETER:: rat_Bminfeas = 0.9_SP, FDratio=0.15_DP
 REAL(DP):: FD, wminN, wminS, bminS, bminN
 REAL(DP), PARAMETER:: minlabSup = 0.05, Lbar=0.4_DP




 INTEGER, PARAMETER:: wnum=20              !number of points for individual wealth
 INTEGER, PARAMETER:: knum=5               !  "         "     "   aggregate capital
 INTEGER, PARAMETER:: znum=12                   !   "        "      aggregate     "
 INTEGER, PARAMETER:: gnum=12
 INTEGER :: iterMAIN, setinvest

 REAL(DP), PARAMETER:: inerror= -1.0E20
 REAL(SP), PARAMETER:: power = 2.7_SP
 REAL(DP), PARAMETER:: weightB = 0.493_DP
 REAL(DP), PARAMETER:: tol_discrRAL= 1.0E-5_DP, tol_Sbond=1.0E-2_DP , tol_Sstock=1.0E-2_DP, tol_labS=1.0E-3_DP, tol_labN=tol_labS
 REAL(DP), PARAMETER:: tol_bisect=1.0E-10_DP, tol_excessD = 1.0E-7_DP
 REAL(DP), PARAMETER:: tol_Pbond=1.0E-6_DP, tol_capital = 1.0E-5, tol_gamm =1.0E-5

!MODEL PARAMS =====================================================================

REAL(SP), PARAMETER:: stdZ = 0.011_SP
REAL(SP), PARAMETER:: mybeta =0.99_SP                  !subjective discount factor
REAL(SP), PARAMETER:: mydelta =0.02_SP                 !depreciation rate
REAL(SP):: roS, zentaS               ! elasticity of subs parameter= (1-ro)^(-1)
REAL(SP):: roN, zentaN, zenta
REAL(SP):: roJ, zentaJ
REAL(SP):: thetaS,kappaS              ! risk aversion parameter of stockholder
REAL(SP):: thetaN,kappaN,kappa
REAL(SP) :: thetaJ,kappaJ
REAL(SP), PARAMETER:: lamda=0.2_SP
REAL(SP) , PARAMETER:: alfa= 0.30_SP                  !capital share of output
REAL(SP):: wmaxN, wmaxS 	! wmaxN must be at least (kmax - (bminN))
REAL(SP), PARAMETER:: ksi = 0.4_SP
REAL(DP) :: meanR, bminRA, wminRA, wmaxRA, meanLabSup, LabADJ


 ! LAW OF MOTION FOR WEALTH
 REAL, DIMENSION (znum) :: w1
 REAL, DIMENSION (znum) :: w2
 REAL, DIMENSION (znum) :: w3

 INTEGER :: countHmax
 REAL(DP), DIMENSION (wnum)  :: wealthN, wealthS, wealthRA        !individual wealth
 REAL(DP), DIMENSION (gnum) :: gamma
 REAL(DP), DIMENSION (knum) :: capital                          !aggregate capital
 REAL(DP), DIMENSION (znum):: Zgrid                                 ! aggregate shock
 REAL(DP):: incwealthS, incwealthN, inccapital, incgamma,stmin
 REAL(DP):: gmin, gmax, meanZ


 REAL(DP), DIMENSION (knum,gnum,znum) :: wage, LABSUP, LABS, LABN, LABRA
 REAL(DP), DIMENSION (knum,gnum,znum) :: Pbond, Pstock, Divd, Invest, capital_SPREAD
 REAL(DP), DIMENSION (knum,gnum,znum) :: capital_next, capital_next0
 REAL(DP), DIMENSION (knum,gnum,znum) :: gam_next,gam_next0
 REAL(DP), DIMENSION (knum,gnum,znum,znum) :: wage_next, interest_next0
 REAL(DP), DIMENSION (knum,gnum,znum,znum) :: Pstock_next, Divd_next, Invest_next
 REAL(DP), DIMENSION (knum,gnum,znum,znum) ::  LABSUP_next, LABS_next
 REAL(DP), DIMENSION (knum, gnum,znum) :: wage0, interest0
 REAL(DP), DIMENSION (knum,znum) :: capital_nextRAL
 REAL, DIMENSION (znum,znum) :: Probz



End module

!===========================================================================================
!===========================================================================================
!===========================================================================================
!===========================================================================================
!===========================================================================================

!==============================================================================================
!==============================================================================================
!==============================================================================================
!==============================================================================================
!==============================================================================================
!==============================================================================================
!==============================================================================================
!==============================================================================================
!==============================================================================================
!==============================================================================================
!==============================================================================================
!==============================================================================================
!==============================================================================================
!==============================================================================================
!==============================================================================================
!==============================================================================================
!==============================================================================================
!==============================================================================================
!==============================================================================================
!==============================================================================================
!==============================================================================================
!==============================================================================================


!     Last change:  MFG   9 Sep 2002    2:45 pm
module my_procsHAB


USE myparamsHAB
implicit none

CONTAINS

!----------------------------------------------------------

subroutine myECHO_2(myfile2, filename2)
implicit none

!dummy arguments
REAL(DP), DIMENSION(:,:), INTENT(IN):: myfile2
CHARACTER(LEN =*), INTENT(IN) :: filename2

!local
INTEGER, DIMENSION(2) :: fileDIM
INTEGER:: i,j

OPEN( UNIT=11, FILE=filename2, STATUS='replace', ACTION = 'WRITE')

fileDIM= SHAPE(myfile2)
if (fileDIM(2)>100) then
  write (*,*) "ERROR THE SECOND DIMENSION OF FILE >100, FORMAT STATEMENT CURRENTLY USES CANNOT HANDLE THIS SIZE"
end if

DO i=1,fileDIM(1)
        WRITE(11,100) (myfile2(i,j), j=1,fileDIM(2))
END DO

CLOSE(UNIT=11)

100 FORMAT(1x,100(3x,F20.10))

end subroutine  myECHO_2

!-----------------------------------------------------------------
subroutine myECHO_3(myfile3, filename3)
implicit none
!!!!!!!!!!!!!!!!!!!!!!!!!!  NOTE: THIS CODE HAS A DIFFERENT CONVENTION THAN THE 4 DIMENSIONAL CODE BELOW...
!!!!!!!!!!!!!!!!!!!!!!!!!!  THE CODE BELOW OUTPUTS THE SECOND DIMENSION OF THE ORIGINAL MATRIX TO THE SECOND DIMENSION
!!!!!!!!!!!!!!!!!!!!!!!!!!  (THAT IS THE X-AXIS) OF THE OUTPUT 2 DIMENSIONAL MATRIX.. HOWEVER, THE CURRENT CODE
!!!!!!!!!!!!!!!!!!!!!!!!!!  OUTPUTS THE FIRST DIMENSION OF THE ORIGINAL MATRIX TO THE X-AXIS OF THE OUTPUT MARIX
!!!!!!!!!!!!!!!!!!!!!!!!!!  THIS IS DONES FOR BACKWARD COMPATIBILITY WITH OLD CODE... SO THAT 'CAPITAL' ALWSAYS APPEARS
!!!!!!!!!!!!!!!!!!!!!!!!!!  AS THE SECOND DIMENSION WHEN USED IN MATLAB

!dummy arguments
REAL(DP), DIMENSION(:,:,:), INTENT(IN):: myfile3
CHARACTER(LEN =*), INTENT(IN) :: filename3

!local
INTEGER, DIMENSION(3) :: fileDIM
INTEGER:: i,j,k

OPEN( UNIT=11, FILE=filename3, STATUS='replace', ACTION = 'WRITE')

fileDIM= SHAPE(myfile3)
if (fileDIM(2)>100) then
  write (*,*) "ERROR THE SECOND DIMENSION OF FILE >100, FORMAT STATEMENT CURRENTLY USES CANNOT HANDLE THIS SIZE"
end if

write (*,*) "FILEDIME is", fileDIM

DO k=1,fileDIM(3)
   DO j=1,fileDIM(2)

        WRITE(11,100) (myfile3(i,j,k), i=1,fileDIM(1))

   END DO
END DO

CLOSE(UNIT=11)

100 FORMAT(1x,100(3x,F20.10))



end subroutine  myECHO_3

!-------------------------------------------------------

subroutine myECHO_4(myfile4, filename4)
implicit none

!dummy arguments
REAL(DP), DIMENSION(:,:,:,:), INTENT(IN):: myfile4
CHARACTER(LEN =*), INTENT(IN) :: filename4

!local
INTEGER, DIMENSION(4) :: fileDIM
INTEGER:: i,j,k,m

OPEN( UNIT=11, FILE=filename4, STATUS='replace', ACTION = 'WRITE')

fileDIM= SHAPE(myfile4)
if (fileDIM(2)>100) then
  write (*,*) "ERROR THE SECOND DIMENSION OF FILE >100, FORMAT STATEMENT CURRENTLY USES CANNOT HANDLE THIS SIZE"
end if

write (*,*) "FILEDIME is", fileDIM

DO k=1,fileDIM(4)
  DO m=1,fileDIM(3)
   DO i=1,fileDIM(1)

        WRITE(11,100) (myfile4(i,j,m,k), j=1,fileDIM(2))

    END DO
   END DO
END DO

CLOSE(UNIT=11)

100 FORMAT(1x,100(3x,F20.10))



end subroutine  myECHO_4
!-----------------------------------------------------------


subroutine INITIALIZER()
implicit none

!LOCAL VARIABLES...
REAL(DP), DIMENSION(knum,gnum,znum):: gam_nextTEMP
REAL(DP), DIMENSION (wnum) :: sqrt_wealthS, sqrt_wealthN
REAL(DP) ::  sqrt_wminS, sqrt_wminA, sqrt_wminN, sqrt_wmaxN, sqrt_wmaxS, Kdiff,wagestar
REAL(DP), DIMENSION (gnum) :: chebG
REAL(DP), DIMENSION(znum):: Kstar, a1, b1, w1,w2,w3

INTEGER(I4B):: i,l,ll,j, gammanow, znow

OPEN( UNIT=27, FILE='Probz.dat', STATUS='old', ACTION = 'read')
READ (27,*) ((Probz(i,j), j=1,znum), i=1,znum)
CLOSE(UNIT=27);

write (*,*) 'MY BETA IS =',mybeta
write (*,*) 'HERE IS KSI=', KSI,'   and LBAR= ', lbar

IF ((RoS /=ThetaS) .OR. (RoN /=ThetaN)) then
     WRITE (*,*) 'THIS PROGRAM WONT WORK IN EPSTEIN-ZIN CASE, SET RRA=1/EIS '
     PAUSE
    END IF
WRITE (*,*) '----------------------------------------------------------------------------'
WRITE (*,*) 'LAMDA IS = ', lamda
WRITE (*,*) 'EIS_S and EIS_N are', (one-roS)**(-1),  (one-roN)**(-1)
WRITE (*,*) 'RISK AVERSION PARAMETERS, THETAS and THETA_N ARE', (one-thetaS), (one-thetaN)
WRITE (*,*) '----------------------------------------------------------------------------'
write (*,*) 'HERE IS Z: '
WRITE(*,120) ZGRID
WRITE (*,*) '----------------------------------------------------------------------------'
write (*,*) 'THE PROBABILITY TRANSITION MATRIX IS:'
write (*,120)  Probz
WRITE (*,*) '----------------------------------------------------------------------------'



 !SET THE AGGREGATE LABOR SUPPLY TO AN AVERAGE INITIAL VALUE
meanlabsup=lbar
write (*,*) 'MEAN LAB SUP IS :', MEANLABSUP
PAUSE


!---- CAPITAL
do i=1,znum
       Kstar(i) = (((one/mybeta)-one+mydelta)/(alfa*Zgrid(i)*((LabADJ*meanLabSup)**(one-alfa))))**(one/(alfa-one))
end do

write (*,*) 'KSTAR IS  :', KSTAR
Kdiff=Kstar(znum)-Kstar(1)
Kmin=Kstar(1)-(Kdiff/2.0)
Kmax=Kstar(znum)+(Kdiff/2.0)
inccapital = (kmax -kmin)/(knum -one)
capital= (/ (kmin + (i-1)* inccapital, i=1,knum) /)

if (Kstar(znum)>MAXVAL(capital)) then
    write (*,*) 'ERROR CURRENTLY CAPITAL GRID DOES NOT CONTAIN MAXIMUM STEADY STATE CAPITAL LEVEL'
    write (*,*) Kstar
    PAUSE
ELSEIF (Kstar(1)< -MAXVAL(-capital)) then
    write (*,*) 'ERROR CURRENTLY CAPITAL GRID DOES NOT CONTAIN MINIMUM STEADY STATE CAPITAL LEVEL'
    write (*,*) Kstar

    PAUSE
end if

FD=FDratio*sum(Kstar)/size(Kstar)

write (*,*) 'FIRM LEVERAGE IS ', FD, 'and debt obligation is', FD*(mybeta-one)
write (*,*) 'MINIMUM OUTPUT NET OF WAGES IS', (alfa)*zgrid(1)*(capital(1)**alfa)*(meanlabsup**(one-alfa))



wagestar=(one-alfa)*(SUM(Zgrid)/SIZE(Zgrid))*(((SUM(capital)/SIZE(capital))**alfa)*(meanlabsup**(-alfa)))
kappa=wagestar/(zenta*(lbar**(zenta-one)))
WRITE (*,*) 'KAPPA IS', KAPPA
write (*,*) 'MINIMUM CONSUMPTION REQUIRED IS:', KAPPA*(LBAR**ZENTA)
kappaS=kappa
kappaN=kappa

BminS=-BminSratio*lbar*wagestar
BminN=-BminNratio*lbar*wagestar

wminN=bminN
wminS=bminS
wmaxN= 3.0_SP*(FD-lamda*bminS)/(one-lamda)
wmaxS= 1.2_SP*(kmax + FD - (one- lamda)*bminN)/lamda

pause


 !initializing the wealth, capital and Gamma GRIDS... FIXED throughout the problem
 !----- initialzing wealthS
 sqrt_wmaxS= ((wmaxS-wminS)**(one/power))
 sqrt_wminS = 0.0_DP
 incwealthS=(sqrt_wmaxS - sqrt_wminS  )/((wnum)-one)
 sqrt_wealthS =(/ (sqrt_wminS  + (l-1)*incwealthS, l=1,wnum) /)
 wealthS= (sqrt_wealthS ** power)+ wminS
 !----- initializing wealthN
 sqrt_wmaxN= ((wmaxN-wminN) ** (one/power))
 sqrt_wminN = 0.0_DP
 incwealthN=(sqrt_wmaxN - sqrt_wminN  )/((wnum)-one)
 sqrt_wealthN =(/ (sqrt_wminN  + (ll-1)*incwealthN, ll=1,wnum) /)
 wealthN= (sqrt_wealthN **power)+ wminN

 WRITE (*,*) '-----------HERE IS WEALTHNS----------'
 !---- GAMMA

 !initializing GLOBAL variables GMIN and GMAX:
 gmin = bminN * (one-lamda)
 gmax = -bminS * lamda +FD
 gamma =(/ (gmin  + (ll-1)*((gmax-gmin)/(gnum-one)), ll=1,gnum) /)
 

 WRITE (*,*) '-------------------------HERE IS WEALTHS----------------------------'
 WRITE (*,120)  wealthS
 WRITE (*,*) '-------------------------HERE IS WEALTHN-----------------------------'
 WRITE (*,120)  wealthN
 write (*,*) '--------------------------- CAPITAL IS--------------------------------'
 WRITE (*,120)  capital

 WRITE(*,*) '-------------------------------GAMMA IS --------------------------------'
 WRITE (*,120)  gamma
 112 FORMAT(1X, 4F15.8)
 120 FORMAT(1X, 10F15.8)


! Initializing Cap_next0 such that the steady state capital is the middle of K grid ====
b1 =(/ (mybeta- 0.001*((znum-1.0_SP)/2.0_SP)+ 0.001*(i-1), i=1,znum) /)
a1= (one-b1)*LOG(Kstar)
w1= 0.01_SP
w2= 0.0_SP
w3= 0.99_SP



CALL wage_sub(capital, wage)

LABSUP=(wage/(kappa*zenta))**(one/(zenta-one))
LABS=LABSUP
LABN=LABS

WRITE (*,*) 'HERE IS LABSUP'
write (*,120)  LABSUP
CALL interest_sub(capital, interest0)
CALL cap_next0(capital, a1,b1, capital_next0)
CALL interestnext_sub(capital_next0, interest_next0)
CALL gamma_nextV(capital,gamma,w1,w2,w3, gam_next0)
!gam_next0=gam_nextTEMP(1,:,:)



OPEN( UNIT=12, FILE='wealthS.dat', STATUS='replace', ACTION = 'write')
OPEN( UNIT=13, FILE='wealthN.dat', STATUS='replace', ACTION = 'write')
OPEN( UNIT=14, FILE='capital.dat', STATUS='replace', ACTION = 'write')
OPEN( UNIT=15, FILE='gamma.dat', STATUS='replace', ACTION = 'write')
OPEN( UNIT=16, FILE='lamda.dat', STATUS='replace', ACTION = 'write')

write (12,114) wealthS
write (13,114) wealthN
write (14,114) capital
write (15,114) gamma
write (16,*) lamda


114 FORMAT( 1x, 200(3x,F20.10))

FORALL(gammanow=1:gnum,znow=1:znum)
    Invest(:,gammanow,znow)=mydelta*capital
END forall

CLOSE (UNIT=12);  CLOSE (UNIT=13);  CLOSE (UNIT=14);  CLOSE (UNIT=15);  CLOSE (UNIT=16)



PAUSE

END subroutine initializer




!--------------------------------------

FUNCTION outerprod(a,b)
REAL(DP), DIMENSION(:), INTENT(IN) :: a,b
REAL(DP), DIMENSION(size(a),size(b)) :: outerprod
outerprod = spread(a,dim=2,ncopies=size(b)) * &
	spread(b,dim=1,ncopies=size(a))
END FUNCTION outerprod


!----------------------------------------------------------

 subroutine wage_sub0(K, comp_wage)

 implicit none

 REAL(DP), DIMENSION (knum), INTENT (IN) :: K                 ! capital values (possibly an array) to calculate the factor prices
 REAL(DP), DIMENSION (knum, znum), INTENT (OUT) :: comp_wage

 comp_wage=(one -alfa)* outerprod((K **(alfa)), Zgrid)

 END subroutine  wage_sub0

!--------------------------------------------

 subroutine interest_sub0(K,int_rate)
 implicit none

 REAL(DP), DIMENSION (knum), INTENT (IN) :: K                 ! capital values (possibly an array) to calculate the factor prices
 REAL(DP), DIMENSION (knum,znum), INTENT (OUT) :: int_rate

 int_rate=(alfa)* outerprod((K **(alfa-one)), Zgrid) -mydelta

 END subroutine interest_sub0

!-----------------------------------------------


 subroutine cap_next0(K,  a,b, cap_next)
 !PURPOSE: returns a [znum x znum x size(K)] array which gives next period
 ! wealth levels for all possible wealth levels today and shock combinations (znow, znext)
 implicit none

 REAL(DP), DIMENSION (knum), INTENT(IN) :: K
 REAL(DP), DIMENSION (znum), INTENT (IN) :: a,b
 REAL(DP) , DIMENSION (knum,gnum,znum), INTENT(OUT) :: cap_next
 INTEGER :: i, sizeZ

 REAL(DP), DIMENSION(knum,gnum)::Kvec
 Kvec=SPREAD(K,2,gnum)


DO i=1, znum
      cap_next(:,:,i) = a(i) + b(i) *LOG(Kvec)
END DO

 cap_next= EXP(cap_next)

 END subroutine cap_next0


!----------------------------------------------------------
!=================================================================


 subroutine wage_sub(K, comp_wage)

! USE nrutil
 implicit none

 REAL(DP), DIMENSION (knum), INTENT (IN) :: K                 ! capital values (possibly an array) to calculate the factor prices
 REAL(DP), DIMENSION (knum,gnum, znum), INTENT (OUT) :: comp_wage
 real(DP)::coeff1, meanwage
 INTEGER:: gammanow,znow


coeff1=((one-zenta)/(one-zenta-alfa))


 do gammanow=1,gnum
   do znow=1,znum
        comp_wage(:,gammanow,znow)=((one-alfa)*Zgrid(znow)*(K**alfa)*((kappa*zenta)**((alfa/(zenta-one)))))**coeff1
   end do
 end do


 END subroutine  wage_sub


!-----------------------------------------------------------

 subroutine interest_sub(K,int_rate)
! USE nrutil
 implicit none

 REAL(DP), DIMENSION (knum), INTENT (IN) :: K                 ! capital values (possibly an array) to calculate the factor prices
 REAL(DP), DIMENSION (knum,gnum,znum), INTENT (OUT) :: int_rate

 INTEGER:: gammanow,znow, know

 do gammanow=1,gnum
   do znow=1,znum
     do know=1,knum

        int_rate(know,gammanow,znow)=(alfa)*Zgrid(znow)*((K(know)/LABSUP(know,gammanow,znow))**(alfa-one)) - mydelta
   end do
 end do
END do
 END subroutine interest_sub

!-----------------------------------------------


 subroutine interestnext_sub(capital_next, int_ratenext)
 implicit none

 REAL(DP), DIMENSION (knum,gnum,znum), INTENT (IN) :: capital_next
 REAL(DP), DIMENSION (knum,gnum,znum,znum), INTENT (OUT) :: int_ratenext
 INTEGER:: gammanow,znow,znext

 do gammanow=1,gnum
   do znow=1,znum
     do znext=1,znum
        int_ratenext(:,gammanow,znow,znext)=(alfa)*Zgrid(znext)&
                          &*((capital_next0(:,gammanow,znow)/LABSUP(:,gammanow,znow))**(alfa-one)) - mydelta
   end do
  end do
end do



END subroutine  interestnext_sub

!--------------------------------------------------


 subroutine gamma_nextV(K,gam,a,b,c, gamma_next)
 implicit none

 REAL(DP), DIMENSION (knum), INTENT(IN) :: K
 REAL(DP), DIMENSION (gnum), INTENT(IN) :: gam


 !wealth evloution params
 REAL(DP), DIMENSION (znum), INTENT (IN) :: a,b,c
 REAL(DP), DIMENSION (knum,gnum,znum), INTENT(OUT) :: gamma_next

 !local
 REAL(DP), DIMENSION(knum, gnum) :: Kvec, gamvec
 INTEGER :: i

 Kvec=SPREAD(K,2,gnum)
 gamvec=SPREAD(gam,1,knum)


 outer: DO i=1, znum
          gamma_next(:,:,i) = a(i) + b(i) *LOG(Kvec) + c(i)* (gamvec)
       END DO  outer


 END subroutine gamma_nextV


!------------------------------------------------------

 subroutine mysplint3HAB(xa,ya,y2a,x, xguess, y, yp, ydp)
 USE nrtype
 IMPLICIT NONE
 REAL(DP), DIMENSION(:), INTENT(IN) :: xa,ya,y2a
 REAL(DP), INTENT(IN) :: x
 INTEGER(I4B), INTENT(IN) :: xguess  !initial guess for "myhunt"
 REAL(DP), INTENT(OUT), OPTIONAL:: y
 REAL(DP), INTENT(OUT), OPTIONAL:: yp
 REAL(DP), INTENT(OUT), OPTIONAL:: ydp
 INTEGER(I4B) :: khi,klo, indx
 REAL(DP) :: a,b,h
 indx=xguess
 call myhunt(xa,x,indx)
 IF (indx>=SIZE(xa)) THEN
     indx=SIZE(xa)-1
    ! WRITE(*,*) 'CAUTION, extrapolating beyond highest grid point!'
   !  WRITE(*,*) 'distance from final grid point is',(x-xa(SIZE(xa)))/(xa(SIZE(xa))-xa(SIZE(xa)-1))
 ELSEIF	(indx==0) THEN
     indx=1
    ! WRITE(*,*) 'CAUTION, extrapolating beyond lowest grid point!'
    ! WRITE(*,*) 'distance from first grid point is', (x-xa(1))/(xa(2)-xa(1))
 END IF
 klo=indx
 khi=klo+1
 h=xa(khi)-xa(klo)


 IF (h == 0.0) THEN
    WRITE(*,*) 'bad xa input in splint'
    pause
 END IF

 a=(xa(khi)-x)/h
 b=(x-xa(klo))/h
 IF (PRESENT(y)) THEN
 y=a*ya(klo)+b*ya(khi)+((a**3-a)*y2a(klo)+(b**3-b)*y2a(khi))*(h**2)/6.0_sp
 END IF
 IF (PRESENT(yp)) THEN
 yp=(ya(khi)-ya(klo))/h -((3.0D+00*(a**2)-one)/6.0_sp)*h*y2a(klo) + ((3.0D+00*(b**2)-one)/6.0_sp)*h*y2a(khi)
 END IF
 IF (PRESENT(ydp)) THEN
 ydp=a*y2a(klo) + b*y2a(khi)
 END IF

 END subroutine mysplint3HAB

 !-----------------------------------------------------

  subroutine mysplint3HABV(xa,ya,y2a,x, xguess, y, yp, ydp)
 USE nrtype
 IMPLICIT NONE

 REAL(DP), DIMENSION(:), INTENT(IN) :: xa
 REAL(DP), DIMENSION(:,:), INTENT(IN) :: ya, y2a
 REAL(DP), INTENT(IN) :: x
 INTEGER(i4B), INTENT(IN) :: xguess  !initial guess for "myhunt"
 REAL(DP), DIMENSION(wnum), INTENT(OUT), OPTIONAL:: y
 REAL(DP), DIMENSION(wnum), INTENT(OUT), OPTIONAL:: yp
 REAL(DP), DIMENSION(wnum), INTENT(OUT), OPTIONAL:: ydp
 INTEGER(I4B) :: khi,klo, indx
 REAL(DP) :: a,b,h
 indx=xguess
 call myhunt(xa,x,indx)
 IF (indx>=SIZE(xa)) THEN
    indx=SIZE(xa)-1
  !  WRITE(*,*) 'CAUTION, extrapolating beyond highest grid point!'
  !  WRITE(*,*) 'distance from final grid popint is', (x-xa(SIZE(xa)))/(xa(SIZE(xa))-xa(SIZE(xa)-1))
  !  pause
 ELSEIF	(indx<1) THEN
    indx=1
 END IF

 klo=indx
 khi=klo+1
 h=xa(khi)-xa(klo)

 IF (h == 0.0) THEN
    WRITE(*,*) 'bad xa input in splint'
    pause
 END IF

 a=(xa(khi)-x)/h
 b=(x-xa(klo))/h
 IF (PRESENT(y)) THEN
 y=a*ya(:,klo)+b*ya(:,khi)+((a**3-a)*y2a(:,klo)+(b**3-b)*y2a(:,khi))*(h**2)/6.0_sp
 END IF
 IF (PRESENT(yp)) THEN
 yp=(ya(:,khi)-ya(:,klo))/h -((3.0D+00*(a**2)-one)/6.0_sp)*h*y2a(:,klo) + ((3.0D+00*(b**2)-one)/6.0_sp)*h*y2a(:,khi)
 END IF
 IF (PRESENT(ydp)) THEN
 ydp=a*y2a(:,klo) + b*y2a(:,khi)
 END IF

 END subroutine mysplint3HABV

 !-------------------------------------------------------------------------------

 !subroutine UPDATE_LABSUP(LabsupS, LabSupN)
 !implicit none
 !REAL(DP), DIMENSION(wnum,knum,gnum,znum), INTENT(IN)::  LabsupS, LabSupN

! REAL(DP), DIMENSION(knum,gnum,znum):: AGlabS, AGlabN
! REAL(DP):: AGwS, AGwN
! INTEGER:: know, gammanow,znow,wnow


!do know=1,knum
!   do gammanow=1,gnum
!      do znow=1,znum
!           AGwN= gamma(gammanow)/(one-lamda)
!           AGwS=((Pstock(know,gammanow,znow) + Divd(know,gammanow,znow))*one  - gamma(gammanow))/(lamda)

!            call GetAG_LAB(wealthS, AGwS,LabSupS(:,know,gammanow,znow), AGlabS(know,gammanow,znow))
!            call GetAG_LAB(wealthN, AGwN,LabSupN(:,know,gammanow,znow), AGlabN(know,gammanow,znow))

!      end do
!   end do
!end do

!LABSUP=0.7_SP*LABSUP+ 0.3_SP*(lamda*AGlabS+(one-lamda)*AGlabN)

!end subroutine

!-----------------------------------------------------------------------------
!subroutine GetAG_LAB(wealth_in, AGw, LabSup_in, AGlab)
!implicit none

!REAL(DP),DIMENSION(wnum), INTENT(IN):: LabSup_in, wealth_in
!REAL(DP), INTENT(IN):: AGw
!REAL(DP), INTENT(OUT):: AGlab
!REAL(DP), DIMENSION(wnum):: coeffaL


!REAL(DP):: slope, weight1
!integer:: xguess


!call myspline(wealth_in, LabSup_in, 1.0e30_sp,1.0e30_sp,coeffaL)

!call mysplint3HAB(wealth_in,LabSup_in, coeffaL, AGw, NINT(wnum/2.0_DP),&
!					 y=AGlab)

!end subroutine

!--------------------------------------------------------------------------------------------


SUBROUTINE myhunt(xx,x,jlo)
USE nrtype
IMPLICIT NONE
INTEGER(I4B), INTENT(INOUT) :: jlo
REAL(DP), INTENT(IN) :: x
REAL(DP), DIMENSION(:), INTENT(IN) :: xx
INTEGER(I4B) :: n,inc,jhi,jm
LOGICAL :: ascnd
n=size(xx)
ascnd = (xx(n) >= xx(1))
IF (jlo <= 0 .or. jlo > n) THEN
jlo=0
jhi=n+1
ELSE
inc=1
IF (x >= xx(jlo) .eqv. ascnd) THEN
	DO
		jhi=jlo+inc
		IF (jhi > n) THEN
			jhi=n+1
			exit
		ELSE
			IF (x < xx(jhi) .eqv. ascnd) exit
			jlo=jhi
			inc=inc+inc
		END IF
	END DO
ELSE
	jhi=jlo
	DO
		jlo=jhi-inc
		IF (jlo < 1) THEN
			jlo=0
			exit
		ELSE
			IF (x >= xx(jlo) .eqv. ascnd) exit
			jhi=jlo
			inc=inc+inc
		END IF
	END DO
END IF
END IF
DO
IF (jhi-jlo <= 1) THEN
	IF (x == xx(n)) jlo=n-1
	IF (x == xx(1)) jlo=1
	exit
ELSE
	jm=(jhi+jlo)/2
	IF (x >= xx(jm) .eqv. ascnd) THEN
		jlo=jm
	ELSE
		jhi=jm
	END IF
END IF
END DO
END SUBROUTINE myhunt

!------------------------------------------------------------
SUBROUTINE BminFeasible(myfeasible)
implicit none

INTEGER, INTENT(OUT):: myfeasible


myfeasible=1

if (ANY(rat_BminFeas* (Wage/(one-Pbond)) +BminN <0)) then
write (*,*) 'ERROR: THE CURRENT BORROWING CONSTRAINT FOR BONDHOLDERS CREATES INFEASIBLE'
WRITE (*,*) ' CHOICE REGION GIVEN WAGE AND BOND PRICE FUNCTIONS'
write (*,*) 'THE LOCATION OF LARGEST DEVIATION IS:   ' , MINLOC(rat_BminFeas* (Wage/(one-Pbond)) +BminN )
WRITE (*,*) 'THE VALUE OF DEVIATION IS :', MINVAL(rat_BminFeas* (Wage/(one-Pbond)) +BminN )
myfeasible=0
END if

END subroutine BminFeasible
!----------------------------------------------------------
 subroutine interp2D(valuefun, valu )
 implicit none

REAL(DP), DIMENSION(wnum, knum, gnum, znum), INTENT(IN) :: valuefun
REAL(DP), DIMENSION(wnum, knum, gnum, znum,znum), INTENT(OUT) :: valu


!local
INTEGER :: znext, gammanext, j, znow, gammanow, know
REAL(DP), DIMENSION(wnum, knum, gnum, znum,znum) :: valu_in
REAL(DP), DIMENSION(wnum, knum,gnum, znum, gnum, znum):: valuINT
REAL(DP), DIMENSION(wnum, knum) :: coeff2a
REAL(DP), DIMENSION(wnum, gnum):: coeff2aG
REAL(DP), DIMENSION(wnum):: dummyarrW


dummyarrW=1

 !NOW INTERPOLATING VALUE AT NEXT PERIOD'S K AND GAMMA
   loop1: DO znext=1,znum
      loop2: DO gammanext=1,gnum

              call mysplie2(dummyarrW, capital, valuefun (:,:, gammanext, znext), coeff2a)
              loop3: DO j=1,knum
                    loop4: DO znow=1,znum
                       loop5: DO gammanow=1, gnum


                       CALL  mysplint3HABV(capital, valuefun (:,:, gammanext, znext), coeff2a,&
                                      capital_next(j, gammanow,znow), j , &
                                      y= valuINT(:,j,gammanow, znow, gammanext, znext))

                         !THIS STEP COMPUTES THE SPLINE INTERPOLATION IN THE CAPITAL DIRECTION
			 !FOR NEXT PERIOD'S CAPITAL VALUES, BUT FOR ALL IND.WEALTH LEVELS AT ONCE
			 ! **** valuINT_H is the value function interpolated at next period's capital
			 ! for grid points of gamma.. so gamma direction not interpolated yet

                             END DO loop5
                          END DO loop4
                     END DO loop3
           END DO loop2

	   !-------------------------interpolating in the GAMMA direction------------

           loop8: DO know=1,knum
              loop9: DO znow=1,znum
                 loop10: DO gammanow=1,gnum

		        !WRITE(*,*) know, gammanow, znow, znext
		        call mysplie2(dummyarrW, gamma, valuINT(:,know,gammanow, znow, :, znext), coeff2aG)

			call mysplint3HABV(gamma, valuINT(:,know, gammanow, znow,:, znext), coeff2aG, &
			                 gam_next(know,gammanow, znow), gammanow,&
					 y=valu_in(:,know,gammanow,znow,znext))

                          END DO loop10
                   END DO loop9
              END DO loop8

END DO loop1

valu=valu_in
END subroutine interp2D


!=======================================================================

subroutine interpGen2D( X_input, X_interpol )
 implicit none

REAL(DP), DIMENSION(knum, gnum, znum), INTENT(IN) :: X_input
REAL(DP), DIMENSION(knum, gnum, znum,znum), INTENT(OUT) :: X_interpol


!local
INTEGER :: znext, gammanext, j, znow, gammanow, know
REAL(DP), DIMENSION(knum, gnum, znum,znum) :: X_interpol_LOCAL
REAL(DP), DIMENSION(knum,gnum, znum, gnum, znum):: X_intermediate
REAL(DP), DIMENSION(knum) :: coeffa
REAL(DP), DIMENSION(gnum):: coeffaG
REAL(DP), DIMENSION(wnum):: dummyarrW


dummyarrW=1

 !NOW INTERPOLATING VALUE AT NEXT PERIOD'S K AND GAMMA
   loop1: DO znext=1,znum
      loop2: DO gammanext=1,gnum

              call myspline(capital, X_input (:, gammanext, znext),1.0e30_sp,1.0e30_sp, coeffa)
              loop3: DO j=1,knum
                    loop4: DO znow=1,znum
                       loop5: DO gammanow=1, gnum

                       CALL  mysplint3HAB(capital, X_input (:, gammanext, znext), coeffa,&
                                      capital_next(j, gammanow,znow), j , &
                                      y= X_intermediate(j,gammanow, znow, gammanext, znext))

                         !THIS STEP COMPUTES THE SPLINE INTERPOLATION IN THE CAPITAL DIRECTION
			 !FOR NEXT PERIOD'S CAPITAL VALUES, BUT FOR ALL IND.WEALTH LEVELS AT ONCE
			 ! **** valuINT_H is the value function interpolated at next period's capital
			 ! for grid points of gamma.. so gamma direction not interpolated yet

                             END DO loop5
                          END DO loop4
                     END DO loop3
           END DO loop2

	   !-------------------------interpolating in the GAMMA direction------------

           loop8: DO know=1,knum
              loop9: DO znow=1,znum
                 loop10: DO gammanow=1,gnum

		        !WRITE(*,*) know, gammanow, znow, znext
		        call myspline(gamma, X_intermediate(know,gammanow, znow, :, znext), 1.0e30_sp,1.0e30_sp,coeffaG)

			call mysplint3HAB(gamma, X_intermediate(know, gammanow, znow,:, znext), coeffaG, &
			                 gam_next(know,gammanow, znow), gammanow,&
					 y=X_interpol_LOCAL(know,gammanow,znow,znext))

                          END DO loop10
                   END DO loop9
              END DO loop8

END DO loop1

X_interpol = X_interpol_LOCAL
END subroutine interpGen2D

!===============================================================================================
function howard(bond_H, stock_H, value_H, choice_H, type_H)
implicit none

REAL(DP), DIMENSION(wnum, knum, gnum, znum), INTENT(IN) :: bond_H, stock_H
REAL(DP), DIMENSION(wnum, knum, gnum, znum, znum), INTENT(IN) :: value_H
INTEGER, INTENT(IN) :: choice_H
CHARACTER, INTENT(IN) :: type_H
REAL(DP), DIMENSION(wnum,knum,gnum,znum) :: howard


!local
INTEGER :: counter, znow,know,gammanow,wnow
REAL(DP), DIMENSION(wnum, knum, gnum, znum,znum) :: valu_H
REAL(DP), DIMENSION(wnum, knum, gnum, znum) :: valuefun_H
REAL(DP), DIMENSION(znum):: dummyarrZ
REAL(DP), DIMENSION(wnum,znum):: coeffV_F
REAL(DP), DIMENSION(znum,wnum):: coeffT

REAL(DP) :: Pbond_H

dummyarrZ=one

IF (choice_H ==0) THEN
    valu_H=1
ELSE
    valu_H=value_H
END IF

ITER_H: DO counter=1, countHmax

      IF (type_H == 'N') THEN
           a: DO know=1,knum
             b: DO znow=1,znum
              c:  DO gammanow=1,gnum
                  Pbond_H= Pbond(know,gammanow,znow)
               d:   DO wnow=1,wnum
                    call mysplie2(dummyarrZ, wealthN, TRANSPOSE(valu_H(:,know,gammanow,znow,:)), coeffT)
                    coeffV_F=TRANSPOSE(coeffT)
                     valuefun_H(wnow,know,gammanow,znow)=valuefuncN(bond_H(wnow,know,gammanow,znow),&
                      & LABN(know,gammanow,znow), valu_H(:,know,gammanow,znow,:),coeffV_F,wnow, know, gammanow, znow)
                  END DO d
                END DO	c
              END DO   b

             END DO  a

       ELSEIF (type_H == 'S') THEN
!       WRITE (*,*)' hi, in the S part'

             aa: DO know=1,knum
                bb: DO znow=1,znum
                  cc:  DO gammanow=1,gnum
                      Pbond_H= Pbond(know,gammanow,znow)
                    dd:   DO wnow=1,wnum
                         call mysplie2(dummyarrZ, wealthS, TRANSPOSE(valu_H(:,know,gammanow,znow,:)), coeffT)
                         coeffV_F=TRANSPOSE(coeffT)
                         valuefun_H(wnow,know,gammanow,znow)=valuefuncS(bond_H(wnow,know,gammanow,znow), &
                          &stock_H(wnow,know,gammanow,znow),LABS(know,gammanow,znow),valu_H(:,know,gammanow,znow,:),&
                          & coeffV_F,wnow, know, gammanow, znow)
                      END DO dd
                    END DO cc
                  END DO bb
             END DO aa
      ELSEIF (type_H == 'R') THEN
           DO know=1,knum
              DO znow=1,znum
               DO gammanow=1,gnum
                  Pbond_H= Pbond(know,gammanow,znow)
                  DO wnow=1,wnum
                    call mysplie2(dummyarrZ, wealthRA, TRANSPOSE(valu_H(:,know,gammanow,znow,:)), coeffT)
                    coeffV_F=TRANSPOSE(coeffT)
                    valuefun_H(wnow,know,gammanow,znow)=valuefuncRA(bond_H(wnow,know,gammanow,znow),&
                   & LABRA(know,gammanow,znow),valu_H(:,know,gammanow,znow,:),coeffV_F,wnow, know, gammanow, znow)
                  END DO
                END DO
              END DO

             END DO


       ELSE
       WRITE (*,*) ' error: the type of value fnction iteration must be N or S'
       END IF

     !INTERPOLATING AT NEXT PERIOD'S CAPITAL AND GAMMA, OUTPUT VALU_h IS THE INTERPOLATED MATRIX
       IF (COUNTER < countHmax) THEN
            call interp2D(valuefun_H, valu_H )
       END IF


END DO	ITER_H

howard =valuefun_H

END function howard


!=======================================================


!
!===============================================================
 REAL(DP) function valuefuncRA(x, lra, valu_F ,coeffV_RA,wnow_F, know_F, gammanow_F, znow_F)
 implicit none


! dummy arguments
REAL(DP), DIMENSION(wnum ,znum), INTENT(IN) :: valu_F, coeffV_RA
INTEGER, INTENT(IN):: wnow_F, know_F, gammanow_F, znow_F
REAL(DP), INTENT(IN) :: x, lra

!local
REAL(DP), DIMENSION(znum) :: vF

INTEGER :: i, xguess
REAL(DP) :: exp_VnextF, a,b,h,utilF, slope, weight1, cons, cash_F



 cash_F= wealthRA(wnow_F) + wage( know_F, gammanow_F, znow_F)*lra
 cons=(cash_F - Pbond(know_F, gammanow_F, znow_F)* x)
 if (cons-kappaJ*(lra**zentaJ) <myeps) then
   write (*,*) 'CONSUMPTION TOO LOW COMPARED TO LABOR.. UTILITY UNDEFINED'
   WRITE (*,*) 'STATE IS',wnow_F, know_F, gammanow_F, znow_F
   PAUSE
 end if

utilF=  (cons-kappaJ*(lra**zentaJ))**roJ


xguess=wnow_F
call myhunt(wealthRA, x, xguess)
IF (xguess>=wnum)    xguess=wnum-1
IF (xguess==0)      xguess=1

do i=1,znum
     h=wealthRA(xguess+1)-wealthRA(xguess)
     a=(wealthRA(xguess+1)-x)/h
     b=(x-wealthRA(xguess))/h
     vF(i)=a*valu_F(xguess,i)+b*valu_F(xguess+1,i)+((a**3-a)*coeffV_RA(xguess,i)+(b**3-b)*coeffV_RA(xguess+1,i))*(h**2)/6.0_sp

end do

exp_VnextF=SUM(probz(znow_F,:)*(vF(:)**thetaJ))
valuefuncRA= (((one-mybeta) * utilF) + (mybeta * (exp_VnextF**(roJ/thetaJ))))**(one/roJ)
!!!!!  CAUTION.. DO NOT DELETE THIS WARNING:                                !!!!!!
!!!!   I REMOVED THE (MINUS) IN FRONT OF THE EXPRESSION ON THE ABOVE LINE   !!!!!!

 END function  valuefuncRA


!-----------------------------------------------


 REAL(DP) function valuefuncN(x, ln,valu_F ,coeffV_N,wnow_F, know_F, gammanow_F, znow_F)
 implicit none


! dummy arguments
REAL(DP), DIMENSION(wnum ,znum), INTENT(IN) :: valu_F, coeffV_N
INTEGER, INTENT(IN):: wnow_F, know_F, gammanow_F, znow_F
REAL(DP), INTENT(IN) :: x,ln

!local
REAL(DP), DIMENSION(znum) :: vF

INTEGER :: i, xguess
REAL(DP) :: exp_VnextF, utilF, slope, weight1, a,b,h, cash_F, cons

cash_F= wealthN(wnow_F) + wage( know_F, gammanow_F,znow_F)*ln
cons=(cash_F - Pbond(know_F, gammanow_F, znow_F)* x)

 if (cons-kappaN*(ln**zentaN) <myeps) then
   write (*,*) 'CONSUMPTION TOO LOW COMPARED TO LABOR.. UTILITY UNDEFINED'
   WRITE (*,*) 'STATE IS',wnow_F, know_F, gammanow_F, znow_F
   PAUSE
 end if

utilF=  (cons-kappaN*(ln**zentaN))**roN

xguess=wnow_F
call myhunt(wealthN, x, xguess)
IF (xguess>=wnum)    xguess=wnum-1
IF (xguess==0)      xguess=1

do i=1,znum
     h=wealthN(xguess+1)-wealthN(xguess)
     a=(wealthN(xguess+1)-x)/h
     b=(x-wealthN(xguess))/h
     vF(i)=a*valu_F(xguess,i)+b*valu_F(xguess+1,i)+((a**3-a)*coeffV_N(xguess,i)+(b**3-b)*coeffV_N(xguess+1,i))*(h**2)/6.0_sp

end do

exp_VnextF=SUM(probz(znow_F,:)*(vF(:)**thetaN))
valuefuncN= (((one-mybeta) * utilF) + (mybeta * (exp_VnextF**(roN/thetaN))))**(one/roN)
!!!!!  CAUTION.. DO NOT DELETE THIS WARNING:                                !!!!!!
!!!!   I REMOVED THE (MINUS) IN FRONT OF THE EXPRESSION ON THE ABOVE LINE   !!!!!!

 END function  valuefuncN

 !------------------------------------------------



REAL(DP) function valuefuncS(b,s, ls,valu_F ,coeffV_F,wnow_F, know_F, gammanow_F, znow_F)
implicit none

! dummy arguments
REAL(DP), DIMENSION(wnum ,znum), INTENT(IN) :: valu_F, coeffV_F
INTEGER, INTENT(IN):: wnow_F, know_F, gammanow_F, znow_F
REAL(DP), INTENT(IN) :: s,b, ls

!local
REAL(DP), DIMENSION(znum) :: vF, wealthnext_F, Pstock_next_F, Divd_next_F
INTEGER, DIMENSION(znum):: indxx
REAL(DP) :: exp_VnextF,h,a1,a2,utilF, slope, weight1, cons, cash_F
INTEGER :: i, xguess

Pstock_next_F=Pstock_next(know_F,gammanow_F,znow_F,:)
Divd_next_F=Divd_next(know_F,gammanow_F,znow_F,:)


exp_VnextF=0.0_DP
cash_F= wealthS(wnow_F) + wage(know_F, gammanow_F, znow_F)*ls
cons=(cash_F -Pstock(know_F,gammanow_F,znow_F)*s -Pbond(know_F, gammanow_F, znow_F)* b)

 if (cons-kappaS*(ls**zentaS) <myeps) then
   write (*,*) 'CONSUMPTION TOO LOW COMPARED TO LABOR.. UTILITY UNDEFINED'
   WRITE (*,*) 'STATE IS',wnow_F, know_F, gammanow_F, znow_F
   PAUSE
 end if

utilF=  (cons-kappaS*(ls**zentaS))**roS

wealthnext_F = (Pstock_next_F + Divd_next_F) * s + b

 xguess=wnow_F

do i=1,znum
    call myhunt(wealthS, wealthnext_F(i), xguess)
    indxx(i)=xguess
end do
where (indxx>=wnum)    indxx=wnum-1
where (indxx==0)        indxx=1

do i=1,znum
 h=wealthS(indxx(i)+1)-wealthS(indxx(i))
 a1=(wealthS(indxx(i)+1)-wealthnext_F(i))/h
 a2=(wealthnext_F(i)-wealthS(indxx(i)))/h
 vF(i)=a1*valu_F(indxx(i),i)+a2*valu_F(indxx(i)+1,i)+((a1**3-a1)*coeffV_F(indxx(i),i)+ &
                                                                &(a2**3-a2)*coeffV_F(indxx(i)+1,i))*(h**2)/6.0_sp
end do

exp_VnextF=SUM(probz(znow_F,:)*(vF(:)**thetaS))
valuefuncS= (((one-mybeta) * utilF) + (mybeta * (exp_VnextF**(roS/thetaS))))**(one/roS)
!!!!!CAUTION.. I REMOVED THE (MINUS) IN FRONT OF THE EXPRESSION ON THE ABOVE LINE...........


 END function  valuefuncS


 !--------------------------------------------


 	SUBROUTINE myspline(x,y,yp1,ypn,y2)
	USE nrtype
      	IMPLICIT NONE
	REAL(DP), DIMENSION(:), INTENT(IN) :: x,y
	REAL(SP), INTENT(IN) :: yp1,ypn
	REAL(DP), DIMENSION(:), INTENT(OUT) :: y2
	INTEGER(I4B) :: n
	REAL(DP), DIMENSION(size(x)) :: a,b,c,r

        IF (SIZE(x) == SIZE(y) .and. SIZE(y) == SIZE(y2)) THEN
		n= SIZE(x)
	ELSE
		WRITE (*,*) 'nrerror: an assert_eq failed with this tag: MYSPLINE'
                WRITE (*,*)   SIZE(x)
                WRITE (*,*)   SIZE(y)
                write (*,*)   SIZE(y2)
                pause


	END IF
     	c(1:n-1)=x(2:n)-x(1:n-1)
	r(1:n-1)=6.0_sp*((y(2:n)-y(1:n-1))/c(1:n-1))
	r(2:n-1)=r(2:n-1)-r(1:n-2)
	a(2:n-1)=c(1:n-2)
	b(2:n-1)=2.0_sp*(c(2:n-1)+a(2:n-1))
	b(1)=1.0
	b(n)=1.0
	IF (yp1 > 0.99e30_sp) THEN
		r(1)=0.0
		c(1)=0.0
	ELSE
		r(1)=(3.0_sp/(x(2)-x(1)))*((y(2)-y(1))/(x(2)-x(1))-yp1)
		c(1)=0.5
	END IF
	IF (ypn > 0.99e30_sp) THEN
		r(n)=0.0
		a(n)=0.0
	ELSE
		r(n)=(-3.0_sp/(x(n)-x(n-1)))*((y(n)-y(n-1))/(x(n)-x(n-1))-ypn)
		a(n)=0.5
	END IF
	IF (n<4) THEN
           call mytridag_ser(a(2:n),b(1:n),c(1:n-1),r(1:n),y2(1:n))
	ELSE
           call mytridag_par(a(2:n),b(1:n),c(1:n-1),r(1:n),y2(1:n))
	END IF

	END SUBROUTINE myspline


!-----------------------------------------------------

	SUBROUTINE mysplie2(x1a,x2a,ya,y2a)
	USE nrtype
	IMPLICIT NONE
	REAL(DP), DIMENSION(:), INTENT(IN) :: x1a,x2a
	REAL(DP), DIMENSION(:,:), INTENT(IN) :: ya
	REAL(DP), DIMENSION(:,:), INTENT(OUT) :: y2a
	INTEGER(I4B) :: j,m,ndum

        IF (SIZE(x1a) == SIZE(ya,1) .and. SIZE(ya,1) == SIZE(y2a,1)) THEN
		m= SIZE(x1a)
	ELSE
		WRITE (*,*) 'nrerror: an assert_eq failed with this tag: MYSPLIe2:1'
	END IF
        IF (SIZE(x2a) == SIZE(ya,2) .and. SIZE(ya,2) == SIZE(y2a,2)) THEN
		ndum= SIZE(x2a)
	ELSE
		WRITE (*,*) 'nrerror: an assert_eq failed with this tag: MYSPLIE2:2'
	END IF

	DO j=1,m
		call myspline(x2a,ya(j,:),1.0e30_sp,1.0e30_sp,y2a(j,:))
	END DO
	END SUBROUTINE mysplie2


!----------------------------------------------------




 	SUBROUTINE mytridag_ser(a,b,c,r,u)
	USE nrtype
	IMPLICIT NONE
	REAL(DP), DIMENSION(:), INTENT(IN) :: a,b,c,r
	REAL(DP), DIMENSION(:), INTENT(OUT) :: u
	REAL(DP), DIMENSION(size(b)) :: gam
	INTEGER(I4B) :: n,j
        INTEGER(I4B), DIMENSION(5) :: vectridag
	REAL(DP) :: bet
	vectridag= (/size(a)+1,size(b),size(c)+1,size(r),size(u)/)

        IF (ALL(vectridag(2:) == vectridag(1))) THEN
		n= vectridag(1)
	ELSE
		WRITE (*,*) 'nrerror: an assert_eq failed with this tag: MYTRIDAG_ser'
	END IF
	bet=b(1)
	IF (bet == 0.0) THEN
        WRITE(*,*) 'mytridag_ser: Error at code stage 1'
        END IF

	u(1)=r(1)/bet
	DO j=2,n
		gam(j)=c(j-1)/bet
		bet=b(j)-a(j-1)*gam(j)
		IF (bet == 0.0) THEN
		   WRITE(*,*) 'mytridag_ser: Error at code stage 2'
                END IF
		u(j)=(r(j)-a(j-1)*u(j-1))/bet
	END DO
	DO j=n-1,1,-1
		u(j)=u(j)-gam(j+1)*u(j+1)
	END DO
	END SUBROUTINE mytridag_ser

	RECURSIVE SUBROUTINE mytridag_par(a,b,c,r,u)
	USE nrtype
	!USE nr, ONLY : mytridag_ser
	IMPLICIT NONE
	REAL(DP), DIMENSION(:), INTENT(IN) :: a,b,c,r
	REAL(DP), DIMENSION(:), INTENT(OUT) :: u
	INTEGER(I4B), PARAMETER :: NPAR_TRIDAG=4
	INTEGER(I4B) :: n,n2,nm,nx
        INTEGER(I4B), DIMENSION(5) :: vectridag
	REAL(DP), DIMENSION(size(b)/2) :: y,q,piva
	REAL(DP), DIMENSION(size(b)/2-1) :: x,z
	REAL(DP), DIMENSION(size(a)/2) :: pivc

	vectridag= (/size(a)+1,size(b),size(c)+1,size(r),size(u)/)
        IF (ALL(vectridag(2:) == vectridag(1))) THEN
		n= vectridag(1)
	ELSE
		WRITE (*,*) 'nrerror: an assert_eq failed with this tag: MYTRIDAG_ser'
	END IF
       	IF (n < NPAR_TRIDAG) THEN
		call mytridag_ser(a,b,c,r,u)
	ELSE
		IF (maxval(abs(b(1:n))) == 0.0) THEN
                WRITE (*,*) 'mytridag_par: possible singular matrix'
                pause
                END IF

		n2=size(y)
		nm=size(pivc)
		nx=size(x)
		piva = a(1:n-1:2)/b(1:n-1:2)
		pivc = c(2:n-1:2)/b(3:n:2)
		y(1:nm) = b(2:n-1:2)-piva(1:nm)*c(1:n-2:2)-pivc*a(2:n-1:2)
		q(1:nm) = r(2:n-1:2)-piva(1:nm)*r(1:n-2:2)-pivc*r(3:n:2)
		IF (nm < n2) THEN
			y(n2) = b(n)-piva(n2)*c(n-1)
			q(n2) = r(n)-piva(n2)*r(n-1)
		END IF
		x = -piva(2:n2)*a(2:n-2:2)
		z = -pivc(1:nx)*c(3:n-1:2)
		call mytridag_par(x,y,z,q,u(2:n:2))
		u(1) = (r(1)-c(1)*u(2))/b(1)
		u(3:n-1:2) = (r(3:n-1:2)-a(2:n-2:2)*u(2:n-2:2) &
			-c(3:n-1:2)*u(4:n:2))/b(3:n-1:2)
		IF (nm == n2) u(n)=(r(n)-a(n-1)*u(n-1))/b(n)
	END IF
	END SUBROUTINE mytridag_par

 !------------------------------------------------



END module



!===========================================================================================
!===========================================================================================
!===========================================================================================
!===========================================================================================
!===========================================================================================



!     Last change:  UR   20 May 2003   11:36 am
module my_firmHAB


USE myparamsHAB
USE my_procsHAB, ONLY : interpGen2D
implicit none

CONTAINS

!-------------------------------------------------------
subroutine INVESTMENT_SUB(consS, Invest_in,whtrINIT)
implicit none

REAL(DP), DIMENSION (:,:,:,:), INTENT(IN) :: consS
REAL(DP), DIMENSION(:,:,:), INTENT(OUT) ::Invest_in
INTEGER, INTENT(IN) :: whtrINIT

REAL(DP), DIMENSION(knum, gnum, znum,znum) :: MuC
REAL(DP), DIMENSION(knum,gnum,znum) :: OPT_INV, invest_lag
REAL(DP) ::  XX, YY, dx, q_min, q_max, qlow, qhigh, qmid,Excess_A, Excess_B, Excess_C, Inv_min, Inv_max, KKnext
REAL(DP) , DIMENSION(znum) :: Invnext_IN, MUC_in, auxil
REAL(DP):: obj1, obj2, obj3, discrINV

INTEGER :: know, gammanow, znow, Maxbis, j, countj,i,k, itermax, iter
LOGICAL:: flag
INTEGER, PARAMETER:: invtoler=1.0E-4

Maxbis=100
itermax=100

q_min= 0.003_SP
q_max= mydelta + 0.15_SP

write (*,*) 'HELLO WE ARE IN INVESTMENT SUB'

CALL marginalUC(consS, MuC,whtrINIT)


WRITE (*,*) 'WE ARE AFTER MARGINAL UC CALLED, HERE IT IS'
WRITE (*,120) minval(MuC), maxval(MuC)
120 FORMAT(1X, 10F15.8)
!pause

where (MuC<0.1)
MuC=0.1_DP
elsewhere (MuC>4.0_DP)
MuC=4.0_DP
end where


if (setinvest==1) then
    CALL interpGen2D(Invest, Invest_next)
else
    do i=1,znum
      do j=1,znum
         do k=1,gnum
             Invest_next(:,k,j,i)=mydelta*capital
         end do
      end do
    end do
end if

inv: do iter=1,itermax
! MAIN ITERATION LOOP STARTS

  loop11: DO know=1,knum
    loop12: DO gammanow=1,gnum
      loop13: DO znow=1,znum

       !SOLVE FOR INVESTMENT AT THIS STATE SPACE POINT -------------
         Inv_min=capital(know)*q_min
         Inv_max=capital(know)*q_max
         dx=Inv_max-Inv_min
         qlow=Inv_min
         qhigh=Inv_max

            MUC_in=MuC(know,gammanow,znow,:)
            Invnext_IN= Invest_next(know,gammanow,znow,:)


            XX= 0.00_DP
            do i=1,znum
               XX= XX+  Probz(znow,i)*MuC(know,gammanow,znow,i) * Zgrid(i) *(LABSUP_NEXT(know,gammanow,znow,i)**(one-alfa))
           !    XX= XX+  Probz(znow,i)*MuC(know,gammanow,znow,i) * Zgrid(i)

            end do


            KKnext= ((one-mydelta) +ADJinvest(Inv_min, capital(know)))*capital(know)

            obj1 =(alfa*(KKnext**(alfa-one))*XX )
            obj2=one/Diff_ADJinvest(inv_min, capital(know))
            do i=1,znum
                auxil(i)=Diff_ADJinvest(Invnext_IN(i), KKnext)
            END do

            obj3=0.0_SP
            do i=1,znum
                obj3 = obj3+ MUC_In(i)*Probz(znow,i)*((one-mydelta)/auxil(i) -Invnext_IN(i)/KKnext + &
                                      &ADJinvest(Invnext_IN(i), KKnext)/auxil(i))
            end do

            Excess_A=obj1-obj2+obj3


            KKnext= ((one-mydelta) +ADJinvest(Inv_max, capital(know)))*capital(know)
            obj1 =(alfa*(KKnext**(alfa-one))*XX )
            obj2=one/Diff_ADJinvest(inv_max, capital(know))
            do i=1,znum
                auxil(i)=Diff_ADJinvest(Invnext_IN(i), KKnext)
            END do

            obj3=0.0_SP
            do i=1,znum
                obj3 = obj3+ MUC_In(i)*Probz(znow,i)*((one-mydelta)/auxil(i) -Invnext_IN(i)/KKnext + &
                                                &ADJinvest(Invnext_IN(i), KKnext)/auxil(i))
            end do

            Excess_B=obj1-obj2+obj3

            IF ((Excess_A >0) .AND. (Excess_B<0)) then                ! looking for a zero between QLOW and QHIGH

                   j=1; flag=.FALSE.;
                   DO WHILE ((j < MAXbis) .AND. (flag == .FALSE.))

                               dx=0.5_SP * dx
                               qmid= qlow + dx

                                KKnext= ((one-mydelta) +ADJinvest(qmid, capital(know)))*capital(know)

                                obj1 =(alfa*(KKnext**(alfa-one))*XX )
                                obj2=one/Diff_ADJinvest(qmid, capital(know))
                                do i=1,znum
                                    auxil(i)=Diff_ADJinvest(Invnext_IN(i), KKnext)
                                END do

                                obj3=0.0_SP

                                do i=1,znum
                                       obj3 = obj3+ MUC_In(i)*Probz(znow,i)*((one-mydelta)/auxil(i) -Invnext_IN(i)/KKnext + &
                                            & ADJinvest(Invnext_IN(i), KKnext)/auxil(i))
                                end do

                                Excess_C=obj1-obj2+obj3

                               IF (Excess_C > 0) then
                                   qlow=qmid
                               END  IF
                               IF ((ABS(Excess_C) < tol_excessD )) then
                                   OPT_INV(know, gammanow,znow)=qmid
                              !     write (*,*) 'OPT invesment is', qmid
                                   flag= .TRUE.
                               END IF
                               j=j+1
                               countJ=j


                    END DO

                    if (countj >=Maxbis) then
                       WRITE (*,*)' no root found in', MAXbis, 'iterations even though QLOW and QHIGH seems to bracket a zero'
                       WRITE (*,*) 'excess_C is', Excess_C
                    end if


                     IF ((countj>=Maxbis) .AND.  ((ABS(Excess_C) < MIN(5.0E-2_DP, 5000.0_DP*tol_excessD)))) then
                           OPT_INV(know,gammanow,znow)= qmid
                           WRITE (*,*) 'THE WEAKER BOUNDS ARE SATISFIED AND THis investment value is RECORDED'
                           write (*,*) 'OPT invesment is', qmid
                     END IF
            ELSE
                         write (*,*) 'ERROR IN INVESTMENT SUB'
                         WRITE (*,*)  'EXCESS A AND b ARE', EXCESS_A, EXCESS_B
                         WRITE (*,*) 'ADJ AT INVMIN AND INVMAX ARE',  ADJinvest(Inv_min, capital(know)),&
                                                       &ADJinvest(Inv_mAX, capital(know))
                         write (*,*)  'derivatives are', Diff_ADJinvest(Inv_min,capital(know)),Diff_ADJinvest(Inv_max,capital(know))
                         PAUSE
            END IF

      END  DO  loop13
    END  DO  loop12
 END  DO  loop11

 CALL interpGen2D(OPT_INV, Invest_next)
 discrINV=MAXVAL(ABS(OPT_INV-Invest_lag))
 if (discrINV <Invtoler) EXIT inv
 Invest_lag=OPT_inv


 END do inv

if (iter>=itermax) then
write (*,*) 'NO OPTIMUM FOUND IN ',ITERMAX,'ITERATIONS.. PAUSING'
write (*,*) 'HERE IS THE DISCREPANCY'
WRITE (*,*) (discrINV)

end if

write (*,*) 'here is investment solution:'
write (*,*) OPT_INV

Invest_in=OPT_INV





end subroutine INVESTMENT_SUB

!---------------------------------------------------------------------


subroutine UPDATE_PStock(consS,  Pstocknew, Discr,whtrINIT)

REAL(DP), DIMENSION(:,:,:,:), INTENT(IN):: consS
REAL(DP), DIMENSION(:,:,:), INTENT(OUT):: Pstocknew, Discr
INTEGER, INTENT(IN) :: whtrINIT


!local
REAL(DP), DIMENSION(knum, gnum,znum,znum) :: MuC,  Pstock_next_UPD, temp_vec
REAL(DP), DIMENSION(knum, gnum,znum) :: Pstock_UPD
INTEGER:: T, Tmax, znow, znext

CALL marginalUC(consS, MuC,whtrINIT)


!UPDATE ON THE PRESENT VALUE EQUATION T TIMES

if (whtrINIT /=0) then
    Pstock_UPD =Pstock
    CALL interpGen2D(Pstock_UPD, Pstock_next_UPD)
    Tmax=25
else
    Pstock_next_UPD=0.0_DP
    Pstock_UPD=0.0_DP
    Tmax=50
end if


do T=1, Tmax

    temp_vec= MuC*(Divd_next + Pstock_next_UPD)
    Pstock_UPD=0.0_DP

    DO znow=1,znum
     do znext=1,znum
        Pstock_UPD(:,:,znow)= Pstock_UPD(:,:,znow) + Probz(znow,znext)*temp_vec(:,:,znow,znext)
        END do
    END DO

    write (*,*) ' here is Pstock at', T,'iteration'
   ! write (*,*) Pstock_UPD

    call interpGen2D(Pstock_UPD, Pstock_next_UPD)
end do


if (whtrINIT==0) then
    Pstock_UPD=(one/(one-(mybeta**Tmax)))*Pstock_UPD
end if

write (*,*) Pstock_UPD

Discr = (ABS(Pstock-Pstock_UPD))

Pstocknew=Pstock_UPD
end subroutine UPDATE_Pstock

!-------------------------------------------------------------

subroutine MarginalUC(consS, MuC, whtrIN)
USE my_procsHAB, ONLY : myspline, mysplint3HAB, interp2D

REAL(DP), DIMENSION(:,:,:,:), INTENT(IN):: consS
REAL(DP), DIMENSION(:,:,:,:), INTENT(OUT):: MuC
INTEGER, INTENT(IN) :: whtrIN

!locals
REAL(DP), DIMENSION( wnum,knum,gnum,znum,znum) :: ConsS_next
REAL(DP), DIMENSION( knum,gnum,znum) :: ConsS_interpol, AGwS,  util
REAL(DP), DIMENSION( knum,gnum,znum,znum) :: ConsS_next_interpol,AGw_next_S, util_next
REAL(DP), DIMENSION( znum) :: Pstock_next_S, Divd_next_S, Gam_next_S
REAL(DP), DIMENSION( wnum):: coeffa
REAL(DP) :: Pstock_S, Divd_S

INTEGER :: know, gammanow, znow,i,ll

write (*,120) consS
write (*,*) ' ========ABOVE WAS CONS UPON ENTERING ========================'


CALL interp2D(consS, consS_next)


WRITE (*,120) MINVAL(consS_next), MAXVAL(consS_next)
write (*,*) ' ========ABOVE WAS CONSS_NEXT AFTER INTERP2D===================='

!pause

 loop11: DO know=1,knum
    loop12: DO gammanow=1,gnum
      loop13: DO znow=1,znum

          !FIND AGGREGATE STOCKHOLDER CONSUMPTION today
          if (whtrIN /= 0) then
              Pstock_S = Pstock(know, gammanow, znow)
              Divd_S = Divd(know, gammanow, znow)
              AGwS(know,gammanow,znow)= ((Pstock_S + Divd_S)* one+(FD  - gamma(gammanow)))/(lamda)
          else
              Pstock_S =0.0_SP
              Divd_S = 0.0_SP
              AGwS(know,gammanow,znow)= (capital(know) *(one + interest0(know, gammanow,znow))+(FD - gamma(gammanow)))/(lamda)
          end if


          CALL  myspline(wealthS, consS(:, know, gammanow, znow),1.0e30_sp,1.0e30_sp, coeffa)
          CALL  mysplint3HAB(wealthS, consS (:, know,gammanow, znow), coeffa,&
                                      AGwS(know,gammanow,znow), wnum/2 , &
                                      y= ConsS_interpol(know, gammanow, znow))


          !FIND AGGREGATE STOCKHOLDER CONSUMPTION tomorrow
          if (whtrIN /=0) then
              Pstock_next_S = Pstock_next(know, gammanow, znow,:)
              Divd_next_S = Divd_next(know, gammanow, znow,:)
              Gam_next_S = Gam_next(know,gammanow, znow)
              AGw_next_S(know,gammanow,znow,:)= ((Pstock_next_S + Divd_next_S)* one+(FD  - Gam_next_S))/(lamda)
          else         ! IF THIS IS THE INITIALIZATION THEN USE A GUESS FUNCTION FOR NEXT PERIOD'S WEALTH
              Pstock_next_S=0.0_SP
              Divd_next_S =0.0_SP
              Gam_next_S =0.0_SP
            AGw_next_S(know,gammanow,znow,:)= (capital_next0(know,gammanow,znow) *(1.0_SP + interest_next0(know, gammanow,znow,:)) &
                           & +(FD- gam_next0(know,gammanow,znow)))/(lamda)
          end if

          DO i=1,znum
              CALL  myspline(wealthS, ConsS_next(:, know, gammanow, znow,i),1.0e30_sp,1.0e30_sp, coeffa)
              CALL  mysplint3HAB(wealthS, ConsS_next (:, know,gammanow, znow,i), coeffa,&
                                          AGw_next_S(know,gammanow,znow,i), wnum/2 , &
                                          y= ConsS_next_interpol(know, gammanow, znow,i))

          END DO



      END  DO  loop13
    END  DO  loop12
 END  DO  loop11


write (*,*) 'the minimum value of CONS is'
write (*,120) MINVAL(ConsS_interpol)
write (*,*) 'the minimum value of CONS_next is'
write (*,120) MINVAL(ConsS_next_interpol)
!pause
write (*,*) 'min and max of AGwS'
write (*,120) MINVAL(AGwS), MAXVAL(AGwS)
write (*,*) 'min and max of AGwSnext'
write (*,120) MINVAL(AGw_next_S), MAXVAL(AGw_next_S)
write (*,*) '========================================================================='
!pause
120 FORMAT(1X, 10F15.8)

if (ANY(ConsS_interpol <=0)) then
write (*,*) "NEGATIVE VALUE FOR CONSUMPTION IN mARGINAL_UC"
write (*,*) MINVAL(ConsS_interpol)
!PAUSE                                                                                                                                                                                       

end if
if (ANY(ConsS_next_interpol <=0)) then
write (*,*) "NEGATIVE VALUE FOR NEXT PERIODS CONSUMPTION IN mARGINAL_UC"
write (*,*) MINVAL(ConsS_next_interpol)

!PAUSE

end if
!if (ANY(LabS_interpol <=0)) then
!write (*,*) "NEGATIVE VALUE FOR CONSUMPTION IN mARGINAL_UC"
!write (*,*) MINVAL(LabS_interpol)

!PAUSE

!end if
if (ANY(LabS_next <=0)) then
write (*,*) "NEGATIVE VALUE FOR NEXT PERIODS CONSUMPTION IN mARGINAL_UC"
write (*,*) MINVAL(LabS_next)

!PAUSE
end if

!where (LabS_interpol <0.0)
!    LabS_interpol=0.0_SP
!ELSEWHERE (LabS_interpol >=1.0)
!    LabS_interpol=0.99_SP
!end where
where (LabS_next <0.0)
    LabS_next=0.0_SP
ELSEWHERE (LabS_next>=1.0)
    LabS_next=0.99_SP
end where

if (any(ConsS_next_interpol-kappaS*(LabS_next**zentaS)<=(myeps))) then
    write (*,*) 'PROBLEM IN MARGINALuc...CONSNEXT TOO LOW '
    WRITE (*,*) ConsS_next_interpol
    WRITE (*,*) kappaS*(LabS_next**zentaS)
    PAUSE
end if

if (any(ConsS_interpol-kappaS*(LabS**zentaS)<=(myeps))) then
    write (*,*) 'PROBLEM IN MARGINALuc...CONS  TOO LOW '
    WRITE (*,*) ConsS_interpol
    WRITE (*,*) kappaS*(LabS**zentaS)
    PAUSE
end if

 util_next= (ConsS_next_interpol-kappaS*(LabS_next**zentaS))**(roS-one)
 util= (ConsS_interpol-kappaS*(LabS**zentaS))**(roS-one)
 
 do znow=1,znum
    MuC(:,:,:,znow) = mybeta * ((util_next(:,:,:,znow)/util))

 end do

end  subroutine MarginalUC


!------------------------------------------------------------------






!--------------------------------------

!--------------------------------------

function ADJinvest(Invest_IN, Kapital)
implicit none

REAL(DP), INTENT(IN):: Invest_IN
REAL(DP), INTENT(IN):: Kapital
REAL(DP) :: ADJinvest
REAL(DP):: AdjA, AdjB, AdjC


AdjA=((mydelta**(one/ksi))/(one-(one/ksi)))
AdjB= (one/(one-ksi))*mydelta
AdjC= (one-(one/ksi))

ADJinvest = AdjB + AdjA*((Invest_IN/Kapital) ** AdjC)


END function  ADJinvest
!-----------------------------------------

function ADJinvestV(InvestV_IN)
implicit none

REAL(DP), dimension (:,:,:),INTENT(IN):: InvestV_IN
REAL(DP), DIMENSION(knum,gnum,znum) :: ADJinvestV
REAL(DP) :: AdjA, AdjB, AdjC


AdjA=((mydelta**(one/ksi))/(one-(one/ksi)))
AdjB= (one/(one-ksi))*mydelta
AdjC= (one-(one/ksi))

ADJinvestV = AdjB + AdjA*((InvestV_IN/capital_spread) ** AdjC)

END function  ADJinvestV

!------------------------------------------------
function Diff_ADJinvest(Invest_IN, Kapital)
implicit none

REAL(DP), INTENT(IN):: Invest_IN,Kapital
REAL(DP) :: Diff_ADJinvest
REAL(DP):: AdjA, AdjB

AdjA=(mydelta**(one/ksi))
AdjB= -(one/ksi)

Diff_ADJinvest = AdjA*((Invest_IN/Kapital) ** AdjB)

END function  Diff_ADJinvest


                                        
end module


!============================================================================================
!============================================================================================
!============================================================================================
!============================================================================================
!============================================================================================
!============================================================================================

!     Last change:  UR   20 May 2003   11:44 am
module MmaximHAB


 USE myparamsHAB
 USE my_procsHAB, ONLY : myhunt, mysplie2
implicit none

contains

!======================================================


subroutine maximLABS (valu_S, wnow_S, know_S, gammanow_S, znow_S, stock_S, bond_S,  valuemax_S, whocall, qD, AGwS)

USE myparamsHAB
USE my_procsHAB, ONLY: mysplie2
implicit none

!dummy arguments
REAL(DP), DIMENSION(wnum, znum), INTENT(IN) :: valu_S
INTEGER, INTENT(IN) :: wnow_S, know_S, gammanow_S, znow_S
REAL(DP), INTENT(INOUT) :: bond_S, stock_S         ! initial guess upon entry.. and..optimal solution upon exit
REAL(DP), INTENT(OUT) :: valuemax_S
CHARACTER, INTENT(IN):: whocall
REAL(DP), INTENT(IN) :: qD , AGwS

!local
REAL(DP) ::cash_S, Pbond_S, bmaxS, stmaxS,mincons
REAL(DP), DIMENSION(2) :: xmin_brent2B, xmin_brent2S, fmin_brent2S, fmin_brent2B
REAL(DP), DIMENSION(znum) :: Pstock_next_S, Divd_next_S
REAL(DP):: ax, bx, cx, f1, f2,f3, fbmax, fstmax, stock_in, bond_in, valuemax_in, fa,fb,fc, Pstock_S, wage_S,ls
INTEGER :: i, success, mychoice, boundary_in
REAL(DP), DIMENSION(wnum,znum):: coeffV_S
REAL(DP), DIMENSION(znum,wnum):: coeffT
REAL(DP), DIMENSION(znum):: dummyarrZ

!local parameter
REAL(DP):: eps1, eps2
REAL(DP), PARAMETER:: tol_dbrent = 1.0E-10_DP

!Variables constructed in here for further calculations...
eps1= MIN((wealthS(2)-wealthS(1))/10, 0.001_DP)
eps2= MIN((wealthS(2)-wealthS(1))/10, 0.0001_DP)
Pstock_next_S= Pstock_next(know_S, gammanow_S, znow_S,:)
Divd_next_S = Divd_next(know_S, gammanow_S,znow_S,:)
Pstock_S = Pstock(know_S, gammanow_S, znow_S)

dummyarrZ=one
call mysplie2(dummyarrZ, wealthS, TRANSPOSE(Valu_S), coeffT)
coeffV_S=TRANSPOSE(coeffT)


wage_S=wage(know_S,gammanow_S,znow_S)
ls=LABS(know_S,gammanow_S,znow_S)
mincons=kappaS*(ls**zentaS)

if (whocall == 'B') then
    cash_S= wealthS(wnow_S) + ls*wage_S
    Pbond_S = Pbond( know_S, gammanow_S, znow_S)
ELSEIF (whocall == 'D') then
    !write (*,*) 'in maximEZS'
    cash_S= AGwS + ls*wage_S
    Pbond_S = qD


else
    write (*,*)' ERROR in MAXIMHABS: variable "whocall" may either be DEMAND or BELLMAN'
    pause
end if

!----------------------------------------------------------
!Chek of there is a feasible point..

stmaxS= upbound( cash_S, Pstock_S, Pbond_S, bminS)
bmaxS= upbound( cash_S, Pbond_S, Pstock_S, stminS)

if ((bmaxS-bminS < 0.000001) .or. (stmaxS-stminS <0.000001)) then
    WRITE(*,*)  wnow_S, know_S, gammanow_S, znow_S
    write (*,*)' no feasible point, interval too small..'
    write (*,*)' bmaxS - bminS =', bmaxS-bminS
    write (*,*)'stmaxS - stminS=', stmaxS-stminS
  !  pause
end if

!-----------------------------------------------

!check if agent is at a corner with respect to both assets
bond_in= bminS
stock_in=stminS
f1= funcS(stminS, bminS, 0)
f2= funcS(stminS + eps1, bminS, 0)
f3= funcS(stminS, bminS + eps1, 0)


if ((f1 < f2) .and. (f1 < f3)) then
    fbmax= funcS(stminS, bmaxS,0)
    fstmax=funcS(stmaxS, bminS,0)
    if ((f2<fstmax) .and. (f3<fbmax)) then
        stock_S= stminS
        bond_S= bminS
        valuemax_S = -f1

        !write(*,*) ' wnow_S, know_S, gammanow_S, znow_S', wnow_S, know_S, gammanow_S, znow_S
	!write (*,*) ' boundary solution obtained in 1, stock, bond are=', stock_S, bond_S
        RETURN
    end if
END if
!-------------------------------------
ax= stminS;  bx=0.0; mychoice=0

do i=1,2
    bond_in = bminS + eps2*(i-1)
    stmaxS= upbound( cash_S, Pstock_S , Pbond_S, bond_in)
    cx= stmaxS

    call mybrak(ax, bx, cx, fa, fb, fc, mychoice, bond_in, boundary_in)
    fmin_brent2B(i)= brent1(ax,bx,cx,tol_dbrent, xmin_brent2B(i), mychoice, bond_in)
end do


!----------------------------

!CHECK IF BOUNDARY SOLUTION
!CASE 2: SET stock HOLDINGS TO stmin, AND CHECK IF OPTIMAL

ax= bminS; bx=0.0 ; mychoice=1

do i=1,2
    stock_in = stminS + eps2*(i-1)
    bmaxS= upbound( cash_S, Pbond_S, Pstock_S, stock_in)
    cx= bmaxS

    call mybrak(ax,bx,cx, fa,fb,fc, mychoice, stock_in, boundary_in)
    fmin_brent2S(i)= brent1(ax,bx,cx,tol_dbrent, xmin_brent2S(i), mychoice, stock_in)
END do

!-----------------------------

if ((fmin_brent2B(1) < fmin_brent2B(2)) .and. (fmin_brent2S(1) >= fmin_brent2S(2)))then
    bond_S= bminS
    stock_S= xmin_brent2B(1)
    valuemax_S = -fmin_brent2B(1)

RETURN
ELSEIF ((fmin_brent2S(1) < fmin_brent2S(2)) .AND. (fmin_brent2B(1) >= fmin_brent2B(2))) then
    stock_S= stminS
    bond_S= xmin_brent2S(1)
    valuemax_S = -fmin_brent2S(1)

RETURN
ELSEIF ((fmin_brent2B(1) < fmin_brent2B(2)) .and. (fmin_brent2S(1) < fmin_brent2S(2))) then

end if
!----------------------------------------------

! IF WE ARE HERE THIS MEANS THERE IS NO CORNER SOLUTION SO TRY INTERIOR SOLUTION

stock_in=stock_S
bond_in=bond_S

call min2d(stock_in, bond_in, valuemax_in, success)
if (success == 1) then
    bond_S= bond_in
    stock_S=stock_in
    valuemax_S =valuemax_in

else
    bond_S= bond_in
    stock_S=stock_in
    valuemax_S= inerror
    WRITE(*,*) 'ERROR IN MAXIMHABS: success is equal to', success
    WRITE(*,*) ' state is wnow, know, gammanow, znow=', wnow_S, know_S, gammanow_S, znow_S
 pause
end if

!-----------------------------------------------------------------

contains

 REAL(DP) function funcS(x,w, choice)
 implicit none

 REAL(DP), INTENT(IN) :: x,w
 INTEGER, INTENT(IN):: choice


 !local
 REAL(DP), DIMENSION (znum) :: wealthnext_S, v
 INTEGER :: i, xguess
 REAL(DP) :: exp_Vnext, bond_f, stock_f,a,b,h, util, slope, weight1, cons
 INTEGER, DIMENSION(znum):: indxx


   if (choice==0) then

       cons=(cash_S - w * Pbond_S - x*Pstock_S)

       if (cons-kappaS*(ls**zentaS) <myeps/2.0_DP) then
          write (*,*) 'FUNCS: CONSUMPTION TOO LOW COMPARED TO LABOR.. UTILITY UNDEFINED'
          WRITE (*,*) 'STATE IS',wnow_S, know_S, gammanow_S, znow_S
          WRITE (*,*)  kappaS, ls, zentaS, cash_S,Pbond_S,w, Pstock_S,x
          write (*,*) cons,kappaS*(ls**zentaS)

          PAUSE
       end if

        util=  (cons-kappaS*(ls**zentaS))**roS


        wealthnext_S = ((Pstock_next_S + Divd_next_S) * x + w)
        xguess=wnow_S

        do i=1,znum
            call myhunt(wealthS, wealthnext_S(i), xguess)
            indxx(i)=xguess
        end do
        where (indxx>=wnum)    indxx=wnum-1
        where (indxx==0)        indxx=1

        do i=1,znum
         h=wealthS(indxx(i)+1)-wealthS(indxx(i))
         a=(wealthS(indxx(i)+1)-wealthnext_S(i))/h
         b=(wealthnext_S(i)-wealthS(indxx(i)))/h
         v(i)=a*valu_S(indxx(i),i)+b*valu_S(indxx(i)+1,i)+((a**3-a)*coeffV_S(indxx(i),i)+&
                                  &(b**3-b)*coeffV_S(indxx(i)+1,i))*(h**2)/6.0_sp
        end do

        exp_Vnext=SUM(probz(znow_S,:)*(v(:)**thetaS))
        funcS= -(((one-mybeta) * util) + (mybeta * (exp_Vnext**(roS/thetaS))))**(one/roS)


   ELSEIF (choice==1) then
        cons=(cash_S - x * Pbond_S- w*Pstock_S)

       if (cons-kappaS*(ls**zentaS) <myeps) then
          write (*,*) 'CONSUMPTION TOO LOW COMPARED TO LABOR.. UTILITY UNDEFINED'
          WRITE (*,*) 'STATE IS',wnow_S, know_S, gammanow_S, znow_S
          WRITE (*,*)  kappaS, ls, zentaS, cash_S,Pbond_S,w, Pstock_S,x
          write (*,*) cons,kappaS*(ls**zentaS)

          PAUSE
       end if

        util=  (cons-kappaS*(ls**zentaS))**roS

        wealthnext_S = ((Pstock_next_S + Divd_next_S ) * w + x)
        xguess=wnow_S

        do i=1,znum
            call myhunt(wealthS, wealthnext_S(i), xguess)
            indxx(i)=xguess
        end do
        where (indxx>=wnum)    indxx=wnum-1
        where (indxx==0)        indxx=1

        do i=1,znum
         h=wealthS(indxx(i)+1)-wealthS(indxx(i))
         a=(wealthS(indxx(i)+1)-wealthnext_S(i))/h
         b=(wealthnext_S(i)-wealthS(indxx(i)))/h
         v(i)=a*valu_S(indxx(i),i)+b*valu_S(indxx(i)+1,i)+((a**3-a)*coeffV_S(indxx(i),i)+&
                                                    &(b**3-b)*coeffV_S(indxx(i)+1,i))*(h**2)/6.0_sp
        end do
        exp_Vnext=SUM(probz(znow_S,:)*(v(:)**thetaS))
        funcS= -(((one-mybeta) * util) + (mybeta * (exp_Vnext**(roS/thetaS))))**(one/roS)



   end if
 end function  funcS

 !---------------------------------------------------------

subroutine mybrak(ax, bx, cx, fa,fb,fc, choice, fixparam, boundary)

REAL(DP), INTENT(INOUT ) :: ax, bx, cx
REAL(DP), INTENT(OUT):: fa,fb,fc
INTEGER, INTENT(IN):: choice
REAL(DP), INTENT(IN) ::fixparam
INTEGER, INTENT(OUT) :: boundary
!local
REAL(DP), PARAMETER::  step =0.618
INTEGER, PARAMETER:: itermax=40
REAL(DP) :: fa_init, fc_init
INTEGER :: i

boundary=0

fa_init= funcS(ax, fixparam, choice)
fc_init= funcS(cx, fixparam, choice)

fa=fa_init
fc=fc_init

    do i=1,itermax
            bx= ax + step* ( cx-ax)
            fb= funcS(bx, fixparam, choice)
            if (fa<= fc) then
                if (fb <= fa )  then
                    !write(*,*) 'bracketting obtained in', i, 'iterations'
                    RETURN
                END if
                if ((fb > fa ) .AND. (fb <=fc)) then
                    cx=bx
                    fc=fb
                ELSEIF ((fb* (one + tol_dbrent) >fa) .AND. (fb* (one + tol_dbrent) > fc)) then
                    write (*,*) 'we are in MAXIMHABS, part MYBRAK and we have a problem:'
                    write (*,*) 'something wrong with bracketting, fa, fb, fc are:', fa,fb, fc
                    cx=bx
                    fc=fb
                 !   pause
                end if

             elseif (fc< fa) then
                if (fb <= fc )  then
                    !write(*,*) 'bracketting obtained in', i,'iterations'
                    RETURN
                END if
                if ((fb > fc ) .AND. (fb < fa)) then
                    ax=bx
                    fa=fb
                ELSEIF ((fb* (one + tol_dbrent) >  fc ) .AND. (fb* (one + tol_dbrent) > fa)) then
                    write (*,*) 'we are in MAXIMHABS, part MYBRAK and we have a problem:'
                    write (*,*) 'something wrong with bracketting, fa, fb, fc are:', fa,fb, fc
                    ax=bx
                    fa=fb
!                    pause
                end if
             end if
    end do


if (fa==fa_init) then
     bx =0.5*(ax +cx)
     !write (*,*) ' boundary solution obrained at lower bound in MYBRAK'
     boundary=1
ELSEIF (fc==fc_init) then
     bx=0.5*(ax + cx)
     !write(*,*) ' boundary solution obtained at upper bound in MYBRAK'
     boundary=2
end if
end subroutine mybrak

!---------------------------------------------------------

subroutine mybrak2(ax,bx,cx, fa,fb,fc, choice, boundary)

REAL(DP), INTENT(INOUT ) :: ax,cx
REAL(DP), INTENT(INOUT) :: bx
REAL(DP), INTENT(OUT):: fa,fb,fc
INTEGER, INTENT(IN):: choice
INTEGER, INTENT(OUT) :: boundary
!local
REAL(DP), PARAMETER::  step =0.618
INTEGER, PARAMETER:: itermax=40
REAL(DP) :: fa_init, fc_init, sa, sb, sc
INTEGER :: i

!write (*,*) ' in MYBRAK2'

boundary=0
!write (*,*)' two consecutive calls to min1D'
call min1d(ax,choice, fa_init, sa)
call min1d(cx,choice, fc_init, sc)
fa=fa_init
fc=fc_init

    do i=1,itermax
            bx= ax + step* (cx-ax)
            !write (*,*)' repeated calls in the loop for bracketting in bond direction'
            call min1d(bx,choice, fb, sb)
            if (fa<= fc) then
                if (fb <= fa )  then
                    !write(*,*) 'bracketting obtained in', i, 'iterations'
                    RETURN
                END if
                if ((fb > fa ) .AND. (fb <=fc)) then
                    cx=bx
                    fc=fb
                    sc=sb
                ELSEIF ((fb > (one + tol_dbrent)*fa) .AND. (fb > (one + tol_dbrent)* fc)) then
                    write (*,*) 'we are in MAXIMHABS, part MYBRAK2 and we have a problem:'
                    write (*,*) 'something wrong with bracketting,ax,bx,cx, fa, fb, fc are:',ax, bx,cx, fa,fb, fc
                    WRITE(*,*) ' sa,sb,sc are=', sa, sb, sc
                    cx=bx
                    fc=fb
                    sc=sb
                  !  pause
                end if
             elseif (fc< fa) then
                if (fb <= fc )  then
                    !WRITE(*,*) 'bracketting obtained in', i,'iterations'
                    RETURN
                END if
                if ((fb > fc ) .AND. (fb < fa)) then
                    ax=bx
                    fa=fb
                    sa=sb
                ELSEIF ((fb > (one + tol_dbrent) * fc ) .AND. (fb > (one+ tol_dbrent)* fa)) then
                    write (*,*) 'we are in MAXIMHABS, part MYBRAK2 and we have a problem:'
                    write (*,*) 'something wrong with bracketting, ax,bx,cx, fa, fb, fc are:', ax,bx,cx, fa,fb, fc
                    WRITE(*,*) ' sa,sb,sc are=', sa, sb, sc
                    ax=bx
                    fa=fb
                    sa=sb
                  ! pause
                end if
             end if
             !write (*,*) ' ax, bx, cx are= ',  ax, bx, cx
    end do

if (fa==fa_init) then
     bx =0.5*(ax +cx)
     !write (*,*) ' boundary solution obrained at lower bound in MYBRAK'
     boundary=1
ELSEIF (fc==fc_init) then
     bx=0.5*(ax + cx)
     !write(*,*) ' boundary solution obtained at upper bound in MYBRAK'
     boundary=2
end if

end subroutine mybrak2

!------------------------------------------------------------


 REAL(DP) function upbound(cash_f, price_f, priceasset_f, asset_f)
 implicit none

 REAL(DP) , INTENT(IN) :: cash_f, priceasset_f, asset_f ,price_f

 if (abs (price_f) < TINY(cash_f)  ) then
     write (*,*) ' assets own price is dangerously close to zero...'
     write (*,*) ' possibility of division by zero, so quitting..'
     RETURN
 else
     upbound = (one/ price_f) * (cash_f -mincons - priceasset_f * asset_f - 10.0_DP*epsC)
 end if

 end function upbound

!------------------------------------------

!IN THE CURRENT VERSION WE ALWAYS BISECT OVER BOND HOLDINGS AND FIND THE MAXIMUM OVER  STOCK HOLDINGS
!FOR THOSE FIXED BOND VALUES. sO THIS FUNCTION WILL ALWAYS BE CALLED WITH *** CHOICE = 0 ***

 subroutine min2d(maxstock, maxbond, valuemax, opt_status)
 implicit none

 REAL(DP), INTENT(OUT) :: maxstock, maxbond, valuemax
 INTEGER, INTENT(OUT) ::  opt_status

 !local
 REAL(DP) :: ax, bx, cx1, cx2
 REAL(DP) :: fa,sa,fc1,sc1, fc2, sc2
 REAL(DP):: xmin_stock, fmin_stock
 REAL(DP):: fmin2D, xmin2D, bmax2D, fixparam
 LOGICAL :: flag
 REAL(DP), PARAMETER :: step1 = 0.618                
 INTEGER, PARAMETER:: itermax =100
 INTEGER ::  iter
 INTEGER:: choice, boundary

 !write (*,*) ' in MIN2D'

 opt_status=1
 !set choice =0 so that we bisect over bond and search over stocks
 choice=0
 fixparam= stminS

 ax= bminS              !initialize ax to bminS upon entrance
 bx=0.0
 flag=.FALSE.          !initialize bracketting control variable flag
 bmax2D= upbound( cash_S, Pbond_S, Pstock_S, stminS)
 call min1d(ax, choice, fa, sa )
 cx1= ax + step1 * ( bmax2D - ax)
 call min1d(cx1, choice, fc1, sc1 )

!---------------------------------------------------
  !we are trying to bracket the minimum in the bond direction, that is:
 !we are trying to find bondA, bondB such that there exist a bondC between these tow points
 !the maximized value over stocks at bondC is smaller than both endpoints
 !fixing bond at ax1 and cx1 in turn, maximize over stock


 iter=1
 do WHILE ((.not. flag) .AND. (iter <=ITERMAX))
 outer: if (fc1 < fa) then                !we could not find ax and bx yet
            cx2= cx1 + step1 * ( bmax2D-cx1)
            call min1d(cx2, choice, fc2, sc2 )
            inner:  if (fc1 > fc2) then
                           ax=cx1
                           fa= fc1
                           cx1=cx2
                           fc1=fc2
                    elseif (fc1 <fc2) then
                           bx=cx1
                           fb=fc1
                           cx1=cx2
                           fc1=fc2
                           flag=.true.
                    end if inner
        elseif (fc1 >=fa) then
            call mybrak2(ax,bx,cx1,fa,fb,fc1, choice, boundary)
            flag=.true.
        end if outer
     iter = iter +1
 end do

if (iter > ITERMAX ) then
 write (*,*) 'could not bracket a minimum in ITERMAX iterations'
 WRITE(*,*) ' current value of variables, fa,fb,fc1 fc2' , fa, fb, fc1,fc2
 write (*,*)' current value of abcissa', ax, bx, cx1,cx2
 opt_status = 0
end if

   fmin2D = brent(ax,bx,cx1,tol_dbrent,xmin2D, choice)

   valuemax= -fmin2D
   maxbond= xmin2D
   !to set maxstock call min1d with optimal bond holdings
   call min1d(maxbond, choice, fmin_stock, xmin_stock)
   maxstock= xmin_stock


 !update brent so that is also gives the maximized value of stock (called dummy in brent) as output

 end subroutine

!---------------------------------------------

 subroutine min1d(assetfix,choice, fmin_in, xmin_in)
 USE myparamsHAB
 implicit none

 REAL(DP), INTENT(IN) :: assetfix
 INTEGER , INTENT(IN) :: choice

 REAL(DP), INTENT(OUT) :: xmin_in
 REAL(DP), INTENT(OUT) :: fmin_in

 !local
 REAL(DP) :: ax,bx,cx,fa,fb,fc
 REAL(DP) :: stmax1D, bmax1D

 !local
 INTEGER:: boundary
! write (*,*) ' in MIN1D'
 if (choice ==0) then
     stmax1D= upbound( cash_S, Pstock_S , Pbond_S, assetfix)
     ax=stminS
     bx=0.0
     cx=stmax1D
     if ((cx-ax) < ( epsC/1000)) then
     write (*,*)' caution the interval for stock maximization is dangerously narrow', wnow_S, know_S, gammanow_S, znow_S
     pause

     end if
 elseif (choice==1) then
     bmax1D= upbound(cash_S, Pbond_S, Pstock_S , assetfix)
     ax=bminS
     bx=0.0
     cx=bmax1D
     if ((cx-ax) < (epsC/1000)) then
     write (*,*)' caution the interval for stock maximization is dangerously narrow', wnow_S, know_S, gammanow_S, znow_S
     pause
     end if
 end if

    call mybrak(ax, bx, cx, fa, fb, fc, choice, assetfix, boundary)
    if (boundary==1) then
        xmin_in=ax
        fmin_in=fa
    ELSEIF (boundary == 2) then
        xmin_in = cx
        fmin_in = fc
    ELSEIF (boundary == 0) then
        fmin_in= brent1(ax,bx,cx,tol_dbrent, xmin_in, choice, assetfix)
    end if

 end subroutine min1d

!-----------------------------------------------------------



FUNCTION brent(ax,bx,cx,tol,xmin, choice) !LAST ARGUMENT 'CHOICE' ADDED TO BRENT
USE nrtype
IMPLICIT NONE
REAL(DP), INTENT(IN) :: ax,bx,cx,tol
REAL(DP), INTENT(OUT) :: xmin
REAL(DP) :: brent
INTEGER(I4B) :: choice

INTEGER(I4B), PARAMETER :: ITMAX=100
REAL(DP), PARAMETER :: CGOLD=0.3819660_sp,ZEPS=1.0e-3_sp*epsilon(ax)
INTEGER(I4B) :: iter
REAL(DP) :: a,b,d,e,etemp,fu,fv,fw,fx,p,q,r,tol1,tol2,u,v,w,x,xm
REAL(DP):: argx, argu   !THIS DEFINITION ADDED TO BRENT
a=min(ax,cx)
b=max(ax,cx)
!write (*,*) ' in BRENT'
v=bx
w=v
x=v
e=0.0
!write (*,*) ' evaluating at X, calling MIN1D'
call min1d(x, choice, fx, argx)    !THESE TWO LINES CHANGED FROM THE ORIGINAL BRENT
!pause
!fx=funcS(x)
fv=fx
fw=fx
do iter=1,ITMAX
	xm=0.5_dp*(a+b)
	tol1=tol*abs(x)+ZEPS
	tol2=2.0_dp*tol1
	if (abs(x-xm) <= (tol2-0.5_dp*(b-a))) then
		xmin=x
		brent=fx
		RETURN
	end if
	if (abs(e) > tol1) then
		r=(x-w)*(fx-fv)
		q=(x-v)*(fx-fw)
		p=(x-v)*q-(x-w)*r
		q=2.0_dp*(q-r)
		if (q > 0.0) p=-p
		q=abs(q)
		etemp=e
		e=d
		if (abs(p) >= abs(0.5_dp*q*etemp) .or. &
			p <= q*(a-x) .or. p >= q*(b-x)) then
			e=merge(a-x,b-x, x >= xm )
			d=CGOLD*e
		else
			d=p/q
			u=x+d
			if (u-a < tol2 .or. b-u < tol2) d=sign(tol1,xm-x)
		end if
	else
		e=merge(a-x,b-x, x >= xm )
		d=CGOLD*e
	end if
	u=merge(x+d,x+sign(tol1,d), abs(d) >= tol1 )

        !write(*,*) ' evaluating at U, calling MIN1D'
        call min1d(u, choice, fu, argu)    !THESE TWO LINES CHANGED FROM THE ORIGINAL BRENT
        !pause
!	fu=funcS(u)


	if (fu <= fx) then
		if (u >= x) then
			a=x
		else
			b=x
		end if
		call shft(v,w,x,u)
		call shft(fv,fw,fx,fu)
	else
		if (u < x) then
			a=u
		else
			b=u
		end if
		if (fu <= fw .or. w == x) then
			v=w
			fv=fw
			w=u
			fw=fu
		else if (fu <= fv .or. v == x .or. v == w) then
			v=u
			fv=fu
		end if
	end if
end do
WRITE(*,*) 'brent: exceed maximum iterations'
pause

END FUNCTION brent

!--------------------------------------

FUNCTION brent1(ax,bx,cx,tol,xmin, choice, param) !LAST ARGUMENT 'CHOICE' ADDED TO BRENT
USE nrtype
IMPLICIT NONE
REAL(DP), INTENT(IN) :: ax,bx,cx,tol, param
REAL(DP), INTENT(OUT) :: xmin
REAL(DP) :: brent1
    INTEGER(I4B) :: choice

INTEGER(I4B), PARAMETER :: ITMAX=100
REAL(DP), PARAMETER :: CGOLD=0.3819660_dp,ZEPS=1.0e-3_dp*epsilon(ax)
INTEGER(I4B) :: iter
REAL(DP) :: a,b,d,e,etemp,fu,fv,fw,fx,p,q,r,tol1,tol2,u,v,w,x,xm
a=min(ax,cx)
b=max(ax,cx)
    !write (*,*) ' in BRENT'
v=bx
w=v
x=v
e=0.0
    !write (*,*) ' evaluating at X, calling MIN1D'
    fx=funcS(x,param,choice)
    !pause
   !fx=funcS(x)
fv=fx
fw=fx
do iter=1,ITMAX
	xm=0.5_dp*(a+b)
	tol1=tol* abs(x)+ZEPS
	tol2=2.0_dp*tol1
	if (abs(x-xm) <= (tol2-0.5_dp*(b-a))) then
		xmin=x
		brent1=fx
		RETURN
	end if
	if (abs(e) > tol1) then
		r=(x-w)*(fx-fv)
		q=(x-v)*(fx-fw)
		p=(x-v)*q-(x-w)*r
		q=2.0_dp*(q-r)
		if (q > 0.0) p=-p
		q=abs(q)
		etemp=e
		e=d
		if (abs(p) >= abs(0.5_dp*q*etemp) .or. &
			p <= q*(a-x) .or. p >= q*(b-x)) then
			e=merge(a-x,b-x, x >= xm )
			d=CGOLD*e
		else
			d=p/q
			u=x+d
			if (u-a < tol2 .or. b-u < tol2) d=sign(tol1,xm-x)
		end if
	else
		e=merge(a-x,b-x, x >= xm )
		d=CGOLD*e
	end if
	u=merge(x+d,x+sign(tol1,d), abs(d) >= tol1 )

            !write(*,*) ' evaluating at U, calling MIN1D'

            fu=funcS(u,param,choice)
            !pause
!	fu=funcS(u)


	if (fu <= fx) then
		if (u >= x) then
			a=x
		else
			b=x
		end if
		call shft(v,w,x,u)
		call shft(fv,fw,fx,fu)
	else
		if (u < x) then
			a=u
		else
			b=u
		end if
		if (fu <= fw .or. w == x) then
			v=w
			fv=fw
			w=u
			fw=fu
		else if (fu <= fv .or. v == x .or. v == w) then
			v=u
			fv=fu
		end if
	end if
end do
WRITE(*,*) 'brent1: exceed maximum iterations'

END FUNCTION brent1
!----------------------------------------------------------

SUBROUTINE mov3(a,b,c,d,e,f)
use nrtype
REAL(DP), INTENT(IN) :: d,e,f
REAL(DP), INTENT(OUT) :: a,b,c
a=d;b=e;c=f
END SUBROUTINE mov3



SUBROUTINE shft(a,b,c,d)
uSE nrtype
REAL(DP), INTENT(OUT) :: a
REAL(DP), INTENT(INOUT) :: b,c
REAL(DP), INTENT(IN) :: d
a=b;b=c;c=d
END SUBROUTINE shft



end subroutine maximLABS

!==================================================================
!=====================================================================
!=================================================================


subroutine maximLABN (valu_N,wnow_S, know_S, gammanow_S, znow_S, bond_S, valuemax_S, whocall, qD, AGwN)
USE my_procsHAB, ONLY: mysplie2
implicit none


!dummy arguments
REAL(DP), DIMENSION(wnum, znum), INTENT(IN) :: valu_N
INTEGER, INTENT(IN) :: wnow_S, know_S, gammanow_S, znow_S
REAL(DP), INTENT(INOUT) :: bond_S         ! initial guess upon entry.. and..optimal solution upon exit
REAL(DP), INTENT(OUT) :: valuemax_S
CHARACTER, INTENT(IN) :: whocall
REAL(DP), INTENT(IN):: qD, AGwN



!local
REAL(DP) ::cash_S, Pbond_S, wage_S,mincons
REAL(DP) :: xmin_dbrent1, fmin_dbrent1
REAL(DP):: fbplus, fbhigh, fblow, fbminus, bhigh, ln
INTEGER ::  success, derivative
REAL(DP), DIMENSION(znum):: dummyarrZ
REAL(DP), DIMENSION(wnum,znum):: coeffV_N
REAL(DP), DIMENSION(znum,wnum):: coeffT



!local parameter
REAL(DP):: eps1
REAL(DP), PARAMETER:: tol_dbrent = 1.0E-10


!Variables constructed in here for further calculations...
eps1= MIN((wealthN(2)-wealthN(1))/10.0, epsC)

dummyarrZ=one
call mysplie2(dummyarrZ, wealthN, TRANSPOSE(valu_N), coeffT)
coeffV_N=TRANSPOSE(coeffT)

wage_S= wage(know_S, gammanow_S,znow_S)
ln=LABN(know_S,gammanow_S,znow_S)
mincons=kappaN*(ln**zentaN)


if (whocall == 'B') then
    Pbond_S = Pbond( know_S, gammanow_S, znow_S)
    cash_S= wealthN(wnow_S) + ln*wage_S
ELSEIF (whocall == 'D') then
    !write (*,*)'in maximEZN'
    Pbond_S = qD
    cash_S= AGwN + ln*wage_S
else
    write (*,*)' ERROR: variable "whocall" may eitther be DEMAND or BELLMAN'
end if

!----------------------------------------
!CHECK TO SEE IF THE INTERVAL IS LARGE ENOUGH FOR THE FOLLOWING MAXIMIZATION ARGUMENTS TO MAKE SENSE..
if ((cash_S- mincons-Pbond(know_S,gammanow_S,znow_S)*bminN)< (epsC + eps1)) then
    write (*,*)' error at maximEZN, check part1, cash_S- bminN is', cash_S -mincons -Pbond(know_S,gammanow_S,znow_S)*bminN
    write (*,*) ' the interval for bond choice is very small.. no feasible point found for bond choice'
    pause
end if

!----------------------------------------

! IF WE ARE HERE THIS MEANS THERE IS NO CORNER SOLUTION SO TRY INTERIOR SOLUTION

call min1d(fmin_dbrent1, xmin_dbrent1, success)

if (success == 1) then
    bond_S= xmin_dbrent1
    valuemax_S = -fmin_dbrent1
   ! WRITE(*,*) 'bond_S at', wnow_S, know_S, gammanow_S, znow_S, ' is ', bond_S
else
    bond_S= inerror
    valuemax_S= inerror

    WRITE(*,*) 'ERROR in MAXIMLABN success is equal to', success
    pause
end if


!-----------------------------------------------------------------

contains

 REAL(DP) function funcN(x)
 implicit none

 REAL(DP), INTENT(IN) :: x
!local
 REAL(DP), DIMENSION(znum) :: v

 INTEGER(I4B) :: i
 REAL(DP) :: exp_Vnext, util,slope, weight1,cons,a,b,h
 INTEGER(I4B):: xguess

if ((cash_S -mincons -Pbond_S*x) <epsC/2 ) then
write (*,*) 'caution, consumption is only...=', cash_S - Pbond_S*x
pause
end if

cons=(cash_S-Pbond_S*x)

if (cons-kappaN*(ln**zentaN) <myeps/2.0_DP) then
      write (*,*) 'FUNCN: CONSUMPTION TOO LOW COMPARED TO LABOR.. UTILITY UNDEFINED'
      WRITE (*,*) 'STATE IS',wnow_S, know_S, gammanow_S, znow_S
      WRITE (*,*)  kappaN, ln, zentaN, cash_S,Pbond_S,x
      write (*,*) cons,kappaN*(ln**zentaN)


      PAUSE
end if

util=  (cons-kappaN*(ln**zentaN))**roN

xguess=wnow_S
call myhunt(wealthN, x, xguess)
IF (xguess>=wnum)    xguess=wnum-1
IF (xguess==0)      xguess=1

do i=1,znum
     h=wealthN(xguess+1)-wealthN(xguess)
     a=(wealthN(xguess+1)-x)/h
     b=(x-wealthN(xguess))/h
     v(i)=a*valu_N(xguess,i)+b*valu_N(xguess+1,i)+((a**3-a)*coeffV_N(xguess,i)+(b**3-b)*coeffV_N(xguess+1,i))*(h**2)/6.0_sp
!
end do
!
exp_Vnext=SUM(probz(znow_S,:)*(v(:)**thetaN))
funcN= -(((one-mybeta) * util) + (mybeta * (exp_Vnext**(roN/thetaN))))**(one/roN)
!
 end function  funcN

!-----------------------------

subroutine mybrak(ax,bx,cx,fa,fb,fc, boundary)

REAL(DP), INTENT(INOUT ) :: ax,cx
REAL(DP), INTENT(INOUT) :: bx
REAL(DP), INTENT(OUT) :: fa,fb,fc
INTEGER, INTENT(OUT) :: boundary

!local
REAL, PARAMETER::  step =0.618
REAL(DP) :: fa_init, fc_init
INTEGER, PARAMETER:: itermax=40
INTEGER :: i

boundary=0

fa_init= funcN(ax)
fc_init= funcN(cx)

fa=fa_init
fc=fc_init

  do i=1,itermax
            bx= ax + step* ( cx-ax)
            fb= funcN(bx)
            if (fa<= fc) then
                if (fb <= fa )  then
                    !write(*,*) 'bracketting obtained in', i, 'iterations'
                    RETURN
                END if
                if ((fb > fa ) .AND. (fb <=fc)) then
                    cx=bx
                    fc=fb
                ELSEIF ((fb > fa) .AND. (fb >  fc)) then
                    write (*,*) 'we are in MAXIMLABN, part MYBRAK1 and we have a problem:'
                    write (*,*) 'something wrong with bracketting, fa, fb, fc are:', fa,fb, fc, ax, bx, cx
                    write (*,*) ' bmax is', (cash_S - epsC)/Pbond_S
                    write (*,*) 'state is=' ,wnow_S, know_S, gammanow_S, znow_S

                    cx=bx
                    fc=fb
                   ! pause
                end if

             elseif (fc< fa) then
                if (fb <= fc )  then
                    !write(*,*) 'bracketting obtained in', i,'iterations'
                    RETURN
                END if
                if ((fb > fc ) .AND. (fb < fa)) then
                    ax=bx
                    fa=fb
                ELSEIF ((fb > fc ) .AND. (fb > fa)) then
                    write (*,*) 'we are in MAXIMLABN, part MYBRAK2 and we have a problem:'
                    write (*,*) 'something wrong with bracketting, fa, fb, fc are:', fa,fb, fc, ax, bx, cx
                    write (*,*) ' bmax is', (cash_S - epsC)/Pbond_S
                    write (*,*) 'state is=' ,wnow_S, know_S, gammanow_S, znow_S
                    ax=bx
                    fa=fb
                   ! pause
                end if
             end if
    end do

if (fa==fa_init) then
     bx =0.5*(ax +cx)
     !write (*,*) ' boundary solution obrained at lower bound in MYBRAK'
     boundary=1
ELSEIF (fc==fc_init) then
     bx=0.5*(ax + cx)
     !write(*,*) ' boundary solution obtained at upper bound in MYBRAK'
     boundary=2
end if
end subroutine mybrak


!------------------------------------------

 subroutine min1d( fmin_in, xmin_in,state_in)
 USE myparamsHAB
 implicit none

 REAL(DP), INTENT(INOUT) :: xmin_in
 REAL(DP), INTENT(OUT) :: fmin_in
 INTEGER(I4B),INTENT(OUT) :: state_in
 !local
 REAL(DP) :: ax,bx,cx, fa, fb, fc
 INTEGER:: boundary_in



 state_in =0
 ax=bminN
 bx=0.0           !0.0 is an arbitrary value to initialize bx. It will be set in "mybrak"
 cx= (cash_S- mincons -10.0_DP*epsC)/Pbond_S


    call mybrak(ax, bx, cx, fa, fb,fc,  boundary_in )

    if (boundary_in==1) then
        xmin_in=ax
        fmin_in=fa
        state_in =1
    ELSEIF (boundary_in == 2) then
        xmin_in = cx
        fmin_in = fc
        state_in=1
    ELSEIF (boundary_in == 0) then
        fmin_in= brent1(ax,bx, cx,tol_dbrent, xmin_in, state_in)
    end if

 end subroutine min1d

 !--------------------------------------------------------

 FUNCTION brent1(ax,bx,cx,tol,xmin, state)
USE nrtype
IMPLICIT NONE
REAL(DP), INTENT(IN) :: ax,bx,cx,tol
REAL(DP), INTENT(OUT) :: xmin
INTEGER, INTENT(OUT) :: state
REAL(DP) :: brent1

INTEGER(I4B), PARAMETER :: ITMAX=100
REAL(DP), PARAMETER :: CGOLD=0.3819660_DP,ZEPS=1.0e-3_DP*epsilon(ax)
INTEGER(I4B) :: iter
REAL(DP) :: a,b,d,e,etemp,fu,fv,fw,fx,p,q,r,tol1,tol2,u,v,w,x,xm

state=1
a=min(ax,cx)
b=max(ax,cx)
!write (*,*) ' in BRENT'
v=bx
w=v
x=v
e=0.0
fx=funcN(x)
fv=fx
fw=fx
do iter=1,ITMAX
	xm=0.5_dp*(a+b)
	tol1=tol* abs(x)+ZEPS
	tol2=2.0_dp*tol1
	if (abs(x-xm) <= (tol2-0.5_dp*(b-a))) then
		xmin=x
		brent1=fx
		RETURN
	end if
	if (abs(e) > tol1) then
		r=(x-w)*(fx-fv)
		q=(x-v)*(fx-fw)
		p=(x-v)*q-(x-w)*r
		q=2.0_dp*(q-r)
		if (q > 0.0) p=-p
		q=abs(q)
		etemp=e
		e=d
		if (abs(p) >= abs(0.5_dp*q*etemp) .or. &
			p <= q*(a-x) .or. p >= q*(b-x)) then
			e=merge(a-x,b-x, x >= xm )
			d=CGOLD*e
		else
			d=p/q
			u=x+d
			if (u-a < tol2 .or. b-u < tol2) d=sign(tol1,xm-x)
		end if
	else
		e=merge(a-x,b-x, x >= xm )
		d=CGOLD*e
	end if
	u=merge(x+d,x+sign(tol1,d), abs(d) >= tol1 )
        fu=funcN(u)
	if (fu <= fx) then
		if (u >= x) then
			a=x
		else
			b=x
		end if
		call shft(v,w,x,u)
		call shft(fv,fw,fx,fu)
	else
		if (u < x) then
			a=u
		else
			b=u
		end if
		if (fu <= fw .or. w == x) then
			v=w
			fv=fw
			w=u
			fw=fu
		else if (fu <= fv .or. v == x .or. v == w) then
			v=u
			fv=fu
		end if
	end if
end do
if (iter > ITMAX) then
   WRITE(*,*) 'brent1: exceeded maximum iterations'
  state=0
  pause
end if

END FUNCTION brent1
!----------------------------------------------------------

SUBROUTINE mov3(a,b,c,d,e,f)
use nrtype
REAL(DP), INTENT(IN) :: d,e,f
REAL(DP), INTENT(OUT) :: a,b,c
a=d;b=e;c=f;
END SUBROUTINE mov3



SUBROUTINE shft(a,b,c,d)
USE nrtype
REAL(DP), INTENT(OUT) :: a
REAL(DP), INTENT(INOUT) :: b,c
REAL(DP), INTENT(IN) :: d
a=b;b=c;c=d
END SUBROUTINE shft

!-------


end subroutine maximLABN

!------------------------------------------------------
!=======================================================

subroutine maximLABRA (valu_RA, wnow_S, know_S, gammanow_S, znow_S, bond_S, valuemax_S, whocall, qD, AGwRA)
USE my_procsHAB, ONLY: mysplie2
implicit none


!dummy arguments
REAL(DP), DIMENSION(wnum, znum), INTENT(IN) :: valu_RA
INTEGER, INTENT(IN) :: wnow_S, know_S, gammanow_S, znow_S
REAL(DP), INTENT(INOUT) :: bond_S         ! initial guess upon entry.. and..optimal solution upon exit
REAL(DP), INTENT(OUT) ::  valuemax_S
CHARACTER, INTENT(IN) :: whocall
REAL(DP), INTENT(IN):: qD, AGwRA


!local
REAL(DP) ::cash_S, Pbond_S
REAL(DP) :: xmin_dbrent1, fmin_dbrent1,mincons
REAL(DP):: fbplus, fbhigh, fblow, fbminus, bhigh, wage_S, lra
INTEGER ::  success, derivative
REAL(DP), DIMENSION(znum):: dummyarrZ
REAL(DP), DIMENSION(wnum,znum):: coeffV_RA
REAL(DP), DIMENSION(znum,wnum):: coeffT



!local parameter
REAL(DP):: eps1
REAL(DP), PARAMETER:: tol_dbrent = 1.0E-10
!Variables constructed in here for further calculations...
eps1= MIN((wealthRA(2)-wealthRA(1))/10.0, epsC)
dummyarrZ=one
call mysplie2(dummyarrZ, wealthRA, TRANSPOSE(valu_RA), coeffT)
coeffV_RA=TRANSPOSE(coeffT)

wage_S=wage(know_S, gammanow_S,znow_S)
lra=LABRA(know_S, gammanow_S,znow_S)

mincons=kappaJ*(lra**zentaJ)

if (whocall == 'B') then
    Pbond_S = Pbond( know_S, gammanow_S, znow_S)
    cash_S= wealthRA(wnow_S) + lra*wage_S
ELSEIF (whocall == 'D') then
    !write (*,*)'in maximLABRA'
    Pbond_S = qD
    cash_S= AGwRA + lra*wage_S
else
    write (*,*)' ERROR: variable "whocall" may eitther be DEMAND or BELLMAN'
end if

!----------------------------------------
!CHECK TO SEE IF THE INTERVAL IS LARGE ENOUGH FOR THE FOLLOWING MAXIMIZATION ARGUMENTS TO MAKE SENSE..
if ((cash_S- mincons-Pbond_S*bminRA)< (epsC + eps1)) then
    write (*,*)' error at maximRA, check part1, cash_S- bminRA is', cash_S -Pbond_S*bminRA, bminRA, cash_S, Pbond_S
    write (*,*) ' the interval for bond choice is very small.. no feasible point found for bond choice'
    pause
end if
!-------------------------------------------
!----------------------------------------

! IF WE ARE HERE THIS MEANS THERE IS NO CORNER SOLUTION SO TRY INTERIOR SOLUTION

call min1d(fmin_dbrent1, xmin_dbrent1, success)

if (success == 1) then
    bond_S= xmin_dbrent1
    valuemax_S = -fmin_dbrent1
    return
else
    bond_S= inerror
    valuemax_S= inerror

    WRITE(*,*) 'ERROR in MAXIMLABRA success is equal to', success
    pause

end if


!-----------------------------------------------------------------

contains

 REAL(DP) function funcRA(x)
 implicit none

 REAL(DP), INTENT(IN) :: x
!local
 REAL(DP), DIMENSION(znum) :: v

 INTEGER(I4B) :: i
 REAL(DP) :: exp_Vnext, util,slope, weight1,cons,a,b,h
 INTEGER(I4B):: xguess

if ((cash_S - mincons -Pbond_S*x) <=epsC ) then
write (*,*) 'caution, consumption is only...=', cash_S - Pbond_S*x
pause
end if

cons=cash_S-Pbond_S*x

if (cons-kappaJ*(lra**zentaJ) <myeps) then
          write (*,*) 'FUNCRA: CONSUMPTION TOO LOW COMPARED TO LABOR.. UTILITY UNDEFINED'
          WRITE (*,*) 'STATE IS',wnow_S, know_S, gammanow_S, znow_S
          WRITE (*,*)  kappaJ, lra, zentaJ, cash_S,Pbond_S,x
          write (*,*) cons,kappaJ*(lra**zentaJ)
          PAUSE
end if

util=  (cons-kappaJ*(lra**zentaJ))**roJ



xguess=wnow_S
call myhunt(wealthRA, x, xguess)
IF (xguess>=wnum)    xguess=wnum-1
IF (xguess==0)      xguess=1

do i=1,znum
     h=wealthRA(xguess+1)-wealthRA(xguess)
     a=(wealthRA(xguess+1)-x)/h
     b=(x-wealthRA(xguess))/h
     v(i)=a*valu_RA(xguess,i)+b*valu_RA(xguess+1,i)+((a**3-a)*coeffV_RA(xguess,i)+(b**3-b)*coeffV_RA(xguess+1,i))*(h**2)/6.0_sp
!
end do
!
exp_Vnext=SUM(probz(znow_S,:)*(v(:)**thetaJ))
funcRA= -(((one-mybeta) * util) + (mybeta * (exp_Vnext**(roJ/thetaJ))))**(one/roJ)
!
!write (*,*) 'UTIL, FUNCRA, EXP_VNEXT ARE AS FOLLOWS'
!WRITE (*,*) UTIL, FUNCRA, EXP_VNEXT, COEFFV_ra
!pause

 end function  funcRA
!-----------------------------------------------------------------------------

subroutine mybrak(ax,bx,cx,fa,fb,fc, boundary)

REAL(DP), INTENT(INOUT ) :: ax,cx
REAL(DP), INTENT(INOUT) :: bx
REAL(DP), INTENT(OUT) :: fa,fb,fc
INTEGER, INTENT(OUT) :: boundary

!local
REAL, PARAMETER::  step =0.618
REAL(DP) :: fa_init, fc_init
INTEGER, PARAMETER:: itermax=40
INTEGER :: i

boundary=0

fa_init= funcRA(ax)
fc_init= funcRA(cx)

fa=fa_init
fc=fc_init


  do i=1,itermax
            bx= ax + step* ( cx-ax)
            fb= funcRA(bx)
            if (fa<= fc) then
                if (fb <= fa )  then
                    !write(*,*) 'bracketting obtained in', i, 'iterations'
                    RETURN
                END if
                if ((fb > fa ) .AND. (fb <=fc)) then
                    cx=bx
                    fc=fb
                ELSEIF ((fb > fa) .AND. (fb >  fc)) then
                    write (*,*) 'we are in MAXIMLABRA, part MYBRAK1 and we have a problem:'
                    write (*,*) 'something wrong with bracketting, fa, fb, fc are:', fa,fb, fc, ax, bx, cx
                    write (*,*) ' bmax is', (cash_S - epsC)/Pbond_S
                    write (*,*) 'state is=' ,wnow_S, know_S, gammanow_S, znow_S

                    cx=bx
                    fc=fb
                   ! pause
                end if

             elseif (fc< fa) then
                if (fb <= fc )  then
                    !write(*,*) 'bracketting obtained in', i,'iterations'
                    RETURN
                END if
                if ((fb > fc ) .AND. (fb < fa)) then
                    ax=bx
                    fa=fb
                ELSEIF ((fb > fc ) .AND. (fb > fa)) then
                    write (*,*) 'we are in MAXIMLABRA, part MYBRAK2 and we have a problem:'
                    write (*,*) 'something wrong with bracketting, fa, fb, fc are:', fa,fb, fc, ax, bx, cx
                    write (*,*) ' bmax is', (cash_S - epsC)/Pbond_S
                    write (*,*) 'state is=' ,wnow_S, know_S, gammanow_S, znow_S
                    ax=bx
                    fa=fb
                   ! pause
                end if
             end if
    end do

if (fa==fa_init) then
     bx =0.5*(ax +cx)
     !write (*,*) ' boundary solution obrained at lower bound in MYBRAK'
     boundary=1
ELSEIF (fc==fc_init) then
     bx=0.5*(ax + cx)
     !write(*,*) ' boundary solution obtained at upper bound in MYBRAK'
     boundary=2
end if
end subroutine mybrak


!------------------------------------------

 subroutine min1d( fmin_in, xmin_in,state_in)
 USE myparamsHAB
 implicit none

 REAL(DP), INTENT(INOUT) :: xmin_in
 REAL(DP), INTENT(OUT) :: fmin_in
 INTEGER(I4B),INTENT(OUT) :: state_in
 !local
 REAL(DP) :: ax,bx,cx, fa, fb, fc
 INTEGER:: boundary_in



 state_in =0
 ax=bminRA
 bx=0.0           !0.0 is an arbitrary value to initialize bx. It will be set in "mybrak"
 cx= (cash_S- mincons-10.0_DP*epsC)/Pbond_S


 if (ax>=cx) then
 write (*,*) 'ERROR IN MIN1D IN MAXIMRA: CX > AX...:', CX, AX
 PAUSE

 end if

    call mybrak(ax, bx, cx, fa, fb,fc,  boundary_in )

    if (boundary_in==1) then
        xmin_in=ax
        fmin_in=fa
        state_in =1
    ELSEIF (boundary_in == 2) then
        xmin_in = cx
        fmin_in = fc
        state_in=1
    ELSEIF (boundary_in == 0) then
        fmin_in= brent1(ax,bx, cx,tol_dbrent, xmin_in, state_in)
    end if

 end subroutine min1d

 !--------------------------------------------------------

 FUNCTION brent1(ax,bx,cx,tol,xmin, state)
USE nrtype
IMPLICIT NONE
REAL(DP), INTENT(IN) :: ax,bx,cx,tol
REAL(DP), INTENT(OUT) :: xmin
INTEGER, INTENT(OUT) :: state
REAL(DP) :: brent1

INTEGER(I4B), PARAMETER :: ITMAX=100
REAL(DP), PARAMETER :: CGOLD=0.3819660_DP,ZEPS=1.0e-3_DP*epsilon(ax)
INTEGER(I4B) :: iter
REAL(DP) :: a,b,d,e,etemp,fu,fv,fw,fx,p,q,r,tol1,tol2,u,v,w,x,xm

state=1
a=min(ax,cx)
b=max(ax,cx)
!write (*,*) ' in BRENT'
v=bx
w=v
x=v
e=0.0
fx=funcRA(x)
fv=fx
fw=fx
do iter=1,ITMAX
	xm=0.5_dp*(a+b)
	tol1=tol* abs(x)+ZEPS
	tol2=2.0_dp*tol1
	if (abs(x-xm) <= (tol2-0.5_dp*(b-a))) then
		xmin=x
		brent1=fx
		RETURN
	end if
	if (abs(e) > tol1) then
		r=(x-w)*(fx-fv)
		q=(x-v)*(fx-fw)
		p=(x-v)*q-(x-w)*r
		q=2.0_dp*(q-r)
		if (q > 0.0) p=-p
		q=abs(q)
		etemp=e
		e=d
		if (abs(p) >= abs(0.5_dp*q*etemp) .or. &
			p <= q*(a-x) .or. p >= q*(b-x)) then
			e=merge(a-x,b-x, x >= xm )
			d=CGOLD*e
		else
			d=p/q
			u=x+d
			if (u-a < tol2 .or. b-u < tol2) d=sign(tol1,xm-x)
		end if
	else
		e=merge(a-x,b-x, x >= xm )
		d=CGOLD*e
	end if
	u=merge(x+d,x+sign(tol1,d), abs(d) >= tol1 )

        !write(*,*) ' evaluating at U, calling MIN1D'

        fu=funcRA(u)


	if (fu <= fx) then
		if (u >= x) then
			a=x
		else
			b=x
		end if
		call shft(v,w,x,u)
		call shft(fv,fw,fx,fu)
	else
		if (u < x) then
			a=u
		else
			b=u
		end if
		if (fu <= fw .or. w == x) then
			v=w
			fv=fw
			w=u
			fw=fu
		else if (fu <= fv .or. v == x .or. v == w) then
			v=u
			fv=fu
		end if
	end if
end do
if (iter > ITMAX) then
   WRITE(*,*) 'brent1: exceeded maximum iterations'
  state=0
  pause
end if

END FUNCTION brent1
!----------------------------------------------------------

SUBROUTINE mov3(a,b,c,d,e,f)
use nrtype
REAL(DP), INTENT(IN) :: d,e,f
REAL(DP), INTENT(OUT) :: a,b,c
a=d;b=e;c=f;
END SUBROUTINE mov3



SUBROUTINE shft(a,b,c,d)
USE nrtype
REAL(DP), INTENT(OUT) :: a
REAL(DP), INTENT(INOUT) :: b,c
REAL(DP), INTENT(IN) :: d
a=b;b=c;c=d
END SUBROUTINE shft

!-------


end subroutine maximLABRA

!=================================================================================


END module  MmaximHAB


!===========================================================================================
!===========================================================================================
!===========================================================================================
!===========================================================================================
!======================================================================================================
!======================================================================================================
!======================================================================================================
!======================================================================================================
!======================================================================================================
!======================================================================================================
!======================================================================================================
!======================================================================================================
!======================================================================================================
!======================================================================================================
!======================================================================================================

!     Last change:  UR   17 Feb 2003   10:10 am
module Mbondsolver

USE myparamsHAB

implicit none

CONTAINS

!-----------------------------------


subroutine demandB(valuefun_DN, valuefun_DS,   PbEQ, bondN_EQ, stockS_EQ,failcount)

USE my_procsHAB, ONLY: interp2D
implicit none


REAL(DP), DIMENSION(wnum, knum, gnum, znum), INTENT(IN) :: valuefun_DN, valuefun_DS
REAL(DP), DIMENSION(knum, gnum, znum),INTENT(OUT) ::PbEQ
REAL(DP), DIMENSION(knum, gnum, znum), INTENT(INOUT) :: stockS_EQ, bondN_EQ
INTEGER, INTENT(OUT) :: failcount


!local
REAL(DP), DIMENSION(wnum, knum, gnum, znum,znum) :: valu_DN, valu_DS
REAL(DP), DIMENSION(knum, gnum, znum) :: failvec
REAL(DP), DIMENSION(wnum, znum):: val_DN, val_DS
REAL(DP), DIMENSION(wnum):: dummyarrW
REAL(DP) :: priceB, SS_EQ, BN_EQ, Pb_tmp
INTEGER :: znow, gammanow, know
LOGICAL :: success


!---------------------------
failcount=0
failvec=0

!NOW INTERPOLATING VALUE AT NEXT PERIOD'S K AND GAMMA
 CALL interp2D( valuefun_DN, valu_DN )

!NOW INTERPOLATING VALUE AT NEXT PERIOD'S K AND GAMMA
 CALL interp2D( valuefun_DS, valu_DS )
   

 loop11: DO know=1,knum
    loop12: DO gammanow=1,gnum
      loop13: DO znow=1,znum

      val_DN= valu_DN(1:wnum, know, gammanow, znow, 1:znum)
      val_DS= valu_DS(1:wnum, know, gammanow, znow, 1:znum)

      CALL bond_solver(val_DN, val_DS,  know, gammanow, znow, priceB, BN_EQ, SS_EQ,  success)

      !WRITE (*,*) 'solution for this round from bondsolver=' , SS_EQ, BN_EQ, priceB
      PbEQ(know, gammanow, znow) = priceB
      stockS_EQ(know, gammanow, znow) = SS_EQ
      bondN_EQ(know, gammanow, znow) = BN_EQ


      write (*,*) 'EQUILIBRIUM PB, STOCK AND BOND HOLDINGS in STATE', KNOW, GAMMANOW, ZNOW, 'ARE:'
      WRITE (*,*) PriceB, SS_EQ, BN_EQ
     !    pause

      IF (.NOT. success ) then
          failvec(know, gammanow, znow)=1
          failcount= failcount+1
          write (*,*) ' NO EQUILIBRIUM PRICE HAS BEEN FOUND.... PAUSING..........'
        !  pause
      END  IF

      END  DO  loop13
    END  DO  loop12
 END  DO  loop11

 ! loop14: DO know=1,knum
 !   loop15: DO gammanow=2,gnum-1
 !     loop16: DO znow=1,znum
 !      Pb_tmp=PbEQ(know, gammanow, znow)

!      IF ((Pb_tmp>=PbEQ(know,gammanow-1,znow)) .and. (Pb_tmp>=PbEQ(know,gammanow+1,znow))) then
!          PbEQ(know,gammanow,znow)=0.5_DP*PbEQ(know,gammanow-1,znow)+0.5_DP*PbEQ(know,gammanow+1,znow)
!      elseif ((Pb_tmp<=PbEQ(know,gammanow-1,znow)) .and. (Pb_tmp<=PbEQ(know,gammanow+1,znow))) then
!          PbEQ(know,gammanow,znow)=0.5_DP*PbEQ(know,gammanow-1,znow)+0.5_DP*PbEQ(know,gammanow+1,znow)
!      end if

 !     END  DO  loop16
 !   END  DO  loop15
 !END  DO  loop14



END  subroutine    demandB

!--------------------------------------------------------------


subroutine bond_solver(VnextN, VnextS,  know_B, gammanow_B, znow_B, PbondEQ, bondN_out, stockS_out,  success)
USE MmaximHAB, ONLY: maximLABN, maximLABS
!USE my_procsHAB, ONLY: GetAG_Lab
implicit none

REAL(DP), DIMENSION(wnum, znum), INTENT(IN) :: VnextN, VnextS
REAL(DP), INTENT(OUT) :: PbondEQ
INTEGER, INTENT(IN) :: know_B, gammanow_B, znow_B
LOGICAL, INTENT(OUT) :: success
REAL(DP), INTENT(OUT) :: stockS_out, bondN_out



!local
REAL(DP), DIMENSION(wnum,znum)::dummyV
REAL(DP), DIMENSION(znum):: R_Stock
REAL(DP) :: ExcessD1, ExcessD2, ExcessD, stockS, bondS, bondN, valuemaxS, valuemaxN
REAL(DP) ::  qlow, qhigh, qmin, qmax, qmid, dx, AGwN, AgwS
INTEGER :: j, wnow_B          ! NOTE THAT wnow_B is not used at all in this program
                           ! it is included only to pass to maximEZS, N but they DOnt use either
INTEGER, PARAMETER :: MAXbis = 40


!---------------
write (*,*)  'WE ARE IN BONDSOLVER AT STATE:   ', Know_B, gammanow_B, znow_B
wnow_B = wnum/2       !this value is to pass to MAXIMEZ, but should have no effect in principle
                            !other than that it is the initial guess in myhunt, IN MAXIMEZ
dummyV=0.0_DP
success=.TRUE.
!--wealth of each agent in current AGGREGATE state----
AGwN= gamma(gammanow_B)/(one-lamda)
AGwS=((Pstock(know_B,gammanow_B,znow_B) + Divd(know_B,gammanow_B,znow_B))*one + (FD - gamma(gammanow_B)))/(lamda)

!CALL GetAG_LAB(wealthN, AGwN,LabSupN, AGlabN)
!CALL GetAG_LAB(wealthS, AGwS,LabSupS, AGlabS)

qmin=MIN(MAX(0.88_DP, (AGwN + LABN(know_B, gammanow_B, znow_B)*(wage(know_B, gammanow_B, znow_B)) &
            & - epsC*10.0_SP)/(bminN)),mybeta-0.01_DP)
qmax=1.15_SP
qlow=MAX(qmin+10.0_DP*epsC,mybeta-0.07_DP)
qhigh=0.3_SP*mybeta+0.7_SP*qmax
dx= qhigh-qlow
!-------------------------------------

!demand at qlow
WRITE (*,*) 'part 1'

!WRITE (*,*) wnow_B, know_B, gammanow_B, znow_B, stockS, bondS, valuemaxS
WRITE (*,*) qlow, AGwS, AGwN
CALL maximLABS(VnextS,  wnow_B, know_B, gammanow_B, znow_B, stockS, bondS, valuemaxS, 'D', qlow, AGwS)
CALL maximLABN(VnextN, wnow_B, know_B, gammanow_B, znow_B, bondN, valuemaxN, 'D', qlow, AGwN)
ExcessD1= (lamda*bondS + (one-lamda)* bondN)-FD
WRITE (*,*) 'ExcessD1 is=' , ExcessD1

!note that IF EXCESSD >0 then we have to increas BOND PRICE, to reduce the return and reduce demand for bond
CALL maximLABS(VnextS, wnow_B, know_B, gammanow_B, znow_B, stockS, bondS, valuemaxS, 'D', qhigh, AGwS)
CALL maximLABN(VnextN, wnow_B, know_B, gammanow_B, znow_B, bondN, valuemaxN, 'D', qhigh, AGwN)
ExcessD2= (lamda*bondS + (one-lamda)* bondN)-FD
WRITE (*,*) 'ExcessD2 is=' , ExcessD2
!write (*,*) 'RSTOCK high and low are=    ', R_Stock(2), R_Stock(1)
write (*,*) know_B, gammanow_B, znow_B


!=====================================================
IF ((ExcessD1 >0) .AND. (ExcessD2<0)) then                ! looking for a zero between QLOW and QHIGH
WRITE (*,*) 'part 2'

      DO j=1, MAXbis

           dx=0.5_DP * dx
           qmid= qlow + dx

           CALL maximLABS( VnextS, wnow_B, know_B, gammanow_B, znow_B, stockS, bondS,valuemaxS, 'D', qmid, AGwS)
           CALL maximLABN( VnextN,wnow_B, know_B, gammanow_B, znow_B, bondN, valuemaxN, 'D', qmid, AGwN)
           ExcessD= (lamda*bondS + (one-lamda)* bondN)-FD

           IF (ExcessD > 0) then
               qlow=qmid
           END  IF
           IF ((ABS(ExcessD) < tol_excessD )) then
               PbondEQ= qmid
               stockS_out=stockS
               bondN_out=bondN

               WRITE (*,*) 'stockS=', stockS
               WRITE (*,*) 'bondS=', bondS
               WRITE (*,*) 'ExcessD=', ExcessD
               WRITE (*,*) 'dx=', dx

               RETURN
           END IF
      END DO
      WRITE (*,*)' no root found in', MAXbis, 'iterations even though QLOW and QHIGH seems to bracket a zero'
      WRITE (*,*) 'excessD is', excessD
      IF ((ABS(ExcessD) < MIN(1.0E-3_DP, 1000.0_DP*tol_excessD) )) then
           PbondEQ= qmid
           stockS_out=stockS
           bondN_out=bondN
           WRITE (*,*) 'THE WEAKER BOUNDS ARE SATISFIED AND THESE PRICES ARE RECORDED'
           WRITE (*,*) 'stockS=', stockS
           WRITE (*,*) 'bondS=', bondS
           WRITE (*,*) 'ExcessD=', ExcessD
           WRITE (*,*) 'dx=', dx

           RETURN
       END IF
       success=.FALSE.
       PbondEQ= qmid
       stockS_out=stockS
       bondN_out=bondN

  END  IF
  !-----------------
  IF (ExcessD1 < 0) then           !looking for a zero between QMIN and QLOW
        ! find excess demand at QMIN
        WRITE (*,*) 'part 3'

        CALL maximLABS( VnextS,wnow_B, know_B, gammanow_B, znow_B, stockS, bondS,valuemaxS, 'D', qmin, AGwS)
        CALL maximLABN( VnextN,wnow_B, know_B, gammanow_B, znow_B, bondN, valuemaxN, 'D', qmin, AGwN)
        ExcessD= (lamda*bondS + (one-lamda)* bondN)-FD
        WRITE (*,*) 'ExcessD is=' , ExcessD

        IF (ExcessD <0 ) then
        WRITE (*,*)' excess supply of bonds even at QMIN=', qmin,' so quitting'
        success=.FALSE.
        pause
        END  IF
         !IF ExcessD at Qmin is >0 then search for a zero between QMIN and Qlow
         dx= qlow-qmin
         qhigh=qlow
         qlow=qmin
         DO j=1, MAXbis

                   dx=0.5_DP * dx
                   qmid= qlow + dx
                   WRITE (*,*) 'part 4'

         CALL maximLABS( VnextS, wnow_B, know_B, gammanow_B, znow_B, stockS, bondS, valuemaxS, 'D', qmid, AGwS)
         CALL maximLABN( VnextN, wnow_B, know_B, gammanow_B, znow_B, bondN, valuemaxN, 'D', qmid, AGwN)
                   ExcessD= (lamda*bondS + (one-lamda)* bondN)-FD
                   WRITE (*,*) 'ExcessD is=' , ExcessD

                   IF (ExcessD > 0) then
                       qlow=qmid
                   END  IF

                   IF ((ABS(ExcessD) < tol_excessD )) then
                       PbondEQ= qmid
                       stockS_out=stockS
                       bondN_out=bondN

                       WRITE (*,*) 'stockS=', stockS
                       WRITE (*,*) 'bondS=', bondS
                       WRITE (*,*) 'ExcessD=', ExcessD
                       WRITE (*,*) 'dx=', dx

                       RETURN
                   END IF
          END DO

          WRITE (*,*)' no root found in', MAXbis, 'iterations between QMIN and QLOW'
          WRITE (*,*) 'excessD is', excessD

         IF ((ABS(ExcessD) < MIN(1.0E-3_DP, 1000*tol_excessD) )) then

               PbondEQ= qmid
               stockS_out=stockS
               bondN_out=bondN


               WRITE (*,*) 'THE WEAKER BOUNDS ARE SATISFIED AND THESE PRICES ARE RECORDED'
               WRITE (*,*) 'stockS=', stockS
               WRITE (*,*) 'bondS=', bondS
               WRITE (*,*) 'ExcessD=', ExcessD
               WRITE (*,*) 'dx=', dx

               RETURN
          END IF

           PbondEQ= qmid
           stockS_out=stockS
           bondN_out=bondN
          success=.FALSE.
   END  IF
   !---------------
    IF (ExcessD2 > 0) then           !looking for a zero between Qhigh and Qmax
         ! find excess demand at QMIN
          WRITE (*,*) 'part 5'

         CALL maximLABS( VnextS,wnow_B, know_B, gammanow_B, znow_B, stockS, bondS, valuemaxS, 'D', qmax, AGwS)
         CALL maximLABN( VnextN,wnow_B, know_B, gammanow_B, znow_B, bondN, valuemaxN, 'D', qmax, AGwN)
           ExcessD= (lamda*bondS + (one-lamda)* bondN)-FD
           WRITE (*,*) 'ExcessD is=' , ExcessD

           IF (ExcessD >0 ) then
           WRITE (*,*)' excess demand for bonds even at QMAX=', qmax,' so quitting '
           success=.FALSE.
           pause
           END  IF
       !--------------------------------------
       !IF ExcessD at Qmax is < 0 then search for a zero between Qhigh and Qmax
         dx= qmax-qhigh
         qlow=qhigh
         qhigh=qmax
         DO j=1, MAXbis
       !  WRITE (*,*) qmid

               dx=0.5_DP * dx
               qmid= qlow + dx
               WRITE (*,*) 'part 6'

           CALL maximLABS( VnextS,wnow_B, know_B, gammanow_B, znow_B, stockS, bondS, valuemaxS, 'D', qmid, AGwS)
           CALL maximLABN( VnextN,wnow_B, know_B, gammanow_B, znow_B, bondN, valuemaxN, 'D', qmid, AGwN)
           ExcessD= (lamda*bondS + (one-lamda)* bondN)-FD
               !   WRITE (*,*) 'ExcessD is=' , ExcessD

               IF (ExcessD > 0) then
                       qlow=qmid
               END  IF
               IF ((ABS(ExcessD) < tol_excessD )) then
                   PbondEQ= qmid
                   stockS_out=stockS
                   bondN_out=bondN

                   WRITE (*,*) 'stockS=', stockS
                   WRITE (*,*) 'bondS=', bondS
                   WRITE (*,*) 'ExcessD=', ExcessD
                   WRITE (*,*) 'dx=', dx

                   RETURN
               END IF
         END DO

         WRITE (*,*)' no root found in', MAXbis, 'iterations between QHIGH and QMAXW'
         WRITE (*,*) 'excessD is', excessD

        IF ((ABS(ExcessD) < MIN(1.0E-3_DP, 1000*tol_excessD) )) then

               PbondEQ= qmid
               stockS_out=stockS
               bondN_out=bondN
               WRITE (*,*) 'THE WEAKER BOUNDS ARE SATISFIED AND THESE PRICES ARE RECORDED'
               WRITE (*,*) 'stockS=', stockS
               WRITE (*,*) 'bondS=', bondS
               WRITE (*,*) 'ExcessD=', ExcessD
               WRITE (*,*) 'dx=', dx

               RETURN
         END IF
         success= .FALSE.
           PbondEQ= qmid
           stockS_out=stockS
           bondN_out=bondN
   END  IF

END  subroutine bond_solver

END  module


!============================================================================================
!============================================================================================
!============================================================================================
!============================================================================================
!============================================================================================
!============================================================================================
!============================================================================================
!============================================================================================
!============================================================================================
!============================================================================================
!============================================================================================
!============================================================================================
!============================================================================================
!============================================================================================
!============================================================================================
!============================================================================================
!============================================================================================
!============================================================================================
!============================================================================================
!============================================================================================
!============================================================================================
!============================================================================================


!     Last change:  MFG  11 Sep 2002    4:11 pm
module bellmanALL

 USE nrtype
 USE myparamsHAB
 USE my_procsHAB, ONLY: myspline, mysplint3HAB, howard, interp2D, wage_sub0, interest_sub0,  cap_next0

implicit none


contains


!====================================================================================

SUBROUTINE bellmanRA (V_IN, warmstart, valueRBell, bondRBell, consRBell, choice)
 USE MmaximHAB, ONLY: maximLABRA
 implicit none

 REAL(DP), DIMENSION(wnum, knum, gnum, znum), INTENT(IN) :: V_IN
 LOGICAL , INTENT(IN) :: warmstart
 REAL(DP), DIMENSION (wnum, knum, gnum, znum), INTENT(OUT) ::valueRBell, bondRBell, consRBell
 INTEGER, INTENT(IN):: choice

!local
 REAL(SP), PARAMETER:: lamda1=1.0_SP, lamda2=.6_SP,  lamda3=0.4_SP, tol_discrRA= 1.0E-3_SP
 INTEGER, PARAMETER:: itermax = 100, choiceH=1

 !local variable definition

 INTEGER:: know,  wnow, gammanow, znow, iterval , g, i, j
 INTEGER, DIMENSION(4):: indx , indxL

 !define prices
 REAL(DP), DIMENSION(wnum) :: dummyarrW
 REAL(DP), DIMENSION(gnum) :: dummyarrG
 REAL(DP):: bondRA, valuemaxRA, discr_bondRA, discr_val, av_disc_labRA, av_disc_bondRA, lamda_up
 REAL(DP)::discr_labRA, tol_discrRA_in,tol_discrLabRA_in
 REAL(DP):: time0, time1, time2, time_lag, time3
 REAL(DP), PARAMETER:: lamda_emerg =0.15

 REAL(DP), DIMENSION (:,:) , ALLOCATABLE :: wealthspread, wagespread,labraspread
 REAL(DP), DIMENSION (:,:,:,:,:), ALLOCATABLE ::  valuINT_RA
 REAL(DP), DIMENSION (:,:,:,:) , ALLOCATABLE :: valueRA,  val_last
 REAL(DP), DIMENSION (:,:,:,:) , ALLOCATABLE :: bondholdRA, bondholdRA_last, consRA

 !----------------------------

 tol_discrRA_in= 1.0E-3
 tol_discrLabRA_in= 1.0E-3

 write (*,*) 'in BELLMAN RA ...........................'

 ALLOCATE(valueRA(wnum, knum, gnum, znum)); ALLOCATE ( val_last(wnum, knum, gnum, znum))
 ALLOCATE(bondholdRA(wnum, knum, gnum, znum)); ALLOCATE ( bondholdRA_last(wnum, knum, gnum, znum))
 ALLOCATE (consRA(wnum, knum, gnum, znum)); ALLOCATE(valuINT_RA(wnum, knum, gnum, znum, znum))

if (choice ==1) then
     bminRA=bminS
     RoJ=RoS
     ThetaJ=ThetaS
     zentaJ=zentaS
     kappaJ=kappaS
     wminRA=wminS
     wmaxRA=wmaxS
     wealthRA=wealthS
     LABRA=LABS
ELSEIF (choice==2) then
     bminRA=bminN
     RoJ=RoN
     ThetaJ=ThetaN
     zentaJ=zentaN
     kappaJ=kappaN
     wminRA=wminN
     wmaxRA=wmaxN
     wealthRA=wealthN
     LABRA=LABN
else
     write (*,*) ' ERROR IN BELLMAN RA.. CHOICE MUST BE 1 OR 2'
     PAUSE
end if

!write (*,*) bminRA, RoJ, ThetaJ, wminRA, wmaxRA
write (*,*) MEANLABSUP

 if (warmstart) then
     ValueRA= V_IN
     val_last =V_IN
 else
     ALLOCATE (wealthspread(wnum ,knum)); ALLOCATE (wagespread(wnum, knum));
     ALLOCATE (labraspread(wnum, knum))

     wealthspread= SPREAD (wealthRA,2, knum)              !spread wealth vector into a matrix

     do gammanow=1, gnum
        do znow=1,znum
            wagespread=SPREAD (wage(:,gammanow,znow),1,wnum)
            labraspread=SPREAD (labra(:,gammanow,znow),1,wnum)
            valueRA (:,:, gammanow, znow)= ((one- mybeta)**(one/roJ))*(((wealthspread + meanLabSup*wagespread- bminRA ) &
                                                    & -kappaJ*(labraspread**zentaJ)))

        END do
     end do
     DEALLOCATE(wealthspread, wagespread,labraspread )
     val_last = inerror
end if



!------------------------

!space filler since "SPLIE2" requires a first entry
dummyarrW= 1.0; dummyarrG= 1.0; bondholdRA_last=inerror; countHmax=1
lamda_up=1.0_SP; bondholdRA = one;

!=====================================================================================
!============================== MAIN  BODY  OF  THE  LOOP  ============================

loop1: do iterval=1, itermax

        if (iterval>25) then
            countHmax= MAX(MIN(4, iterval-25),0)
        end if
        CALL CPU_TIME(time0)
        time_lag=time0
        WRITE (*,*) '=================================================='
        WRITE (*,*) 'BEGINNING OF ITERATION', iterval
        WRITE (*,*) 'counthmax', counthmax

        ! CALL 2 DIMENSIONAL SPLINE CONSTRUCTER
        call interp2D(valueRA, valuINT_RA)
        CALL CPU_TIME(time1)
        WRITE (*,*) 'ONE INTERPOLATION TAKES        ', TIME1-TIME0

         ! DONE: SPLINE CONSTRUCT
         !NOWAGENT's MAXIMIZTAION PROBLEM
         !_________________________________________________________________________________

        outer: do znow=1,znum
 !
          MidO: do know=1,knum
 !
               MidI: do gammanow=1,gnum
 !
                   inner: do wnow=1,wnum

                          call maximLABRA (valuINT_RA(1:wnum, know, gammanow, znow, 1:znum), &
                                             wnow, know, gammanow, znow, bondRA, valuemaxRA,'B',0.0_DP,0.0_DP)

                          if (bondRA >inerror) then

                           consRA(wnow,know,gammanow,znow) = wealthRA(wnow) + wage(know,gammanow,znow)*labRA(know,gammanow,znow) &
                                        & -Pbond(know,gammanow,znow) * bondRA
                           bondRA=  lamda_up*bondRA + (one - lamda_up)*bondholdRA(wnow,know, gammanow, znow)
                           bondholdRA(wnow,know,gammanow,znow)=bondRA
		 	  END if

                          end do inner
                     end do MidI
            end do MidO
      end do outer

      CALL CPU_TIME(time2)
      valueRA = howard(bondholdRA, bondholdRA, valuINT_RA, choiceH, 'R')
      CALL CPU_TIME(time3)
      100 FORMAT(1x,200(3x,F20.10))

 !     write (*,120) valueRA(1:wnum,3,3,2)
 !     WRITE (*,*) '================================================================================='
 !     write (*,*) MINVAL(VALUERA), MAXVAL(valueRA)
 !     write (*,*) ' ABOVE WAS VALUERA ==========================================================='
 !     WRITE (*,*) '================================================================================='
 !     PAUSE
 120 FORMAT(1X, 10F15.8)


      !------------------------

             ! define the discrepancy in the decision rules, between iterations
       discr_bondRA= MAXVAL(ABS( bondholdRA_last - bondholdRA))
       discr_val = MAXVAL(ABS(val_last - valueRA))
       av_disc_bondRA= (sum(ABS(bondholdRA_last - bondholdRA))/SIZE(bondholdRA))
       indx= maxloc(ABS(bondholdRA_last  - bondholdRA))


       WRITE(*,98) 'the index of maximum deviation for BOND is', indx
       WRITE(*,99) 'the value at that point', bondholdRA_last(indx(1),indx(2),indx(3), indx(4)),&
                                            & bondholdRA(indx(1),indx(2),indx(3),indx(4))
       WRITE(*,98) 'the index of maximum value deviation is', MAXLOC( ABS(val_last -valueRA))
       WRITE(*,99) 'discr_bondRA is', discr_bondRA
       WRITE(*,99) ' average deviation in bondholding', av_disc_bondRA
       WRITE(*,99) 'ONE ITERATION TAKES:    ', TIME3-TIME0
       WRITE(*,99) '_________________________________________________'
       98 FORMAT(1X,A35, 3I8)
       99 FORMAT(1X,A35, 3F15.8)

       if (ABS(discr_bondRA) < tol_discrRA_in) EXIT loop1

       bondholdRA_last = bondholdRA
       val_last = valueRA

     if (discr_bondRA >0.4) then
           lamda_up=lamda1
     else if (discr_bondRA<0.005) then
          lamda_up=lamda3
     else
          lamda_up = lamda2
     end if


    if (iterval >= 80) then
       write (*,*) ' iteration in bellmanHABN reached 80, dampening the iteration..'
        lamda_up = lamda_emerg
        tol_discrRA_in =1.0E-4
    end if

end do loop1

!------------------------------------------------------------
!  MAXIMIZATION LOOP ENDED AND COVERGENCE OBTAINED.. NOW HOUSEKEEPING....
!-------------------------------------------------------------

WRITE(*,*) 'final value of discrepancy is:', discr_bondRA
WRITE(*,*) 'average deviation in stock is:', av_disc_bondRA

if (iterval>ITERMAX) then
WRITE(*,*) ' program completed, but NO CONVERGENCE IN SPECIFIED STEPS'
else
write (*,*) ' program completed SUCCESSFULLY in', iterval, 'iterations'
END if

valueRBell= valueRA
bondRBell= bondholdRA
consRBell=consRA
DEALLOCATE(valueRA, bondholdRA, bondholdRA_last,valuINT_RA, val_last, consRA)

end subroutine bellmanRA


!===================================================================================================

subroutine bellmanHABS(V_IN, warmstart, valueSBell, bondSBell, stockSBell, consSBell)

 USE MmaximHAB, ONLY: maximLABS
 implicit none

! I/O
 REAL(DP), DIMENSION(wnum, knum, gnum, znum), INTENT(IN) :: V_IN
 LOGICAL , INTENT(IN) :: warmstart
 REAL(DP), DIMENSION (wnum, knum, gnum, znum), INTENT(OUT) ::valueSBell, bondSBell, stockSBell, consSBell

 !local
 REAL(SP), PARAMETER:: lamda1=1.0_SP, lamda2=0.5_SP,  lamda3=0.25_SP,lamda4=1.0_SP, lamda5=0.6_SP, lamda6=0.5_SP
 INTEGER, PARAMETER:: itermax = 150

 INTEGER :: i, j,g, choice, count1, count2
 INTEGER:: know,  wnow, gammanow, znext, znow, iterval, repeatcount, emergency, last_emerg
 INTEGER, DIMENSION(4):: indxB, indxS

 !define prices

 REAL(DP), DIMENSION(wnum) :: dummyarrW
 REAL(DP), DIMENSION(gnum) :: dummyarrG
 REAL(DP), DIMENSION(itermax) :: devS, devB
 REAL(DP), DIMENSION (5):: monotonB, monotonS
 REAL(DP) :: stockS, bondS, valuemaxS , tol_Sbond_in, tol_Sstock_in,tol_labS_in, av_pastS, av_pastB, av_S, av_B
 REAL(DP) :: discr_bondS, discr_stockS,discr_val , av_disc_bondS, av_disc_stockS, lamda_up, lamda_manual, av_disc_labS
 REAL(DP) :: time0, time1, time2, time_lag,time3
 REAL(SP), PARAMETER:: lamda_emerg= 0.2_SP
 LOGICAL:: monoton

!---------------

 REAL(DP), DIMENSION(wnum, knum, gnum, znum) :: bondsNEW, stocksNEW
 REAL(DP), DIMENSION (:,:), ALLOCATABLE :: wealthspread, wagespread,labsspread
 REAL(DP), DIMENSION (:,:,:,:,:), ALLOCATABLE  ::  valuINT_S
 REAL(DP), DIMENSION (:,:,:,:), ALLOCATABLE :: valueS, val_last        ! value function for all ages
 REAL(DP), DIMENSION (:,:,:,:), ALLOCATABLE :: stockholdS, bondholdS, stockholdS_last, bondholdS_last, consS

!----------------------

write (*,*) 'IN BELLMANHABS !!!!!!'

choice=1;countHmax=1;emergency=0;last_emerg=0
 !----------------------------------


 !-----------------------------------------

 ALLOCATE(valueS (wnum, knum, gnum, znum)); ALLOCATE(val_last(wnum, knum, gnum, znum))
 ALLOCATE(bondholdS(wnum, knum, gnum, znum)); ALLOCATE(bondholdS_last(wnum, knum, gnum, znum))
 ALLOCATE(stockholdS(wnum, knum, gnum, znum)); ALLOCATE(stockholdS_last(wnum, knum, gnum, znum))
 ALLOCATE(consS(wnum, knum, gnum, znum)); ALLOCATE(valuINT_S(wnum, knum, gnum, znum, znum))

!---------
 if (warmstart) then
     valueS= V_IN
     val_last= V_IN
 else
     ALLOCATE (wealthspread(wnum ,knum)); ALLOCATE (wagespread(wnum, knum));
     ALLOCATE (labsspread(wnum, knum))
     wealthspread= SPREAD (wealthS,2, knum)              !spread wealth vector into a matrix

     do gammanow=1, gnum
        do znow=1,znum
         wagespread=SPREAD (wage (:,gammanow,znow),1,wnum)
         labsspread=SPREAD (labs (:,gammanow,znow),1,wnum)
         
          valueS (:,:, gammanow, znow)= ((one- mybeta)**(one/roS))*(((wealthspread + meanLabSup*wagespread- bminS -stminS )-&
                                                    &kappaS*(LABSspread**zentaS)))

        end do
     end do
     DEALLOCATE(wealthspread, wagespread,labsspread)
     val_last= inerror
end if
!---------------------------------------------------------
!INITIALIZING A FEW VARIABLES..
dummyarrW= 1;dummyarrG= 1;bondholdS_last=inerror;stockholdS_last=inerror

lamda_up=one;tol_Sbond_in= tol_Sbond;tol_Sstock_in =tol_Sstock;

!-------------------------------------------------
! ITERATION STARTS HERE.................
!--------------------------------------------------

count1=FLOOR(30/REAL(itermain))
count2=FLOOR(REAL(itermain/10)+1)
loop1: do iterval=1, itermax


    if (iterval>count1) then
        countHmax= MIN(MAX(10-count2,2), iterval-count1)
    end if

    CALL CPU_TIME(time0)
    time_lag=time0
    WRITE (*,*) '=================================================='
    WRITE (*,*) 'BEGINNING OF ITERATION', iterval , '======', iterval ,' =====', iterval, '======'
    WRITE (*,*) 'COUNTHMAX IS:         ', counthmax

    ! CALL 2 DIMENSIONAL SPLINE CONSTRUCTER
    call interp2D(valueS, valuINT_S)
    CALL CPU_TIME(time1)
    WRITE (*,*) 'ONE INTERPOLATION TAKES        ', TIME1-TIME0

    !----------------------------------------  MAXIMIZATION   LOOP ----------------------
     outer: do znow=1,znum
     !
          MidO: do know=1,knum
     !
                   MidI: do gammanow=1,gnum
     !
                       inner: do wnow=1,wnum

                            call maximLABS(valuINT_S(1:wnum, know, gammanow,znow, 1:znum), &
                                         wnow, know, gammanow, znow, stockS, bondS, valuemaxS,'B', 0.0_DP,0.0_DP)

                              if (( bondS >inerror) .AND. (stockS >inerror)) then
                                   bondSNEW(wnow,know,gammanow,znow) = bondS
                                   stockSNEW(wnow,know,gammanow,znow)= stockS

                                consS(wnow,know,gammanow,znow) = wealthS(wnow) + wage(know,gammanow,znow)*LABS(know,gammanow,znow)&
                                          & -Pbond(know,gammanow,znow) * bondS - Pstock(know,gammanow,znow) * stockS
                                   bondS= lamda_up*bondSNEW(wnow,know,gammanow,znow) &
                                            & +(one -lamda_up)*bondholdS(wnow, know, gammanow, znow)
			           stockS=lamda_up*stockSNEW(wnow, know,gammanow,znow)&
                                          & + (one - lamda_up)* stockholdS(wnow, know, gammanow, znow)

                                   bondholdS(wnow, know, gammanow, znow)= bondS
			           stockholdS(wnow, know, gammanow, znow)= stockS

			      else
                                   bondholdS(wnow, know, gammanow, znow)= inerror
			           stockholdS(wnow, know, gammanow, znow)= inerror

			      END if
                              end do inner
                         end do MidI
                end do MidO
          end do outer

          CALL CPU_TIME(time2)
          write (*,*) 'maximization takes:    ', time2 - time1
          valueS = howard(bondholdS, stockholdS, valuINT_S, choice, 'S')
          CALL CPU_TIME(time3)


     !-------------------------------------------------
     !-----------------------------------------

           ! define the discrepancy in the decision rules, between iterations
           discr_bondS= MAXVAL(ABS( bondholdS_last - bondSNEW))
           discr_stockS=  MAXVAL(ABS( stockholdS_last - stockSNEW))

           discr_val = MAXVAL(ABS(val_last - valueS))
           av_disc_bondS= (sum(ABS(bondholdS_last - bondSNEW))/SIZE(bondSNEW))
           av_disc_stockS= (sum(ABS(stockholdS_last - stockSNEW))/SIZE(stockSNEW))

           indxB= maxloc(ABS(bondholdS_last  - bondSNEW))
           indxS= maxloc(ABS(stockholdS_last  - stockSNEW))



           WRITE(*,98) 'the index of maximum deviation for stock and bond  are', indxS, '***', indxB
           WRITE(*,99) 'the value at that point for bond is', bondholdS_last(indxB(1),indxB(2),indxB(3), indxB(4)),&
                                                & bondSNEW(indxB(1),indxB(2),indxB(3),indxB(4))
           WRITE(*,99) 'the value at that point for stock is', stockholdS_last(indxS(1),indxS(2),indxS(3), indxS(4)),&
                                                & stockSNEW(indxS(1),indxS(2),indxS(3),indxS(4))
           WRITE(*,98) 'the index of maximum value deviation is', MAXLOC( ABS(val_last -valueS))
           WRITE(*,99) 'discr_bondS is',  bondSNEW(indxB(1),indxB(2),indxB(3),indxB(4))- &
                                         & bondholdS_last(indxB(1),indxB(2),indxB(3), indxB(4))
           WRITE(*,99) 'discr_stockS is',  stockSNEW(indxS(1),indxS(2),indxS(3),indxS(4))- &
                                           & stockholdS_last(indxS(1),indxS(2),indxS(3), indxS(4))

           WRITE(*,99) ' average deviation in bondholding of the bondholders', av_disc_bondS
           WRITE(*,99) 'ONE ITERATION TAKES:    ', TIME3-TIME0
           98 FORMAT(1X,A35, 4I4, A5, 4I4)
           99 FORMAT(1X,A35, 3F15.8)
           write (*,*) 'itermain, tolerance is', itermain, tol_Sbond_in

           ! UPDATING PREVIOUS PERIOD'S STOCK AND BOND HOLDING'S WITH THE NEW ONES
           bondholdS_last = bondholdS
           stockholdS_last= stockholdS

           val_last = valueS

           IF ((av_disc_bondS <1.0E-5) .AND. (av_disc_stockS < 1.0E-5) ) EXIT loop1
           if ((ABS(discr_bondS) < tol_Sbond_in  ) .and. (ABS(discr_stockS) < tol_Sstock_in)) EXIT loop1

    !------------

           ! checking if the iteration is in a loop
           devB (iterval) =  bondSNEW(indxB(1),indxB(2),indxB(3),indxB(4))- &
                                         & bondholdS_last(indxB(1),indxB(2),indxB(3), indxB(4))
           devS (iterval) =  stockSNEW(indxS(1),indxS(2),indxS(3),indxS(4))- &
                                           & stockholdS_last(indxS(1),indxS(2),indxS(3), indxS(4))


           if ((iterval > 15 ) .AND. (iterval > last_emerg +4)) then
               repeatcount=0
               do i=1,5
                   do j=1,10
                       if ((ABS( devS(iterval-i+1) - devS (iterval-4 -j)) < 1.0E-8) .OR. &
                           & (ABS( devB(iterval-i+1) - devB (iterval-4 -j)) < 1.0E-8))  then
                           repeatcount= repeatcount + 1
                       end if
                   end do
               end do
               if (repeatcount >=3) then
               emergency= emergency +1
               last_emerg= iterval
               end if

           end if

           monoton=.FALSE.
           if ((iterval >20) .AND. (iterval > last_emerg +4)) then
              monotonS = devS(iterval-4:iterval)
              monotonB = devB(iterval-4:iterval)

              if ((ALL(monotonB < 0) .or. (ALL(monotonB >0))) .AND.  ((ALL(monotonS <0)) .or. (ALL(monotonS >0)))) then
              monoton=.TRUE.
              end if

              av_pastS=sum(devS(iterval-19:iterval-10))/10.0
              av_pastB=sum(devB(iterval-19:iterval-10))/10.0
              av_S= sum(devS(iterval-9:iterval))/10.0
              av_B = sum(devB(iterval-9:iterval))/10.0

              if (((av_pastS < 1.2*av_S) .OR. (av_pastB < 1.2*av_B)) .AND. (.NOT. monoton))  then
                  emergency = emergency+1
                  last_emerg=iterval
              end if


           end if

        ! UPDATING LAMDA, THE DAMPENING RATIO.....
        if ((emergency == 0) .OR. (iterval > last_emerg + 10) .OR. ( monoton)) then

            if (itermain<15) then
            if (max(discr_bondS, discr_stockS) >0.4) then
                lamda_up=lamda1
            else if (MAX(discr_bondS, discr_stockS)<0.005) then
                lamda_up=lamda3
            else
                lamda_up = lamda2
            end if
            tol_SBond_in= MAX( (tol_Sbond/(DBLE(iterMAIN)**2)), 1.0E-5_DP)
            tol_Sstock_in= MAX( (tol_Sstock/(iterMAIN**2)), 1.0E-5_DP)


            else
            if (max(discr_bondS, discr_stockS) >0.4) then
               lamda_up=lamda4
            else if (MAX(discr_bondS, discr_stockS)<0.005) then
               lamda_up=lamda5
            else
               lamda_up = lamda6
            end if
            tol_SBond_in= MAX( (tol_Sbond/(iterMAIN**2)), 1.0E-5_DP)
            tol_Sstock_in= MAX( (tol_Sstock/(iterMAIN**2)), 1.0E-5_DP)


            end if
        else
            write (*,*) ' iteration in bellmanHABS GOT in a LOOP or no improvement...'
            WRITE (*,*) 'dampening the iteration, emergency=', emergency
            lamda_up = MAX(lamda_emerg/ emergency, 0.05)
            tol_Sbond_in= 5.0E-4
            tol_Sstock_in=5.0E-4

        end if

        if (iterval > 70) then
          lamda_up =lamda_emerg/3
          tol_Sbond_in= 1.0E-4
          tol_Sstock_in=1.0E-4
        end if
        if ((iterval >= 80) .AND. (ABS(discr_stockS) < 0.01) .AND. (ABS(discr_bondS) < 0.01)) EXIT loop1
        write (*,*) 'iteration number =', iterval, ' completed.'

end do loop1

!------------------------------------------------------------
!  MAXIMIZATION LOOP ENDED AND COVERGENCE OBTAINED.. NOW HOUSEKEEPING....
!-------------------------------------------------------------
100 FORMAT(1x,200(3x,F20.10))

WRITE(*,*) 'final value of discrepancy is:', discr_bondS
WRITE(*,*) 'average deviation in stock is:', av_disc_bondS

if (iterval>ITERMAX) then
    WRITE(*,*) ' program completed, but NO CONVERGENCE IN SPECIFIED STEPS'
else
    write (*,*) ' program completed SUCCESSFULLY in', iterval, 'iterations'
END if

valueSBell= valueS
bondSBell= bondholdS
stockSBell= stockholdS
consSBell=consS
DEALLOCATE(valueS, bondholdS, stockholdS, stockholdS_last, bondholdS_last, valuINT_S, val_last, consS)

end subroutine bellmanHABS
!=======================================================================================












!=======================================================================

SUBROUTINE bellmanHABN (V_IN, warmstart, valueNBell, bondNBell, consNBell)
 USE MmaximHAB, ONLY: maximLABN
 implicit none

 REAL(DP), DIMENSION(wnum, knum, gnum, znum), INTENT(IN) :: V_IN
 LOGICAL , INTENT(IN) :: warmstart
 REAL(DP), DIMENSION (wnum, knum, gnum, znum), INTENT(OUT) ::valueNBell, bondNBell, consNBell

!local
 REAL(SP), PARAMETER:: lamda1=1.0_SP, lamda2=.6_SP,  lamda3=0.4_SP, tol_discrN= 1.0E-3_SP
 INTEGER, PARAMETER:: itermax = 100, choiceH=1

 !local variable definition

 INTEGER:: know,  wnow, gammanow, znow, iterval , g, i, j , count1, count2
 INTEGER, DIMENSION(4):: indx, indxL

 !define prices
 REAL(DP), DIMENSION(wnum) :: dummyarrW
 REAL(DP), DIMENSION(gnum) :: dummyarrG
 REAL(DP):: bondN, valuemaxN, discr_bondN, discr_val, av_disc_bondN, lamda_up
 REAL(DP):: time0, time1, time2, time_lag, time3, tol_discrN_in
 REAL(DP), PARAMETER:: lamda_emerg =0.15

 REAL(DP), DIMENSION (:,:) , ALLOCATABLE :: wealthspread, wagespread,labnspread
 REAL(DP), DIMENSION (:,:,:,:,:), ALLOCATABLE ::  valuINT_N
 REAL(DP), DIMENSION (:,:,:,:) , ALLOCATABLE :: valueN,  val_last
 REAL(DP), DIMENSION (:,:,:,:) , ALLOCATABLE :: bondholdN, bondholdN_last,consN

 !----------------------------

 write (*,*) 'in BELLMANEZ N ...........................'

 ALLOCATE(valueN(wnum, knum, gnum, znum)); ALLOCATE ( val_last(wnum, knum, gnum, znum))
 ALLOCATE(bondholdN(wnum, knum, gnum, znum)); ALLOCATE ( bondholdN_last(wnum, knum, gnum, znum))
 ALLOCATE (consN(wnum, knum, gnum, znum)); ALLOCATE(valuINT_N(wnum, knum, gnum, znum, znum))

 if (warmstart) then
     ValueN= V_IN
     val_last =V_IN
 else
     ALLOCATE (wealthspread(wnum ,knum)); ALLOCATE (wagespread(wnum, knum));
     ALLOCATE (labnspread(wnum, knum))

     wealthspread= SPREAD (wealthN,2, knum)              !spread wealth vector into a matrix

     do gammanow=1, gnum
        do znow=1,znum
            wagespread=SPREAD (wage (:,gammanow,znow),1,wnum)
            labnspread=SPREAD (labn (:,gammanow,znow),1,wnum)
            
          valueN (:,:, gammanow, znow)= ((one- mybeta)**(one/roN))*(((wealthspread + meanLabSup*wagespread- bminN ) &
                                                    &-kappaN*(LABNspread**zentaN)))
                                                   
!            valueN (:,:, gammanow, znow)= ((one- mybeta)**(one/roN))*(( wealthspread + wagespread- bminN ))
        END do
     end do
     DEALLOCATE(wealthspread, wagespread,labnspread )
     val_last = inerror
end if

!------------------------

!useless array, space filler since "SPLIE2" requires a first entry
dummyarrW= 1.0; dummyarrG= 1.0; bondholdN_last=inerror; countHmax=1
lamda_up=1.0_SP; bondholdN = one; tol_discrN_in = tol_discrN

!=====================================================================================
!============================== MAIN  BODY  OF  THE  LOOP  ============================
count1=FLOOR(30/REAL(itermain))
count2=FLOOR(REAL(itermain/10)+1)

loop1: do iterval=1, itermax

        if (iterval>count1) then
            countHmax= MIN(MAX(10-count2,2), iterval-count1)
        end if
        CALL CPU_TIME(time0)
        time_lag=time0
        WRITE (*,*) '=================================================='
        WRITE (*,*) 'BEGINNING OF ITERATION', iterval
        WRITE (*,*) 'counthmax', counthmax

        ! CALL 2 DIMENSIONAL SPLINE CONSTRUCTER
        call interp2D(valueN, valuINT_N)
        CALL CPU_TIME(time1)
        WRITE (*,*) 'ONE INTERPOLATION TAKES        ', TIME1-TIME0

         ! DONE: SPLINE CONSTRUCT
         !NOWAGENT's MAXIMIZTAION PROBLEM
         !_________________________________________________________________________________

        outer: do znow=1,znum
 !
          MidO: do know=1,knum
 !
               MidI: do gammanow=1,gnum
 !
                   inner: do wnow=1,wnum

                          call maximLABN (valuINT_N(1:wnum, know, gammanow, znow, 1:znum), &
                                             wnow, know, gammanow, znow, bondN, valuemaxN,'B', 0.0_DP,0.0_DP)


                          if (bondN >inerror) then
                              consN(wnow,know,gammanow,znow) = wealthN(wnow) + wage(know,gammanow,znow)*LABN(know,gammanow,znow) &
                                          & -Pbond(know,gammanow,znow) * bondN
                              bondN=  lamda_up*bondN + (one - lamda_up)*bondholdN(wnow,know, gammanow, znow)
                              bondholdN(wnow,know,gammanow,znow)=bondN

			  END if
                          end do inner
                     end do MidI
            end do MidO
      end do outer

      CALL CPU_TIME(time2)
      write (*,*) 'maximization takes:    ', time2 - time1
      valueN = howard(bondholdN, bondholdN, valuINT_N, choiceH, 'N')
      CALL CPU_TIME(time3)
      100 FORMAT(1x,200(3x,F20.10))

      !------------------------

       ! define the discrepancy in the decision rules, between iterations
       discr_bondN= MAXVAL(ABS( bondholdN_last - bondholdN))
       discr_val = MAXVAL(ABS(val_last - valueN))
       av_disc_bondN= (sum(ABS(bondholdN_last - bondholdN))/SIZE(bondholdN))
       indx= maxloc(ABS(bondholdN_last  - bondholdN))

       WRITE(*,98) 'the index of maximum deviation for BOND is', indx
       WRITE(*,99) 'the value at that point', bondholdN_last(indx(1),indx(2),indx(3), indx(4)),&
                                            & bondholdN(indx(1),indx(2),indx(3),indx(4))
       WRITE(*,98) 'the index of maximum value deviation is', MAXLOC( ABS(val_last -valueN))
       WRITE(*,99) 'discr_bondN is', discr_bondN
       WRITE(*,99) ' average deviation in bondholding', av_disc_bondN
       WRITE(*,99) 'ONE ITERATION TAKES:    ', TIME3-TIME0
       WRITE(*,99) '_________________________________________________'
       98 FORMAT(1X,A35, 3I8)
       99 FORMAT(1X,A35, 3F15.8)

       if ((ABS(discr_bondN) < tol_discrN_in)) EXIT loop1

       bondholdN_last = bondholdN
       val_last = valueN

     if (discr_bondN >0.4) then
           lamda_up=lamda1
     else if (discr_bondN<0.005) then
          lamda_up=lamda3
     else
          lamda_up = lamda2
     end if

    tol_discrN_in= MAX( (tol_discrN/(iterMAIN**2)), 1.0E-6)

    if (iterval >= 80) then
       write (*,*) ' iteration in bellmanHABN reached 80, dampening the iteration..'
        lamda_up = lamda_emerg
        tol_discrN_in =1.0E-4


    end if

end do loop1

!------------------------------------------------------------
!  MAXIMIZATION LOOP ENDED AND COVERGENCE OBTAINED.. NOW HOUSEKEEPING....
!-------------------------------------------------------------

WRITE(*,*) 'final value of discrepancy in BOND is:', discr_bondN
WRITE(*,*) 'average deviation in stock is:', av_disc_bondN

if (iterval>ITERMAX) then
WRITE(*,*) ' program completed, but NO CONVERGENCE IN SPECIFIED STEPS'
else
write (*,*) ' program completed SUCCESSFULLY in', iterval, 'iterations'
END if

valueNBell= valueN
bondNBell= bondholdN
consNBell=consN
DEALLOCATE(valueN, bondholdN, bondholdN_last, valuINT_N, val_last, consN)
end subroutine bellmanHABN


!===============================================================================
end module BELLMANall




!===============================================================================================
!===============================================================================================
!===============================================================================================
!===============================================================================================
!===============================================================================================
!===============================================================================================
!===============================================================================================



program mainEQ

USE nrtype
USE myparamsHAB
USE my_firmHAB
USE my_procsHAB, ONLY:wage_sub, interest_sub, gamma_nextV, interestnext_sub, myhunt, initializer, outerprod, &
                      & myECHO_2, myECHO_3, myECHO_4, cap_next0
USE bellmanALL, ONLY: BellmanRA, BellmanHABS, BellmanHABN
USE Mbondsolver, ONLY:demandB
implicit none

 !local
 REAL(DP), DIMENSION (wnum, knum, gnum, znum) :: valueS_M, valueN_M, VS_guess, VN_guess, LabSupS_M, LabSupN_M
 REAL(DP), DIMENSION (wnum, knum, gnum, 2) :: valueS_T, valueN_T, consS_T
 REAL(DP), DIMENSION (knum, gnum, 2) :: capital_nextT, gam_nextT


 REAL(DP), DIMENSION(wnum, knum, gnum, znum):: consS_M, consN_M, bondS_M, bondN_M, stockS_M, consS_guess
 REAL(DP), DIMENSION(knum,gnum,znum,znum):: Rsnext, Rs
 REAL(DP), DIMENSION(knum, gnum, znum) :: PbEQ, Pb_LAG, gamnext_LAG, capnext_LAG,Rb, Invest_M, capital_next_temp
 REAL(DP), DIMENSION(knum, gnum, znum) :: stockS_EQ, bondN_EQ, DiscrPs, Pstocknew
 REAL(DP), DIMENSION(wnum) :: sqrt_wealthS, sqrt_wealthN, wealthADJ
 REAL, DIMENSION(znum):: g1,g2,g3
 REAL(DP) ::  sqrt_wmaxS, sqrt_wminS, sqrt_wmaxN, sqrt_wminN
 REAL(DP) :: DISCR_PBOND, DISCR_PSTOCK, DISCR_CAPITAL, DISCR_GAMM, slope, weight1, avg_Pbond, avg_Pstock, avg_capital, avg_gamm
 REAL(DP):: weightgam, weightcap, weightP, weightG, stdZ_scaled, Gstar, FDdum

 INTEGER, DIMENSION(3) :: indxPbond, indxPstock, indx_cap, indx_gamm
 INTEGER:: choice, l,ll,i, j,g, failcount, wnow, know, znow , xguess, znext, whetherPRICES, initone, init_iternum
 INTEGER:: contained , cond_exit , custom, terminate, indmax, WhetherCONS, nmax,nmaxsmall, indmaxsmall, indmaxx,gammanow
 LOGICAL:: warmstart, warmstartCONS

 !ALLOCATABLES
 REAL(DP), DIMENSION(:,:,:), ALLOCATABLE :: Pstock0, Pbond0, Invest0,Discr, value_initS, value_initN, valueS3D, valueN3D
 REAL(DP), DIMENSION(:,:), ALLOCATABLE :: consS_V, valueS_V, valueN_V, capital_next_V, gam_next_V, Pstock_V, Divd_V, PbEQ_V
 REAL(DP), DIMENSION (:,:), ALLOCATABLE:: consRAL_S, consRAL_N, Invest_V
 REAL(DP), DIMENSION(:,:), ALLOCATABLE:: stockS_V, bondS_V, bondN_V,  PbEQ_Z,  gam_nextZ,PstockZ,DivdZ,InvestZ,consN_V
 REAL(DP), DIMENSION(:,:), ALLOCATABLE:: capital_nextZZZ

 !integer parameters:
 INTEGER, PARAMETER:: ITMAX_MAIN = 250


!===================================================================================================================
!================================== M A I N      C O D E     B E G I N S    H E R E ================================
!===================================================================================================================

!SET PREFERENCE PARAMETERS:
RoS = -5
RoN = -9
ThetaS= -5
ThetaN= -9
zentaS=2.0_DP
zentaN=zentaS
zenta=zentaS
LabADJ=1.0_DP            ! THIS PARAMETER ADJUSTS STEADY STATE CAPITAL STOCK DOWNWARD IN KSTAR CALCULATION TO ACCOUNT
                         ! FOR THE FACT THAT STOCKHOLDERS WORK LESS THAN MEANLABSUP
FDdum=0.0_DP

setinvest=0
meanZ=0.9_SP
stdZ_scaled=stdZ*meanZ
Zgrid= meanZ+ (/ (-(znum-1)*stdZ_scaled/2 + (i-1)* stdZ_scaled, i=1,znum) /)  ;

terminate=0;
Pb_LAG = inerror; capnext_LAG= inerror; gamnext_LAG = inerror
weightP=0.25;

write (*,*) '=========================================================================================='
write (*,*) '====================  PROGRAM VERSION 10/18/04 ---- TIME =3:35pm   ========================'
write (*,*) '=========================================================================================='

!CALL THE INITIALIZER CODE
CALL initializer()

capital_SPREAD= SPREAD(SPREAD (capital,2,gnum),3,znum)
initone=1;
write (*,*) wage
pause

!=======================================================================================================
!=======================================================================================================
 WRITE (*,*) 'ENTER THE INITIAL INTERATION NUMBER        >>'
 READ (*,*) init_ITERNUM
 !init_ITERNUM=0
 initONE= init_ITERNUM

 if (init_ITERNUM >1) then
!start reading in data from previous iterations.....

        stdZ_scaled=stdZ*meanZ
        Zgrid= meanZ+ (/ (-(znum-1)*stdZ_scaled/2 + (i-1)* stdZ_scaled, i=1,znum) /)  ;

        OPEN( UNIT=73, FILE='PbEQ_TMP.dat', STATUS='OLD', ACTION = 'READ')
        OPEN( UNIT=76, FILE='cnext_TMP.dat', STATUS='OLD', ACTION = 'READ')
        OPEN( UNIT=7, FILE='gnext_TMP.dat', STATUS='OLD', ACTION = 'READ')
        OPEN( UNIT=17, FILE='Pstock_TMP.dat', STATUS='OLD', ACTION = 'READ')
        OPEN( UNIT=18, FILE='Divd_TMP.dat', STATUS='OLD', ACTION = 'READ')
        OPEN( UNIT=19, FILE='Invest_TMP.dat', STATUS='OLD', ACTION = 'READ')

        OPEN( UNIT=10, FILE='stockS_TMP.dat', STATUS='OLD', ACTION = 'READ')
        OPEN( UNIT=11, FILE='bondS_TMP.dat', STATUS='OLD', ACTION = 'READ')
        OPEN( UNIT=12, FILE='bondN_TMP.dat', STATUS='OLD', ACTION = 'READ')
        OPEN( UNIT=13, FILE='valueS_TMP.dat', STATUS='OLD', ACTION = 'READ')
        OPEN( UNIT=14, FILE='valueN_TMP.dat', STATUS='OLD', ACTION = 'READ')
        OPEN( UNIT=15, FILE='consS_TMP.dat', STATUS='OLD', ACTION = 'READ')
        OPEN( UNIT=16, FILE='consN_TMP.dat', STATUS='OLD', ACTION = 'READ')


        nmaxSmall= gnum*znum
        nmax= wnum*gnum*znum

        ALLOCATE(stockS_V(nmax,knum));ALLOCATE( bondS_V(nmax,knum));ALLOCATE( bondN_V(nmax,knum));
        ALLOCATE(consS_V(nmax,knum));ALLOCATE( consN_V(nmax,knum));ALLOCATE( valueS_V(nmax,knum));
        ALLOCATE(valueN_V(nmax,knum)); ALLOCATE(PbEQ_Z( nmaxSmall,knum));
        ALLOCATE(capital_nextZZZ(nmaxSmall,knum)); ALLOCATE(gam_nextZ(nmaxSmall,knum));
        ALLOCATE(PstockZ(nmaxSmall,knum)); ALLOCATE(DivdZ(nmaxSmall,knum)); ALLOCATE(InvestZ(nmaxSmall,knum))


        READ (10,*) ((stockS_V(i,j), j=1,knum), i=1,nmax)
        read (11,*) ((bondS_V(i,j), j=1,knum), i=1,nmax)
        read (12,*) ((bondN_V(i,j), j=1,knum), i=1,nmax)
        read (13,*) ((valueS_V(i,j), j=1,knum), i=1,nmax)
        read (14,*) ((valueN_V(i,j), j=1,knum), i=1,nmax)
        read (15,*) ((consS_V(i,j), j=1,knum), i=1,nmax)
        read (16,*) ((consN_V(i,j), j=1,knum), i=1,nmax)

        read (73,*) ((PbEQ_Z(i,j),j=1,knum),i=1,nmaxSmall)
        read (76,*) ((capital_nextZZZ(i,j),j=1,knum),i=1,nmaxSmall)
        read (7,*)  ((gam_nextZ(i,j), j=1,knum),i=1,nmaxSmall)
        read (17,*) ((PstockZ(i,j), j=1,knum),i=1,nmaxSmall)
        read (18,*) ((DivdZ(i,j), j=1,knum),i=1,nmaxSmall)
        read (19,*) ((InvestZ(i,j), j=1,knum),i=1,nmaxSmall)

        CLOSE(UNIT=73);CLOSE(UNIT=76);CLOSE(UNIT=7); CLOSE(UNIT=10);CLOSE(UNIT=11)
        CLOSE(UNIT=12);CLOSE(UNIT=13);CLOSE(UNIT=14);CLOSE(UNIT=17);CLOSE(UNIT=18);CLOSE(UNIT=19)
        CLOSE(UNIT=15);CLOSE(UNIT=16);

        !!----------------------------------------------------------------

        do l=1,znum
                do g=1, gnum
                      indmaxx=(g-1)*wnum+(l-1)*wnum*gnum
                      stockS_M(:,:,g,l)= stockS_V(1+indmaxx:indmaxx+wnum,:)
                      bondS_M(:,:,g,l)=bondS_V(1+indmaxx:indmaxx+wnum,:)
                      bondN_M(:,:,g,l)=bondN_V(1+indmaxx:indmaxx+wnum,:)
                      valueS_M(:,:,g,l)=valueS_V(1+indmaxx:indmaxx+wnum,:)
                      valueN_M(:,:,g,l)=valueN_V(1+indmaxx:indmaxx+wnum,:)
                      consS_M(:,:,g,l)=consS_V(1+indmaxx:indmaxx+wnum,:)
                      consN_M(:,:,g,l)=consN_V(1+indmaxx:indmaxx+wnum,:)
                end do
        end do
        write (*,*) 'SHAPE OF NEW INCOMING FUNCTIONS IS', SHAPE(valueS_M)


        do znow= 1, znum
               indmaxx=(znow-1)*gnum
               Pbond(:,:, znow)= TRANSPOSE(PbEQ_Z(1+indmaxx:indmaxx+gnum,: ))
               capital_next(:,:,znow)=TRANSPOSE(capital_nextZZZ(1+indmaxx:indmaxx+gnum,:))
               gam_next(:,:, znow)=TRANSPOSE(gam_nextZ(1+indmaxx:indmaxx+gnum,:))
               Pstock(:,:,znow)=TRANSPOSE(PstockZ(1+indmaxx:indmaxx+gnum,:))
               Divd(:,:,znow)=TRANSPOSE(DivdZ(1+indmaxx:indmaxx+gnum,:))
               Invest(:,:,znow)=TRANSPOSE(InvestZ(1+indmaxx:indmaxx+gnum,:))
        end do
        write (*,*)'point 5'

        write (*,*) 'HERE IS PBEQ'
        WRITE (*,121) Pbond
        WRITE (*,*) '----------------------------'
        WRITE (*,*) 'HERE IS CAPITAL_NEXT'
        WRITE (*,121) CAPITAL_NEXT
        WRITE (*,*)'-------------------------------'
        WRITE (*,*) 'HERE IS GAM_NEXT'
        WRITE (*,121) GAM_NEXT
        WRITE (*,*)'-------------------------------'
        write (*,*) 'HERE IS PSTOCK'
        WRITE (*,121) Pstock
        WRITE (*,*) '----------------------------'
        WRITE (*,*) 'HERE IS DIVD'
        WRITE (*,121) Divd
        WRITE (*,*)'-------------------------------'
        WRITE (*,*) 'HERE IS INVEST'
        WRITE (*,121) Invest

        write (*,*) 'MOST IMPORTANTLY, HERE IS THE SHAPE OF DATA...'
        WRITE (*,*) SHAPE (ValueS_M);  WRITE (*,*) SHAPE (ValueN_M);  WRITE (*,*) SHAPE (Pbond)
        WRITE (*,*) SHAPE (Capital_next);  WRITE (*,*) SHAPE (gam_next); WRITE (*,*) SHAPE (Pstock)
        WRITE (*,*) SHAPE (Divd); WRITE (*,*) SHAPE (Invest)

        setinvest=1
        121 FORMAT(1X, 6F15.8)
   !    PAUSE

        capital_next0=capital_next

        CALL wage_sub(capital, wage)
        CALL interest_sub(capital, interest0)
        CALL interestnext_sub(capital_next0, interest_next0)
        CALL interpGen2D(LABSUP, LABSUP_next)
        CALL interpGen2D(LABS, LABS_next)
        
        capital_next0=capital_next
        gam_next0=gam_next

        WRITE (*,*) ' capitalmin , capitalmax is', Minval(capital), MAXval(capital)

        VN_guess = ValueN_M
        VS_guess = ValueS_M
        warmstart = .TRUE.

        CALL interpGen2D(Pstock, Pstock_next)
        CALL interpGen2D(Divd, Divd_next)
        CALL interpGen2D(Invest, Invest_next)

        DEALLOCATE(stockS_V,bondS_V, bondN_V,valueS_V, valueN_V, consS_V,consN_V)
        DEALLOCATE(PbEQ_Z,capital_nextZZZ, gam_nextZ, PstockZ,DivdZ,InvestZ)


end if             ! this is the IF part which executes for init_iter >0........



!!=======================================================================================================
!=======================================================================================================
!!=======================================================================================================

IF (initONE==1) THEN
    WRITE (*,*) 'ENTER 1 IF YOU WANT TO INITIALIZE USING EISPAPER CONSUMPTION FUNCTION >>     '
    READ (*,*) WhetherCONS

    ! THIS PART IMPORTS INITIALIZING DATA FROM EISPAPER VERSION IF EXECUTED
    IF (WhetherCONS ==1) then

        OPEN( UNIT=10, FILE='consS_INIT.dat', STATUS='old', ACTION = 'read')
        OPEN( UNIT=11, FILE='valueS_INIT.dat', STATUS='old', ACTION = 'read')
        OPEN( UNIT=12, FILE='valueN_INIT.dat', STATUS='old', ACTION = 'read')
        OPEN( UNIT=13, FILE='cnext_INIT.dat', STATUS='old', ACTION = 'read')
        OPEN( UNIT=14, FILE='gnext_INIT.dat', STATUS='old', ACTION = 'read')
        OPEN( UNIT=15, FILE='Invest_INIT.dat', STATUS='old', ACTION = 'read')

        nmax= wnum*gnum*znum
        nmaxsmall=gnum*znum

        ALLOCATE(consS_V(nmax,knum));ALLOCATE(valueS_V(nmax,knum));ALLOCATE(valueN_V(nmax,knum));
        ALLOCATE(capital_next_V(nmaxsmall,knum)); ALLOCATE(gam_next_V(nmaxsmall,knum))
        ALLOCATE(Invest_V(nmaxsmall,knum))

        READ (10,*) ((consS_V(i,j), j=1,knum), i=1,nmax)
        READ (11,*) ((valueS_V(i,j), j=1,knum), i=1,nmax)
        READ (12,*) ((valueN_V(i,j), j=1,knum), i=1,nmax)
        READ (13,*) ((capital_next_V(i,j), j=1,knum), i=1,nmaxsmall)
        READ (14,*) ((gam_next_V(i,j), j=1,knum), i=1,nmaxsmall)
        READ (15,*) ((Invest_V(i,j), j=1,knum), i=1,nmaxsmall)

        CLOSE(UNIT=10);CLOSE(UNIT=11);CLOSE(UNIT=12);

        DO l=1,znum
                DO g=1, gnum
                  indmax=(g-1)*wnum+(l-1)*wnum*gnum
                  consS_M(:,:,g,l)= consS_V(1+indmax:indmax+wnum,:)
                  valueS_M(:,:,g,l)=valueS_V(1+indmax:indmax+wnum,:)
                  valueN_M(:,:,g,l)=valueN_V(1+indmax:indmax+wnum,:)
              END DO
        END DO

        do l=1,znum
                  indmaxsmall=(l-1)*gnum
                  capital_next0(:,:,l)=TRANSPOSE(capital_next_V(1+indmaxsmall:indmaxsmall+gnum,:))
                  gam_next0(:,:,l)=TRANSPOSE(gam_next_V(1+indmaxsmall:indmaxsmall+gnum,:))
                  Invest(:,:,l)=TRANSPOSE(Invest_V(1+indmaxsmall:indmaxsmall+gnum,:))
           
        end do

        setinvest=1

        WRITE (*,*) 'MOST IMPORTANTLY, HERE IS THE SHAPE OF DATA...'
        WRITE (*,*) SHAPE (consS_M)
        WRITE (*,*) SHAPE (ValueS_M)
        WRITE (*,*) SHAPE (ValueN_M)
        WRITE (*,*) SHAPE (capital_next0)
        WRITE (*,*) SHAPE (gam_next0)
        WRITE (*,*) 'here is capital_next0'
        WRITE (*,*) capital_next0
        WRITE (*,*) 'here is gam_next0'
        WRITE (*,*)  gam_next0

        DEALLOCATE(consS_V, valueS_V, valueN_V,capital_next_V,gam_next_V)

        VN_guess = ValueN_M
        VS_guess = ValueS_M
        consS_guess=consS_M
        warmstart = .TRUE.
        CLOSE(UNIT=10); CLOSE(UNIT=11); CLOSE(UNIT=12); CLOSE(UNIT=13); CLOSE(UNIT=14)

    ELSEIF (WhetherCONS ==0) THEN
        capital_next=capital_next0
        gam_next=gam_next0
        Pbond=mybeta
        warmstart=.false.
        write (*,*) 'capital_next is:  '
        WRITE(*,120) capital_next
        write (*,*) '=============== gamma_nextV is ,===================='
        write (*,120)  gam_next
        write (*,*) '===============interest0 is: ======================'
        write (*,120)  interest0
        write (*,*) '==========interest_next0 is  ===================='
        write (*,120) interest_next0
        write (*,*) '======================================================'

       ! pause
        CALL bellmanRA (VN_guess, warmstart, valueN_M, bondN_M, consN_M, 2)
        warmstart=.false.
        CALL bellmanRA (VS_guess, warmstart, valueS_M, bondS_M, consS_M, 1)


    ELSE
        WRITE (*,*) ' ERROR: WHETHERCONS CAN ONLY BE 0 OR 1 '
        PAUSE
    END IF

   !!=======================================================================================================
   !=========================OBTAINING INITIAL GUESSES FOR AGGREGATE FUNCTIONS============================

    ALLOCATE (Pstock0(knum,gnum,znum)); ALLOCATE (Pbond0(knum, gnum, znum))
    ALLOCATE (Invest0(knum, gnum, znum)); ALLOCATE (Discr(knum, gnum, znum))

    !1) solve for INVESTMENT using the Euler equation
    capital_next=capital_next0
    gam_next=gam_next0
    CALL interpGen2D(LABSUP, LABSUP_next)
    CALL interpGen2D(LABS, LABS_next)
    
    !Invest=Invest0
    CALL INVESTMENT_SUB(consS_M, Invest0,0)
    Invest=Invest0
    setinvest=1
    !2) obtain new capital_next using the investment
    capital_SPREAD= SPREAD(SPREAD (capital,2,gnum),3,znum)
    capital_next=(one-mydelta)*capital_SPREAD + ADJInvestV(Invest)*capital_SPREAD
    capital_next= 0.8_SP*capital_next + 0.2_SP*capital_next0
    WRITE (*,*) 'capital_next is'
    WRITE (*,*) capital_next

    !3) obtain new value for dividend function
    do gammanow=1,gnum
         do znow=1,znum
              Divd(:,gammanow,znow) = alfa*Zgrid(znow)*((capital**alfa)*(MAX(LABSUP(:,gammanow,znow),minLabSup)**(one-alfa))) &
                                         & -Invest(:,gammanow,znow)-FDdum*FD*(one-mybeta)
         END do
    END do

    WRITE (*,*) 'point 5'

    CALL interpGen2D(Divd, Divd_next)
    WRITE (*,*) 'point 6'
    !4) 0btain initial stock price using present value equation
    CALL UPDATE_PStock(consS_M, Pstock0, Discr,0)
    Pstock=Pstock0
    CALL interpGen2D(Pstock, Pstock_next)

 !   CALL UPDATE_LABSUP(LabsupS_M, LabSupN_M)
    write (*,*) 'UPDATED VALUE OF LABSUP IS:'
    WRITE (*,120) LABSUP
    write (*,*) '=======WAGE IS NEXT =========================================================================='
    write (*,120) wage

   ! PAUSE
    CALL wage_sub(capital, wage)


    WRITE (*,120) Divd
    write (*,*) '============================================================================================'
    WRITE (*,120) Pstock
    write (*,*) '============================================================================================'
    WRITE (*,120) Pstock_next
    write (*,*) '============================================================================================'
    WRITE (*,120) Divd_next
    write (*,*) '============================================================================================'
    WRITE (*,120) Invest
    write (*,*) 'ABOVE IS INVESTMENT INITIAL SOLUTION==============================='

    WRITE (*,*) 'point 7'
   ! pause
    !5) Clear markets and obtain new bond pricing function
    CALL demandB(valueN_M, valueS_M, Pbond0, bondN_EQ, stockS_EQ, failcount)
 !   LABSUP=0.7_SP*LABSUP+ 0.3_SP*(lamda*LabS_EQ+(one-lamda)*labN_EQ)
    gam_next = 0.5_SP*(one - lamda) * bondN_EQ +0.5_SP*Gam_next0
    Pbond=Pbond0
    DEALLOCATE(Pstock0,Pbond0, Invest0, Discr)
    !6) Interpolate these functions everytime before Bellman's are called
    CALL interpGen2D(Pstock, Pstock_next)
    CALL interpGen2D(Divd, Divd_next)
    CALL interpGen2D(Invest, Invest_next)
    CALL interpGen2D(LABSUP, LABSUP_next)
    CALL interpGen2D(LABS, LABS_next)
    
    120 FORMAT(1X, 10F15.8)

END if

!AT THIS POINT WE HAVE ALL THE INITIAL GUESSES FOR AGGREGATE FUNCTIONS=======================
!NOW WE ARE ITERATING ON THE BOND AND STOCK PRICES UNTIL CONVERGENCE=========================

!========================================================================================================
!===================== M A I N    B O D Y   O F   T H E   C O D E =======================================
!========================================================================================================
!warmstart=.false.
EQB: DO iterMAIN=initone, ITMAX_MAIN

         if (itermain>=40) then
            FDdum=min(0.25_DP*((floor(itermain/20.0_DP))-one),one)
         end if
         write (*,*)  'ITERMAIN, FDdum and FD are: ', Itermain, FDdum, FD


         CALL bellmanHABS (VS_guess, warmstart, valueS_M, bondS_M, stockS_M, consS_M)
         CALL bellmanHABN (VN_guess, warmstart, valueN_M, bondN_M, consN_M)
         warmstart= .TRUE.

!         CALL UPDATE_LABSUP(LabS_M, LabN_M)
         CALL wage_sub(capital, wage)

         !1) solve for INVESTMENT using the Euler equation
         CALL INVESTMENT_SUB(consS_M,Invest_M,1)
!         Invest=Invest0
         Invest=Invest_M
         !2) obtain new capital_next using the investment
          capital_next_temp=(one-mydelta)*capital_SPREAD + ADJInvestV(Invest)*capital_SPREAD
          capital_next=weightP*capital_next_temp +(one-weightP)*capital_next
         !3) obtain new value for dividend function
         do gammanow=1,gnum
             DO znow=1,znum
                 Divd(:,gammanow,znow) =alfa*Zgrid(znow)*((capital**alfa)*(MAX(minLabSup,LABSUP(:,gammanow,znow))**(one-alfa))) &
                                                                &- Invest(:,gammanow,znow)-FDdum*FD*(one-Pbond(:,gammanow,znow))
             END DO
         end do
         !4) 0btain new stock price using present value equation
         CALL  UPDATE_PStock(consS_M, Pstocknew, DiscrPs,1)
         Pstock=weightP*Pstocknew +(one-weightP) *Pstock

         !5) Clear markets and obtain new bond pricing function
         CALL demandB(valueN_M, valueS_M, PbEQ, bondN_EQ, stockS_EQ, failcount)
  !      LABSUP=0.3_SP*LABSUP+ 0.7_SP*(lamda*LabS_EQ+(one-lamda)*labN_EQ)

         gam_next = weightP* (one - lamda) * bondN_EQ +(one-weightP) * gam_next
         Pbond = weightP * PbEQ + (one - weightP) * Pbond

         !UPDATING LAWS OF MOTION FOR CAPITAL AND GAMMA------------------------------------------

         IF ((MODULO(iterMAIN, 3) ==0) .OR. ((iterMAIN > 20) .AND. &
               & ((DISCR_CAPITAL < 1.0E-2) .AND. (DISCR_GAMM < 1.0E-2)))) then
         END IF

 !        After Updating Pstock using the PRESENT value equation and INVESTMENT function by solving firm's problem
 !        I should create next period's interpolated values form Pstock and DIVIDENd.. these are used in agent's problem and maybe ELSEwhere

         CALL interpGen2D(Pstock, Pstock_next)
         CALL interpGen2D(Divd, Divd_next)
         CALL interpGen2D(Invest, Invest_next)
         CALL interpGen2D(LABSUP, LABSUP_next)
         CALL interpGen2D(LABS, LABS_next)
         !CALCULATE ASSET PRICES....
         DO i=1,znum
               Rsnext(:,:,:,i) = (Pstock_next(:,:,:,i) + Divd_next(:,:,:,i))/Pstock -one
         END DO
         Rb = (one/ PbEQ) - one

          write (*,*) "ITERATION NUMBER=  ", ITERMAIN, "COMPLETED"
          write (*,*) 'INTERMEDIATE VALUES OF STOCK AND BOND RETURN ECHOED... NOW PAUSING'



          ! FIND DISCREPANCY BETWEEN ITERATIONS----------------------------------------------------
          DISCR_PBOND = MAXVAL(ABS((PbEQ - Pb_LAG)))
          DISCR_PSTOCK= MAXVAL(discrPs)
          DISCR_CAPITAL = MAXVAL (ABS (capital_next_temp - capnext_LAG))
          DISCR_GAMM = MAXVAL(ABS((one-lamda)*bondN_EQ - gamnext_LAG))

          indxPbond = MAXLOC (ABS(PbEQ-Pb_LAG))
          indxPstock=MAXLOC (discrPs)
          indx_cap = MAXLOC(ABS(lamda*stockS_EQ- capnext_LAG))
          indx_gamm = MAXLOC (ABS((one-lamda)*bondN_EQ - gamnext_LAG))

          avg_Pbond= SUM(ABS(PbEQ - Pb_LAG)/(SIZE(PbEQ)))
          avg_Pstock=SUM (discrPs)/SIZE(Pstock)
          avg_capital= SUM(ABS(lamda*stockS_EQ - capnext_LAG)/(SIZE(capital_next)))
          avg_gamm= SUM(ABS((one-lamda)*bondN_EQ - gamnext_LAG)/(SIZE(gam_next)))

          !--------------------------------------------------------------------------------------
          !ECHO INTERMEDAITE RESULTS...
          WRITE (*,*) ' Pbond new', PbEQ
          WRITE (*,*) 'Pblag', Pb_LAG
          WRITE (*,*) 'dIFfPbond' ,PbEQ - Pb_LAG
          WRITE (*,*)'--------------------------'
          WRITE (*,*) ' capital_next', capital_next
          WRITE (*,*) 'capnext_LAG', capnext_LAG
          WRITE (*,*) 'dIFfcapital', capital_next - capnext_LAG
          WRITE (*,*)'------------------------'
          WRITE (*,*)'gam_next', gam_next
          WRITE (*,*)'gamnext_lag', gamnext_LAG
          WRITE (*,*) 'dIFfgamma', gam_next-gamnext_LAG
          WRITE (*,*)'----------------------------'
          WRITE (*,*) 'DISCR. IN BOND PRICE IS=', DISCR_PBOND, 'at location=', PbEQ(indxPbond(1), &
                                                                        & indxPbond(2), indxPbond(3))
          WRITE (*,*) 'DISCR. IN STOCK PRICE IS=', DISCR_PSTOCK, 'at location=', Pstock(indxPstock(1), &
                                                                        & indxPstock(2), indxPstock(3))
          WRITE (*,*) 'DISCR. in CAPITAL law of motion is', discr_capital,'at location',capital_next(indx_cap(1), &
                                                                        & indx_cap(2), indx_cap(3))
          WRITE (*,*) 'DISCR. in GAMMA law of motion is', discr_gamm,'at location',gam_next( indx_gamm(1), &
                                                                        & indx_gamm(2), indx_gamm(3))


          !-----------------------------------------------------------------------------------------------
          !update
          VS_guess = valueS_M
          VN_guess = valueN_M
          Pb_LAG = PbEQ
          capnext_LAG = capital_next
          gamnext_LAG = gam_next

          if (itermain>40) then
            weightP=0.25
          ELSEIF (itermain>30) then
            weightP=0.25
          end if


        !!!!!!!!!!!!!!!! THE OUTPUT MATRICES ARE (WNUM*GNUM*ZNUM X KNUM) DIMENSIONAL !!!!!!!!!!!!!!!!!
        !!!!!!!!!!!!!!!! THE OUTPUT MATRICES ARE (WNUM*GNUM*ZNUM X KNUM) DIMENSIONAL !!!!!!!!!!!!!!!!!


          call myECHO_3(PbEQ,'PbEQ_TMP.dat'); call myECHO_3(capital_next,'cnext_TMP.dat'); call myECHO_3(gam_next,'gnext_TMP.dat')
          call myECHO_3(Pstock,'Pstock_TMP.dat'); call myECHO_3(Divd,'Divd_TMP.dat'); call myECHO_3(Invest,'Invest_TMP.dat')
          call myECHO_3(lamda*stockS_EQ,'stocks_EQ_TMP.dat') ; call myECHO_3(labSup,'labSup_TMP.dat');

          call myECHO_4(consS_M,'consS_TMP.dat'); call myECHO_4(consN_M,'consN_TMP.dat'); call myECHO_4(bondS_M,'bondS_TMP.dat')
          call myECHO_4(bondN_M,'bondN_TMP.dat'); call myECHO_4(valueS_M,'valueS_TMP.dat'); call myECHO_4(valueN_M,'valueN_TMP.dat')
          call myECHO_4(stockS_M,'stockS_TMP.dat')


        OPEN( UNIT=38, FILE='Rstock_TMP.dat', STATUS='replace', ACTION = 'WRITE')
        OPEN( UNIT=42, FILE='zshock_TMP.dat', STATUS='replace', ACTION = 'WRITE')
        OPEN( UNIT=77, FILE='iterationNUMB.dat', STATUS='replace', ACTION = 'write')


        WRITE (77,*) itermain
        WRITE (42,100) zgrid

        do i=1,znum
             Rsnext(:,:,:,i) = ((Pstock_next(:,:,:,i) + Divd_next(:,:,:,i))/Pstock) -one
        END do

        do znext=1,znum
          DO znow= 1,znum
            DO  g=1, gnum
               WRITE (38,100) (Rsnext(j,g,znow,znext), j=1,knum)
            END do
          END do
        end do

        CLOSE(UNIT=38);CLOSE(UNIT=42); CLOSE(UNIT=77)

        CALL wage_sub(capital, wage)
        CALL interest_sub(capital, interest0)
        CALL interestnext_sub(capital_next0, interest_next0)


        !--------------------------------- EXIT ??? ------------------------------------
       IF ((iterMAIN > 10) .AND. (MODULO(iterMAIN, 3) ==0)) then
              IF ((DISCR_PBOND < TOL_PBOND) .AND. (DISCR_CAPITAL < TOL_CAPITAL) .AND. (DISCR_GAMM < TOL_GAMM)) EXIT EQB
       END IF

       IF ((iterMAIN >=200) .AND. (MODULO(iterMAIN, 50) ==0)) then
              WRITE(*,*) 'HERE ARE THE DISCREPANCIES......'
              WRITE (*,*) 'DISCR. IN BOND PRICE IS=', DISCR_PBOND, 'at location=', PbEQ(indxPbond(1), &
                                                                        & indxPbond(2), indxPbond(3))
              WRITE (*,*) 'DISCR. IN STOCK PRICE IS=', DISCR_PSTOCK, 'at location=', Pstock(indxPstock(1), &
                                                                        & indxPstock(2), indxPstock(3))
              WRITE (*,*) 'discr in CAPITAL law of motion is', discr_capital,'at location',capital_next( indx_cap(1), &
                                                                            & indx_cap(2), indx_cap(3))
              WRITE (*,*) 'discr in gama law of motion is', discr_gamm,'at location',gam_next( indx_gamm(1), &
                                                                            & indx_gamm(2), indx_gamm(3))
              WRITE (*,*)'-------------------'
              WRITE (*,*) 'IF YOU WOULD LIKE TO TERMINATE THE PROGRAM ANYWAY, ENTER 1---------->>>>  '
              READ(*,*) terminate
              IF (terminate ==1) then
                  WRITE (*,*) 'YOU CHOSE TO TERMINATE THE PROGRAM SO SAVING RESULTS WITH THIS CONVERGENCE LEVEL'
                  EXIT EQB
              END IF

          END IF



END DO EQB

!==================================================================================================================================
!============================== ITERATION ENDS HERE... NOW PREPARE DATA FOR OUTPUTTING=============================================
!==================================================================================================================================


IF (iterMAIN > ITMAX_MAIN) then
WRITE (*,*)' NO CONVERGENCE IN',ITMAX_MAIN,'NUMBER OF ITERATIONS'
ELSE
WRITE (*,*)'program converged successfully in  ', iterMAIN,'  iterations'
WRITE (*,*) PbEQ
END IF


DO i=1,znum
    Rsnext(:,:,:,i) = ((Pstock_next(:,:,:,i) + Divd_next(:,:,:,i))/Pstock) -one
END DO


Rb(:,:,:) = (one /PbEQ(:,:,:)) - one

IF ((ABS(MAXVAL(-capital_next)) > capital(1)) .AND. (MAXVAL(capital_next) < capital(knum))) then
contained= 1
END IF
WRITE (*,*) 'the converged law of motion is contained? yes IF 1, no IF 0', contained

call myECHO_3(PbEQ,'PbEQ.dat'); call myECHO_3(capital_next,'cnext.dat'); call myECHO_3(gam_next,'gnext.dat')
call myECHO_3(Pstock,'Pstock.dat'); call myECHO_3(Divd,'Divd.dat'); call myECHO_3(Invest,'Invest.dat')
call myECHO_3(lamda*stockS_EQ,'stocks_EQ.dat') ; call myECHO_3(labSup,'labSup.dat');

call myECHO_4(consS_M,'consS.dat'); call myECHO_4(consN_M,'consN.dat'); call myECHO_4(bondS_M,'bondS.dat')
call myECHO_4(bondN_M,'bondN.dat'); call myECHO_4(valueS_M,'valueS.dat'); call myECHO_4(valueN_M,'valueN.dat')
call myECHO_4(stockS_M,'stockS.dat');



OPEN( UNIT=38, FILE='Rstock.dat', STATUS='replace', ACTION = 'WRITE')
OPEN( UNIT=39, FILE='Rbond.dat', STATUS='replace', ACTION = 'WRITE')
OPEN( UNIT=42, FILE='zshock.dat', STATUS='replace', ACTION = 'WRITE')
OPEN( UNIT=43, FILE='contain.dat', STATUS='replace', ACTION = 'WRITE')

WRITE (42,100) Zgrid
WRITE (43,1010) contained
1010 format (I5)

!!!!!!!!!!!!!!1! THE OUTPUT MATRIX IS (GNUM*ZNUM X KNUM) DIMENSIONAL !!!!!!!!!!!!!!!!!!!
DO znow= 1, znum
    DO g=1, gnum
       WRITE (39,100) (Rb(j,g,znow), j=1,knum)
   END DO
END DO

!!!!!!!!!!!!!!1! THE OUTPUT MATRIX IS (GNUM*ZNUM*ZNUM X KNUM) DIMENSIONAL !!!!!!!!!!!!!!!!!!!

DO znext=1,znum
 DO znow= 1, znum
    DO g=1, gnum
       WRITE (38,100) (Rsnext(j,g,znow,znext), j=1,knum)
   END DO
 END DO
end do


CLOSE( UNIT=38);CLOSE( UNIT=39);CLOSE(UNIT =42);CLOSE(UNIT=43);

100 FORMAT(1x,50(3x,F20.10))


END program  mainEQ


!============================================================================================
!============================================================================================
!============================================================================================
!============================================================================================
!============================================================================================
!============================================================================================
!============================================================================================
!============================================================================================
!============================================================================================
!============================================================================================
!============================================================================================
!============================================================================================
